/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         minimal_base_yyparse
#define yylex           minimal_base_yylex
#define yyerror         minimal_base_yyerror
#define yydebug         minimal_base_yydebug
#define yynerrs         minimal_base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram_minimal.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2022, PgPool Global Development Group
 * Portions Copyright (c) 1996-2022, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *rels,
											   int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 328 "gram_minimal.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
# define YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int minimal_base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASENSITIVE = 294,
    ASSERTION = 295,
    ASSIGNMENT = 296,
    ASYMMETRIC = 297,
    ATOMIC = 298,
    AT = 299,
    ATTACH = 300,
    ATTRIBUTE = 301,
    AUTHORIZATION = 302,
    BACKWARD = 303,
    BEFORE = 304,
    BEGIN_P = 305,
    BETWEEN = 306,
    BIGINT = 307,
    BINARY = 308,
    BIT = 309,
    BOOLEAN_P = 310,
    BOTH = 311,
    BREADTH = 312,
    BY = 313,
    CACHE = 314,
    CALL = 315,
    CALLED = 316,
    CASCADE = 317,
    CASCADED = 318,
    CASE = 319,
    CAST = 320,
    CATALOG_P = 321,
    CHAIN = 322,
    CHAR_P = 323,
    CHARACTER = 324,
    CHARACTERISTICS = 325,
    CHECK = 326,
    CHECKPOINT = 327,
    CLASS = 328,
    CLOSE = 329,
    CLUSTER = 330,
    COALESCE = 331,
    COLLATE = 332,
    COLLATION = 333,
    COLUMN = 334,
    COLUMNS = 335,
    COMMENT = 336,
    COMMENTS = 337,
    COMMIT = 338,
    COMMITTED = 339,
    COMPRESSION = 340,
    CONCURRENTLY = 341,
    CONFIGURATION = 342,
    CONFLICT = 343,
    CONNECTION = 344,
    CONSTRAINT = 345,
    CONSTRAINTS = 346,
    CONTENT_P = 347,
    CONTINUE_P = 348,
    CONVERSION_P = 349,
    COPY = 350,
    COST = 351,
    CREATE = 352,
    CROSS = 353,
    CSV = 354,
    CUBE = 355,
    CURRENT_P = 356,
    CURRENT_CATALOG = 357,
    CURRENT_DATE = 358,
    CURRENT_ROLE = 359,
    CURRENT_SCHEMA = 360,
    CURRENT_TIME = 361,
    CURRENT_TIMESTAMP = 362,
    CURRENT_USER = 363,
    CURSOR = 364,
    CYCLE = 365,
    DATA_P = 366,
    DATABASE = 367,
    DAY_P = 368,
    DEALLOCATE = 369,
    DEC = 370,
    DECIMAL_P = 371,
    DECLARE = 372,
    DEFAULT = 373,
    DEFAULTS = 374,
    DEFERRABLE = 375,
    DEFERRED = 376,
    DEFINER = 377,
    DELETE_P = 378,
    DELIMITER = 379,
    DELIMITERS = 380,
    DEPENDS = 381,
    DEPTH = 382,
    DESC = 383,
    DETACH = 384,
    DICTIONARY = 385,
    DISABLE_P = 386,
    DISCARD = 387,
    DISTINCT = 388,
    DO = 389,
    DOCUMENT_P = 390,
    DOMAIN_P = 391,
    DOUBLE_P = 392,
    DROP = 393,
    EACH = 394,
    ELSE = 395,
    ENABLE_P = 396,
    ENCODING = 397,
    ENCRYPTED = 398,
    END_P = 399,
    ENUM_P = 400,
    ESCAPE = 401,
    EVENT = 402,
    EXCEPT = 403,
    EXCLUDE = 404,
    EXCLUDING = 405,
    EXCLUSIVE = 406,
    EXECUTE = 407,
    EXISTS = 408,
    EXPLAIN = 409,
    EXPRESSION = 410,
    EXTENSION = 411,
    EXTERNAL = 412,
    EXTRACT = 413,
    FALSE_P = 414,
    FAMILY = 415,
    FETCH = 416,
    FILTER = 417,
    FINALIZE = 418,
    FIRST_P = 419,
    FLOAT_P = 420,
    FOLLOWING = 421,
    FOR = 422,
    FORCE = 423,
    FOREIGN = 424,
    FORWARD = 425,
    FREEZE = 426,
    FROM = 427,
    FULL = 428,
    FUNCTION = 429,
    FUNCTIONS = 430,
    GENERATED = 431,
    GLOBAL = 432,
    GRANT = 433,
    GRANTED = 434,
    GREATEST = 435,
    GROUP_P = 436,
    GROUPING = 437,
    GROUPS = 438,
    HANDLER = 439,
    HAVING = 440,
    HEADER_P = 441,
    HOLD = 442,
    HOUR_P = 443,
    IDENTITY_P = 444,
    IF_P = 445,
    ILIKE = 446,
    IMMEDIATE = 447,
    IMMUTABLE = 448,
    IMPLICIT_P = 449,
    IMPORT_P = 450,
    IN_P = 451,
    INCLUDE = 452,
    INCLUDING = 453,
    INCREMENT = 454,
    INDEX = 455,
    INDEXES = 456,
    INHERIT = 457,
    INHERITS = 458,
    INITIALLY = 459,
    INLINE_P = 460,
    INNER_P = 461,
    INOUT = 462,
    INPUT_P = 463,
    INSENSITIVE = 464,
    INSERT = 465,
    INSTEAD = 466,
    INT_P = 467,
    INTEGER = 468,
    INTERSECT = 469,
    INTERVAL = 470,
    INTO = 471,
    INVOKER = 472,
    IS = 473,
    ISNULL = 474,
    ISOLATION = 475,
    JOIN = 476,
    KEY = 477,
    LABEL = 478,
    LANGUAGE = 479,
    LARGE_P = 480,
    LAST_P = 481,
    LATERAL_P = 482,
    LEADING = 483,
    LEAKPROOF = 484,
    LEAST = 485,
    LEFT = 486,
    LEVEL = 487,
    LIKE = 488,
    LIMIT = 489,
    LISTEN = 490,
    LOAD = 491,
    LOCAL = 492,
    LOCALTIME = 493,
    LOCALTIMESTAMP = 494,
    LOCATION = 495,
    LOCK_P = 496,
    LOCKED = 497,
    LOGGED = 498,
    MAPPING = 499,
    MATCH = 500,
    MATCHED = 501,
    MATERIALIZED = 502,
    MAXVALUE = 503,
    MERGE = 504,
    METHOD = 505,
    MINUTE_P = 506,
    MINVALUE = 507,
    MODE = 508,
    MONTH_P = 509,
    MOVE = 510,
    NAME_P = 511,
    NAMES = 512,
    NATIONAL = 513,
    NATURAL = 514,
    NCHAR = 515,
    NEW = 516,
    NEXT = 517,
    NFC = 518,
    NFD = 519,
    NFKC = 520,
    NFKD = 521,
    NO = 522,
    NONE = 523,
    NORMALIZE = 524,
    NORMALIZED = 525,
    NOT = 526,
    NOTHING = 527,
    NOTIFY = 528,
    NOTNULL = 529,
    NOWAIT = 530,
    NULL_P = 531,
    NULLIF = 532,
    NULLS_P = 533,
    NUMERIC = 534,
    OBJECT_P = 535,
    OF = 536,
    OFF = 537,
    OFFSET = 538,
    OIDS = 539,
    OLD = 540,
    ON = 541,
    ONLY = 542,
    OPERATOR = 543,
    OPTION = 544,
    OPTIONS = 545,
    OR = 546,
    ORDER = 547,
    ORDINALITY = 548,
    OTHERS = 549,
    OUT_P = 550,
    OUTER_P = 551,
    OVER = 552,
    OVERLAPS = 553,
    OVERLAY = 554,
    OVERRIDING = 555,
    OWNED = 556,
    OWNER = 557,
    PARALLEL = 558,
    PARAMETER = 559,
    PARSER = 560,
    PARTIAL = 561,
    PARTITION = 562,
    PASSING = 563,
    PASSWORD = 564,
    PGPOOL = 565,
    PLACING = 566,
    PLANS = 567,
    POLICY = 568,
    POSITION = 569,
    PRECEDING = 570,
    PRECISION = 571,
    PRESERVE = 572,
    PREPARE = 573,
    PREPARED = 574,
    PRIMARY = 575,
    PRIOR = 576,
    PRIVILEGES = 577,
    PROCEDURAL = 578,
    PROCEDURE = 579,
    PROCEDURES = 580,
    PROGRAM = 581,
    PUBLICATION = 582,
    QUOTE = 583,
    RANGE = 584,
    READ = 585,
    REAL = 586,
    REASSIGN = 587,
    RECHECK = 588,
    RECURSIVE = 589,
    REF = 590,
    REFERENCES = 591,
    REFERENCING = 592,
    REFRESH = 593,
    REINDEX = 594,
    RELATIVE_P = 595,
    RELEASE = 596,
    RENAME = 597,
    REPEATABLE = 598,
    REPLACE = 599,
    REPLICA = 600,
    RESET = 601,
    RESTART = 602,
    RESTRICT = 603,
    RETURN = 604,
    RETURNING = 605,
    RETURNS = 606,
    REVOKE = 607,
    RIGHT = 608,
    ROLE = 609,
    ROLLBACK = 610,
    ROLLUP = 611,
    ROUTINE = 612,
    ROUTINES = 613,
    ROW = 614,
    ROWS = 615,
    RULE = 616,
    SAVEPOINT = 617,
    SCHEMA = 618,
    SCHEMAS = 619,
    SCROLL = 620,
    SEARCH = 621,
    SECOND_P = 622,
    SECURITY = 623,
    SELECT = 624,
    SEQUENCE = 625,
    SEQUENCES = 626,
    SERIALIZABLE = 627,
    SERVER = 628,
    SESSION = 629,
    SESSION_USER = 630,
    SET = 631,
    SETS = 632,
    SETOF = 633,
    SHARE = 634,
    SHOW = 635,
    SIMILAR = 636,
    SIMPLE = 637,
    SKIP = 638,
    SMALLINT = 639,
    SNAPSHOT = 640,
    SOME = 641,
    SQL_P = 642,
    STABLE = 643,
    STANDALONE_P = 644,
    START = 645,
    STATEMENT = 646,
    STATISTICS = 647,
    STDIN = 648,
    STDOUT = 649,
    STORAGE = 650,
    STORED = 651,
    STRICT_P = 652,
    STRIP_P = 653,
    SUBSCRIPTION = 654,
    SUBSTRING = 655,
    SUPPORT = 656,
    SYMMETRIC = 657,
    SYSID = 658,
    SYSTEM_P = 659,
    TABLE = 660,
    TABLES = 661,
    TABLESAMPLE = 662,
    TABLESPACE = 663,
    TEMP = 664,
    TEMPLATE = 665,
    TEMPORARY = 666,
    TEXT_P = 667,
    THEN = 668,
    TIES = 669,
    TIME = 670,
    TIMESTAMP = 671,
    TO = 672,
    TRAILING = 673,
    TRANSACTION = 674,
    TRANSFORM = 675,
    TREAT = 676,
    TRIGGER = 677,
    TRIM = 678,
    TRUE_P = 679,
    TRUNCATE = 680,
    TRUSTED = 681,
    TYPE_P = 682,
    TYPES_P = 683,
    UESCAPE = 684,
    UNBOUNDED = 685,
    UNCOMMITTED = 686,
    UNENCRYPTED = 687,
    UNION = 688,
    UNIQUE = 689,
    UNKNOWN = 690,
    UNLISTEN = 691,
    UNLOGGED = 692,
    UNTIL = 693,
    UPDATE = 694,
    USER = 695,
    USING = 696,
    VACUUM = 697,
    VALID = 698,
    VALIDATE = 699,
    VALIDATOR = 700,
    VALUE_P = 701,
    VALUES = 702,
    VARCHAR = 703,
    VARIADIC = 704,
    VARYING = 705,
    VERBOSE = 706,
    VERSION_P = 707,
    VIEW = 708,
    VIEWS = 709,
    VOLATILE = 710,
    WHEN = 711,
    WHERE = 712,
    WHITESPACE_P = 713,
    WINDOW = 714,
    WITH = 715,
    WITHIN = 716,
    WITHOUT = 717,
    WORK = 718,
    WRAPPER = 719,
    WRITE = 720,
    XML_P = 721,
    XMLATTRIBUTES = 722,
    XMLCONCAT = 723,
    XMLELEMENT = 724,
    XMLEXISTS = 725,
    XMLFOREST = 726,
    XMLNAMESPACES = 727,
    XMLPARSE = 728,
    XMLPI = 729,
    XMLROOT = 730,
    XMLSERIALIZE = 731,
    XMLTABLE = 732,
    YEAR_P = 733,
    YES_P = 734,
    ZONE = 735,
    NOT_LA = 736,
    NULLS_LA = 737,
    WITH_LA = 738,
    MODE_TYPE_NAME = 739,
    MODE_PLPGSQL_EXPR = 740,
    MODE_PLPGSQL_ASSIGN1 = 741,
    MODE_PLPGSQL_ASSIGN2 = 742,
    MODE_PLPGSQL_ASSIGN3 = 743,
    UMINUS = 744
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASENSITIVE 294
#define ASSERTION 295
#define ASSIGNMENT 296
#define ASYMMETRIC 297
#define ATOMIC 298
#define AT 299
#define ATTACH 300
#define ATTRIBUTE 301
#define AUTHORIZATION 302
#define BACKWARD 303
#define BEFORE 304
#define BEGIN_P 305
#define BETWEEN 306
#define BIGINT 307
#define BINARY 308
#define BIT 309
#define BOOLEAN_P 310
#define BOTH 311
#define BREADTH 312
#define BY 313
#define CACHE 314
#define CALL 315
#define CALLED 316
#define CASCADE 317
#define CASCADED 318
#define CASE 319
#define CAST 320
#define CATALOG_P 321
#define CHAIN 322
#define CHAR_P 323
#define CHARACTER 324
#define CHARACTERISTICS 325
#define CHECK 326
#define CHECKPOINT 327
#define CLASS 328
#define CLOSE 329
#define CLUSTER 330
#define COALESCE 331
#define COLLATE 332
#define COLLATION 333
#define COLUMN 334
#define COLUMNS 335
#define COMMENT 336
#define COMMENTS 337
#define COMMIT 338
#define COMMITTED 339
#define COMPRESSION 340
#define CONCURRENTLY 341
#define CONFIGURATION 342
#define CONFLICT 343
#define CONNECTION 344
#define CONSTRAINT 345
#define CONSTRAINTS 346
#define CONTENT_P 347
#define CONTINUE_P 348
#define CONVERSION_P 349
#define COPY 350
#define COST 351
#define CREATE 352
#define CROSS 353
#define CSV 354
#define CUBE 355
#define CURRENT_P 356
#define CURRENT_CATALOG 357
#define CURRENT_DATE 358
#define CURRENT_ROLE 359
#define CURRENT_SCHEMA 360
#define CURRENT_TIME 361
#define CURRENT_TIMESTAMP 362
#define CURRENT_USER 363
#define CURSOR 364
#define CYCLE 365
#define DATA_P 366
#define DATABASE 367
#define DAY_P 368
#define DEALLOCATE 369
#define DEC 370
#define DECIMAL_P 371
#define DECLARE 372
#define DEFAULT 373
#define DEFAULTS 374
#define DEFERRABLE 375
#define DEFERRED 376
#define DEFINER 377
#define DELETE_P 378
#define DELIMITER 379
#define DELIMITERS 380
#define DEPENDS 381
#define DEPTH 382
#define DESC 383
#define DETACH 384
#define DICTIONARY 385
#define DISABLE_P 386
#define DISCARD 387
#define DISTINCT 388
#define DO 389
#define DOCUMENT_P 390
#define DOMAIN_P 391
#define DOUBLE_P 392
#define DROP 393
#define EACH 394
#define ELSE 395
#define ENABLE_P 396
#define ENCODING 397
#define ENCRYPTED 398
#define END_P 399
#define ENUM_P 400
#define ESCAPE 401
#define EVENT 402
#define EXCEPT 403
#define EXCLUDE 404
#define EXCLUDING 405
#define EXCLUSIVE 406
#define EXECUTE 407
#define EXISTS 408
#define EXPLAIN 409
#define EXPRESSION 410
#define EXTENSION 411
#define EXTERNAL 412
#define EXTRACT 413
#define FALSE_P 414
#define FAMILY 415
#define FETCH 416
#define FILTER 417
#define FINALIZE 418
#define FIRST_P 419
#define FLOAT_P 420
#define FOLLOWING 421
#define FOR 422
#define FORCE 423
#define FOREIGN 424
#define FORWARD 425
#define FREEZE 426
#define FROM 427
#define FULL 428
#define FUNCTION 429
#define FUNCTIONS 430
#define GENERATED 431
#define GLOBAL 432
#define GRANT 433
#define GRANTED 434
#define GREATEST 435
#define GROUP_P 436
#define GROUPING 437
#define GROUPS 438
#define HANDLER 439
#define HAVING 440
#define HEADER_P 441
#define HOLD 442
#define HOUR_P 443
#define IDENTITY_P 444
#define IF_P 445
#define ILIKE 446
#define IMMEDIATE 447
#define IMMUTABLE 448
#define IMPLICIT_P 449
#define IMPORT_P 450
#define IN_P 451
#define INCLUDE 452
#define INCLUDING 453
#define INCREMENT 454
#define INDEX 455
#define INDEXES 456
#define INHERIT 457
#define INHERITS 458
#define INITIALLY 459
#define INLINE_P 460
#define INNER_P 461
#define INOUT 462
#define INPUT_P 463
#define INSENSITIVE 464
#define INSERT 465
#define INSTEAD 466
#define INT_P 467
#define INTEGER 468
#define INTERSECT 469
#define INTERVAL 470
#define INTO 471
#define INVOKER 472
#define IS 473
#define ISNULL 474
#define ISOLATION 475
#define JOIN 476
#define KEY 477
#define LABEL 478
#define LANGUAGE 479
#define LARGE_P 480
#define LAST_P 481
#define LATERAL_P 482
#define LEADING 483
#define LEAKPROOF 484
#define LEAST 485
#define LEFT 486
#define LEVEL 487
#define LIKE 488
#define LIMIT 489
#define LISTEN 490
#define LOAD 491
#define LOCAL 492
#define LOCALTIME 493
#define LOCALTIMESTAMP 494
#define LOCATION 495
#define LOCK_P 496
#define LOCKED 497
#define LOGGED 498
#define MAPPING 499
#define MATCH 500
#define MATCHED 501
#define MATERIALIZED 502
#define MAXVALUE 503
#define MERGE 504
#define METHOD 505
#define MINUTE_P 506
#define MINVALUE 507
#define MODE 508
#define MONTH_P 509
#define MOVE 510
#define NAME_P 511
#define NAMES 512
#define NATIONAL 513
#define NATURAL 514
#define NCHAR 515
#define NEW 516
#define NEXT 517
#define NFC 518
#define NFD 519
#define NFKC 520
#define NFKD 521
#define NO 522
#define NONE 523
#define NORMALIZE 524
#define NORMALIZED 525
#define NOT 526
#define NOTHING 527
#define NOTIFY 528
#define NOTNULL 529
#define NOWAIT 530
#define NULL_P 531
#define NULLIF 532
#define NULLS_P 533
#define NUMERIC 534
#define OBJECT_P 535
#define OF 536
#define OFF 537
#define OFFSET 538
#define OIDS 539
#define OLD 540
#define ON 541
#define ONLY 542
#define OPERATOR 543
#define OPTION 544
#define OPTIONS 545
#define OR 546
#define ORDER 547
#define ORDINALITY 548
#define OTHERS 549
#define OUT_P 550
#define OUTER_P 551
#define OVER 552
#define OVERLAPS 553
#define OVERLAY 554
#define OVERRIDING 555
#define OWNED 556
#define OWNER 557
#define PARALLEL 558
#define PARAMETER 559
#define PARSER 560
#define PARTIAL 561
#define PARTITION 562
#define PASSING 563
#define PASSWORD 564
#define PGPOOL 565
#define PLACING 566
#define PLANS 567
#define POLICY 568
#define POSITION 569
#define PRECEDING 570
#define PRECISION 571
#define PRESERVE 572
#define PREPARE 573
#define PREPARED 574
#define PRIMARY 575
#define PRIOR 576
#define PRIVILEGES 577
#define PROCEDURAL 578
#define PROCEDURE 579
#define PROCEDURES 580
#define PROGRAM 581
#define PUBLICATION 582
#define QUOTE 583
#define RANGE 584
#define READ 585
#define REAL 586
#define REASSIGN 587
#define RECHECK 588
#define RECURSIVE 589
#define REF 590
#define REFERENCES 591
#define REFERENCING 592
#define REFRESH 593
#define REINDEX 594
#define RELATIVE_P 595
#define RELEASE 596
#define RENAME 597
#define REPEATABLE 598
#define REPLACE 599
#define REPLICA 600
#define RESET 601
#define RESTART 602
#define RESTRICT 603
#define RETURN 604
#define RETURNING 605
#define RETURNS 606
#define REVOKE 607
#define RIGHT 608
#define ROLE 609
#define ROLLBACK 610
#define ROLLUP 611
#define ROUTINE 612
#define ROUTINES 613
#define ROW 614
#define ROWS 615
#define RULE 616
#define SAVEPOINT 617
#define SCHEMA 618
#define SCHEMAS 619
#define SCROLL 620
#define SEARCH 621
#define SECOND_P 622
#define SECURITY 623
#define SELECT 624
#define SEQUENCE 625
#define SEQUENCES 626
#define SERIALIZABLE 627
#define SERVER 628
#define SESSION 629
#define SESSION_USER 630
#define SET 631
#define SETS 632
#define SETOF 633
#define SHARE 634
#define SHOW 635
#define SIMILAR 636
#define SIMPLE 637
#define SKIP 638
#define SMALLINT 639
#define SNAPSHOT 640
#define SOME 641
#define SQL_P 642
#define STABLE 643
#define STANDALONE_P 644
#define START 645
#define STATEMENT 646
#define STATISTICS 647
#define STDIN 648
#define STDOUT 649
#define STORAGE 650
#define STORED 651
#define STRICT_P 652
#define STRIP_P 653
#define SUBSCRIPTION 654
#define SUBSTRING 655
#define SUPPORT 656
#define SYMMETRIC 657
#define SYSID 658
#define SYSTEM_P 659
#define TABLE 660
#define TABLES 661
#define TABLESAMPLE 662
#define TABLESPACE 663
#define TEMP 664
#define TEMPLATE 665
#define TEMPORARY 666
#define TEXT_P 667
#define THEN 668
#define TIES 669
#define TIME 670
#define TIMESTAMP 671
#define TO 672
#define TRAILING 673
#define TRANSACTION 674
#define TRANSFORM 675
#define TREAT 676
#define TRIGGER 677
#define TRIM 678
#define TRUE_P 679
#define TRUNCATE 680
#define TRUSTED 681
#define TYPE_P 682
#define TYPES_P 683
#define UESCAPE 684
#define UNBOUNDED 685
#define UNCOMMITTED 686
#define UNENCRYPTED 687
#define UNION 688
#define UNIQUE 689
#define UNKNOWN 690
#define UNLISTEN 691
#define UNLOGGED 692
#define UNTIL 693
#define UPDATE 694
#define USER 695
#define USING 696
#define VACUUM 697
#define VALID 698
#define VALIDATE 699
#define VALIDATOR 700
#define VALUE_P 701
#define VALUES 702
#define VARCHAR 703
#define VARIADIC 704
#define VARYING 705
#define VERBOSE 706
#define VERSION_P 707
#define VIEW 708
#define VIEWS 709
#define VOLATILE 710
#define WHEN 711
#define WHERE 712
#define WHITESPACE_P 713
#define WINDOW 714
#define WITH 715
#define WITHIN 716
#define WITHOUT 717
#define WORK 718
#define WRAPPER 719
#define WRITE 720
#define XML_P 721
#define XMLATTRIBUTES 722
#define XMLCONCAT 723
#define XMLELEMENT 724
#define XMLEXISTS 725
#define XMLFOREST 726
#define XMLNAMESPACES 727
#define XMLPARSE 728
#define XMLPI 729
#define XMLROOT 730
#define XMLSERIALIZE 731
#define XMLTABLE 732
#define YEAR_P 733
#define YES_P 734
#define ZONE 735
#define NOT_LA 736
#define NULLS_LA 737
#define WITH_LA 738
#define MODE_TYPE_NAME 739
#define MODE_PLPGSQL_EXPR 740
#define MODE_PLPGSQL_ASSIGN1 741
#define MODE_PLPGSQL_ASSIGN2 742
#define MODE_PLPGSQL_ASSIGN3 743
#define UMINUS 744

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 266 "gram_minimal.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 1397 "gram_minimal.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int minimal_base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1427 "gram_minimal.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  907
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   111518

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  507
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  690
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3212
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6106

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   744

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   496,     2,     2,
     501,   502,   494,   492,   505,   493,   503,   495,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   506,   504,
     489,   491,   490,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   499,     2,   500,   497,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   498
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   893,   893,   897,   901,   906,   914,   922,   942,   954,
     968,   969,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1098,  1107,  1123,  1135,
    1136,  1137,  1146,  1147,  1151,  1152,  1156,  1161,  1165,  1175,
    1183,  1187,  1191,  1196,  1200,  1248,  1250,  1254,  1258,  1262,
    1266,  1280,  1299,  1308,  1320,  1321,  1325,  1334,  1343,  1352,
    1374,  1382,  1390,  1398,  1406,  1414,  1432,  1451,  1463,  1464,
    1475,  1486,  1497,  1513,  1532,  1533,  1537,  1544,  1552,  1553,
    1554,  1555,  1556,  1557,  1571,  1578,  1585,  1592,  1602,  1611,
    1620,  1624,  1633,  1642,  1650,  1661,  1662,  1671,  1683,  1691,
    1700,  1712,  1721,  1730,  1738,  1748,  1759,  1760,  1764,  1765,
    1768,  1770,  1774,  1775,  1776,  1777,  1781,  1782,  1783,  1789,
    1801,  1805,  1809,  1826,  1834,  1835,  1836,  1840,  1841,  1842,
    1846,  1847,  1851,  1852,  1861,  1862,  1870,  1878,  1889,  1897,
    1908,  1909,  1914,  1915,  1921,  1927,  1933,  1940,  1947,  1954,
    1961,  1972,  1983,  1984,  1988,  1989,  1997,  2013,  2020,  2027,
    2034,  2041,  2061,  2071,  2081,  2091,  2101,  2113,  2125,  2135,
    2145,  2155,  2167,  2179,  2189,  2199,  2209,  2219,  2229,  2239,
    2251,  2263,  2273,  2286,  2287,  2292,  2306,  2319,  2335,  2352,
    2362,  2372,  2382,  2392,  2402,  2411,  2420,  2429,  2439,  2449,
    2465,  2475,  2485,  2495,  2505,  2522,  2532,  2542,  2552,  2563,
    2577,  2593,  2602,  2611,  2626,  2635,  2646,  2657,  2665,  2674,
    2683,  2691,  2699,  2708,  2717,  2726,  2734,  2742,  2751,  2759,
    2767,  2776,  2785,  2794,  2803,  2812,  2821,  2832,  2840,  2849,
    2858,  2867,  2876,  2885,  2894,  2902,  2910,  2918,  2925,  2936,
    2937,  2941,  2942,  2943,  2947,  2956,  2960,  2961,  2965,  2973,
    2981,  2989,  3000,  3003,  3004,  3008,  3009,  3014,  3018,  3022,
    3027,  3034,  3036,  3041,  3045,  3049,  3060,  3068,  3121,  3134,
    3148,  3160,  3167,  3171,  3185,  3198,  3199,  3204,  3214,  3225,
    3236,  3263,  3270,  3304,  3340,  3363,  3364,  3368,  3369,  3378,
    3379,  3380,  3383,  3384,  3389,  3390,  3394,  3398,  3402,  3406,
    3410,  3414,  3418,  3422,  3426,  3430,  3434,  3438,  3442,  3451,
    3455,  3459,  3463,  3467,  3468,  3473,  3477,  3484,  3491,  3492,
    3493,  3494,  3495,  3499,  3503,  3511,  3522,  3542,  3562,  3583,
    3604,  3625,  3659,  3660,  3661,  3662,  3663,  3670,  3677,  3678,
    3682,  3683,  3687,  3688,  3692,  3696,  3703,  3707,  3714,  3715,
    3716,  3720,  3721,  3724,  3747,  3766,  3788,  3789,  3793,  3794,
    3798,  3799,  3803,  3811,  3812,  3813,  3845,  3853,  3861,  3874,
    3886,  3899,  3911,  3921,  3945,  3965,  3966,  3967,  3971,  3972,
    3991,  3999,  4007,  4015,  4027,  4039,  4040,  4041,  4045,  4046,
    4047,  4048,  4049,  4050,  4051,  4052,  4053,  4054,  4063,  4071,
    4075,  4089,  4107,  4123,  4140,  4156,  4176,  4199,  4200,  4204,
    4205,  4209,  4210,  4213,  4219,  4220,  4223,  4227,  4235,  4240,
    4246,  4247,  4251,  4256,  4263,  4264,  4268,  4278,  4288,  4296,
    4305,  4318,  4330,  4337,  4345,  4353,  4361,  4369,  4379,  4380,
    4384,  4385,  4388,  4400,  4401,  4404,  4415,  4426,  4440,  4441,
    4446,  4447,  4448,  4451,  4452,  4453,  4454,  4457,  4458,  4461,
    4462,  4465,  4483,  4496,  4518,  4519,  4522,  4528,  4534,  4551,
    4560,  4582,  4596,  4613,  4629,  4630,  4631,  4643,  4657,  4674,
    4688,  4689,  4701,  4722,  4733,  4747,  4756,  4768,  4769,  4772,
    4773,  4776,  4777,  4780,  4784,  4788,  4792,  4796,  4800,  4804,
    4808,  4812,  4816,  4820,  4825,  4829,  4833,  4839,  4840,  4844,
    4845,  4846,  4853,  4856,  4857,  4869,  4885,  4901,  4902,  4910,
    4911,  4915,  4916,  4920,  4921,  4925,  4926,  4930,  4931,  4941,
    4953,  4954,  4967,  4975,  4993,  5002,  5014,  5017,  5021,  5025,
    5029,  5036,  5048,  5059,  5062,  5066,  5079,  5089,  5099,  5109,
    5119,  5129,  5139,  5149,  5159,  5169,  5179,  5189,  5199,  5218,
    5230,  5231,  5232,  5233,  5237,  5238,  5242,  5243,  5253,  5262,
    5275,  5276,  5280,  5284,  5292,  5296,  5300,  5307,  5311,  5316,
    5321,  5328,  5335,  5340,  5350,  5363,  5379,  5380,  5385,  5386,
    5390,  5391,  5401,  5411,  5420,  5438,  5459,  5480,  5502,  5536,
    5552,  5553,  5557,  5566,  5581,  5591,  5604,  5605,  5617,  5626,
    5644,  5669,  5687,  5702,  5703,  5707,  5708,  5712,  5713,  5717,
    5718,  5722,  5736,  5740,  5741,  5745,  5746,  5747,  5748,  5749,
    5759,  5771,  5772,  5783,  5806,  5838,  5839,  5840,  5844,  5846,
    5868,  5870,  5872,  5874,  5876,  5881,  5882,  5886,  5887,  5891,
    5903,  5904,  5908,  5917,  5921,  5925,  5930,  5940,  5941,  5945,
    5946,  5950,  5951,  5955,  5956,  5960,  5961,  5962,  5966,  5970,
    5971,  5972,  5976,  5977,  5982,  5983,  6010,  6011,  6012,  6013,
    6014,  6015,  6028,  6039,  6054,  6056,  6061,  6066,  6068,  6073,
    6084,  6085,  6086,  6087,  6098,  6117,  6129,  6142,  6153,  6164,
    6176,  6185,  6193,  6201,  6211,  6221,  6231,  6241,  6251,  6262,
    6272,  6285,  6288,  6289,  6292,  6296,  6303,  6304,  6305,  6306,
    6307,  6308,  6311,  6314,  6315,  6323,  6330,  6331,  6334,  6336,
    6347,  6359,  6371,  6383,  6397,  6398,  6414,  6430,  6431,  6435,
    6448,  6459,  6468,  6478,  6488,  6489,  6492,  6493,  6496,  6497,
    6498,  6501,  6515,  6520,  6531,  6541,  6554,  6555,  6559,  6568,
    6581,  6592,  6606,  6617,  6640,  6651,  6670,  6681,  6692,  6703,
    6714,  6725,  6736,  6747,  6758,  6769,  6780,  6791,  6806,  6807,
    6808,  6809,  6810,  6811,  6812,  6813,  6814,  6815,  6816,  6817,
    6818,  6828,  6829,  6830,  6831,  6832,  6836,  6837,  6838,  6839,
    6840,  6841,  6842,  6843,  6848,  6849,  6850,  6854,  6855,  6858,
    6859,  6862,  6864,  6869,  6870,  6881,  6893,  6894,  6895,  6905,
    6914,  6923,  6932,  6941,  6950,  6959,  6968,  6977,  6986,  7000,
    7009,  7018,  7027,  7036,  7045,  7054,  7063,  7075,  7076,  7090,
    7101,  7112,  7123,  7134,  7145,  7156,  7167,  7178,  7189,  7202,
    7203,  7206,  7207,  7217,  7224,  7233,  7242,  7251,  7260,  7269,
    7278,  7287,  7296,  7305,  7314,  7323,  7332,  7341,  7350,  7359,
    7368,  7379,  7380,  7383,  7384,  7394,  7412,  7428,  7456,  7458,
    7460,  7462,  7470,  7480,  7481,  7484,  7492,  7500,  7508,  7515,
    7526,  7530,  7537,  7541,  7552,  7561,  7570,  7579,  7588,  7597,
    7606,  7615,  7624,  7633,  7642,  7651,  7660,  7668,  7677,  7686,
    7695,  7704,  7713,  7722,  7731,  7744,  7745,  7749,  7750,  7755,
    7756,  7766,  7780,  7791,  7804,  7805,  7808,  7809,  7819,  7830,
    7831,  7835,  7839,  7843,  7854,  7868,  7883,  7901,  7902,  7903,
    7904,  7905,  7906,  7918,  7950,  7985,  7986,  7990,  7991,  7995,
    7996,  8000,  8001,  8004,  8005,  8010,  8022,  8041,  8046,  8051,
    8058,  8059,  8062,  8063,  8066,  8067,  8070,  8071,  8074,  8075,
    8076,  8079,  8080,  8081,  8097,  8111,  8126,  8140,  8157,  8158,
    8161,  8162,  8166,  8167,  8171,  8172,  8177,  8191,  8199,  8207,
    8223,  8224,  8228,  8229,  8244,  8254,  8264,  8274,  8284,  8297,
    8298,  8299,  8300,  8301,  8307,  8311,  8326,  8327,  8333,  8343,
    8347,  8352,  8360,  8402,  8406,  8410,  8414,  8422,  8423,  8427,
    8439,  8440,  8445,  8446,  8451,  8452,  8459,  8463,  8467,  8471,
    8475,  8479,  8483,  8487,  8491,  8495,  8499,  8503,  8507,  8511,
    8515,  8519,  8524,  8531,  8535,  8539,  8543,  8547,  8553,  8554,
    8560,  8570,  8574,  8585,  8591,  8600,  8606,  8607,  8611,  8612,
    8616,  8617,  8620,  8633,  8637,  8652,  8661,  8670,  8683,  8684,
    8689,  8690,  8707,  8718,  8729,  8740,  8751,  8762,  8776,  8787,
    8801,  8812,  8826,  8834,  8836,  8838,  8843,  8845,  8850,  8851,
    8856,  8875,  8885,  8886,  8890,  8894,  8906,  8918,  8930,  8944,
    8945,  8946,  8950,  8963,  8964,  8974,  8987,  8991,  8995,  8999,
    9006,  9027,  9040,  9053,  9066,  9081,  9082,  9085,  9086,  9087,
    9097,  9107,  9125,  9135,  9145,  9155,  9165,  9175,  9185,  9195,
    9205,  9215,  9225,  9235,  9245,  9256,  9267,  9277,  9287,  9297,
    9307,  9317,  9327,  9338,  9349,  9360,  9371,  9382,  9393,  9404,
    9415,  9426,  9437,  9448,  9459,  9471,  9483,  9495,  9507,  9519,
    9531,  9542,  9553,  9565,  9577,  9588,  9599,  9608,  9618,  9628,
    9638,  9648,  9658,  9668,  9678,  9688,  9698,  9713,  9714,  9717,
    9718,  9728,  9738,  9748,  9758,  9769,  9779,  9791,  9792,  9802,
    9812,  9822,  9832,  9842,  9852,  9862,  9872,  9882,  9892,  9902,
    9912,  9922,  9932,  9942,  9952,  9962,  9972,  9982,  9992, 10002,
   10012, 10022, 10032, 10042, 10052, 10062, 10081, 10091, 10092, 10095,
   10097, 10103, 10104, 10105, 10106, 10107, 10119, 10135, 10144, 10153,
   10162, 10171, 10180, 10189, 10198, 10207, 10216, 10225, 10234, 10243,
   10252, 10261, 10270, 10279, 10288, 10297, 10306, 10315, 10324, 10333,
   10342, 10370, 10378, 10387, 10413, 10422, 10429, 10435, 10462, 10473,
   10482, 10490, 10492, 10514, 10522, 10532, 10542, 10561, 10580, 10590,
   10600, 10610, 10621, 10632, 10643, 10654, 10665, 10683, 10692, 10709,
   10727, 10728, 10729, 10734, 10740, 10749, 10750, 10751, 10752, 10753,
   10757, 10758, 10761, 10762, 10763, 10764, 10768, 10769, 10770, 10782,
   10793, 10794, 10797, 10807, 10814, 10834, 10843, 10851, 10860, 10869,
   10877, 10885, 10893, 10901, 10909, 10917, 10925, 10936, 10944, 10955,
   10956, 10957, 10961, 10964, 10967, 10970, 10973, 10980, 10982, 10984,
   10989, 10991, 10995, 10996, 10997, 11009, 11023, 11037, 11056, 11078,
   11079, 11080, 11081, 11091, 11108, 11119, 11120, 11124, 11125, 11129,
   11133, 11137, 11155, 11156, 11157, 11158, 11159, 11160, 11161, 11168,
   11169, 11180, 11188, 11196, 11205, 11215, 11233, 11242, 11251, 11260,
   11272, 11276, 11287, 11299, 11317, 11324, 11341, 11355, 11365, 11374,
   11383, 11393, 11405, 11417, 11428, 11429, 11440, 11451, 11463, 11475,
   11487, 11499, 11509, 11522, 11523, 11537, 11562, 11574, 11583, 11595,
   11609, 11610, 11622, 11643, 11654, 11666, 11678, 11682, 11689, 11690,
   11694, 11701, 11702, 11706, 11707, 11708, 11712, 11713, 11717, 11718,
   11721, 11722, 11725, 11726, 11730, 11731, 11735, 11742, 11744, 11749,
   11750, 11763, 11771, 11782, 11790, 11801, 11802, 11803, 11804, 11805,
   11806, 11807, 11808, 11809, 11810, 11820, 11831, 11832, 11836, 11837,
   11838, 11839, 11840, 11850, 11858, 11876, 11896, 11897, 11907, 11914,
   11921, 11928, 11945, 11956, 11977, 11981, 11989, 11995, 12002, 12008,
   12015, 12024, 12025, 12029, 12031, 12036, 12047, 12057, 12067, 12073,
   12082, 12091, 12097, 12098, 12109, 12124, 12125, 12136, 12147, 12148,
   12151, 12152, 12153, 12154, 12155, 12156, 12157, 12158, 12161, 12162,
   12166, 12167, 12168, 12179, 12196, 12211, 12212, 12216, 12221, 12245,
   12256, 12257, 12269, 12287, 12288, 12292, 12299, 12306, 12313, 12323,
   12336, 12337, 12341, 12354, 12367, 12376, 12385, 12394, 12403, 12415,
   12427, 12439, 12442, 12443, 12444, 12445, 12446, 12447, 12450, 12451,
   12452, 12500, 12501, 12505, 12506, 12521, 12522, 12529, 12537, 12545,
   12553, 12561, 12569, 12580, 12581, 12613, 12629, 12646, 12647, 12666,
   12670, 12674, 12689, 12696, 12703, 12713, 12714, 12717, 12733, 12734,
   12735, 12739, 12749, 12760, 12766, 12778, 12791, 12797, 12798, 12802,
   12814, 12822, 12827, 12832, 12837, 12842, 12850, 12858, 12863, 12868,
   12875, 12876, 12880, 12881, 12882, 12889, 12890, 12894, 12895, 12899,
   12900, 12904, 12905, 12909, 12913, 12914, 12917, 12926, 12939, 12944,
   12949, 12953, 12965, 12966, 12970, 12979, 12995, 13004, 13013, 13022,
   13034, 13037, 13042, 13043, 13051, 13071, 13072, 13074, 13079, 13080,
   13084, 13085, 13088, 13089, 13114, 13123, 13133, 13134, 13138, 13139,
   13140, 13141, 13142, 13146, 13159, 13166, 13173, 13180, 13181, 13185,
   13186, 13190, 13191, 13195, 13196, 13200, 13212, 13213, 13214, 13215,
   13219, 13220, 13230, 13237, 13256, 13257, 13261, 13262, 13268, 13273,
   13282, 13290, 13299, 13306, 13314, 13350, 13376, 13380, 13406, 13410,
   13424, 13445, 13467, 13480, 13497, 13503, 13508, 13514, 13521, 13522,
   13532, 13538, 13546, 13550, 13554, 13561, 13569, 13574, 13575, 13576,
   13577, 13581, 13582, 13597, 13601, 13609, 13616, 13623, 13630, 13637,
   13648, 13649, 13662, 13666, 13674, 13688, 13702, 13703, 13718, 13729,
   13742, 13747, 13748, 13751, 13752, 13755, 13756, 13761, 13762, 13767,
   13768, 13777, 13782, 13783, 13787, 13791, 13797, 13822, 13833, 13847,
   13848, 13852, 13866, 13923, 13937, 13939, 13944, 13946, 13948, 13950,
   13955, 13957, 13962, 13970, 13990, 13995, 14002, 14007, 14013, 14018,
   14027, 14029, 14032, 14036, 14037, 14038, 14039, 14040, 14041, 14046,
   14066, 14067, 14068, 14069, 14080, 14086, 14094, 14095, 14101, 14106,
   14111, 14116, 14121, 14126, 14131, 14136, 14142, 14148, 14154, 14161,
   14183, 14192, 14196, 14204, 14208, 14216, 14228, 14249, 14253, 14259,
   14263, 14276, 14284, 14294, 14296, 14298, 14300, 14302, 14304, 14309,
   14310, 14317, 14326, 14334, 14343, 14354, 14362, 14363, 14364, 14368,
   14370, 14372, 14374, 14376, 14378, 14380, 14385, 14390, 14396, 14404,
   14409, 14416, 14423, 14427, 14431, 14467, 14468, 14470, 14479, 14495,
   14497, 14499, 14501, 14503, 14505, 14507, 14509, 14511, 14513, 14515,
   14517, 14519, 14521, 14524, 14526, 14529, 14531, 14533, 14535, 14538,
   14543, 14552, 14557, 14566, 14571, 14580, 14585, 14595, 14604, 14613,
   14622, 14641, 14650, 14659, 14668, 14677, 14694, 14703, 14712, 14721,
   14730, 14739, 14748, 14752, 14756, 14764, 14772, 14780, 14788, 14809,
   14832, 14844, 14851, 14867, 14872, 14878, 14885, 14892, 14900, 14908,
   14934, 14936, 14938, 14940, 14942, 14944, 14946, 14948, 14950, 14952,
   14954, 14956, 14958, 14960, 14962, 14964, 14966, 14968, 14970, 14974,
   14978, 14983, 14999, 15000, 15001, 15018, 15031, 15033, 15035, 15047,
   15072, 15084, 15096, 15104, 15115, 15126, 15136, 15142, 15151, 15161,
   15171, 15184, 15194, 15225, 15261, 15272, 15273, 15280, 15287, 15291,
   15295, 15299, 15303, 15307, 15311, 15315, 15319, 15323, 15327, 15331,
   15335, 15339, 15343, 15347, 15349, 15356, 15363, 15370, 15377, 15388,
   15402, 15412, 15423, 15439, 15449, 15456, 15463, 15470, 15474, 15482,
   15491, 15500, 15504, 15508, 15512, 15516, 15520, 15529, 15533, 15543,
   15547, 15551, 15556, 15571, 15573, 15577, 15579, 15581, 15584, 15587,
   15590, 15591, 15594, 15602, 15612, 15613, 15616, 15617, 15618, 15623,
   15627, 15631, 15635, 15642, 15643, 15651, 15652, 15656, 15657, 15665,
   15666, 15670, 15671, 15676, 15685, 15687, 15702, 15705, 15733, 15734,
   15737, 15738, 15746, 15754, 15762, 15771, 15781, 15799, 15845, 15854,
   15863, 15872, 15881, 15893, 15894, 15895, 15896, 15897, 15911, 15912,
   15913, 15916, 15917, 15920, 15923, 15924, 15925, 15928, 15929, 15932,
   15933, 15934, 15935, 15936, 15937, 15938, 15939, 15940, 15941, 15942,
   15943, 15946, 15948, 15953, 15955, 15960, 15962, 15964, 15966, 15968,
   15970, 15982, 15986, 15993, 15997, 16003, 16007, 16017, 16029, 16030,
   16033, 16034, 16037, 16041, 16045, 16051, 16052, 16057, 16067, 16068,
   16069, 16070, 16071, 16072, 16073, 16074, 16078, 16079, 16080, 16081,
   16086, 16091, 16100, 16121, 16125, 16130, 16141, 16158, 16164, 16165,
   16166, 16169, 16177, 16187, 16202, 16203, 16207, 16219, 16220, 16223,
   16224, 16227, 16231, 16238, 16242, 16246, 16255, 16267, 16268, 16272,
   16273, 16277, 16278, 16281, 16282, 16292, 16293, 16297, 16298, 16301,
   16309, 16317, 16325, 16348, 16349, 16360, 16364, 16370, 16372, 16377,
   16379, 16381, 16391, 16393, 16404, 16408, 16412, 16416, 16420, 16429,
   16437, 16469, 16473, 16480, 16488, 16492, 16496, 16502, 16503, 16505,
   16506, 16507, 16511, 16552, 16580, 16584, 16588, 16594, 16596, 16610,
   16646, 16659, 16660, 16663, 16664, 16681, 16682, 16683, 16688, 16689,
   16690, 16695, 16696, 16697, 16698, 16704, 16705, 16706, 16707, 16708,
   16714, 16715, 16735, 16736, 16737, 16738, 16739, 16740, 16741, 16742,
   16743, 16744, 16745, 16746, 16747, 16748, 16749, 16750, 16751, 16752,
   16753, 16754, 16755, 16756, 16757, 16758, 16759, 16760, 16761, 16762,
   16763, 16764, 16765, 16766, 16767, 16768, 16769, 16770, 16771, 16772,
   16773, 16774, 16775, 16776, 16777, 16778, 16779, 16780, 16781, 16782,
   16783, 16784, 16785, 16786, 16787, 16788, 16789, 16790, 16791, 16792,
   16793, 16794, 16795, 16796, 16797, 16798, 16799, 16800, 16801, 16802,
   16803, 16804, 16805, 16806, 16807, 16808, 16809, 16810, 16811, 16812,
   16813, 16814, 16815, 16816, 16817, 16818, 16819, 16820, 16821, 16822,
   16823, 16824, 16825, 16826, 16827, 16828, 16829, 16830, 16831, 16832,
   16833, 16834, 16835, 16836, 16837, 16838, 16839, 16840, 16841, 16842,
   16843, 16844, 16845, 16846, 16847, 16848, 16849, 16850, 16851, 16852,
   16853, 16854, 16855, 16856, 16857, 16858, 16859, 16860, 16861, 16862,
   16863, 16864, 16865, 16866, 16867, 16868, 16869, 16870, 16871, 16872,
   16873, 16874, 16875, 16876, 16877, 16878, 16879, 16880, 16881, 16882,
   16883, 16884, 16885, 16886, 16887, 16888, 16889, 16890, 16891, 16892,
   16893, 16894, 16895, 16896, 16897, 16898, 16899, 16900, 16901, 16902,
   16903, 16904, 16905, 16906, 16907, 16908, 16909, 16910, 16911, 16912,
   16913, 16914, 16915, 16916, 16917, 16918, 16919, 16920, 16921, 16922,
   16923, 16924, 16925, 16926, 16927, 16928, 16929, 16930, 16931, 16932,
   16933, 16934, 16935, 16936, 16937, 16938, 16939, 16940, 16941, 16942,
   16943, 16944, 16945, 16946, 16947, 16948, 16949, 16950, 16951, 16952,
   16953, 16954, 16955, 16956, 16957, 16958, 16959, 16960, 16961, 16962,
   16963, 16964, 16965, 16966, 16967, 16968, 16969, 16970, 16971, 16972,
   16973, 16974, 16975, 16976, 16977, 16978, 16979, 16980, 16981, 16982,
   16983, 16984, 16985, 16986, 16987, 16988, 16989, 16990, 16991, 16992,
   16993, 16994, 16995, 16996, 16997, 16998, 16999, 17000, 17001, 17002,
   17003, 17004, 17005, 17006, 17007, 17008, 17009, 17010, 17011, 17012,
   17013, 17014, 17015, 17016, 17017, 17018, 17019, 17020, 17021, 17022,
   17023, 17024, 17025, 17026, 17027, 17028, 17029, 17030, 17031, 17032,
   17033, 17034, 17035, 17036, 17037, 17038, 17039, 17040, 17041, 17042,
   17043, 17057, 17058, 17059, 17060, 17061, 17062, 17063, 17064, 17065,
   17066, 17067, 17068, 17069, 17070, 17071, 17072, 17073, 17074, 17075,
   17076, 17077, 17078, 17079, 17080, 17081, 17082, 17083, 17084, 17085,
   17086, 17087, 17088, 17089, 17090, 17091, 17092, 17093, 17094, 17095,
   17096, 17097, 17098, 17099, 17100, 17101, 17102, 17103, 17104, 17105,
   17106, 17107, 17121, 17122, 17123, 17124, 17125, 17126, 17127, 17128,
   17129, 17130, 17131, 17132, 17133, 17134, 17135, 17136, 17137, 17138,
   17139, 17140, 17141, 17142, 17143, 17153, 17154, 17155, 17156, 17157,
   17158, 17159, 17160, 17161, 17162, 17163, 17164, 17165, 17166, 17167,
   17168, 17169, 17170, 17171, 17172, 17173, 17174, 17175, 17176, 17177,
   17178, 17179, 17180, 17181, 17182, 17183, 17184, 17185, 17186, 17187,
   17188, 17189, 17190, 17191, 17192, 17193, 17194, 17195, 17196, 17197,
   17198, 17199, 17200, 17201, 17202, 17203, 17204, 17205, 17206, 17207,
   17208, 17209, 17210, 17211, 17212, 17213, 17214, 17215, 17216, 17217,
   17218, 17219, 17220, 17221, 17222, 17223, 17224, 17225, 17226, 17227,
   17228, 17229, 17242, 17243, 17244, 17245, 17246, 17247, 17248, 17249,
   17250, 17251, 17252, 17253, 17254, 17255, 17256, 17257, 17258, 17259,
   17260, 17261, 17262, 17263, 17264, 17265, 17266, 17267, 17268, 17269,
   17270, 17271, 17272, 17273, 17274, 17275, 17276, 17277, 17278, 17279,
   17280, 17281, 17282, 17283, 17284, 17285, 17286, 17287, 17288, 17289,
   17290, 17291, 17292, 17293, 17294, 17295, 17296, 17297, 17298, 17299,
   17300, 17301, 17302, 17303, 17304, 17305, 17306, 17307, 17308, 17309,
   17310, 17311, 17312, 17313, 17314, 17315, 17316, 17317, 17318, 17319,
   17320, 17321, 17322, 17323, 17324, 17325, 17326, 17327, 17328, 17329,
   17330, 17331, 17332, 17333, 17334, 17335, 17336, 17337, 17338, 17339,
   17340, 17341, 17342, 17343, 17344, 17345, 17346, 17347, 17348, 17349,
   17350, 17351, 17352, 17353, 17354, 17355, 17356, 17357, 17358, 17359,
   17360, 17361, 17362, 17363, 17364, 17365, 17366, 17367, 17368, 17369,
   17370, 17371, 17372, 17373, 17374, 17375, 17376, 17377, 17378, 17379,
   17380, 17381, 17382, 17383, 17384, 17385, 17386, 17387, 17388, 17389,
   17390, 17391, 17392, 17393, 17394, 17395, 17396, 17397, 17398, 17399,
   17400, 17401, 17402, 17403, 17404, 17405, 17406, 17407, 17408, 17409,
   17410, 17411, 17412, 17413, 17414, 17415, 17416, 17417, 17418, 17419,
   17420, 17421, 17422, 17423, 17424, 17425, 17426, 17427, 17428, 17429,
   17430, 17431, 17432, 17433, 17434, 17435, 17436, 17437, 17438, 17439,
   17440, 17441, 17442, 17443, 17444, 17445, 17446, 17447, 17448, 17449,
   17450, 17451, 17452, 17453, 17454, 17455, 17456, 17457, 17458, 17459,
   17460, 17461, 17462, 17463, 17464, 17465, 17466, 17467, 17468, 17469,
   17470, 17471, 17472, 17473, 17474, 17475, 17476, 17477, 17478, 17479,
   17480, 17481, 17482, 17483, 17484, 17485, 17486, 17487, 17488, 17489,
   17490, 17491, 17492, 17493, 17494, 17495, 17496, 17497, 17498, 17499,
   17500, 17501, 17502, 17503, 17504, 17505, 17506, 17507, 17508, 17509,
   17510, 17511, 17512, 17513, 17514, 17515, 17516, 17517, 17518, 17519,
   17520, 17521, 17522, 17523, 17524, 17525, 17526, 17527, 17528, 17529,
   17530, 17531, 17532, 17533, 17534, 17535, 17536, 17537, 17538, 17539,
   17540, 17541, 17542, 17543, 17544, 17545, 17546, 17547, 17548, 17549,
   17550, 17551, 17552, 17553, 17554, 17555, 17556, 17557, 17558, 17559,
   17560, 17561, 17562, 17563, 17564, 17565, 17566, 17567, 17568, 17569,
   17570, 17571, 17572, 17573, 17574, 17575, 17576, 17577, 17578, 17579,
   17580, 17581, 17582, 17583, 17584, 17585, 17586, 17587, 17588, 17589,
   17590, 17591, 17592, 17593, 17594, 17595, 17596, 17597, 17598, 17599,
   17600, 17601, 17602, 17603, 17604, 17605, 17606, 17607, 17608, 17609,
   17610, 17611, 17612, 17613, 17614, 17615, 17616, 17617, 17618, 17619,
   17620, 17621, 17622, 17623, 17624, 17625, 17626, 17627, 17628, 17629,
   17630, 17631, 17632, 17633, 17634, 17635, 17636, 17637, 17638, 17639,
   17640, 17641, 17642, 17643, 17644, 17645, 17646, 17647, 17648, 17649,
   17650, 17651, 17652, 17653, 17654, 17655, 17656, 17657, 17658, 17659,
   17660, 17661, 17662
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "ATOMIC", "AT",
  "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BREADTH",
  "BY", "CACHE", "CALL", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COLUMNS", "COMMENT", "COMMENTS", "COMMIT",
  "COMMITTED", "COMPRESSION", "CONCURRENTLY", "CONFIGURATION", "CONFLICT",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH",
  "DESC", "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD",
  "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "METHOD",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC",
  "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY",
  "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED",
  "OWNER", "PARALLEL", "PARAMETER", "PARSER", "PARTIAL", "PARTITION",
  "PASSING", "PASSWORD", "PGPOOL", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP",
  "ROUTINE", "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES",
  "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED",
  "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "NOT_LA", "NULLS_LA", "WITH_LA", "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR",
  "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3",
  "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "parse_toplevel", "stmtmulti", "toplevel_stmt", "stmt", "CallStmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "AlterOptRoleList",
  "AlterOptRoleElem", "CreateOptRoleElem", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem_options", "index_elem", "opt_include",
  "index_including_params", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "function_with_argtypes_list",
  "function_with_argtypes", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "aggregate_with_argtypes",
  "aggregate_with_argtypes_list", "opt_createfunc_opt_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "ReturnStmt", "opt_routine_body", "routine_body_stmt_list",
  "routine_body_stmt", "transform_type_list", "opt_definition",
  "table_func_column", "table_func_column_list", "AlterFunctionStmt",
  "alterfunc_opt_list", "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt",
  "RemoveOperStmt", "oper_argtypes", "any_operator",
  "operator_with_argtypes_list", "operator_with_argtypes", "DoStmt",
  "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_type", "reindex_target_multitable", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "PublicationObjSpec", "pub_obj_list", "AlterPublicationStmt",
  "CreateSubscriptionStmt", "AlterSubscriptionStmt",
  "DropSubscriptionStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "TransactionStmtLegacy", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "InsertStmtShort", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "UpdateStmtShort", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "MergeStmt", "merge_when_list", "merge_when_clause",
  "opt_merge_when_condition", "merge_update", "merge_delete",
  "merge_insert", "merge_values_clause", "DeclareCursorStmt",
  "cursor_name", "cursor_options", "opt_hold", "SelectStmt",
  "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "func_arg_list_opt", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "unicode_normal_form",
  "overlay_list", "position_list", "substr_list", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "opt_slice_bound",
  "indirection", "opt_indirection", "opt_asymmetric", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "attr_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "PLpgSQL_Expr", "PLAssignStmt", "plassign_target", "plassign_equals",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "BareColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,    60,
      62,    61,    43,    45,    42,    47,    37,    94,   744,    91,
      93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5254

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5254)))

#define YYTABLE_NINF -2822

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2822)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   11489,  1672, 20618, -5254, -5254,  1672, 65768, -5254, 74850,   -11,
     186,    88,   205, 20101, 75328, 84888,  1083,   359, 16151,  1672,
   84888,  1752, 56686, 71026,   293, 84888,  1118,   937, 56686, 84888,
    1908, 85366,  1196,  1494,   175, 85844, 75806, 69592,  1311, 84888,
    1528,  1427, 86322, 76284,  1415, 76762,   937, 52886,   352,  1353,
   86800, 84888,108718,  1427, 77240, 77240, 77240,  2286,  1873,  1465,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,     5, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  2118, -5254,
     790,  2215,    45,   961,  1554, -5254, -5254,  2078, 65768, 84888,
   84888, 84888,  1805, 84888,  1740, 84888,   500, 65768, 61944, 77718,
    1924,  1747, 48960, 87278, -5254, 65768, 84888, 59554, 65768, 84888,
   84888, 87756, 84888, 88234, 84888,  1940, 73416, 84888,  1899, 84888,
   84888, 60032, 88712,  2065,  1489,   251, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
    1829,  1811, -5254,   262, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, 64334, 84888, 19863,  1118,  2078, -5254,  2286,
   84888,  2088, 84888,  1866, 89190, 84888, -5254, 84888,  1981, 89668,
     831,  2086, 61944,  2180, 49455,  2084, 84888, 84888, 61944, 90146,
   90624, 91102, 84888, 84888, -5254, -5254,  2052, 84888, -5254,  2188,
   62422,  1431,  2194,  2359,  2273,  1891, -5254, 78196, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, 65290,   359, -5254, -5254,
    2233, 66246,  2289, -5254, -5254, 91580,109182,  2077, -5254,   842,
   66724, 62900,  2451,  2091, 49950,  2504, -5254, 67202, -5254, 63378,
   67680, -5254, -5254, -5254, -5254, -5254, 92058, -5254, 92536,  2205,
    2289, -5254,109646, 63856, -5254,  2354, 93014, 93492, 93970,  2078,
    2092,  1174,  1749, 43616, -5254, -5254, -5254,  2146, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,  1249, -5254,   333,  1316,
     236,   216,   269, -5254, -5254,   228,   234,   249,   333,  2590,
    2590, -5254, 84888, -5254, -5254,  1316,   758,  2219,  2126,  2126,
    2126,  2416,    21, -5254,  2126,  2316, -5254, -5254, -5254, -5254,
   76762, -5254,  2144, 78674, 84888, 79152,  1118,  2243,  2672,  2281,
   -5254, -5254, -5254, -5254, -5254, 64334,  2667,  2667, 84888, -5254,
   -5254,  2730,  2353,  2577,  2310, -5254, -5254, -5254,  2528,  2536,
    2555,   157,  1118,   256, -5254,  2692, -5254,  2567, 29910, 29910,
    1118, 79630, 94448,   254, 65290,  1118, 80108,  2424,  1561,  2578,
   -5254, -5254, -5254,   635, -5254,  2833,  2455,  2722,  2310,  1489,
   45544, -5254, -5254,  2453,  1811, 76762, -5254, -5254, -5254, 64334,
    2784, 32380, 84888,  2460, -5254,  2474,  2460, -5254, -5254,  2506,
   -5254,  2506,  2506,  2475,  2475,  2668,  2501, -5254, -5254, -5254,
    1024,  2506,  2475, -5254,110574, -5254,  1636,  1736, -5254, -5254,
    2967, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  2538,
   -5254,  1007,  2110, -5254, -5254, -5254, 29910, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254,  2505,  2527,    45, -5254, 12723, 64334,
   84888,  1644,  1644,  2982,  1644,  1700,  1701, -5254,  2849, -5254,
    2872,  2839,  2844, 76762,  2573,   995, -5254,  1540,  2585,   133,
    2598,  1638,  2535, -5254,   753, 84888,   247,  2629, 80586,  4522,
    2601,  1811,  2609, -5254, -5254, -5254, -5254,  2739,  1480, -5254,
   -5254, -5254, -5254,  2915,  2960,  5982,   331, 81064, -5254, -5254,
   -5254, -5254, 84888, 84888, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254,  2614,  1414, -5254, -5254,  2611,  2963,  2831,
    6549,  1140,  2922,  2780,  1449, 10046,  2837,  1548,  2973,  7140,
    1516,  2974,  1915,  2098, 78674, 84888,  2932,  2976,  4192,  1799,
     227,  2850,  1003,  2922,  2966,  2788,  1449,  2985,  6467, 84888,
   -5254,  2914,  3027,   704, -5254,   383, -5254, 23541, 32380, 52408,
   -5254,  1811,  1723, -5254, -5254, 55730, -5254,  2707,  2864,   771,
   65768,  2651, 84888, 84888, -5254,108718, 65768, -5254,  2874, 50445,
   65768, -5254, 65768, -5254, -5254,  2995,108718, 84888, 84888, -5254,
   84888, -5254, -5254,  2661, -5254, -5254, -5254, -5254, -5254,  2126,
   84888,  3093,108718,  2894,   156,   901,  3129, 84888,  2896,   901,
    2705, 94926, -5254, -5254,   901, -5254, -5254, -5254, 84888, 84888,
    2671,  1496,  2888,   152,   901,  2904,  3130,  3131,  2908,  2753,
    2910,  2474,  3095,  2880,   945,   195,  2114,   901,  2732, 95404,
   95882, 84888,  2733, 84888,  2667, 65768,  2765, 65768, 65768, 84888,
    3022, 84888, -5254,  2868, -5254, -5254,  1155, -5254, -5254, -5254,
   -5254, -5254,  3040, -5254,   210,  3041,  2695,  3045,  1817,  3050,
     214, -5254, -5254,  2742, -5254,  3055,   226, -5254,  3056, -5254,
    2706, 96360, -5254, 96838, 97316,  3064,   265, -5254, 61944,  3067,
     226,  3069,  2706,  3072,   226,  3073,   317,  3077, -5254,  1035,
    3030,  3081,   214,  3083,  2115,  2706, -5254,  3084,   287, -5254,
    3085,   327, -5254,  3086,  2955, -5254, 32380, -5254,  2838, -5254,
    1353,  1920,  1749,  3033, 76762,  1316, -5254, 84888,  1316, 84888,
    1316, 84888,  1316, 84888,  1316, 84888, 84888, 84888,  1316, -5254,
   -5254, -5254, 84888,  2749, 84888, -5254, 84888, -5254, -5254, -5254,
   72460, 61944, 72938, -5254, 84888, -5254,   121,  1118, -5254, -5254,
   -5254,  1438, -5254,  2310, -5254,108718,  3214, 61944,  2667,  1949,
   -5254, 84888, 84888, -5254, -5254, -5254,  3021, 84888,  3087,  3090,
   72460, 61944, -5254, 97794, -5254, 65290,  2972,  2758, -5254, -5254,
   -5254, -5254, -5254,  2174,  3254,   233,  3255, 32380,  2762,   233,
     233,  2763,  3098, -5254, -5254, -5254,   267,  2767,  2769, -5254,
     253,   253, -5254,  2771,  2772, -5254,   278,  2777,  2779,  3275,
    3277,   279,  2783,  2785,  2786,  1024,   233,  2789, 32380, -5254,
    2791,   253,  2792,  2795,  2796,  3279,  2797, -5254,  3283,  2799,
     310,   332,  2800,  2801, -5254,  3025, -5254,   280,  2803,  2804,
    2805,  2807,  2809,  2810,  2811,  2812, 32380, 32380, 32380, -5254,
   27435,  1811,  1118, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254,   294, 48465, -5254,  2853, -5254, -5254,  3020, -5254, -5254,
   32380, -5254, -5254,   119, -5254,   296, -5254, -5254, -5254,  1811,
    3103,  2815, -5254, -5254,   957,  2817, -5254,  2256, -5254, -5254,
   -5254, -5254, -5254, -5254, 64812,  3286, -5254,   328,  1118,   383,
    1944,  3223, 54774, 55252, -5254, -5254,  3094, -5254, 84888, -5254,
   -5254,  1811,   163,  1991, -5254,  2146, 19232,  2010,  2460, 84888,
   84888,  3291, -5254,  2828, -5254, -5254, 32380, -5254, -5254, -5254,
    2590, -5254,  2506,  2506, -5254, -5254,  3297,  2920,  2921,  2590,
   -5254,  2590, -5254,  2840,  2841,  2590,  2924,  2925,  2926, -5254,
    2836,  2928,  2590, -5254, -5254, 57642,  2213, -5254,  3166,   358,
   -5254, -5254, -5254,  2029, -5254,  2845, -5254,  2474, -5254, -5254,
      45,    45, 32380,    45,   272,  1755, 30404, 32874,  3179,  3071,
    1272,   261,  3185, -5254,  3074,  1700,  1701, 76762, 84888, 76762,
   98272, -5254, 32380, -5254,  3293,  2944,  2948,  2999, 53842, -5254,
    2949,  2916,  2952,  3007,  2870,  2954,  2959,  3015, -5254,  3147,
   -5254, -5254,  2970,  3037,  3306,  2971, 98750, -5254, -5254,   315,
   -5254, -5254, -5254,   315, -5254,  2899,  1406,  1029,   311,  2975,
     438,   850,  3301, -5254,  1424, -5254, -5254,  3031, -5254, 12275,
   84888,  3242,  7849,  3112,   331,  3032, -5254, -5254, -5254,  3170,
    2988, 84888,  2992,  3134,   331,   312, 99228, -5254, -5254, 84888,
   -5254, -5254, -5254, -5254,  5167,  3285, 26507, -5254,  1885,  2997,
    2977,  3004, 84888, 68636,  2128,  3109,  3132,  1630,  2241,   715,
    3060, 84888,  1567,  3139, 84888,  2929,  3006,  3010,  3243,  2930,
     688,  3343,  2934, -5254, -5254, -5254,  3309, -5254,   459,  1848,
    3135, -5254,  3246,  3290,  8393,  3005,  3008,107326, -5254,  3028,
      47, 50940, 84888, 84888,  3034,  3043, 99706,  5167,  3321, 71504,
   71504,  3046,  3047, 44580,  3338,  1756,  3048, -5254, -5254, -5254,
    1756,  3049,  3051,100184,  5167,  3331, 84888,  3057,  3058, 84888,
  110574,   331, -5254,  3409,   331,   331,  2042,  3428,  3070,   345,
    3232,   795,   901,  2934,  3294, -5254,  3075,  3078,   334, -5254,
    3200, 84888,  3079,  3080,  1763,  3164,  1118, -5254,  3171, -5254,
    3088,  3175,  3092,   820,  2671, -5254, -5254,  3099, 76762,  3196,
    3203,  1567,   225,  1105,  2934, -5254,  3096,  3097,  2930,  2930,
   84888, 84888, 84888, 84888, 84888,   235,  3466,  3469,  3100,   452,
     882,  3011, -5254,  1756, 60510,  3102, -5254,  1756, 84888,   219,
    1114,  2934,  1659,  1950, -5254, -5254, -5254,  1489, -5254, 32380,
   32380, 32380,  3018, -5254,  2498, 19232,    86, -5254,   299, 14463,
    3017, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, 84888, 64334, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, 84888, -5254, 84888,  3303,
  108718,  3308,  3241,  3310,  3325,   331, 84888, 84888,  3327,  3329,
    3332,108718,  3333,  3334,  3335,  3262,  3137,   171,  3122,  3059,
    3519,  3405, 84888, 57642, -5254,   315, -5254,108718,  3273,  3410,
   -5254, 84888,  3296,    76, -5254,  3444,  3140, -5254, -5254,  1152,
   84888, 71982,  2671, -5254, -5254,  3417, 61944,   336,  3418,  1118,
    3120,  3420,  3289,  1118, 61944,  3340, 84888, 84888, 84888, 84888,
     150, -5254, 60510,  3312, -5254, 84888,  3313,  3294,  3314,  3549,
     747,  2126,100662,  3421,101140,  3089, 84888,  3101,  3101,  3550,
  108718,  1537,  3365, -5254, -5254,  2264, -5254,  3228, -5254, 65768,
   -5254, -5254, 65768, -5254, -5254,108718, 84888,  3104,108718,108718,
   -5254, -5254, 65768, 65768, -5254, 61944, 61944,  3441,   287,  3445,
    3158,  3447,  3167, 50940, 50940, -5254,   329, 65768, -5254, 61944,
   65768, -5254, 84888, -5254, 84888, -5254, -5254, -5254, -5254,108718,
  108718, -5254, 61944, 60510,  3454, 84888, 84888, -5254, 84888, 84888,
   -5254, 84888, 84888,  2037,101618,  1749, -5254, 84888,  3235, 84888,
   -5254, 84888, -5254, 84888, -5254, 84888, -5254, 84888, -5254, -5254,
   -5254, 84888, -5254, 84888,  2051, -5254, -5254,  2055,  1067, 84888,
   84888,   903, 65768, 84888,  3336, 84888, 65768, 65768, 84888, 84888,
   84888, 84888, 84888,  3195,  2817,  1271, -5254,   277,   376, 76762,
    3344, -5254, -5254,  2074,  2286,  1207, 84888,  1399, -5254, -5254,
   -5254, -5254, 72938, 71026,  3443,   371, 84888, -5254, -5254,  9245,
   32380,  1811, 29411, -5254, -5254, 19232,  3157, 32380, 32380,  3117,
    2590,  2590, -5254,   286, 32380, 32380, 32380,  2590,  2590, 32380,
    6383, 32380, 50940, 32380, 37814, 24541, 32380, 32380, 27929,  1210,
    2771, 32380,  3366, 38796, 32380,  1944,  3367, 32380,  1944,  6383,
    3608,  3608,  2437,  6956,  3119,  1811, -5254,  2590,   974, -5254,
     326,108718, 32380, 32380, 32380, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, 32380,
   -5254, 57642, -5254, -5254, -5254, -5254, -5254, -5254,  3212, -5254,
   -5254, -5254, -5254, -5254, -5254,  4500, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, 84888,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, 28423, -5254, -5254, -5254, -5254,  3125, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254,  4086, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, 28917, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254,  3127, -5254, -5254, 32380, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  3213, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  1293,
   32380, 32380, 32380, 32380, 32380, 32380, 32380, 32380, 32380, -5254,
   32380,   458, -5254, -5254,  3448,  3470,  1076,   554, 81542, 29910,
    3166, 23541, -5254,   268,  3166, -5254, -5254, -5254, 84888,  3286,
   -5254, -5254,  3215, -5254, -5254, -5254, -5254, -5254,   302, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,  3128, -5254, -5254, -5254,
   -5254,  3128, -5254,  3133,  3449,  3450,   317, 84888,  2490, 32380,
    3212,   270, 84888, 32380,  3125,  4086, 32380,  3127, 32380,  3213,
   -5254, 32380, -5254,  2100,   211, 32380,  2113,  3142, -5254, -5254,
    3138,  2841,  3156,  3162,  3143,  3144,  2590,   224,  3146,   202,
    1202,  3282,  2590,  3397,  3150, -5254, 57642, -5254, 40724,  3197,
   -5254, -5254, -5254,  1427, 84888, 84888, -5254,  3439, -5254,  3151,
   -5254, 14525,  3439, -5254, -5254, 38305,  3276,  3435,  3371, -5254,
   -5254, -5254,  3154, 19232, 33368, 33368, -5254,  1942, 19232,  2283,
   -5254, -5254, -5254, -5254, -5254, -5254,   749, -5254, 84888,   162,
    3179,   261,  3220, -5254,  3625,  3222, 84888, -5254,  2117, -5254,
   61944, 84888, 84888,  3370, -5254,  3609, -5254,110574, -5254,  3169,
   -5254,110110,105920, -5254, -5254,    59, -5254,   973, 61944, -5254,
   84888, 84888, 61944, 84888, 84888, -5254, 61944,  3217, 84888, 84888,
   -5254, -5254, -5254, -5254, -5254, 56208,   890, 71026,  3311, 70070,
   -5254, -5254,  3165, 84888,  3231,  3453,  3456,   115, -5254, -5254,
  102096, -5254,  3400, 61944, 84888, 84888, 32380,  3403, 84888, 84888,
   -5254,   289,  3263,  3264, -5254, 84888,  3266, 65768,  3184,108718,
   65768, 51435, 65768, 65768,  3521,108718, 84888, 84888,  1655, 76762,
     242,  1138,  2934,  3413, -5254,   896, -5254, 61944, -5254, 84888,
    3404, -5254, -5254, -5254, 82020,  3639,  3316, -5254, -5254, -5254,
  102574, -5254, -5254,  3408, -5254,  2127, -5254, 61944, 61944, 84888,
    9081,103052,    -2,  3424, -5254, -5254,108718, -5254, 84888, 82498,
   84888, 84888,  3459, 84888, 73894,103530,104008,   676,  1253,  3464,
   84888, 74372,  3465, -5254,  3339, 84888, -5254, -5254, 58120, 61944,
   84888,   862, 57642, -5254,  3460, -5254, 84888, -5254,   899, -5254,
   84888,  4284,  3423, -5254, -5254,  3298,  3315, 84888,   243,  1164,
    2934,  3573, 84888, 84888,  3206,  2133, 61944, 84888, 57642, -5254,
    3431,  1123, 61944, 84888, 82020, -5254,  3432,  3318, -5254, 76762,
   -5254,  3209,  2126,  2453,  2087,  3209, 61944, 84888, -5254,  3209,
   84888, 94448, -5254, 61944,   954, -5254, 61944, 84888, 82020, -5254,
    3433,  3379, 61944, 84888,  8541, -5254, -5254, -5254,   331, -5254,
   -5254, -5254, -5254, -5254, 84888, 84888,   331, 84888, 84888,   331,
    1472, -5254, 61944, 84888, -5254, -5254, -5254,  3352, 61944, 84888,
   84888,   333, 84888, -5254, 84888, 61944,  3272, 84888, 84888, -5254,
   -5254, 84888,  5885, 84888, 84888, 84888, 84888, 84888, 84888, 61944,
   84888, -5254, -5254,  1177,  1451,  1787,  1850,  1266, 84888,  3543,
   84888,104486, 61944, 84888, 84888,  1118, 84888, 57642,  1693, -5254,
   -5254,  3361, -5254, 61944,   954, -5254,  9675, 84888, 84888, 84888,
    3319,  3322,   191,  3411, -5254, -5254, -5254,    89,    89,  3446,
   -5254, 32380, 32380, 30898,  3238, -5254, -5254, 32380,  2707, -5254,
   -5254, -5254,   339,  3706,   339,104964,   339,   339,  3526,  3304,
    3305,   339,   339,   339,  3524,   339,   339,   339, 84888,  3427,
   -5254, -5254,  3427,   182, 32380,108718, 84888, -5254,  2135, -5254,
    3258, -5254, -5254, 57642, 84888,   241,   176,  3602,  3475, 69114,
    2218,  3593, 84888,  3320, 84888,  3724,  3357,  1366, -5254,  2218,
   84888, -5254,  1341, 71026, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, 84888, -5254, -5254,  3595, 84888, 41206,  3438, -5254,  1118,
    2671,  2671,  2671,  2671,  3267,  2671, 84888,  3396,  3618,  2218,
    3278,  3624, -5254,  3294,  3628,  1882, 84888,  3497, 69114,  3341,
    3324,  3514,  3749,  2126,  1118,  3517,  3503, -5254, 54308, -5254,
    2671,  3764, 26971,  6660,  7855,  3507,  3572, -5254, -5254,  3516,
     777, 84888,  3613,  3614,  3635, -5254,   210, -5254,  3766,  1817,
    3636,   214, -5254,   226, -5254,  2706, -5254, 84888, -5254, 84888,
   84888, 84888, 84888,   265, -5254, -5254,   226,  2706,   226,   317,
   -5254,  3581,   214,  2706,  3434,  3646,   287, -5254,   327, -5254,
    3520,   317, -5254,  3545,  2126, -5254,   173, 46026, -5254, -5254,
   -5254, -5254, -5254, -5254,  2142, -5254, 84888, -5254,  3621,  3622,
    3626,  3627,  3629,  3323,  3342,  3350, 84888,  3345,  3323,   331,
    3346,  3337, -5254,  3345,  3345,  3323,  2817,  2817,  3323,  3342,
   60988,  3796,  3645, -5254,  3415,  3326,  3658,   772, -5254,   812,
    1310,  3582, -5254, -5254, -5254, -5254,108718, -5254, 61944,  3374,
    2667,  2667,   158,  3551,  3347, 60988,  3780,   317, -5254, 65768,
   84888,108718, 65768,  3561, 65768, 65768,108718, 84888, 84888,  2157,
   -5254,  1625, -5254,  1859, 32380,   441, -5254, 15868,  2163, 32380,
    3351,  3353, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  3354,
    3671, -5254,  2179,  2181,  2220,  3356,  3362,  5157,  6303,  3363,
   15920,  3358,  3364,  3368,  3372, 37814, 37814, 27435,  1319, -5254,
   37814,  3369,  3546,  2226, 15323,  3373,  3375, 16687, 31392, 32380,
   31392, 31392, 17511,  3376,  3378, -5254,  3712, -5254,  2230, 57642,
    3538, 18003,  2234, -5254, 32380, 57642,  6333, 32380, -5254, 32380,
    3381, -5254, -5254,  2556,  2556,  2556,  6383, -5254,  3388, -5254,
   37814, 37814, -5254,  1383, 27435, -5254, -5254,  3676, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254,  2254, -5254, -5254, -5254,  3599,
    3044, 50940,  8051, 32380,   282, 32380,  3125, 32380,  3461,  2556,
    2556,  2556,   489,   489,   281,   281,   281,  1918,   554, -5254,
   -5254, -5254,  3384,  3385,  3386,  3579,  3387, 32380, -5254,  2340,
    2602, 84888,  5409,  5606,  5976, -5254, -5254, -5254,  3197,    86,
    3197, -5254,  1489,  2590,   974, 55730, -5254, -5254, -5254, -5254,
   -5254, -5254, 84888, 19232, -5254, -5254,  3642,  3391,  2238, -5254,
   -5254,  2590, -5254, -5254,  1616,  1616,  3393, -5254,  3398, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,  3394, -5254, -5254, -5254,
   41688,  3725,  3401, 40242, 82976,  3399,  2217, -5254, 82976, 83454,
   82976, -5254,  3422, -5254,  1811, 32380,  3720, -5254, -5254, -5254,
   32380, -5254, -5254,  1779,  3425,   654,   110,  2336,  2336,  1942,
     848, -5254, -5254,  3467, -5254, 32380,  2294, -5254,  2406, -5254,
   -5254, -5254, -5254,  2817, -5254,  3661, -5254, -5254, -5254, 40724,
    3451, 84888, 40724, -5254, -5254, -5254, -5254, -5254, -5254,105920,
    2110, -5254,110110, -5254,110110, -5254,  2110,  3851, -5254,105920,
    1843, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, 61944, 61944,  3630, 84888,  3631,  3632,
   32380,  1068, 84888,  3412,  3416,  1446,  3710,  3426, -5254,  3758,
     317, -5254, -5254,  3504, -5254, 19232, -5254, -5254, -5254, -5254,
   -5254, 61944, 84888, -5254, 65290, -5254, -5254,108718, -5254, -5254,
   84888, 84888, -5254, -5254, -5254,108718, -5254, -5254, -5254, 84888,
     759,  3505,  3506, 84888, -5254,   164,  3200,  9919, 84888, 84888,
   84888,  3716, -5254, -5254, -5254, -5254,  3638, -5254,  3769, -5254,
  105920, -5254,  2706,  1190,  3509,  2934,  3657, -5254,  3776,  3845,
   -5254,  3555,   925, -5254, -5254,  3565, -5254, -5254, -5254, -5254,
    3781,   317,  3784,   317, 84888, 84888, 84888, 84888,  3570, -5254,
   -5254, -5254, -5254,  3571,  3708, -5254, 57642, 57642, 57642,  2257,
   -5254, -5254,  1118, -5254, -5254, -5254, -5254, -5254, -5254,  3742,
   -5254,  2259, -5254,   -23, 84888, -5254, -5254, -5254, -5254, -5254,
    3787, 61944, 84888,  9989, 84888, 84888, 84888,  3659,  1936,  1168,
  108718, -5254,107790, -5254, -5254,  2265, -5254,  3455, 84888,  3527,
   61944,  3511, -5254, -5254, -5254,  3792,  3754,  2126, 71504,  3496,
    3496,  2093, -5254, -5254, -5254, -5254, -5254,  3722,  3648, -5254,
     340,  3654, 61944,  3544, -5254, -5254, -5254, -5254,  3808,  3559,
   -5254, -5254,  3564,  1205,  2934,  3294, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254,  3594, -5254, -5254, -5254, -5254,
    1588,  1588, -5254, -5254, -5254,  1588,  1321,   410,  1278,  2934,
   -5254,  1603,  1593,  3568, -5254,  3575, -5254, -5254, -5254,  3743,
    3745,  3746,  3577,  3583,  3633,  3585,  3586,  3641, -5254,  3589,
    3644,  3604,  3649,  3605,  3872,   317,108718,  3755,  1118,  3637,
    3874,   317, -5254,  3615, -5254,  3616, -5254,  2269,  3979, -5254,
   84888, -5254,   244,  1285,  2934, -5254,  3617, -5254, 61944, 84888,
   -5254, -5254, -5254, 32380,  3528,  3529,  3534, 19232, 19232, 32380,
   -5254, -5254, 19232,  3539, -5254, -5254, -5254, -5254,108718, -5254,
   84888,  3820, -5254, -5254,   339, 84888, 84888, -5254, -5254, -5254,
   84888, -5254, -5254, -5254,  3822, -5254,   472,   472, -5254, -5254,
    3857,  7278,  3540,   199, -5254, 57642, 47475,  2360,   174,   901,
   -5254, 65290, 84888, 65290, -5254,   176,  3756, 84888, 84888, 84888,
    3547,  3548, -5254, -5254, -5254, -5254, 61944,   959, 61944,  2590,
   -5254, -5254,  3640, -5254, 84888,  2126,  4045,  3884,   145, -5254,
    4005,  3131,   336,  1568,   223,  2753,  3943,  2474, 32380,   165,
   -5254, -5254,  1811, 84888,  3324, -5254, -5254, -5254, -5254,  1118,
   -5254,  3563,  3552, -5254, 84888,  3901, 84888, 84888, 84888, 84888,
    3374,  3580, 84888,  3578,108718, 84888,  2613,  2930,  4035,  3920,
    2286,  3341,  3665,  3930, 76762,  3603,  2279, -5254, -5254,   777,
   -5254,  2288,   188, -5254,  1118, 65290,106862,  3918, -5254,   547,
    7855, -5254, -5254,   547,  1402, 84888, -5254, -5254, -5254, -5254,
    3805,  2089, -5254,  3903, -5254, -5254,  2286, -5254,108718,  3597,
   -5254,  2303, -5254, -5254, -5254,   287,  3655,   317,  3656,   317,
   -5254, -5254, -5254, -5254, 84888, -5254, 84888, 60510, -5254, -5254,
   84888, -5254,  3942,  3652,    43, 45062,  3814, -5254, 84888,   187,
   -5254,  3610, -5254, -5254, -5254,  3740,  3741,  3744,  3750,  3751,
   84888,  3323, -5254,  3600, 84888, 84888, 61944,  1651, -5254, -5254,
    3819, -5254, -5254, 76762,  3736, -5254, -5254, -5254, -5254,  3961,
    3964, -5254, -5254, -5254,   878, -5254, 84888, 84888, 61944, 72460,
     375, 61944, -5254,  3898,  3899,  3904,  3907,   331,  3908,  3910,
    3916,  3917,  3919, -5254, -5254, -5254,  3620, 18069, 32380, -5254,
    3994,108718, -5254,  7340, -5254, -5254, -5254, 32380, -5254, -5254,
   -5254, -5254, -5254, -5254,  2197, 32380, -5254, 32380, -5254, -5254,
   25041,  4126,  4126,  3647,108718, 37814, 37814, 37814, 37814,   276,
    2792, 37814, 37814, 37814, 37814, 37814, 37814, 37814, 37814, 37814,
   37814,   573, -5254,  3842, 32380, 32380, 31886, -5254, -5254,108718,
    3643,  3376,  3651,  3653, 32380, -5254, -5254, -5254,  2305, 39278,
    3660, 57642, -5254, 32380, 15235,  2307,  3689, 18230,  1811,  7916,
    1118, 32380,  1099,  1162, 32380,  2309, 32380,  3971, -5254, -5254,
   -5254, -5254, -5254, -5254,  3876, -5254, 32380,  3662,  3211, 37814,
   37814,  3566, -5254,  3596, 32380, 27435, -5254,  3446,  3690, 46508,
   -5254, 25541,  3663,   937,   937,   937,   937, -5254, 84888, 84888,
   84888,  3720,  3664,  3720,   383,  3668, -5254, -5254, -5254, -5254,
    2286, -5254,  3650, -5254, -5254, -5254, -5254, -5254, 82976, 83454,
   82976,  3666, 39760, 26024,  2217,  3669, 84888, -5254, -5254,  3672,
   40724,  3928,  3858, -5254, 40724,  3858,  1664,  3858,  3935,  3752,
   46990, -5254, -5254,  3673, -5254,  3864, -5254,  1885, 19232,  4102,
    3976, -5254,  3674, -5254,  3425,  1225, -5254, -5254, -5254,   865,
   -5254,  3763, -5254, -5254, -5254,  3399, 33862,  3813, -5254,  2148,
    2313,  1916, -5254, -5254,105920, -5254,  3738,  2706,  2706,  1129,
    3323,  4011,  1129,  8264, -5254, -5254, 42170, 84888, 84888, -5254,
   84888, 84888,  1576, 84888, -5254, 84888, -5254, -5254, -5254,  4135,
    3739,  3753,  3955, -5254,  2598, -5254, -5254, 61944, 84888, -5254,
   -5254, -5254,   316,  1444,  2934, -5254,  3765, -5254, -5254,  3973,
   84888, -5254,  4125,  3777, 84888,  4033, 84888, 83932, -5254,  3756,
    1576,  3795,  4014,  1176,  2930,   345,  3330, -5254,  1397, -5254,
   -5254,  3774, -5254, 84888, -5254, 84888, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254,  3824, -5254, -5254, -5254, -5254, 58120, -5254,
   -5254, 84888, -5254, 57642, 47475, 57642, -5254, 84888, -5254,  1381,
     445,  1502,  2934, -5254,  3786, -5254,  4049,  3789,  3793,  3828,
     200,  1466,  3794,  3797,  3849,  3711,  3715,  3718, -5254, 57642,
   47970,  3881, 84888,  2706,  3717,  3767, 84888,  3861,  3496, -5254,
    3727, -5254, -5254,  3496,   333,  1118, -5254, -5254,  1118,  2706,
    1118, 84888, 84888, 84888, 84888,   333, -5254, -5254, -5254,  4167,
    3821, 84888, 84888, 84888, 84888, -5254,  3783, -5254, -5254, -5254,
   84888, 84888,  4064,   229,  2160, 61944, 84888, 84888, 61944, 84888,
   84888, 84888, 84888, 84888, 84888, 84888,  3946, -5254,  4158,  4083,
    2308,  4127,  3815, 84888, -5254, 84888,  1118, -5254,  3200, 84888,
   84888, 84888, 84888, -5254, -5254, -5254, -5254, -5254,  3446, -5254,
    3759,  4022,   339, -5254,  4023,  4025,  4026,   339, -5254, -5254,
     901, -5254,   467, 84888, -5254,  2617, 84888, -5254, -5254, -5254,
    3674,   459,  1848, -5254, -5254, -5254, -5254, -5254, -5254,  3761,
   84888, 84888, 37814, -5254,  2267,  1580,  1023, -5254,  4034, 84888,
    3025, -5254, -5254, -5254,  1115, 84888, -5254, -5254, -5254, -5254,
    3762, -5254,   672,  3580, -5254,  4052, 69114,  2706, 61944, 61944,
    2706, -5254,108718,  3768,  3324, -5254,   849,  3840, -5254, 61944,
     336,105442,  3120,  3800,  3972,  8762, 40724, 41206,  1588, -5254,
    3770,  3760, -5254, -5254, 84888,  3756, 60510,  2317,  3294,  4222,
     796,  2092, -5254, 70548,  3953,  3580,  4052, -5254,  2930,  3982,
    3984, -5254,  2286, 84888,  3374,  3324,  1118, 84888,  3231, 47475,
   -5254,  4265,  2125, -5254,105920, 32380, 32380, -5254,  3771, -5254,
    3772,  7855, -5254,  3844,  3773,  4231, 32380, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254,  3860,  3779, 84888, 84888,   777,
   84888, -5254,  3782,  3636, -5254,  3636, -5254, 84888, -5254, 84888,
   -5254,   317, -5254,  3902,   317, 84888, -5254, -5254, -5254,  3835,
    2319, -5254, -5254,  4195,  3813, -5254,  2321, 46026,  3451, 32380,
    1811, 84888, 84888, 84888, 84888, 84888,  3323,   331,  3337, -5254,
   -5254,  4107, 60988,  3645, -5254,  2327, 84888, -5254, -5254, -5254,
    4175, -5254, -5254,   371,  4115,   317, -5254,   349,   349,   349,
     349,  4070,   349,   349,   349,   349,   349, -5254, 32380, 19232,
   -5254,  3788, -5254, 19232,  3791,  8816, 18318, -5254,  2329, 32380,
   -5254,   503,   503,   503,  1975,  4122, -5254,  2945,   503,   503,
     503,   526,   526,   240,   240,   240,  4126,   573, 18557, 18605,
   18917,  3798, -5254, -5254, -5254,  3376, -5254, 34356,    84,  4237,
   38796, -5254, -5254, -5254,  3838,  3839,  3799, -5254, 32380, 34850,
    3801,110574,  4000, -5254,   431, 32380, 32380,  3823, -5254,  7187,
   32380, -5254,  3823,   484, 32380,  1902,  4114, 32380, 32380,  3703,
    9735,  3803, 32380,106384, -5254, -5254, -5254,  2333, 32380, 84888,
   84888, 84888, 84888, -5254, -5254, -5254,  3976,  1118,  3976,  1118,
    3809, -5254, -5254, -5254, -5254, 58598,  3806,  3538, 82976,  3811,
   84888,  2217, 40724, -5254, -5254,  2122, -5254, 40724,  4078, -5254,
   40724, 65768, -5254, 84888,  3812, 84888, -5254,  1644, 32380,  3843,
   50940, -5254, -5254, -5254, -5254,  3896, -5254,  4041, 19232, 29910,
   -5254, 32380, -5254,  3897,  2337, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254,  3909, 71026,  4153, -5254, 32380,  2338, -5254,  3867,
    4251,   351,  2344,  2345,  1576, -5254,  2346, -5254,  1646,  4132,
     443, -5254,   317, -5254,108718, 84888, 84888, 84888,  2870, -5254,
   -5254, 84888, 84888, 84888, 84888, -5254, -5254, 61944, 84888, -5254,
   84888, -5254, -5254, -5254, -5254,   333,  2267,  4139,  4145,  4060,
   -5254,   331, -5254,  2267,  4062,   333, 84888, -5254, -5254, -5254,
    2909, -5254,108718,   317,   317, -5254, -5254, -5254, -5254, -5254,
    3848, -5254,  4282,  3933, 84888, 84888, 84888, 84888, 84888, 61944,
   84888, 84888,  2590,  2590,108718,  3837, -5254,  2590,  2590,  3850,
   -5254, 61944, 84888, 84888, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254,  3926, -5254, 32380,  4273, -5254,
   -5254, 84410, -5254, 32380, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, 61944, 84888,  3931, -5254,  3936, -5254,
     442, -5254, -5254, 84888, 84888, 84888, 84888,  4194, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  4189,
   84888, -5254, -5254,  1118,  1118,108718,   317,   317, -5254, -5254,
   -5254,  3937, -5254, -5254,  3856,  4143,   339, -5254,   339,   339,
     339, -5254,  3863, -5254,   901,  4240, -5254,  1576,  1801,  4193,
   -5254, 32380, -5254,  1552,  1975, -5254,  4248,  4331, -5254, -5254,
   -5254, -5254,  3272,  2126,  3272, -5254, -5254, 65768,  1412, -5254,
    4173,   241, 57642,  4089, 69114,  1603,  1809,  3870,  4001, -5254,
    2706,  2706,  3934, 84888,  4341, -5254, -5254, -5254, -5254, -5254,
   -5254, 61944,  3511, -5254,  4108,  1142,  4211, 84888, 41206, -5254,
    3399, -5254, -5254, -5254,  1118, -5254, -5254,  4009,  3324, -5254,
    2156, 84888,  4103, 69114,  3374,  2350, -5254, -5254, -5254,  3925,
    4328,  3341, -5254,  1603,  3953, -5254, -5254,  4304,  3981,  3938,
    4356, -5254,  3981,  4223,  4110,  3900, -5254,  3603, -5254, 84888,
   -5254, 19232, 19232,  1118,111038,   547,108718,  4230, -5254, 19232,
   84888,   809,  3894,  4066, -5254,  4199,   317,  2352, -5254,   317,
     317, -5254, 84888, -5254,  2286,  1999, 84888,  1811,   101, -5254,
    3914, 84888, -5254,  3813, 19232,  3323,  3323,  3323,  3323,  3323,
   -5254,  4117, -5254, -5254, -5254,  4191, -5254,   317, 60988, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,   349, -5254, -5254, -5254,
   -5254, -5254, 19232, -5254, -5254, -5254, 32380, -5254,  9881, 37814,
    4236, -5254, 32380, 32380, 32380, -5254,  3912,  2363,  2369, -5254,
   -5254,    84, -5254,  4237, -5254, -5254, -5254, 10565,  3963, 19232,
    4021,  3915,  3922,  3823,  3823,  7187,  3823, 32380, 32380,  3823,
    3823, 32380, -5254, -5254, 11299,  4104, -5254, -5254, 11621, -5254,
   -5254, -5254, -5254,  3843, -5254,  3843, -5254,  4048, -5254,  2370,
    4379, 36826,  4346, -5254, 84888,  2374, -5254, 32380,  3932, -5254,
   -5254, 40724,  2122,  3940,  2382, 84888,  2386,108718, 35344, 19232,
   84888,  3446,  3929, -5254, 84888,  2815, 18965, -5254, -5254, 60988,
    4141, 60988,  1576, 11889,  4224, 42170, 51930, 84888, -5254, 84888,
   -5254,  4096,  4224,  4224, -5254, -5254, -5254, -5254, -5254, -5254,
    3944, -5254, -5254, -5254, -5254,  4017, -5254, -5254,    44,  3344,
   -5254,  2360, -5254,  4398,  4283,  4289, -5254, -5254, -5254, -5254,
   -5254, -5254,  4158, -5254, -5254, 47475, 61944, 84888, -5254,  4020,
   -5254, -5254, -5254, -5254, -5254, -5254, 44098, 50940, -5254,   200,
    3947,  3949,  1466, -5254, -5254, -5254, 84888, 12021,  3950, -5254,
   -5254, 12809,   649,  3344, 84888, 84888,  3952,  3956,  3957,  1728,
    1634,  1875,  3323,  4277, 84888, -5254, -5254, -5254,  4158, -5254,
   -5254, 84888, -5254,   339, -5254, -5254, -5254, -5254, 57642, -5254,
    2919,  3863,  1118, 65768,  4408,  4408, 13385,  4178, -5254, -5254,
     347,  4015,  4215,  4015,  3960, 84888,  1115,  3965,  2387, -5254,
   84888,  3966,  4094,  2173,  2173, 84888, 84888, 84888,  2388,  2286,
    2706,  3767,   336,  4309, 69114,  4360,  3756,   369, -5254, 84888,
    4433, 84888,  3374,  3580, 84888,  3970, -5254, -5254, 70548,  4184,
    2360, 84888,  2613,  3953,  3341,   992, 84888, -5254,  1565, -5254,
    2286, -5254, 84888, 76762, 42170,  4303, -5254,110110, -5254,  2392,
   -5254, -5254, -5254,  4050, 19994,  3197,  4091,  4092,  3974,  1694,
    4313, 84888,   775, -5254, -5254, -5254, -5254, -5254, -5254,    43,
   -5254, -5254,  4391, 42170,  4351, 32380, -5254, -5254, -5254, 84888,
   -5254,   375, -5254, 19153, -5254,  4499, 37814, 19232, 19232, 19232,
   32380, -5254, 32380, -5254, -5254, -5254, -5254,   667, -5254, -5254,
    3823,  3823,  3823, -5254,  4429,  3446, -5254, -5254, -5254,  1803,
    4378,  3422, 58598,  3990, -5254, 37814,  2393, -5254,  3757, 84888,
    2398, -5254, 19232, 84888, -5254, -5254, 32380, -5254,  2400, -5254,
    3991,  1159,  3992, 24041,  3993, -5254, -5254, -5254, -5254, -5254,
   19232,  3996, -5254,  4458,   261, -5254, -5254,   213,  4043, -5254,
    1651,  1129,   330,  4251,  4002,  3272, -5254,  4003, -5254, -5254,
    2930,  1048, 84888,  3272,  3272, -5254, 84888,  4099, -5254,  4308,
   -5254, -5254,  4061, -5254,   677,  3344, 84888,108718, -5254,   143,
    4344, -5254,108718,108718, -5254, -5254, -5254, 32380, -5254,  4100,
   -5254, -5254, -5254, 32380, 32380, 68158, -5254, -5254, 84888, 84888,
   84888, 84888, 84888, -5254,   317, -5254, -5254,  2408, -5254, 43134,
   -5254, -5254,  3129,  1118,  3129,  1632, -5254, -5254,  3129,  3129,
   -5254,  3197, -5254,  4408,   965, -5254, -5254,  4252,  4019, 32380,
    4315, -5254,   817,  4238, -5254,  4024, -5254, 65768,  4517, -5254,
   57642,  3580,  4052, 84888, -5254, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,  2410,  3756,  4365,  3324,
    3938, -5254, 84888,  4063, -5254, 40724,  3756,  2286,  2092, -5254,
    3953,  3580,  4052, -5254, -5254,  4027,  3984,  3341,  2613,  4169,
   -5254,  4170, -5254,  4461,  4246,  4465,  3374, -5254,  3231,  2412,
   -5254, 84888, -5254, -5254,  7855,111038,108718, -5254, -5254, -5254,
    4036,  4405,  4081,  4084, -5254, -5254, -5254,  1694, -5254,  1585,
    4404,  4090, -5254,  4105, 84888, -5254, -5254,  4101, 84888,  2417,
     114, 19232,  3756,   317, 32380,  4499,  2418,  2419,  4111, -5254,
   32380,  1334,  4381,  4384, 84888, -5254, -5254, -5254, 84888,  1975,
    4044, 36826, 57642,  2427, -5254,108254, -5254,  2428,  2439, -5254,
   32380,  4053, 32380, -5254, 35344, 84888,  4055,  3179,  4519,  4312,
   -5254, -5254,  4387, -5254, -5254, 84888,  4015, 50940,  1048,  3425,
    2126,  4015,  4015, -5254, 84888,  4019, 32380, -5254,  4152, -5254,
   -5254,  2446,   125,  4229,  4229,  2447,  2452, 13429, 84888,  2458,
    2459, -5254,  2464,  2590,  3342,  1875,  3342, -5254,  3323, -5254,
   -5254, 57642, -5254, 61466, -5254, -5254, -5254,  1118, -5254,  1118,
    4287, 84888, 53364,  1118,  1118, -5254, -5254, -5254, -5254,  4367,
   -5254,  3294, -5254, 13459,  4162, -5254, -5254, -5254,   478, -5254,
    4285,  4291, -5254,  4077, -5254,  2472, -5254,  1603,  4208,  3756,
   -5254, -5254, 84888,  4545,  4548, -5254,  1224, 84888,  3399, -5254,
    3938,  3374,  3341,  1603,  3953,  2360, 42652,  3981,  2613,  3984,
   -5254, -5254,  4298, -5254,  4300, -5254,  4093,  4396, 42170, -5254,
    2235,   547, -5254, -5254, -5254,   365,  4421,  4424, -5254, -5254,
   -5254,  3129, -5254,    96,  4098,  4448, -5254, -5254,  2286, -5254,
    3197, -5254,  4225, -5254, -5254, 19232, -5254, -5254, -5254,  3376,
   35838, 35838, 35838,  4112,  4554,  4555,   709,  2481, 38796, -5254,
   -5254, -5254, 84888,  4322,  1349,  4579,  4274,  2483, 35344,  2487,
   -5254, -5254, -5254, -5254, 32380,  4209,  4519, 60988,  2488,  3496,
    4119,  3425, -5254,  4215, -5254, -5254,  3344, -5254, 19232, 84888,
   65768,  4565, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  3344,
    4207, -5254, -5254, 68158, -5254, 84888, -5254, -5254,  2494, -5254,
   -5254, -5254, 84888,  3894, -5254,  3894, -5254, -5254, -5254,  2686,
    4232, 84888,  1313,  1313,  4502, -5254,  4188, -5254,  4130, -5254,
    4631,  4266, 84888, -5254, -5254,   200,  2286, 69114,  3756, -5254,
   -5254,  2613,  3953,  3341, 32380,  2496, -5254,  4251,   351, -5254,
    3984,  3981, -5254, -5254, 42170,  4137,  3025, -5254,  4504, -5254,
   -5254, -5254,  1836, 65768, 65768, 84888, -5254, -5254, -5254, 32380,
    1115, -5254, -5254, 46026, 37320,  4286,   237, 14627,  4492, -5254,
    4492,  4492, -5254, 84888, 84888, 84888, -5254,  3538, -5254, -5254,
   37814, 37814,  4370, -5254,  1349, -5254, 84888, -5254,  4148, -5254,
   -5254,  2510, -5254, 19232,   462,  4239,   330, -5254, -5254, -5254,
   -5254,  4238,  1576,  1576, -5254,  3344, -5254, 84888, -5254,  4150,
   -5254, -5254, -5254, 61466,  3894, -5254, -5254, -5254, -5254,  4633,
   -5254,   284, -5254, -5254, -5254, -5254, 84888,  3756,  3837,  3938,
   -5254,  3984,  3341,  2613, 13782, -5254, 42652, 84888, 84888,  3981,
   -5254,  2515, 42170,  3324,  4299, -5254,  2847, -5254, -5254, -5254,
   -5254, -5254, -5254, -5254,   884,  4159,  4160, -5254, -5254, 14090,
   65768,  1542,  4623, -5254, -5254, -5254, -5254, -5254,  1276, -5254,
   -5254, -5254,  1082,  1234,  1623,  4583,  1975,  1975, -5254, -5254,
   -5254, 32380, -5254, -5254,  4397,  4292, -5254, -5254,   308, -5254,
    1576, -5254, -5254, -5254, 32380, -5254, -5254,  2126,  2126,  3756,
   -5254, -5254,  3981,  2613,  3984,  4251, -5254, -5254, -5254, -5254,
   -5254,  4396, -5254,  2520,  3981,  4090,  2580, -5254, -5254,  2587,
    2527,  4254,  4501, -5254,  4174, -5254, 36332,  4317, -5254,  4380,
   -5254, 84888, 84888, 59076, 84888, 84888, 14134, -5254, 46026,  4410,
     181, -5254,  1576,  2521, -5254, -5254, -5254, -5254,  3984,  3981,
   84888,  3025, -5254, 42170,  3197,  4525, -5254,  2847,  4293,  4296,
   57164, -5254, -5254, -5254, -5254, -5254,   303,  4566, -5254,  2522,
   -5254,  4181, -5254,  4242,    43,  4186, 84888, -5254, -5254,  3981,
   -5254, -5254,  3324, -5254, -5254,  1115, -5254,  4233,  4234, -5254,
    2529, -5254, -5254, -5254, -5254, 32380, 59076, -5254, -5254,  4244,
   32380,  2557, -5254,  3981, 65768,  4518,  4523, -5254, 57164,    89,
    4250,  4249,  2562,   710,  3197,  4197, 65768, 65768, -5254,  4198,
   84888, -5254, -5254,    43, -5254, -5254, 57164, -5254, -5254,  1118,
   -5254,  4253,  2564,  4249, -5254, -5254
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1698,  1441,   648,  1529,  1528,  1441,     0,   266,     0,  1539,
       0,  1441,   430,  1099,     0,     0,     0,     0,   648,  1441,
       0,  1698,     0,     0,     0,     0,     0,  1711,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1441,     0,
       0,  1718,     0,     0,     0,     0,  1711,     0,  1541,     0,
       0,     0,     0,  1718,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   133,   132,   134,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   116,
      94,   128,    49,   125,   103,   104,   122,   105,   123,    16,
     107,    62,    23,   119,   118,   120,    89,    55,    90,    77,
      97,   117,    34,   121,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   124,   114,   109,   129,   127,    11,
     135,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   131,    44,  1539,   102,   115,   101,
      84,   108,    87,   112,   130,   113,    85,   126,  1662,  1661,
    1722,  1665,  1697,     0,  1677,  1440,  1439,  1454,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   647,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1451,  2315,  2332,  2333,  2334,  2335,
    2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,
    2347,  2346,  2348,  2349,  2692,  2350,  2351,  2352,  2641,  2642,
    2693,  2643,  2644,  2353,  2354,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2645,  2646,  2362,  2363,  2364,  2365,  2366,  2647,
    2694,  2367,  2368,  2369,  2370,  2371,  2372,  2695,  2373,  2374,
    2375,  2376,  2377,  2378,  2379,  2380,  2381,  2696,  2382,  2383,
    2384,  2697,  2385,  2386,  2387,  2388,  2389,  2390,  2648,  2649,
    2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,
    2401,  2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,  2650,  2419,
    2420,  2421,  2422,  2651,  2423,  2424,  2425,  2426,  2652,  2427,
    2428,  2429,  2698,  2699,  2430,  2431,  2432,  2433,  2434,  2653,
    2654,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2700,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2701,  2655,  2454,  2455,  2456,  2457,  2656,  2657,  2658,
    2458,  2702,  2703,  2459,  2704,  2460,  2461,  2462,  2463,  2464,
    2465,  2659,  2705,  2466,  2706,  2467,  2468,  2469,  2470,  2471,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,
    2482,  2483,  2484,  2485,  2486,  2487,  2660,  2707,  2661,  2488,
    2489,  2490,  2491,  2492,  2493,  2494,  2662,  2663,  2495,  2496,
    2497,  2708,  2498,  2664,  2499,  2665,  2500,  2501,  2502,  2503,
    2504,  2505,  2506,  2507,  2508,  2509,  2666,  2709,  2510,  2710,
    2667,  2511,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,  2521,  2522,  2668,  2523,  2669,  2526,  2524,  2525,  2527,
    2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2670,
    2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,
    2547,  2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,  2711,
    2556,  2557,  2558,  2559,  2560,  2671,  2561,  2562,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,
    2575,  2576,  2672,  2577,  2578,  2712,  2579,  2580,  2673,  2581,
    2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,  2591,
    2592,  2593,  2594,  2674,  2595,  2596,  2597,  2598,  2713,  2599,
    2600,  2601,  2602,  2603,  2604,  2675,  2676,  2605,  2606,  2677,
    2607,  2678,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,
    2616,  2617,  2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,
    2679,  2680,  2626,  2714,  2627,  2628,  2629,  2630,  2631,  2632,
    2633,  2634,  2635,  2636,  2637,  2681,  2682,  2683,  2684,  2685,
    2686,  2687,  2688,  2689,  2690,  2691,  2638,  2639,  2640,   137,
       0,     0,  2282,  2316,  2317,  2320,  2315,   402,   401,  1651,
    2279,  2316,  1538,     0,  1518,   648,     0,  1454,   429,  1698,
       0,     0,     0,     0,     0,     0,   864,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   185,
       0,     0,     0,     0,   453,   452,     0,     0,  1065,   458,
       0,     0,     0,     0,     0,   638,  1580,  2524,  1578,  1652,
     267,   270,   271,   268,   269,  2298,     0,  1211,  1212,  1214,
       0,     0,  1224,   904,   905,     0,     0,     0,   918,     0,
       0,     0,   902,     0,     0,     0,   924,     0,   921,     0,
       0,   925,   922,   899,   923,   906,     0,   898,     0,     0,
    1224,   926,     0,     0,   900,     0,     0,     0,     0,  1454,
    1577,   459,  1698,     0,  1561,  1562,  1563,  1539,  1551,  1564,
    1556,  1558,  1557,  1559,  1560,  1555,     0,  2297,  2333,   994,
     994,   994,   994,   991,   992,   994,   994,   994,  2544,     0,
       0,   973,     0,   975,  2299,   994,   999,  2341,   530,   530,
     530,     0,   998,  1003,   530,     0,  1422,  1463,  2281,  1710,
       0,   974,  1421,     0,     0,     0,  2605,  1567,     0,     0,
    1239,  1235,  1237,  1238,  1236,     0,  1068,  1068,  2563,  1431,
     249,  2574,  2675,  2605,   248,   242,   244,   216,  2337,     0,
       0,   998,     0,  1454,  1429,   970,  1717,  1715,     0,  2266,
    2360,  2376,  2469,   239,  2556,  2564,  2574,  2675,  2605,  2637,
     195,   205,   200,     0,   260,  2574,  2675,  2605,   256,  1451,
       0,  1678,  1826,  1825,  2275,     0,  1424,  1423,  1540,     0,
    1543,     0,  2539,  1682,  1685,  1545,  1683,  2318,  1901,  1930,
    1908,  1930,  1930,  1897,  1897,  2406,  1910,  1898,  1899,  1935,
       0,  1930,  1897,  1902,     0,  1900,  1938,  1938,  1925,     3,
    1882,  1883,  1884,  1885,  1911,  1912,  1886,  1917,  1918,  1922,
    1887,  1952,  1897,  2319,  1719,  1720,  2266,     4,  2312,     5,
    2261,  2311,     6,     7,  1674,     0,     0,     1,  1698,     0,
    1550,  1714,  1714,     0,  1714,     0,  1666,  1674,  1669,  1673,
       0,     0,     0,     0,     0,     0,  1425,     0,     0,     0,
     929,     0,  1466,  1050,     0,     0,     0,     0,     0,  1308,
       0,  1108,  1107,  2321,  2304,  2305,  2306,     0,  2302,  2303,
    2322,  2323,  2324,     0,  2441,  1308,     0,     0,  2177,  2188,
    2189,  2190,  2364,  2423,  2185,  2186,  2187,  2179,  2180,  2181,
    2182,  2183,  2184,     0,     0,  1206,  2178,     0,  2441,     0,
    1308,     0,   164,     0,   141,  1308,     0,     0,  2441,     0,
       0,  2441,     0,     0,     0,     0,     0,  2441,     0,     0,
       0,     0,     0,   164,  2474,     0,   141,  2441,     0,     0,
    1445,     0,     0,     0,  1447,  1450,  1437,     0,  2258,     0,
    2259,  2283,     0,  1532,  1526,  1535,  1531,  1521,     0,  2275,
       0,     0,     0,     0,   912,     0,     0,   902,     0,     0,
       0,   913,     0,   914,   915,     0,     0,     0,     0,   911,
       0,  1435,  1427,     0,  1569,  1571,  1570,  1572,  1568,   530,
       0,     0,     0,  2441,     0,   141,  1505,     0,  2441,   141,
       0,     0,   457,   456,   141,  2302,   455,   454,  2364,  2423,
       0,  1098,     0,  1181,   141,  2441,     0,   187,  2441,   707,
    2441,  1545,     0,   651,     0,   819,  2474,   141,     0,     0,
       0,     0,     0,     0,  1068,     0,     0,     0,     0,     0,
       0,     0,   637,   648,  1581,  1579,     0,  1215,   241,   240,
    1213,   916,  2441,  1140,   363,     0,     0,  2441,  1486,  2441,
     363,   933,   917,     0,   903,  2441,   363,  1104,  2441,  2307,
     174,     0,   901,  2364,  2423,  2441,   363,  1208,     0,  2441,
     363,  2441,   170,  2441,   363,  2441,   363,  2441,   652,     0,
       0,  2441,   363,  2441,  2474,   172,   920,  2441,   363,   927,
    2441,   363,  2277,  2441,     0,  1438,     0,  1573,     0,  1553,
    2679,     0,  1698,     0,     0,   994,   993,     0,   994,     0,
     994,     0,   994,     0,   994,     0,     0,     0,   994,  2300,
    2301,   976,     0,  1000,     0,  1008,     0,  1007,  1006,  1005,
       0,     0,     0,  1009,     0,  1830,  1609,     0,  1419,   243,
     194,     0,   255,   254,  1434,     0,     0,     0,  1068,     0,
    1067,     0,     0,  1430,   247,   245,     0,     0,     0,     0,
       0,     0,  1436,     0,  1428,     0,     0,     0,  2285,  2287,
    2288,  2191,  2261,     0,  2642,  2643,  2644,  2250,     0,  2645,
    2646,  2647,  2694,  2081,  2068,  2077,  2082,  2069,  2071,  2078,
    2648,  2649,  2019,  2650,  2651,  2295,  2652,  2653,  2654,  2656,
    2657,  2658,  2659,  2073,  2075,  2660,  2661,  2663,     0,  2296,
    2664,  2665,  2505,  2667,  2668,  2670,  2671,  2079,  2673,  2674,
    2675,  2676,  2677,  2678,  2294,   497,  2080,  2680,  2682,  2683,
    2684,  2685,  2687,  2688,  2689,  2690,     0,     0,     0,  2272,
       0,  2048,     0,  1890,  1891,  1913,  1914,  1892,  1919,  1920,
    1893,     0,  2271,  1955,  2136,  2047,  2064,     0,  2053,  2054,
       0,  2046,  2042,  1700,  2267,     0,  2043,  2284,  2286,  2251,
    1700,  2265,   208,   262,     0,   263,  2273,  2574,   196,   238,
     210,   237,   211,   209,     0,  2362,   197,     0,     0,   198,
       0,     0,     0,     0,   259,   257,     0,  1426,     0,  1828,
    1827,  2276,   938,     0,  1542,  1539,  2201,     0,  1684,     0,
       0,     0,  1929,  1916,  1924,  1923,     0,  1906,  1905,  1904,
       0,  1903,  1930,  1930,  1928,  1907,  1882,     0,     0,     0,
    1934,     0,  1932,  1878,  1874,     0,  1941,  1942,  1943,  1940,
    1953,  1939,     0,  1888,  1944,     0,  1897,  1894,  1785,     0,
    1664,  1663,     8,     0,  1547,  1549,  1524,  1545,  1712,  1713,
       0,     0,     0,     0,     0,     0,     0,     0,  1772,  1730,
    1731,  1733,  1769,  1773,  1781,     0,  1670,     0,     0,     0,
    1832,  1624,     0,  1452,     0,     0,     0,     0,     0,  1139,
       0,     0,     0,     0,   930,     0,     0,     0,  1472,     0,
    1474,  1475,  1476,     0,     0,     0,     0,  1477,  1478,  1466,
     251,  1485,  1482,  1465,  1467,  1480,     0,     0,     0,     0,
       0,     0,     0,  1497,     0,   178,   179,     0,   664,   648,
       0,  2441,     0,     0,     0,     0,  1149,  1156,  1307,     0,
       0,     0,     0,     0,     0,     0,     0,  1150,  1148,     0,
    1151,   253,  1161,  1188,  1191,     0,     0,  1106,  1109,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,  1298,     0,
       0,     0,  1307,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   278,   280,   293,   358,     0,   629,     0,     0,
       0,   632,     0,  2441,  1308,     0,     0,     0,  1210,     0,
       0,     0,     0,     0,     0,     0,     0,  1191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   139,   140,   145,
       0,     0,     0,     0,  1191,     0,     0,     0,     0,     0,
       0,     0,   615,   628,     0,     0,     0,     0,     0,   625,
       0,     0,   141,   283,   605,   611,     0,     0,     0,   714,
     713,     0,     0,     0,     0,     0,     0,  1395,     0,  1394,
       0,     0,     0,     0,     0,  1495,  1494,     0,     0,     0,
       0,     0,  1298,     0,   272,   274,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   394,   395,     0,     0,     0,   145,     0,     0,  1298,
       0,   285,     0,     0,  1446,  1443,  1444,     0,  1449,     0,
       0,     0,     0,  2056,     0,  2205,  1722,  2203,  1124,  2257,
       0,  2325,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,
    2723,  2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,
    2733,  2734,  2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,
    2743,  2744,  2745,  2746,  2747,  2748,  2749,  2750,  2751,  2752,
    2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,
    2783,  2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2254,
    2253,  2280,  2326,  2327,  2328,  2329,  2260,     0,     0,   227,
     228,   226,  1533,   229,  1534,  1530,     0,  1516,     0,     0,
       0,     0,     0,     0,     0,     0,  2364,  2423,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   827,  1466,  1504,     0,     0,     0,
     657,     0,  2441,     0,   143,   865,     0,   817,   458,     0,
       0,     0,     0,  1371,   143,     0,     0,   181,     0,     0,
     711,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   818,     0,     0,   143,     0,  2441,   608,  2441,     0,
     530,   530,     0,     0,  1070,     0,     0,     0,     0,     0,
       0,     0,     0,  1656,  1655,  1658,  1657,     0,  1654,     0,
     361,   362,     0,  1198,  1223,     0,     0,     0,     0,     0,
     894,   919,     0,     0,  1192,     0,     0,  2441,   363,  2441,
       0,  2441,     0,     0,     0,  1200,   363,     0,  1194,     0,
       0,  1196,     0,  1397,     0,   910,   908,   907,   909,     0,
       0,   892,     0,     0,     0,     0,     0,   887,     0,     0,
     889,     0,     0,     0,     0,  1698,  1552,     0,     0,     0,
     984,     0,   988,     0,   979,     0,   985,     0,   980,   977,
     978,     0,   983,     0,     0,   531,   533,     0,     0,  2388,
    2405,     0,  2430,  2462,  2463,  2515,  2530,  2559,  2564,  2570,
       0,  2599,  2610,     0,  1014,  1045,  1004,   723,     0,     0,
    1619,  1420,  2210,     0,  1698,     0,     0,     0,  1231,  1232,
     246,   217,     0,     0,     0,  1047,  2563,  1433,   969,   648,
       0,  2044,     0,  2051,  2052,  2249,     0,     0,     0,     0,
       0,     0,  2050,     0,     0,     0,     0,     0,     0,     0,
    1977,     0,     0,  2209,     0,     0,  2209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1978,
    1959,  1960,  2048,  2201,     0,  2049,  2291,     0,  1952,  2330,
    2191,     0,  2188,  2189,  2190,  2792,  2793,  2794,  2795,  2796,
    2797,  2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,  2806,
    2807,     0,  2808,  2809,  2810,  2811,  2812,  2814,  2813,  2815,
    2816,  2817,  2818,  2819,  2820,  2264,  2822,  2823,  2824,  2825,
    2826,  2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,
    2836,  2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,
    2846,  2847,  2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,
    2856,  2857,  2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,
    2876,  2877,  2878,  2879,  2880,  2881,  2882,  2883,  2884,  2885,
    2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,
    2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,
    2906,  2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,
    2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,
    2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,
    2936,  2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
    2956,  2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,
    2966,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  1992,  2974,
    2975,  2976,  2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,
    1994,  3025,  3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,
    3034,  3035,  3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,
    3044,  3045,  3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,
    3054,  3055,  3056,  3057,  3058,  3059,  3062,  3060,  3061,  3063,
    3064,  3065,  3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,
    3074,  3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,
    3084,  3085,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,
    3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,
    3104,  3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,
    3114,  3115,  3116,  3117,  3119,  3118,  3120,  3121,  3122,  3123,
    3124,  3125,  3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,
    3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,
    3144,  3145,  3146,  3147,  3148,  3149,  3150,  3151,  3152,  3153,
    3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,
    3194,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,
    3204,  3205,  3206,  3207,  3208,  3209,  3210,  3211,  3212,     0,
    2185,  2186,  2187,  2179,  2180,  2181,  2182,  2183,  2184,  2195,
       0,     0,  2270,  2331,     0,  2138,     0,  1974,     0,     0,
    1785,     0,  2289,  2252,  1785,   264,   265,   261,     0,     0,
     213,   212,     0,   231,   235,   236,   207,   234,     0,   230,
     215,  2125,  2124,   214,   206,   203,   201,   218,   220,   221,
     204,   202,   258,     0,     0,     0,   363,  1550,  1537,     0,
       0,  2264,     0,  2199,     0,     0,  2197,     0,     0,     0,
    1782,     0,  1686,     0,  1690,     0,     0,     0,  1927,  1926,
    1879,  1875,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   931,     0,  1895,     0,  1848,
    2313,  2314,  2262,  1718,  1550,     0,  1546,  1681,  1680,  1723,
    1724,  1090,  1679,  1752,  1753,     0,     0,     0,     0,  1778,
    1776,  1743,  1734,  1742,     0,     0,  1740,     0,  1744,  1955,
    1771,  1668,  1728,  1729,  1732,  1667,     0,  1774,     0,  1622,
    1772,  1733,  1606,  1583,  1584,     0,     0,  1833,     0,  1453,
       0,     0,     0,  1119,  1121,     0,  1120,     0,  1123,     0,
    1132,     0,     0,  1118,  1137,     0,  1126,  1124,     0,  1493,
       0,     0,     0,     0,     0,  1473,     0,     0,     0,  2599,
     250,  1476,  1481,  1468,  1479,     0,     0,     0,     0,     0,
    1049,  1048,     0,     0,  1072,     0,     0,   497,  1500,   519,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
     813,   810,     0,     0,   809,     0,   662,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   687,     0,
    1298,     0,   291,     0,  1158,     0,  1157,     0,  1162,     0,
       0,  1159,  1154,  1155,  2564,  2574,  2605,   252,  1160,  1190,
       0,  1189,  1185,     0,  1101,     0,  1102,     0,     0,     0,
       0,     0,  2415,  2441,   299,   322,     0,  1297,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   344,     0,     0,   347,   346,     0,     0,
       0,     0,     0,   352,     0,   330,     0,   331,     0,   351,
       0,     0,     0,   630,   631,     0,     0,     0,  1298,     0,
     287,     0,     0,     0,     0,     0,     0,     0,     0,  1207,
       0,   740,     0,     0,  2564,  1186,     0,     0,  1380,     0,
    1381,  1384,   530,     0,   530,  1386,     0,     0,  1383,  1385,
       0,     0,   167,     0,   162,   166,     0,     0,  2564,  1187,
       0,     0,     0,     0,     0,   613,   614,   627,     0,   618,
     619,   616,   620,   621,     0,     0,     0,     0,     0,     0,
       0,   612,     0,     0,   709,   708,   712,     0,     0,     0,
       0,     0,     0,  1389,     0,     0,  1181,     0,     0,  1388,
    1396,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1241,  1240,     0,     0,     0,     0,  1308,     0,   855,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     727,     0,   726,     0,   163,   168,     0,     0,     0,     0,
       0,     0,     0,     0,   225,  1442,  1448,  1722,  1722,  1722,
    2062,     0,     0,     0,     0,  1721,  2255,  2258,  1521,  1527,
    1520,  1519,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   408,
     405,   406,   408,     0,     0,     0,     0,   829,     0,   832,
     835,  1464,   481,     0,     0,   654,   687,     0,     0,   461,
     176,     0,     0,     0,     0,   742,     0,  1181,  1180,   138,
     185,   187,   459,     0,   186,   188,   190,   191,   192,   189,
     193,     0,   706,   710,     0,     0,     0,     0,   650,     0,
       0,     0,     0,     0,     0,     0,  1853,     0,     0,   161,
       0,     0,   603,   607,     0,     0,     0,     0,   461,   569,
     374,  2441,     0,   530,     0,  2441,     0,  1069,     0,   816,
       0,     0,     0,  1143,  1143,     0,     0,   756,   755,     0,
       0,     0,     0,     0,     0,  1653,   363,  1141,     0,  1487,
       0,   363,   934,   363,  1105,   175,  2308,     0,   896,     0,
       0,     0,     0,   363,  1209,   884,   363,   171,   363,   363,
     653,     0,   363,   173,     0,     0,   363,   928,   363,  2278,
       0,   363,  1576,  2441,   530,  1554,     0,     0,   981,   990,
     989,   987,   986,   982,     0,  1001,     0,   529,     0,     0,
       0,     0,     0,  1022,  1023,     0,     0,  1019,  1024,     0,
    1026,  1010,  1012,  1020,  1021,  1027,  1016,  1015,  1028,  1029,
       0,     0,  1047,   721,     0,     0,     0,     0,  1616,     0,
    1614,     0,  1831,  1618,  1607,  1566,     0,  1565,     0,   596,
    1068,  1068,     0,     0,   998,     0,     0,   363,  1432,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2214,     0,  2215,     0,     0,  2248,  2244,     0,     0,     0,
       0,     0,  2218,  2221,  2222,  2223,  2220,  2224,  2219,     0,
       0,  2225,     0,     0,     0,     0,     0,     0,     0,     0,
    2205,  2208,     0,     0,  2671,     0,     0,     0,     0,  2020,
       0,     0,  2172,     0,  2205,     0,     0,     0,     0,     0,
       0,     0,  2201,  2240,     0,   495,     0,  2012,     0,     0,
       0,  2123,     0,  2120,     0,     0,     0,     0,  2261,     0,
       0,  2292,  1956,  1970,  1971,  1972,  1975,  2269,     0,  2263,
       0,     0,  1957,  1983,     0,  2241,  2008,     0,  2013,  1998,
    2226,  2227,  2228,  2229,  2015,     0,  1991,  1996,  2000,     0,
    1979,     0,  1976,     0,  2264,  2200,     0,  2198,     0,  1967,
    1968,  1969,  1961,  1962,  1963,  1964,  1965,  1966,  1973,  2176,
    2174,  2175,     0,     0,     0,  2146,     0,     0,  1995,  2433,
    2469,     0,  1711,  1711,  1711,  1699,  1709,  2268,  1848,  1722,
    1848,  2274,     0,     0,  1952,     0,  1829,   936,   937,   935,
    1523,  1536,  1550,  2202,  1544,  1688,     0,     0,     0,  1896,
    1909,     0,  1937,  1936,  1938,  1938,     0,  1880,     0,  1921,
    1946,  1947,  1948,  1949,  1950,  1951,     0,  1945,  1889,   932,
       0,  2561,  2691,     0,  1809,  1784,  1786,  1796,  1809,  1816,
    1809,  2065,  1846,  2066,  2275,     0,  1755,  2310,  1525,  1548,
       0,  1088,  1089,     0,  1093,  2671,  2561,     0,     0,     0,
       0,  1745,  1779,     0,  1770,     0,  2285,  1746,  2284,  1747,
    1750,  1751,  1741,  1780,  1620,     0,  1775,  1672,  1671,     0,
    1851,     0,     0,  1834,  1783,  1347,  1242,  1309,  1122,     0,
    1897,  1133,     0,  1117,     0,  1116,  1897,     0,  1134,     0,
    1897,  1348,  1243,  1310,  1349,  1244,  1311,  1350,  1484,  1245,
    1483,  1471,  1470,  1469,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   794,  2441,
     363,  1498,  1351,     0,  1246,   359,  1499,  1312,  1503,   812,
     811,     0,     0,  1313,     0,   663,   668,     0,   670,   671,
    2364,  2423,   672,   675,   676,     0,   678,   667,   666,     0,
       0,     0,     0,     0,   684,   689,     0,     0,     0,     0,
       0,     0,  1152,  1153,  1352,  1249,     0,  1314,     0,  1100,
       0,  1250,   177,     0,     0,   279,  2441,   301,     0,   479,
     794,     0,  1300,   298,   328,     0,   343,   338,   339,   337,
    2441,   363,  2441,   363,     0,     0,     0,     0,     0,   340,
     335,   336,   332,     0,     0,   345,  2336,  2407,  2575,     0,
     695,   697,     0,   702,   348,  1270,   370,   369,   368,     0,
     353,     0,   375,   378,     0,   350,   329,   327,   324,   294,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1202,     0,  1355,  1315,     0,  1337,     0,     0,     0,
       0,   734,  1358,  1256,  1318,     0,     0,   530,     0,   545,
     545,   530,  1369,  1257,   165,  1287,   154,     0,     0,   150,
       0,     0,     0,     0,   144,  1359,  1258,  1319,     0,     0,
    1360,  1259,     0,     0,   284,   606,   617,   622,  1264,   626,
     623,  1327,   624,  1367,  1260,     0,  1363,  1290,  1322,   589,
    1181,  1181,  1370,  1390,  1261,  1181,     0,  1298,     0,   273,
     275,     0,  1068,     0,  1262,     0,  1320,  1362,  1289,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1506,     0,
       0,     0,     0,     0,     0,   363,     0,     0,     0,  1300,
    2441,   363,  1361,     0,  1295,     0,  1335,     0,     0,   396,
       0,  1288,  1298,     0,   286,  1266,     0,  1329,     0,     0,
     223,   222,   224,     0,     0,     0,     0,  2206,  2207,     0,
    2204,  2057,  2257,     0,  1517,   958,   944,   957,     0,   940,
    2405,     0,   943,   945,     0,     0,     0,   946,   950,   951,
       0,   942,   939,   941,     0,   407,     0,     0,   751,   752,
       0,     0,     0,     0,   831,     0,     0,  1496,     0,   141,
     661,     0,     0,     0,   656,   686,   691,     0,     0,     0,
       0,   460,   464,   468,   469,   470,     0,     0,     0,     0,
     155,   142,     0,   873,     0,   530,     0,   744,  1181,  1373,
       0,   187,   180,     0,     0,   707,     0,  1545,     0,     0,
     584,   587,   586,     0,   374,   826,   824,   823,   825,   847,
     822,     0,  1852,  1854,     0,     0,     0,     0,     0,     0,
     596,   463,     0,     0,   533,     0,   572,     0,     0,     0,
       0,   569,     0,     0,     0,  2318,     0,   843,   815,     0,
    1111,     0,  1129,  1112,     0,     0,     0,     0,  1166,  1173,
    1142,  1167,  1144,  1173,     0,     0,   757,   761,   760,   764,
     762,     0,   758,   635,  1659,  1660,     0,  1199,     0,     0,
    1492,     0,  1490,   895,  1193,   363,     0,   363,     0,   363,
    1201,  1195,  1197,  1398,     0,   893,     0,     0,   886,   888,
       0,   890,     0,     0,     0,     0,  1598,  1586,     0,  1785,
    1625,     0,  2261,  1002,   532,     0,     0,     0,     0,     0,
       0,  1018,   633,  1025,     0,     0,     0,  1040,  1035,  1037,
       0,  1041,   720,     0,     0,  1617,  1610,  1612,  1611,     0,
       0,  1608,  2211,   885,     0,   602,     0,     0,     0,     0,
    1047,     0,  1042,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1716,  2212,  2213,     0,     0,     0,  2245,
       0,     0,  2098,     0,  2070,  2072,  2084,     0,  2099,  2055,
    2100,  2074,  2076,  2085,     0,     0,  2192,     0,  2088,  2087,
       0,  2022,  2023,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2037,  2089,  2171,     0,     0,     0,  2091,  2090,     0,
       0,  2239,     0,     0,     0,  2096,   496,  2101,     0,     0,
       0,     0,  2107,     0,  2128,     0,     0,     0,  2045,  2202,
       0,     0,     0,     0,     0,     0,     0,     0,  2014,  1999,
    2017,  1993,  1997,  2001,     0,  2016,     0,     0,  1987,     0,
       0,  1985,  2009,  1981,     0,     0,  2010,     0,     0,     0,
    2063,     0,     0,  1711,  1711,  1711,  1711,  1708,     0,     0,
       0,  1755,     0,  1755,   199,     0,   232,   219,  1522,  1689,
    1698,  1915,     0,  1933,  1931,  1876,  1881,  1954,  1809,  1816,
    1809,     0,     0,  1674,     0,  1796,     0,  1808,  1794,  1807,
       0,     0,  1822,  1820,     0,  1822,     0,  1822,     0,  1788,
       0,  1812,  1790,  1807,  1792,     0,  1838,  2276,  1847,     0,
    1768,  1725,     0,  2193,  1093,     0,  1727,  1749,  1748,     0,
    1738,     0,  1777,  1735,  1621,  1605,     0,  1603,  1585,     0,
       0,  1897,  1114,  1115,     0,  1138,     0,  1052,  1053,     0,
    1051,     0,     0,     0,   518,  1071,     0,     0,     0,   794,
       0,     0,   522,     0,  1501,     0,  1368,  1286,   665,     0,
       0,     0,     0,   680,   639,   681,   683,     0,     0,   682,
     685,   688,  1298,     0,   292,  1272,     0,  1333,  1146,     0,
       0,  1103,     0,     0,     0,     0,     0,     0,   478,   691,
     323,     0,     0,     0,     0,   383,     0,   303,   315,   381,
     321,     0,   355,     0,   326,     0,   319,   341,   333,   342,
     334,   354,   356,     0,   699,   700,   698,   694,     0,   701,
     703,     0,   372,     0,     0,     0,   349,     0,  1354,     0,
    1298,     0,   288,  1268,     0,  1331,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1336,     0,
       0,     0,     0,   739,     0,   736,     0,     0,   545,  1382,
       0,  1379,  1377,   545,     0,     0,   147,   146,     0,   153,
       0,     0,     0,     0,     0,     0,  1391,  1392,  1393,     0,
       0,     0,     0,     0,     0,   390,     0,   295,   297,   296,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   397,   365,     0,
     850,     0,     0,     0,   399,     0,     0,  1346,     0,     0,
       0,     0,     0,  1353,  1251,  2060,  2061,  2058,  1722,  2256,
       0,     0,     0,   955,     0,     0,     0,     0,   410,   411,
     141,   409,   432,     0,   794,     0,     0,   828,   833,   841,
    2505,  2179,  2180,   839,   834,   836,   838,   840,   837,     0,
       0,     0,     0,   500,     0,     0,     0,   487,     0,     0,
     497,   480,   483,   484,     0,     0,   657,   660,   658,   659,
       0,   679,     0,   463,   507,   559,     0,   157,     0,     0,
     158,   156,     0,     0,   374,   741,     0,   738,  1372,     0,
     183,     0,   711,     0,     0,     0,     0,     0,  1181,   649,
       0,   846,   848,   820,     0,   691,     0,     0,   608,     0,
     530,  1577,   591,     0,   561,   463,   559,   568,     0,     0,
     576,   373,     0,     0,   596,   374,     0,     0,  1072,     0,
     842,     0,     0,  1110,     0,     0,     0,  1163,  1168,  1164,
       0,  1143,  1125,     0,  1165,     0,     0,  1171,  1096,  1145,
    1097,  1414,  1415,  1412,  1413,     0,     0,     0,     0,     0,
       0,  1650,     0,     0,  1488,     0,   897,     0,   880,     0,
     882,   363,   728,     0,   363,     0,  1590,  1592,  1591,     0,
       0,  1593,  2261,     0,  1603,  1630,     0,     0,  1851,     0,
    1629,     0,     0,     0,     0,     0,  1017,     0,  1011,  1013,
    1038,     0,     0,  1047,  1044,     0,     0,  1615,  1613,   594,
       0,  1233,  1234,  1047,     0,   363,  1046,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2216,     0,  2247,
    2243,     0,  2067,  2217,     0,     0,     0,  2172,     0,     0,
    2021,  2033,  2034,  2035,  2232,     0,  2040,     0,  2030,  2031,
    2032,  2024,  2025,  2026,  2027,  2028,  2029,  2036,  2236,  2235,
       0,     0,  2093,  2094,  2095,  2238,  2102,     0,  2354,  2129,
       0,  2106,  2122,  2121,     0,     0,     0,  2109,     0,     0,
    2118,     0,  2173,  2293,  1958,     0,     0,  1984,  2242,  2002,
       0,  2018,  1980,  2192,     0,     0,     0,     0,     0,  1989,
       0,     0,     0,  2149,  2144,  2145,  2169,     0,     0,     0,
       0,     0,     0,  1702,  1701,  1707,  1768,  2057,  1768,     0,
       0,  1877,  1795,  1791,  1793,     0,  2686,     0,  1798,  1805,
       0,  1787,     0,  1821,  1817,     0,  1818,     0,     0,  1819,
       0,     0,  1789,     0,  1805,     0,  1845,  1714,     0,  2140,
       0,  1726,  1091,  1092,  1736,     0,  1739,  2384,  1849,     0,
    1604,     0,  1135,     0,     0,  1127,  1058,  1059,  1062,  1060,
    1057,  1061,     0,     0,     0,   794,     0,     0,   540,     0,
    1085,  1085,     0,     0,   524,   581,     0,   797,     0,     0,
       0,   795,   363,  1247,     0,     0,     0,     0,   640,  1366,
    1248,     0,     0,     0,     0,  1147,  1301,     0,     0,  1271,
       0,   300,   477,   476,   481,     0,     0,   306,   316,     0,
     311,     0,  1299,     0,     0,     0,     0,   310,   313,   385,
       0,   382,     0,   363,   363,   357,   696,   371,   376,   377,
     380,  1306,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   874,   857,     0,     0,   875,
     876,     0,     0,     0,  1204,  1205,  1203,  1338,  1339,  1344,
    1341,  1340,  1343,  1345,  1342,     0,  1254,     0,     0,   732,
    1302,     0,  1374,     0,  1378,   151,   148,   149,   152,  1303,
    1284,  1265,  1328,   590,     0,     0,     0,  1263,     0,  1321,
       0,  1280,  1274,     0,     0,     0,     0,     0,  1365,  1294,
    1326,  1364,  1292,  1324,  1291,  1323,  1293,  1325,  1285,     0,
       0,  1856,   854,     0,     0,     0,   363,   363,   853,   730,
    1267,     0,  1330,  1276,     0,     0,     0,   947,     0,     0,
       0,   949,   415,   433,   141,     0,   750,   814,     0,     0,
     830,     0,   485,     0,   491,   498,     0,     0,   502,   503,
     501,   486,  1181,   530,  1181,   783,   784,     0,     0,   804,
       0,   655,     0,     0,   461,     0,   504,     0,     0,   465,
     160,   159,     0,     0,     0,   745,   749,   747,   746,   748,
     743,     0,   734,   187,  2441,     0,     0,     0,     0,   588,
     582,   585,  1387,   821,     0,  1855,   724,     0,   374,   604,
       0,     0,     0,   461,   596,     0,   466,   471,   472,   481,
       0,   569,   560,     0,   561,   570,   571,     0,   578,  1462,
       0,   597,   578,     0,     0,     0,   845,     0,   844,     0,
    1113,  1130,  1131,     0,     0,  1173,     0,     0,  1175,  1170,
       0,     0,   763,   766,   759,   642,   363,     0,  1491,   363,
     363,  1230,     0,   891,     0,     0,     0,  1595,  1601,  1582,
       0,     0,  1626,  1603,  1627,  1032,  1033,  1034,  1031,  1030,
     634,     0,  1036,   995,   722,     0,   595,   363,     0,   996,
     972,   964,   971,   960,   963,   965,     0,   967,   968,   962,
     959,   961,  2246,  2083,  2086,  2097,     0,  2171,  2202,     0,
       0,  2041,     0,     0,     0,  2092,  2681,     0,     0,  2133,
    2134,     0,  2130,  2131,  2126,  2127,  2108,     0,  2494,  2113,
       0,     0,     0,  2006,  2004,  2003,  1988,     0,     0,  1986,
    1982,     0,  2011,  2135,     0,  2151,  2148,  2168,  2202,  1706,
    1705,  1704,  1703,  2140,  2290,  2140,   233,  1693,  1841,     0,
    1844,     0,     0,  1797,     0,     0,  1799,     0,     0,  1801,
    1803,     0,     0,     0,     0,     0,     0,  2279,     0,  1767,
       0,  1722,     0,  1737,     0,  1602,     0,  1128,  1136,     0,
       0,     0,   520,     0,   535,     0,     0,     0,  1078,  1087,
    1077,     0,   535,   535,   799,   798,   801,   796,   800,  1502,
       0,   673,   674,   677,  1273,     0,  1334,  1282,     0,  1619,
     302,   473,   309,     0,     0,     0,   304,   384,   386,   305,
     308,   312,   365,   325,   318,     0,     0,     0,  1269,     0,
    1332,  1278,  1305,  1356,  1252,  1316,     0,     0,   863,     0,
       0,     0,     0,  1357,  1253,  1317,     0,     0,     0,  1376,
    1375,     0,     0,  1619,     0,     0,     0,     0,     0,     0,
       0,     0,  1511,     0,     0,   364,   852,   851,   365,   398,
    1296,     0,  2059,     0,   948,   953,   954,   952,     0,   404,
     412,   415,     0,     0,  1221,  1221,     0,     0,   482,   499,
       0,   580,   539,   580,     0,     0,     0,     0,     0,   692,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     737,   736,   182,     0,   461,     0,   691,     0,   849,     0,
       0,     0,   596,   463,     0,     0,  1574,   462,     0,     0,
     474,     0,   572,   561,   569,     0,     0,   593,     0,  1455,
       0,   599,     0,     0,     0,   793,  1169,     0,  1183,     0,
    1124,  1094,  1178,     0,  1698,  1848,     0,     0,     0,     0,
     776,     0,   646,  1222,  1489,   881,   883,   729,  1587,     0,
    1588,  1594,     0,     0,     0,     0,  1631,  1623,  1039,     0,
    1043,  1047,   966,  2231,  2173,  2038,     0,  2234,  2233,  2237,
       0,  2103,     0,  2104,  2132,  2110,  2114,     0,  2111,  2112,
    2007,  2005,  1990,  2137,     0,  1722,  2170,  1676,  1675,     0,
    1696,  1846,     0,     0,  1840,     0,     0,  1870,     0,     0,
       0,  1806,  1824,     0,  1802,  1800,     0,  1813,     0,  1815,
    2383,  2654,  2558,     0,  1754,  1756,  1759,  1761,  1760,  1762,
    1758,  2139,  2141,     0,  1733,  2194,  1850,     0,  1632,  1633,
    1040,     0,   363,  1085,     0,  1181,   541,  2505,   542,  1084,
    1086,  1090,     0,  1181,  1181,   669,     0,     0,   281,     0,
     307,   317,   367,   379,     0,  1619,     0,     0,   861,   870,
     870,   858,     0,     0,   877,  1255,   733,     0,   544,     0,
     276,  1281,  1275,     0,     0,     0,  1513,  1514,     0,     0,
       0,     0,     0,  1304,   363,  1277,   956,     0,   435,   442,
     416,   420,  1505,     0,  1505,     0,   417,   421,  1505,  1505,
     414,  1848,   431,  1221,     0,  1218,  1217,   528,   610,     0,
       0,   489,     0,   550,   488,     0,   805,     0,     0,   690,
       0,   463,   559,     0,   517,   508,   509,   510,   511,   513,
     512,   514,   515,   516,   506,   505,     0,   691,   867,   374,
    1462,   731,     0,     0,   704,     0,   691,     0,  1577,   592,
     561,   463,   559,   467,   481,     0,   576,   569,   572,     0,
     573,     0,   577,     0,     0,     0,   596,  1515,  1072,     0,
    1073,     0,   794,  1182,  1143,     0,     0,  1172,  1176,  1177,
       0,     0,     0,     0,  1225,   770,   771,   765,   767,     0,
     778,   782,   641,     0,     0,   645,   636,     0,     0,     0,
       0,  1628,   691,   363,     0,  2039,     0,     0,  2116,  2115,
       0,  2155,     0,     0,     0,  1687,  1839,  1842,     0,  1873,
       0,     0,     0,     0,  1859,     0,  1804,     0,     0,  1814,
       0,     0,     0,  1763,     0,     0,     0,  1772,  1641,     0,
    1634,  1054,     0,  1055,  1079,     0,   580,     0,  1090,  1093,
     530,   580,   580,  1283,     0,   610,     0,   320,     0,   289,
    1279,     0,     0,   872,   872,     0,     0,     0,     0,     0,
       0,   392,     0,     0,  1507,     0,  1508,  1509,  1512,   400,
     413,     0,   440,     0,   438,   437,   439,     0,   428,     0,
       0,     0,     0,     0,     0,   403,  1216,  1220,  1219,     0,
     490,     0,   492,     0,     0,   536,   537,   538,     0,   494,
     546,   547,   802,     0,   807,     0,   693,     0,     0,   691,
     558,   715,     0,     0,     0,  1456,     0,     0,   583,   725,
    1462,   596,   569,     0,   561,   475,     0,   578,   572,   576,
     574,   575,     0,  1459,     0,   598,     0,  1081,     0,   792,
       0,  1173,  1184,  1179,  1174,  1418,     0,     0,   768,   773,
     772,  1505,   777,     0,     0,     0,   644,   643,     0,  1600,
    1848,  1597,     0,   719,   997,  2230,  2119,  2105,  2117,  2150,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1871,
    1872,  1857,     0,     0,  1861,  1811,  1837,     0,     0,     0,
    1757,  2142,  2143,  2309,     0,     0,  1641,     0,     0,   545,
       0,  1093,  1075,   539,   794,   794,  1619,   314,   366,     0,
       0,     0,   868,   871,   859,   860,   879,   878,   735,  1619,
       0,   388,   387,     0,   391,     0,   436,   445,     0,   443,
     418,   423,     0,   427,   425,   424,   419,   422,   527,     0,
       0,     0,     0,     0,     0,   548,     0,   549,     0,   806,
       0,     0,     0,   717,   866,     0,     0,   461,   691,  1457,
    1575,   572,   561,   569,     0,     0,   563,  1085,  1085,   448,
     576,   578,  1460,  1461,     0,     0,   497,  1074,     0,  1095,
    1417,  1416,  1698,     0,     0,     0,   779,   780,   775,     0,
       0,  1589,  1599,     0,  2641,  2384,  2613,     0,  2167,  2156,
    2167,  2167,  2147,     0,     0,     0,  1843,     0,  1860,  1863,
       0,     0,     0,  1869,  1862,  1864,     0,  1823,     0,  1835,
    1765,     0,  1764,  1640,     0,     0,   363,   534,   794,   543,
    1076,   550,   523,   521,   282,  1619,   862,     0,   277,     0,
     393,  1510,   441,     0,   426,   609,   493,   579,   555,     0,
     554,     0,   552,   551,   803,   808,     0,   691,   856,  1462,
     705,   576,   569,   572,     0,   562,     0,  1087,  1087,   578,
     446,     0,     0,   374,     0,  1400,  1698,  1399,  1401,  1409,
    1406,  1408,  1407,  1405,     0,  1228,  1229,   769,   774,     0,
       0,  1848,     0,  2160,  2159,  2158,  2162,  2161,     0,  2154,
    2152,  2153,     0,     0,     0,     0,  1866,  1867,  1868,  1865,
    1810,     0,  1766,  1643,     0,     0,  1635,  1636,     0,  1056,
     525,   794,   290,   869,     0,   444,   553,   530,   530,   691,
     716,  1458,   578,   572,   576,  1085,   564,  1086,   566,   565,
     450,  1081,  1082,     0,   578,   782,     0,  1410,  1404,  1674,
    1661,     0,     0,   781,     0,  1596,     0,     0,  2164,     0,
    2165,     0,     0,     0,     0,     0,     0,  1638,     0,     0,
       0,  1637,   526,     0,   557,   556,   718,   449,   576,   578,
    1087,   497,  1080,     0,  1848,     0,  1402,  1698,     0,     0,
     787,  2157,  2163,  2166,  1692,  1691,     0,     0,  1695,     0,
    1836,  1642,  1639,     0,     0,     0,     0,  1644,   389,   578,
     447,   567,   374,  1083,  1063,     0,  1403,     0,     0,   789,
       0,   785,   788,   790,   791,     0,     0,  1858,  1648,     0,
       0,     0,   451,   578,     0,     0,     0,   753,     0,  1722,
       0,     0,     0,     0,  1848,     0,     0,     0,   786,     0,
       0,  1645,  1649,     0,  1646,  1064,   787,  1226,  1227,     0,
    1694,     0,     0,     0,   754,  1647
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5254, -5254, -5254,  3802,  -562, -5254, -5254,  -953,  -215,  3029,
   -1079, -5254, -5254, -5254,  1367, -5254, -5254, -5254, -5254,  3775,
   -5254,  1713, -2877, -5254, -5254,   151,   192, -1372,   137,  3348,
    1389, -5254,  -980, -5254, -5254,  -606,     3, -5254,   218,   372,
   -5254, -5254, -5254, -5254, -5254, -5254, -5254, -5254,  -768,  1824,
   -5254,  1917,  1195,  4821, -4684, -5254, -5254, -1510, -3686, -5254,
     496, -5254,   525, -4685, -1045, -5254, -5254, -5254,  1812, -5254,
   -5254, -5254,  1757,   997,  -469, -5254, -5254, -5254, -5254, -5254,
   -5254,  -886, -5254, -5254, -1156,     8,  -632, -2911, -4202, -5254,
   -5254,   354,  -507, -1464, -5254,   546, -5254, -4514, -5254,  -120,
   -2624, -2492, -5254, -5254, -5254,  -479, -1443,  1295, -5254,  -727,
   -1132,  1631, -2570, -1005, -5254,  -356, -3497, -1131,  -899,  -896,
   -1038, -4252, -4738, -5254, -5254, -1154, -3688, -5019, -5253, -4703,
   -4672,  1302, -5254,  -148,   360, -5254,    10, -3590, -3674,    17,
     335, -5254,    20,    24, -5254,   348,  -826,  -987, -1591, -5254,
    -906, -5254, -5254, -5254, -3377, -5254, -5254, -5254,   155, -5254,
   -5254, -5254, -5254,   394, -5254, -5254, -5254, -5254, -5254, -5254,
   -3138,  1785,  1786, -5254, -4052, -5254,  -928, -5254,   556, -3435,
    1228, -5254, -5254,   991,  3778,   377, -5254, -5254, -5254, -5254,
   -5254, -5254, -1778, -5254, -5254, -5254, -5254,  -125,  -451, -5254,
   -5254, -5254, -5254, -5254, -5254, -5254,    25, -5254,   953,   314,
   -5254, -5254,  -743, -5254, -5254, -5254, -5254, -5254, -5254, -1210,
   -5029, -1320, -1300, -5254, -3421, -5254, -5254, -5254,  -426, -5254,
   -5254, -5254, -5254, -5254,  -834, -5254,  1045, -4045, -5254, -5254,
     353, -5254, -5254, -5254, -5254, -5254, -1013,  -368,  2950, -5254,
    -600,  -803, -5254, -5254, -5254,  -358, -5254, -5254, -5254, -5254,
   -5254,  -506, -1287,  4777,  4161, -1119,   599,  -833,  -559, -5254,
   -5254, -5254, -2768, -5254, -5254, -4156, -5254,  4769,  2349,   948,
      29, -5254,    -7,    81,  3587, -5254,   904, -1159, -3045,   298,
    -558, -5254, -5254, -5254, -3042, -5254, -5254, -5254, -5254, -3985,
      36, -5254,  -724, -5254, -4267, -5073, -4476, -4014, -1178, -5254,
   -4702, -4200, -4994, -4009, -5254,  1813, -5254, -5254,  -567,  -184,
    2931, -5254, -1461,  2152, -1376, -5254, -2453,   374,  1387,  2935,
   -3194,  -124,  2923, -2958, -5254,  -715,   981, -5254,  -450, -3716,
   -5254, -5254, -5254, -2680,  -692, -5254, -5254,  1536,   350, -5254,
   -5254, -5254, -5254,  -641,  2902,  -200, -5254, -5254,  4129, -5254,
   -4843, -5254,  4097, -5254, -5254, -5254, -5254,  2821,  2823, -5254,
   -5254, -1435,  1153, -5254,  -844, -5254, -5254,  1919,   584, -5254,
   -5254, -5254, -5254,  1239,  -549, -5254, -5254, -5254, -5254, -5254,
   -5254, -5254,  -994, -1198, -5254, -5254, -4750, -5254, -5254, -5254,
   -5254, -5254,  2229,  -951,  -745,  3995,   656,    37, -5208, -5254,
   -5254, -1196, -5254,  3349, -5254, -5254, -5254, -5254, -5254,   368,
     370, -5254, -5254, -5254, -5254, -4261, -5254, -5254, -4916, -5254,
   -5254,  1895, -5254, -5254,  1336,     6,  3052, -5254, -5254, -5254,
     -26, -5254, -5254, -1014,  2242, -5254, -2353, -5254,  -576, -5254,
   -5254, -1874,    39, -4244, -5254,  -638, -5254,  2889, -5254, -5105,
   -1207,  -123, -5254, -5254, -4247,    19, -5254, -5254, -5254, -5254,
   -4900, -5254,  -634, -5254, -4831,   362, -3719, -5254,     4, -5254,
    -517,  -890, -5254, -5254, -5254, -3651,    40,   131, -5254, -5254,
      16,   109,   -36,   -39,   -27,    11,   130,  3458, -5254, -5254,
   -5254,     7,  3501, -5254,   -28,  -856,  4811,  4813, -5254,  -866,
    -142, -5254,  1485,  -708, -2555,  3406,  3414, -5254,  1473,  2252,
   -2411, -2414, -5254,  -959,  -869,  -704, -5254, -5254, -5254, -5254,
   -1520,  -695, -2563, -5254,  3419, -5254, -5254, -5254, -2372, -3292,
   -3220,  1509, -3222, -3110, -5254,   798,   779,  -988,  -202,   -31,
   -1465,  -784,  -248, -5254, -5254,  1519,  -448, -5254, -5254,  -449,
   -3223,   389, -5254, -4475, -2766,  1529, -1127,  -839, -5254,  -970,
   -5254,  -665,  5858,  3481,  -823, -5254, -5254,  -794, 10393, -5254,
   -5254, -5254, 12718, 13943, -5254, -5254, 14415, 14542, -5254,  -619,
   15502,  9427,  -786, -1906,   491, 17624, -1807,  -495,    22, -5254,
   -2898, -2292, -5254, -5254, -5254,  -412,   886,   572, -5254, -4493,
   -4324, -5254, -5254, -1946, -5254,  -674, -5254,  -672, -5254, -5254,
   -5254, -2954, -4578, -3174,  2389, -5254, -5254, -5254,  -203, -5254,
   17385, -3201, -5254,  -391, -1002, -1586,  2860, -2883, -1910, -5254,
   -5254, -5254, -3059, -5254, -5254, -5254,  -776,  1621, -5254, -5254,
    1724, -5254, -5254, -5254,  -966,  1963,  -750, -1187,  1627,  4008,
    -780,  2396,  -795, 16259,  -683, 12517, -1267, -5254,  6244, -4203,
     123,  6877,    38,  -135,  4359,  -652,  2314,  2736, -5254, -5254,
    5099,  7765,  -598,  -857, -5254,    -6, 14201, 10510, -3621, -5254
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,    62,    63,  1599,  2980,  2834,
    3760,  3761,    64,    65,  1595,    66,    67,    68,    69,  1509,
      70,  1086,  1847,  2994,    71,  2670,   831,   832,   833,  2536,
    2537,  2925,  2538,  2526,  1360,  1793,  1531,   805,   806,  1491,
    1532,    73,    74,  1354,  2517,    75,    76,    77,  1562,  1655,
    1563,  1564,  1503,  1893,  4821,  5587,  3550,  2789,  3808,  3551,
    3552,  4188,  4189,  4277,  5601,  5602,    78,  1671,  1672,    79,
      80,  2962,  3726,  4330,  5189,  5190,  5430,   640,  4844,  4845,
    5417,  5418,  5615,  5768,  5769,  2995,   671,  3803,  4414,  3751,
    4915,  3752,  4916,  3753,  4917,  4178,  4179,  3737,  4361,  4362,
    2040,  4857,  4363,  3754,  4876,  5464,  3755,  2689,  5630,  3029,
    1967,  1965,  5365,  5443,  4677,  4678,  4251,  5639,  5640,  5641,
    5892,  4878,  4921,  4922,  5805,  5806,  3806,  4420,  4928,  5247,
    5441,  3448,    82,  3779,  3780,    83,   734,  1869,  3915,   735,
    3032,   672,   736,  2996,    88,  3022,  5632,  3023,  1625,  2848,
    4343,  3893,    89,  1113,  4153,  5272,  5525,  5526,   725,    90,
    1855,    91,    92,  2975,  3744,    93,  2706,  3465,    94,    95,
    3484,  3485,  3486,    96,  4371,  5208,  1565,  3539,  3540,  3541,
    3542,  4209,    97,  1850,  3003,  3004,    98,    99,   100,  3135,
    3136,   101,  2911,   102,   103,   104,   105,  4245,  4779,  4892,
    3581,  3767,  4387,  4890,   106,  3730,  2997,  3050,  3841,  3842,
    5270,  5517,  5518,  5519,  5691,  5927,  5521,  5693,  5828,  5695,
    4867,  6060,  6061,  5502,  4142,  4691,   108,  4868,  4869,  5645,
     109,  2704,   110,   111,  1824,  2968,  2969,  4344,  3039,  3816,
    3817,  4400,  4401,   112,  3668,   113,  4755,  4756,   673,  5653,
    5593,  5754,   114,   115,  4759,  4760,   116,   117,   118,   119,
     120,   726,  1048,  1049,   728,  1168,  1169,  3420,  1130,   121,
    2546,   122,  3706,   123,  1246,  4991,   124,   761,  1186,  1187,
    2998,   126,   771,  3154,   773,  3120,  3121,  1983,  3897,  3898,
    4503,   127,   128,  3132,  3157,   129,  1496,  2680,  2681,  4672,
    2999,   674,  1231,  3036,  3443,  5499,  5098,  5500,  5816,  5983,
    5099,  5371,  3374,  4106,   131,   675,  1537,  2745,  1136,  1137,
    3043,  3821,  2650,  2651,  1694,  4441,  2653,  3823,  2654,  1469,
    2655,  1123,  1124,  3829,  3830,  3831,  3832,  4437,  4447,  4448,
    5264,  5510,  4444,  1843,  5258,  5259,   132,  1534,  2742,   133,
     134,   135,  1578,   973,  1146,  1147,   136,   687,   688,   137,
    5435,   138,  1126,   139,  5268,   140,   141,   796,   797,   142,
     143,  2759,  4191,   144,  1535,   145,   146,  3575,  3576,  4771,
     147,   148,   149,  2820,  2821,   150,   151,   152,   153,   154,
    5917,  5986,  5987,  5988,  4455,  5822,   155,  1218,   156,   157,
     158,   159,   197,  1014,  1015,  1016,   926,  3000,  5249,   161,
     162,  1492,  1493,  1494,  1495,  2675,   163,   164,   165,  3851,
    3852,   166,   167,   168,   169,  1827,   170,   171,  5408,   172,
     173,  1797,   174,   175,  1022,  1023,  1024,  1025,  1795,  3322,
     634,   850,  1385,  1391,  1434,  1435,  1436,   177,   738,   178,
    1226,  1053,   739,  1177,   180,   740,   181,  2633,  3876,  4479,
    4480,  4481,  4484,  5284,  4660,   741,  3400,   183,  1990,  3141,
    3144,  3396,   742,   184,  3879,  3880,  3881,  4486,   743,  5358,
    5359,  5735,  5956,  5957,  6011,  6047,   744,   763,  1116,  3054,
     745,  1321,   189,   190,   191,   906,   853,   854,  3327,  5320,
    5545,   746,  2510,  3305,   780,  1440,   894,   895,   896,   915,
    2935,  2599,  2600,  2624,  2625,  1449,  1450,  2612,  2616,  2617,
    3387,  3380,  2605,  4100,  5344,  5345,  5346,  5347,  5348,  5349,
    4649,  2620,  2621,  1452,  1453,  1454,  2629,   194,  2589,  3355,
    3356,  3357,  4077,  4078,  5857,  4092,  4088,  4634,  5069,  3358,
     842,  1216,  1461,  4642,  5859,  3359,  5058,  5059,  5324,  4096,
    3366,  4117,  3791,  3792,  3793,  3360,  5553,  5554,  5854,  5855,
    5326,  5327,  2656,  1414,   880,  1322,   881,  1427,  1323,  1401,
     883,  1324,  1325,  1326,   886,  1327,  1328,  1329,   889,  1393,
    1330,  1331,  1410,  1423,  1424,  1386,  5328,  1333,  1334,  1335,
    3362,  1336,  4580,  5031,  5017,  3232,  3233,  2533,  4576,  4000,
    4570,  2505,  3295,  5081,  5351,  5352,  4040,  4604,  5045,  5315,
    5713,  5838,  5839,  5939,  1337,  1338,  1339,  3292,  2499,   976,
    1340,  4346,  2501,  3223,  3201,  1697,  3202,  1993,  2014,  3173,
    3189,  3190,  3269,  3203,  3211,  3216,  3224,  3256,  1341,  3175,
    3176,  3940,  2016,  1342,  1020,  1700,  1021,  1429,  3251,  1350,
    1351,  1344,  1984,   843,  5065,  1172,  1780,   777,  1345,  1346,
    1347,  1348,  1571,   947,  1139,  1140,   897,   899,   900,  2593,
     630,   622,   949,  3543,  2502,   631,   624,   625,  1785,  2503
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     623,  1054,  1624,    72,   185,  1056,   176,   193,    81,   975,
      84,   192,   974,  1080,   841,  1696,   187,    85,   845,   182,
      86,   905,  1908,   939,    87,   107,  1355,   737,   619,   125,
     810,   980,   192,  2861,   985,  1026,   130,   160,  1343,   179,
     186,  1207,  1208,  1209,  1171,  1792,   893,  1213,   916,  2783,
    1570,  1406,  1455,  1676,  2688,  1786,  1441,  1152,  1443,  1426,
     765,  1382,  1629,  3447,  1688,  2011,   765,  3397,  3750,  1397,
    1398,  1165,  1964,  1232,   927,  2746,  3398,  1852,  1405,  2754,
    1117,  2004,   983,  1369,  3017,  4051,  3833,  4053,  1119,  4180,
    3901,  1412,  2652,  4252,  1381,  4651,  1005,  1474,  4399,  1178,
    2755,  4204,  3172,  4206,   772,  2929,  4159,  4115,  3781,   188,
    3920,  1566,  1825,  2766,  3772,  4348,  1830,  4450,   811,  1794,
    3147,  1834,  4679,  4425,  2822,  2822,  4412,  4714,  2822,  1047,
     188,  1844,  3665,  4074,  5062,  1026,  1588,  4091,  3308,   628,
    1150,  1605,  3310,  1154,  1864,   764,   679,  4674,  2891,  2892,
     910,   764,  3241,   918,  2737,  3084,  1179,   233,  2585,  4485,
    2652,  4935,  1781,  1162,  4924,   919,   904,  4914,  5074,  4739,
    5076,  4875,  4104,   804,  5527,  1897,  3709,  5447,  3712,  3713,
     838,   856,  4119,  3717,  3718,  3719,  5244,  3721,  3722,  3723,
    5212,  1538,   623,   830,  3320,   998,  3633,  1026,  3413,  3415,
    5121,   623,   950,  3392,  3389,  5100,  4024,  1448,  4409,   623,
    5529,   950,   623,  4923,  2737,  4120, -2426,  2887,  1362,  5378,
    1451,  1623,  2717,  5486,  1533,   950,  1119,  3208, -2464,  5251,
    1654,  2737,  1860,  5667, -2489,   747, -2350,  4969,  5243, -1930,
    1681,  3368,  1394,  1395,  2918,  5022,  1837,   747,  4089, -2527,
    4094,  1026,  1404,  3964,  5410,  5411,  2544, -2318,   638, -1897,
     685,  1861,  5655,  5400,  1188,  1533, -2318, -2318, -2319, -2429,
    1533,  1505,  1890, -2697, -2283,  3690,  1890, -2319, -2319,  1381,
     747,  2898, -2697, -2697, -1910, -1935, -1925,   790,  1890,  3182,
     925,  3873,   685,  2672,  2061,  3014,  3363,  1192,  2757,  6043,
     685,   917,   685,  3740,  2757, -2282,  4435,  3769,   685,   685,
    5592,  1026,  3249,  1106,  1660,  2885, -1938,  1988,  1478,  1841,
    3459,  2757,  2757,  2757,  3249,  2550,  4364,  1890,  1822,  1241,
    3918,  2523,  1817,  1567,   685,  2508,  1567,  4396, -1938,   747,
     685,  4247,   747,  2960,   747,   685,   685,  4160,  3479,  1890,
    -141,  3417,  5436,  4906, -2177,   685,  -141,  1661,  2552,  2588,
    3479, -2177,  4993,  4994,  4995,   685,  4997,  4998,  4999,  5000,
    5001,  4336,  1359,  2590,  4752,   791,  2822,  5579,   913,  1890,
    1874,   913,  3728,  2978,  4936,  1506,  5701,  5282,   753,  1890,
    3340,  1890,  1890,  2039,  5820,  2757,  4804, -1751,  3137,  3183,
     753,  2690,  5967,  5934,  1479,  5240,   753,   636,   753,  4545,
    2807,  4546,   754,  3741,    41,  1786,  5811,  5751,  1688,  5019,
    5377,   753,  1444,  2596,   754,  3133, -2487,  1119,  5097,  2691,
     754,  3480,   754,  2992,  2732,  1470,  2603,  3394,  1211,  3442,
     632,   753,  6009,  3480,  2061,   754,  2524,  4477,  5382,  1839,
      45,   975,  5799,  3341,  -686,  5826,   632,  1480,  3325,  5568,
    1387,  2527,   775,  2592,  2793,   754,  2539,  2539,  4214,  5669,
     747,  1471,   635,  3874,  3184,  1472,  1397,  1398,   685,  3015,
    4215,  6044,  3326,  4478,  5569,  5589,  3289,  5827,  4753,  2757,
     633,  5752,    49,  3290,  5414,  1446,  1916,  1405,  2903, -1072,
    4271,   975,  2061,  1010,  1996,  5487,   909,   195,  2552,  1473,
    2545,  3134, -2196,  1251,  2993,  1412,  3964,  1074,  6010, -2196,
   -2822, -2822, -2822,  1084,  2757,   848,  1212,  3138,  2694,  2733,
    5020,  5444,  1662,  2550,  2604,  1097,  5438,  3185,   792,  3964,
    3186,  5475,    41,   869,  1447,  3395,    57,  4547,  2808,  1906,
    3156,   196,  5935,  5702,  3156,  1481,  3446,  5909,  1891,  1985,
    5968,  3418,  1891,  5107,  3419,  2525,  2552,  2061,  1781,  1420,
   -1751,  2055,  1786,  4805,  1891,  1995,  5821,  2979,    45,   793,
     794,  3938,  2692,   686,  5741,  5953,  3964,  3729,  2961,  2005,
    5626,  2933,  -434,  4348,  3693,  4754,  5954,  4445,  2550,  2513,
    5338,  5782,  5283,  1011,  3742,  1842,  1946,  4160,  2724,  3483,
    2864,   937,  1842,  1891,  5166,  3705,  4256,  2671,  2731,  4774,
      49,  3483,  3691,  1507,  2509,  4990,  1989,   950,  6045,  2971,
    4365,  2552,  2587,    50,  3460,  1891,  2917,  1663,  5167,  2008,
    1394,  1395,  2886,  1057,  1577,  1111,   950,  1119,  5972,  5810,
     192,  3016,   950,  3187,  1012,  1058,    51,  1823,  1055,  3488,
    3564,  4309,  1212,  1212,   950,  1891,  2856,  1404,  1989,  2859,
    4397, -2487,  3250,  1243,  3875,  1891,   795,  1891,  1891,  4436,
     950,  2899,  6046,  1392,  4029,   623,  1508,  2927,  2928,  5765,
     893,  5971,  4487,  3743,   623,   950,  1823,   905,  4884,  5304,
    1823,   623,  2866,   950,   623,  2846,   639,  2563,  2849,  2850,
    2784,  1182, -2177,  1013,  3363,  1892,   893,   950,  4684,  1899,
   -2426,  6019,  3168,  1487,  3337,  1488,  5287,   950,   759,   760,
    2801,  1903, -2464,  4701, -1930,  3139,  2926,  3979, -2489,  4932,
   -2350,  5911,  5662,   192,  2722, -2487,  2767,  2630,   188,  1215,
    4931,  4782, -2318, -2527,  1396,  3140,  4784, -2487,  2521,  2828,
    2631,   759,   760, -2319,  3188,  6049,  1119,  1018, -2697, -2283,
    1914,  1019,  1407, -2429,  1119,  1119,  1456,  1497,  2498,  1400,
   -1935, -1925,  5901,  2568,  2569,  1943,  1185,  2845,  1190,   950,
    1194,  3970,  1936,  1408,  1407,  2057,  1198,  2511,   929,   931,
   -2282,  5930,   934,  3313,  6065,  1597,  2800,  1371,  4348,  2879,
    2880,  1409,   623,   623,  1215,  1408,  3086,  2784,   950,  2741,
    1568,  1569,   992,  1568,  1569,   759,   760,  4272,  1598,  1002,
    2934,  3104,  1939,  1411,  1906,  4502,   975,  -141,  -141,  1808,
    5292,   188,   904,   950,  3291,   623,  5874,  4091,  5439,  2591,
    1018,  3114,  1804,   849,  1019,  2695,  1809,  1018,  1810,  5878,
    4631,  1019,  4744,  3129,  4635,  4328,  4329,   918,   893,  2904,
   -2196,   764,  2741,   764,  4397,   764,  1906,  4885,  4515,   919,
    4502,   764,  1199,  1200,  5974,  4409,  5108,  5574,  1687,  2741,
     623,  1498,  1460,  1201,  4390,  4534,  4446,  3174,  2905,  2948,
    3837,  5955,  5168,   950,  5739,   938,  1799,  1512,  4843,  5744,
    5745,    72,   185,  4847,   176,   193,    81,  5783,    84,   192,
     804,  1221,  1223,  3905,   187,    85,  5803,   182,    86,  2054,
    4664,  2785,    87,   107,  5538,  1490,  1948,   125,   911,  6069,
    2809, -1750,  1070,  4155,   130,   160,  4323,   179,   186,  4182,
    4266,  4267,  2619,  1133,  6018,  4268,  4846,  3596,  4622,  4122,
    4624,  4123,  5791,  3907,  5809,  4109,  2970,  3389,  2696,  4058,
    5665,  2606,  4886,  1358,  3556,  5962,  1220,  1366,  5802,  4873,
    3546,  5266,  1388,  2495,  2496,  2497,  2498,  3838,  6101,  4509,
    5635,  1685, -2822, -2822, -2822,  3974,  3975,  3976,  3977,  3978,
    3979,  1219,  5931,  2716,   912,  2566,  5627,   920,  2988, -1897,
    6093,   623,   623,  1782,  3115,   917,  2607,   188,  3492,   950,
    3976,  3977,  3978,  3979,   623,  5399,  6074,  1665,  3026,   893,
     623,  5480,  1856,  1666,   623,  3547,   623,  3524,  2785,  4772,
     893,  2825,  5523,  3597,  2829,  2592,  2493,  2494,  2495,  2496,
    2497,  2498,  1372,  5588,  3027,  1499,   893, -2279,  3363,  4887,
    2768,  3363,  1463,  4183,  5902,  3974,  3975,  3976,  3977,  3978,
    3979,  2638,  5919,  5717,  2769,  1857,  2770,  4911,  2515,   764,
    1203,  4679,   913,  4955,   920,  5845,  3371,  1416,  4388,  1786,
    5383, -1897,  1402,  1403,  1183,  1500,  2786,  3598,  3525,   623,
    2682,   623,   623,  4912,  4900,  5907,  5908,  3363,  5910,  1251,
    3363,   680,  3964,  3493, -1750,  5489,  3965,  3966,  3967,  2683,
    1416,  2697,  1925,  5636,   685,  2787,  1373,  2784,  2609,  1501,
    5490,   804,  1221,  4585,  3548,  4110,  2784,  2771,  1237,  2682,
    4378,  1667,   950,  4860,  3030,  4510,  5539,  2878,   764,  2516,
    2788,  3906,  4654,  1460,  1906,  3960,  3599,  6045,  2858,  5628,
    2784,  5617,  1417,  5619,  1589,  1926,  5919,  5623,  5624,  1686,
     623,   921,  1251,  4874,  5474,  3964,  3372,  6041,  2684,  3965,
    3966,  3967,  1906,  3557,  3126,  3127,  2784,  1646,  2610,  2782,
    1026,  3908,  4230,   192,  1883,  1417,  4586,  1502,  2685,  5637,
    5648,  3649,  3839,  2786,  4156,   950,  5980,  3650,  1884,  2632,
     922,  2635,  1645,  2698,  3106,  1555,  3840,  2684,  4888,   893,
    5524,   950,  5230,   914,  3247,  1418,  5267,  2784,  1419,  5261,
    5664,  5676,  2787,  5242,  5661,   950,  1071,  2685,  4680,   950,
    5236,  1061,  3108,  1064,  3434,  2906,  1066,  1134,  3028,  5647,
    1858,   623,  5286,  3065,  5092,  3088,  5932,  2788,  1418,  1204,
    1091,  1419,  1464,  3600,  1885, -1897,  1095,  3077,  1882,  6017,
    1018,  4184,  4185,  6020,  1019,  3412,  3116,  5919,  1590,  5663,
    3083,  6024,   623,  4345,   905,  3489,  3113,  3507,  4889,  4865,
    3118,   188,  2987,  1052,  2691,  3125,  2782,  4913,  3128,  4861,
    2784,  4186,  2055,  3549,  4666,  1668,  4231,  2784,  4111,  5491,
     623,   623,   623,  4379,   623,  3651,  6050,  3969,  1950,  3349,
    1952,  1823,  1954,  1184,  1956,  4655,  1958,  1959,  1960,  1251,
    3435,  4717,  3964,  1962,   623,  3063,  3965,  3966,  3967,  3061,
    1927,  1420,   779,  3225,  3274,  1669,  6072,  3700,  2785,  2686,
    3076,   651,  5850,  3078,  5945,  1859,  1054,  2785,   950,  2548,
    1056,  1597,  2013,  3565,  1886,  4718,   950,   950,  2737,  3095,
    6084,  3082,   920,  4442,  1420,  5888,  5572,  5997,   975,  1670,
    3969,  2785,  2022,  2907,  1598,  1175,  3601,  3970,  2686,  4652,
     623,  3199,  3109,  2060,  3602,   681,  2061,  3603,  3961,  3962,
     923,  2597,  2598,  3981,  2602,  3117,  5063,  2785,  4056,  3123,
    3124,   653,  5066,   919,   919,  5651,   919,  5070,  6031,  1782,
    5072,  -601,  1887,  3026,  5659,  3110,  1460,  2550,  1460,  2052,
    5825, -1099,  2861,  1444, -2822,  3296,   623,  5209,  3111,  4866,
     623,   623,  1591,  4012,  4013,  1928,  5205,  4719,  2785,  3027,
    3970,  4653,  1421,  3343,   682,   816,   623,  5998,  6001,  1183,
    2552,  4983,   893,  2687, -1897,  3579,  2784,  5851,  2888,  1244,
    4232,  4987, -1897,  3112,  1396, -1897,  1425,  2919, -1897,  3652,
    5703,  3226,  1592,  4945,  3275,  1421,  2983,  4667,   753,  3276,
     764,  4172,   683,  4668,   684,   764,   764,   788,   922,  3781,
    4669,  3490,  2687,  3167,  1505,  4911,  1446,  4488,  1422,  3309,
    4233,   790,   754,  2786,  4348,  3968,  1593,  5710,   651,  3653,
    1888,  2785,  2786,  2567,  2784,  4451,  3277,  3566,  2785,  4014,
     893,  4912,  2574,  1518,  2575,  4670,  5561,  3969,  2578,  3209,
    3580, -1066,  2787,  5999,  4234,  2584,  2786,  1786,  3230,   917,
     917,  2787,   917,  3654,  4837,  2700,  5488,  4671,  5479,  4841,
     817,  1575,  1576,  3047,  5206,  2701,  4173,  2788,  4264,  1420,
    5742,   893,  2786,  2676, -2822,  2787,  2788,  3297,   653, -2822,
    5889,  3822,  2851,   664,  2677,   665,  3048,  3106,  3971,  3972,
    3973,  3974,  3975,  3976,  3977,  3978,  3979,  5793,  1490,   791,
    2788,  2787,  2678,  1490,   893,  2984,  2782,  3970,  3663,  1010,
    6002,   669,  4452,  2786,  3526,  2782, -2822,  2882,  1506,  3169,
    5852,  3171,  4269,  4349,  3148,  5853,  2788,  3178,  5493,  2989,
     812,  1801,   655,  3192,  3193,  3194,  5494,   764,  4905,  2782,
    4757,  4274,  2787,  5224,  3213,  1594,  1813,   764,  4311,  3019,
    3228,  3971,  3972,  3973,  3974,  3975,  3976,  3977,  3978,  3979,
    2025,  5890,  2652,  5711,  5817,  2782,  2652,  2788,   950,  3909,
    4352,  2557,  1438,   651,  3278,  3527,  1490,  1835,  1836,  1230,
    1490,  1010,  4742,   623,   623,   623,  2786,  2785,  1184,  5891,
    6000,  1199,  1200,  2786,  5712,  3432,  4687,  4270,  1189,  1191,
    1193,  4858,  1873,  1195,  1196,  1197,  2782,  5978,  5979,  1011,
     975,   975,  1906,  1202,  3074,  2787,  1579,  3678,  4902,  3064,
    2852,  4275,  2787,  1666,  2853,  5797,  2702,  5060,  4354,  1781,
     195,  3131,  5870,   653,   764,  2774,  4864,   764,   764,  3106,
    2788,   789,  1910,  1912,  4185,  2785,  5900,  2788,  3049,  3910,
     664,   815,   665,  3655,  4758,  3604,  4278,  4743,  2679,  -164,
    1012,  4345,   792, -1099, -2822,  1098,  2703,  5104,  3057,  2775,
    4276,  4453,  4859,  4730,   196,   668,  1906,  1439,  1838,  2782,
    4688,  1011,   950,  5654,     3,     4,  2782,  4770,  3363,   958,
    1580, -2302,  3363,  3656,   893,  -164,   959,   960,   961,  5668,
    6037,  1099,  5495,   793,   794,   893,  1555,  4703,  3971,  3972,
    3973,  3974,  3975,  3976,  3977,  3978,  3979,  1782,  1626,  1013,
    6051,   893,  5675,  5197,  1406,  -164,  1842,  3657,  4357,   975,
    -459,  1667,  1012,  3393,   839,  3604,  1100,  4082,  5105,  3479,
     950,  4454,  1465,  4689,  3363,  5970,   731,  4690,   950,   731,
    1607,  5334,  2786,  2794,   851,  1372,   950,  3615,  1627,   747,
    5542,  1444, -1721,  6080, -2822,  4746,    15,  1445, -1721,    15,
    4083,  3588,  4358,   907,   893,  2493,  2494,  2495,  2496,  2497,
    2498,  2787,  1466,   623,  1101,  4637,   623,  3446,  4359,   893,
    1608,  1013,   893,   893,  5522,  4085,   623,   623,  5982,   950,
     950,    20,  1098,  5620,    20,   664,  2788,   665,  5621,  1597,
    2786,   623,  1251,   950,   623,  3964,  1467,  6016,  1105,  3965,
    3966,  3967,  3480,   893,   893,  3553,   950,   950,   764,  1373,
    5543,  2061,  1598,  1838,  1446, -1721,  5037,  2815,  1099,  2787,
    1475,  1237,  3616,  5291,  5689,  2782,  1368,  4138,  3855,  -459,
    3619,  3577,  1823,  3622,  2839,  5515,   192,  3481,  3142,  5213,
    5622,  2920,  2550,  5211,  2788,  5819,   623,  2832,  1628,   908,
     623,   623,  2835,  4391,  5801,  5193,  4345,  2606,  5409,  5516,
    1476,  1106,  3505,  1447, -1721,  1251,  4360,  5800,  3964,  2762,
    5690,  2763,  3965,  3966,  3967,  2552,  3153,  3482,  1057,  3365,
    3781,  2921,  5235,  2782,   623,   192,   623,  5214,  5194,  6053,
    1058,   623,   623,  1055,  1477,  5646,  5222,  4087,   623,   623,
     623,  1101,  2607,   623,  2861,   623,  4527,   623,   623,   623,
     623,   623,   623,  2652,  3799,   623,  2531,   623,   623,  4171,
    6003,   623,  5511,  2652,  5360,  2909,  5362,  4487,  1842,  2915,
    3577,  4008,  2764,  3664,   188,   893,   623,   623,   623,   924,
    3658,  3694,  3695,  3696,  6004,  1107,  1483,  4102,  5184,  1181,
    5185,  5186,  5187,   623,  3591,  1782,  3614,  1119,  1407,  2532,
    3098,  5680,  3099,  3152,  3100,  2608,  3101,    33,  3102,  4473,
      33,   195,  3103,  1939,  5406,  3589,  3502,  3590,  1407,  1408,
    3483,  1656,    36,   188,  3363,  3363,  3849,  3700,  5915,    29,
    3381,  4501,   925,  4318,  3639,  5903,  3738,  5407,    41,  1408,
    3969,    41,  1635,  2822,  2652,  3934,  2870,   933,  2738,  3659,
    2561,  1229,  2831,  1949,  2609,   196,  1951,  1409,  1953,  1939,
    1955,  1657,  1957,  3180,  3181,  1658,  1961,  5697,  3684,  3227,
    3195,  3196,  2851,  2777,    45,  2871,  4502,    45,  4541,  4542,
    4543,  4544,   935,  3660,  4548,  4549,  4550,  4551,  4552,  4553,
    4554,  4555,  4556,  4557,  3328,  1659,  3785,  3786,  3787,  3788,
    3240,  3790,  5201,  5658,  5203,  1383,  4620,  1636,  5406,  3630,
    3970,  3631,  3661,  3969,  2610,  3635,    49,  4680,  1407,    49,
     957,  5454,  4273,   732,   956,    41,  3818,  2757,  5625,    50,
    2774,  5407,    50,  3892,  5973,  1108,   623,  1632,  2758,  1408,
    4081,  3596,  4595,  4596,  5123,  1787,  3662,  5984,  1788,  1637,
    2867,  5128,    51,  1939,   234,    51,  1638,  1411,  4227,  1639,
     637,    45,  5868,  3756,  2775,  1433,  4081,  4310,   729,  5533,
      57,    41,  1109,   733,   783,  5455,   623,  1633,  5456,  2893,
    2894,  2895,  2896,  3970,  5457,  1000, -1674,   813,   964,   965,
     966,   967,   968,   969,   970,   971,   972,  1597,  4228, -1674,
    2922,  1862,  1933,    49,   784, -1674,   994,    45,   785,  1009,
    2852,  1634,  5458,  2923,  2853,  4082,    50,  4421,  4855,  5279,
    1598,  3390,  3391,  1364,  1863,  1934,  3811,  3597,  5231,   623,
    1018,  1110,  4229,  1111,  1019,  4081,   995,  1112,  -141,    51,
    2757,  4082,  2924,  5872,  5873,  4856,  2519,  4806,  4083,    49,
    1017,  2765, -1674,  3363,  4823,  5406,  3255,  5916,  1060,  4126,
    3363,  4107,    50,  4084,  1396,  3363,  2586,   747,  3363,  5459,
    4807,  1600, -1674,  4085,  4083,  4687,  4680,  4824,  5407,  3935,
    3773,  3598,  5460, -1673,  3936,    51,  6073,  1062,    41,  4084,
    1673,   762,  3998,  1677,  5461,  4458, -1673,   762,  4005,  4085,
    4459,  4086, -1673,    57,  1018,  4680, -2283,  4017,  1019,  4018,
    4082,  3971,  3972,  3973,  3974,  3975,  3976,  3977,  3978,  3979,
    1640, -1674,  5818,  1067,    45,  2949,  2950,  4086,  5067,  2539,
   -1674,  4939,  4663,  4019,  3757,  5416,  4459,  1396,  1094,  2586,
    3599,  2967,  1945,  4083,  5060,  1788,  3916,  3917,  1081, -1673,
    6091,  4349,  6094,  3891,  4661,  -600,  1641,  4350,  4084,  4688,
    1642,  1102,  3990,  4052,  3992,  3993,    49,  5960,  4085, -1673,
    4351,  1997,  6105,  1103,  1788,  3010,  3011,  3012,  3013,    50,
    3260,  3261,  3262,  3263,  3971,  3972,  3973,  3974,  3975,  3976,
    3977,  3978,  3979,  1104,  1643,  4087,  4086,  5832,  4352,  1125,
    4353,  1644,    51,  1121,   623,   623,   623,   623,   623,   623,
     623,   623,   623,  2547,   623,  1072,  1788,  1073, -1673,  1132,
      57,  4087,  4689,   623,  5591,   623,  4690, -1673,   975,  5595,
    5596,  3472,  2560,  2931,  2932,  2561,  1587,  3260,  3261,  3262,
    3263,  1604,     3,     4,  4020,    41,  3469,  3600,  3473,  3474,
    4021,  2594,  5373,  5374,  1788,  3087,  4354,  1141,  1478,  3092,
    6012,  3091,  2561,   623,  1142,  4854,  5681,   623,  4063,  4064,
     623, -1674,   623,  3105,  3321,   623,  3106,  3107,  4161,   623,
    3106,    45,  1148,  5068,  4355,  5462,  2060,  4054,  5463,  2061,
    4087,  1159,  3758, -2822, -2822, -2822,  3145,  4121,  1166,  3146,
    1782, -2275,   623,  3466,  4190, -1674,  1018, -2276,  1206,  1076,
    1019,  1077,  1018,  1176,  1206,  4729,  1019,   632, -1674,   623,
    2550,   747,  3324,    49, -1674,  1939,  3363,  2551,   623,   623,
    3361,  1396,  3501,  1425,  4097,  3329,    50,  3234,  2561,  3404,
    3237,  3759,  2561,  1205,  1479,  1786,  2587,  1206,  4907,  3499,
    4027,  4356,  3500,  2552,   950,  3571,  4357,  3734,  3572,    51,
    3735,   893, -1745, -1745,  3883,   893,   893,  3106, -1673,  1217,
    3601, -1674,   950, -1749, -1749,    41,   950,    57,  3602,  3933,
     950,  3603,  2561,  3255,  4407,  3942,  5940,  5941,  2561,   950,
    3436, -1674,  3439,  2012,  4720,    57,  4727,  1480,  4022,  1214,
    4358,  3948,  4345,  3949,  2561,  5576,  2561,   950,  3487,  4023,
     623,    45,  5866,  5581,  5582,  4490,  4359,  3354,  3595,  3336,
    3338,   623,  1210,   893,   623,  3346,   623,   623,  5995,   893,
    3209,  3209,  4711,  3433,  1396,  3209,  2586,  1119,  3252,  4164,
   -1674,   950,  3950,  1610,  3052,  2561,  3053,  4702,  3983, -1674,
    1227,  2561,  3997,    49,  1228,  2561,  4002,  3388,  3388,  4003,
    4061,   950,   950,  2561,  1225,  1611,    50,  2553,  2652,  4043,
     893,  4044,  2554,  1230,  4130,  3209,  3209,  5840,  5841,  4207,
    4514,  4212,  4208,  4394,  4213, -1748, -1748,  4238,  5807,    51,
    4239,  4307,  1782,   950,  4239,  1481,  1782,  1234,  3681,  3363,
    4680,  4430,  4127,  4128,  4431,  4745,  4366,    57,  3587,  2556,
    4433,   902,   903,  4434,  4360,  4222,  1612,  1236,   764,  5567,
     950,  6054,  1782,  3363,  5503,  4464,   950,  4566,  4465,  4577,
    4567,  4588,  4578,  1237,  2561,  4662,  3963,  1238,  3419,  4908,
     950,  4965,  3106,  4970,  4966,  1239,  4971,   950,  3991,  4984,
     950,  5007,  1989,  1235,  2561,  5047,   950,  1482,  2561,  5088,
    5094,  1240,  3419,  5095,  2557,  1483,  5101,  5102,  5103,  3106,
    3106,  3106,  5237,  1247,  5274,  5238,   950,  4465,  4148,  1245,
    4248,  6095,   950,  4015,  4253,  5301,  1119,  1370,  5302,   950,
   -1674,  5303,  5321,  1484,  2561,  5322,  5331,  1485,  2970,  1939,
    1374,    36,  3511,   950,  5337,  1613,  5235,  4404,  5339,  5449,
    5469,  4404,  5450,  3106,  5504,  5550,   950,  5505,  5551,  4337,
    5556,  1782,  5559,  1939,  1367,  4404,  4042,   950,  4925,  3629,
    5610,  1486,  5650,  5611,  5677,  2518,  4680,  5678,  4279,  5700,
    5706,  5707,  5678,  4003,  2561,   623,   623,   623,  4243,  5721,
    5725,   623,  5722,  1939,  1614,  1375,  1018,  2559,  1615,  1430,
    1019,  5726,  1376,  1487,  2561,  1488,  1610,  1380,  5750,  5756,
    4259,  3146,  3146,  2860,  5757,  1384,  1392,  3146,   623,   893,
    5760,  5761,  3363,  2561,  2561,  1389,  5762,  1782,  1611,  5763,
    4918,   764,  5420,  3822,  5789,  1390,  1396,  5790,  3926,   764,
    3928,  3929,   764,  5846,  1399,  5860,  4404,  1617,  2561,  5862,
    5867,  3363,  2561,  3106,   764,  1489,  5882,   911,  5905,  5883,
     623,  5906,  1400,  1413,  5733,  4682,  4683,  1430,  5807,  4686,
   -1722,  4045,  5952,  4046,  4680,  5564, -1722,  5981,  5421,  1612,
    5678,  4521,  6022,  6048,  6067,  6023,  2561,  5722,  3361,  1431,
    3363,  6077,   893,  1619,  6078,  3923,   893,  2489,  4384,  1415,
    1442,  3800,  2592,  5422,  1457, -2822, -2822, -2822,  2493,  2494,
    2495,  2496,  2497,  2498,  2060,  1458,  1620,  2061,  2652,  6083,
    1459,  5423,  4966,   912,  6092,  5424,  6104,  2561,   975,  6078,
    3342,  3344,  3345,  4418,  1462,  4419,  1622,  4848,  5010,  4849,
    5011,  1539,  6026, -1722,  6027,  4723,  1468,  5425,  2550,  1430,
    5426, -1662,  4616,  1510,  4618, -2822,  5053,  4636,  5055,  4639,
    4398,  1425,  1536,  1688,  4377,  5427,  4380,  5317,  1613,  5318,
   -2320,  1541,  3877,  1542,  1581,  1577,  1582,  1583,  1594,  4505,
      29,  2552,  1596,  1606,   950,  4680,  1609,  1631,  1647,  1648,
    1675,  1786, -1722,  1674,   188,  4367,  1664,  4369,  1678,  4729,
     893,   913,   950,  1119,  4572,  1119,  1683,  1684,  1796,   950,
    1798,  3252,  1800,   623,  1805,   893,   623,  1614,   623,   623,
     893,  1615,  1811,  1816,  1819,  1821,  1826,  1829,   623,  1831,
    4103,   905,  1823,   623,  1840,  1845,  2860,  1846,  -184,  1848,
    1849,  1851,  1854,  3363,  1853,  1865,  1872,  1876,  5885,  1880,
    4026,   214,  5913,  1889,  1894,  5428,  1895,  1929,  1896,   623,
     623,   623,  5295,  1898,   623,   188,  1901,  4496,  1902,  1905,
    1617,  1906,   623,   623,   623,   623,    41,  1913,   905,  4439,
    1917,  2060,  1919,  1782,  2061,  1920,  1922,  1119,   623,  1782,
    1924,   623,  4721,   623,  1930, -2822,  1932,  1935,  1938,  1941,
   -2822,  1942,   764,  1944,   623,   623,  5120,  5429,   623,  1947,
    1963,  1994,    45,  2000,  2002,  2550,  1619,  2003,  2009,  2010,
   -1901, -1908, -2822,  2017,  2018,  2019,  4513,   623,  2020,   623,
    2021,   623,    57,  2023,  4048,  4049,  4050, -2822,  2024,  1620,
    2025, -1898,   914, -1899,  2026, -1902,  2027,  2028,  2552, -1900,
    2029,   623,  2031,  2032,    49,  4967,  2033,  2034,  2035,  1622,
    2036,  2037,  2038,  2039,  2041,  2042,  2043,    50,  2044,   950,
    2045,  2046,  2047,  2048,  2504,  3477,  2052,   905,  2506,  2508,
    2509,  4698,  2518,  2522,  2534,  4952,  2542,  2587,  2564,  2565,
      51,  1610,  2557,  2570,  4769,  2572,  2573,  2582,  2588,  2576,
    2577,  2579,  2580,  2581,   623,  2583,  1445,   623,    57, -1411,
    2595, -1411,  2626,  1611,  1447,  2628,  3553,  4594,  4740,   623,
    2639,  2640,  2642,  2052,   623,  2641,  2658,  1610,  2659,  2660,
    2661,  2662,  3361,  2586,  3363,  3361,  2663,  4842,  2664,   623,
    4829,  2665,  3577,   783,  2667,  3255,  3363,  2666,  2668,  1611,
    2674,  2699,  2693,   623,  2705,  2719,   623,  6052,  2723,  2726,
    2725,  4036, -2822,   893,  1612,  2727,   893, -2822,   893,  2729,
    2730,  2743,  2749,   893,  2747,  4177,  2760,  2748,  2761,  2772,
    2776,  3361,  1054,  2779,  3361, -2822,  1056,  2780,   950,   950,
    2778,  2782,  2781,  2790,   623,  2792,  4055,  2795,   764,  2791,
    1612,  4722,  2796,  2797, -2822,  2806,  2802,  2816,  2696,  2803,
    2830,  2812,  4834,  3617,  4062,   950,  3620,  2840,   950,  4068,
    2813,   893,  4073,  2826,  2827,  2833,  2836,  2847,  2837,   893,
    3209,  3209,  3209,  3209,  2842,  2843,  3209,  3209,  3209,  3209,
    3209,  3209,  3209,  3209,  3209,  3209,  2854,  2855,  2857,  5535,
    1555,  2872,  2862,  1613,   893,  2863,  2868,  2869,  2874,  2557,
    4108,  4108,  2876,  2883,  4569,  2875,  4723,  2881,  3354,  2877,
    2884,  3354,  2900,  2889,  2890,  2901,  2908,  2902,  5549,  2913,
    2930,  2942,  3363,  2937,  2592, -2822,  2944,  2945,  2946,  1613,
    1782,  1782,  1782,  4103,  3209,  3209,  2493,  2494,  2495,  2496,
    2497,  2498,  1614,  2947,  3711,  2951,  1615,  2952,  2958,  2963,
    2953,  2955,  2956,  2957,  2959,   950,  2965,  3724,  2966,  2973,
    2964,  2860,   646,  2974,   893,  3733,   893,  2977,  5257,  4538,
    2990,  3001,  1628,  3005,   950,  3006,  2060,  4627,  1614,  2061,
    3009,  2982,  1615,  3018,  3021,  3024,  3025,  3045,  3034,  3051,
    3038,  4980, -2822,  3055,  3067,  1617,   950,  2860,  3069,  3070,
    3071,  4724,  3042,  4565,  3777,  3060,  2060,  3085,  3072,  2061,
    2550,  3097,  3130,  3174,  3363,  3155,  3119, -2822,  3179,  3143,
    3363,  2061,  3229,  3235,  3239,  3801,  3254,  3248,  3271,  3293,
    3273,  1617,  3294,  3315,  3312,  3316,  3332,  3331,  3317,  3318,
    2550,  1619,  3333,  2552,  3330,  3334,  3335, -2822,  3339,  1420,
    4607,  3347,  3348,   912,  3365,  3382,  3370,  3383,  3384,  3385,
     893,  3399,  3401,  3402,  1620,  3408,  3440,  3409,  3856,  3428,
    3858,  3411,  3442,  2552,  3437,  3444,  3451,  1619,  3445,  3456,
    3461,  3462,   950,  3464,  1622,  3467,  1364,   623,  3475,  3491,
    3496,  3515, -2822,   623,  3498,  3508,  3528,  3533,  3534,  3567,
    1620,  1368,   893,  2493,  2494,  2495,  2496,  2497,  2498,  3560,
    3554,  3570,  4597,  2060,  3588,  3561,  2061,  3578,  3585,  3608,
    1622,  3609,  4725,  3562,  3586,  4726,  4880,  4881,  3625,  1782,
     893,  3363,  1842,  3667,  3680,   950,  3688,   950,   913,  3689,
    3701,  3692,  4598,  3708,  3714,  3715,  3716,  2550,  3720,  3736,
     950,  5218,   950,  3725, -2822,  3747,  3748, -2822,  5032,  3924,
    3762,  3766, -2822,  3768,  3776,  3783,  3931,  1251,  3789,  3794,
    3964,  3795,   623,  3764,  3965,  3966,  3967,  3797,  3802,  3796,
    2552,  3798,  3805,  4428,  3807,  3809,  3810, -2822,  3813,  3814,
    3819,  5078, -2822,  3834,  5552,  4918,  3835,  3836,   893, -2822,
    3844,  3845,  3846,  3848,  3850,  3864,  3870,  3866,  4975,  4976,
    4977,  4978,  4979,  3867,  3890,  5127,  3872,  3885,  3886,   950,
     893,  3900,  3887,  3888,  3156,  3889,  4424,  3903,  1939, -2822,
    3904,  2782,  3902,  2060,  3914,  3911,  2061,  3919,  3921,   905,
    3895,  3927,   893,  3947, -2169,  3996,  3999,  1936,  4016,  5041,
    1903,  3894,  1212,  3944,  2557,  3945,  3946,  3209,  3951,   764,
    5578,   950,  4461,  3693,  3952,  3956,  3958,  2550,  4011,  4025,
    3959,  3982,  1215,  3960, -2822,  3987,  4039,  3988,  4034,  5085,
    3995,  2561,  4381,  4010,  2557,  4035,  4037,  4038,  4041,  4059,
     950,  5191,  4060,  4065, -2822,  4601,  4067,  4071,  4066, -2822,
    2552,  4099,  4072,  4114,  4080,  4095,  4112,  4105,  4116,  4124,
    4140,  4143,   950,  4136,  4169,   950,  4129,  4137,  4132,   188,
    4131,  4145,  4157,  4158,  4168,  4170,  4174,  4141,  4175,  4176,
    4177,  4181,   623,  4192,  4193,   893, -2822,  4195,  4201,  4202,
    4203,   623,  4211,  4217,  4242,  4226,  4240, -2822,  4246,   623,
    4247,   623,  4244,  4250,   623,   188,  4254,  4255,   893,   623,
     623,   623,   623,  4258,  4261,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   623,  3969,  4262, -2822,   623,   623,
     623,  4263,  4260,   893,   904,  4280,  4265,  4282,   623,  4283,
    4284,  2557,  4281,   623,  4285,  1782,  4287,   623,  4296,   905,
    4286,  2592,  4288,  4289,  4290,   623,  4291,  4292,   623,  5082,
     623,  4103,  4294,  4301, -2822,  4609,  4610,  4611,  4612, -2822,
     623,  4293,  4295,   623,   623,  2898,  4299,  4303,   623,   623,
    4315,  4316,  4305,  4306,  4312,   623,  4317,  4103,  4322,  4319,
    4327,  4333,  4335,  5946,  5947,  3970,  4370, -2822,  4385,  4375,
     764,  4386,  4389,  4376,  4393,  5118, -2822,  4404,  2493,  2494,
    2495,  2496,  2497,  2498,  1057,  4403,   623,  4382,  4406,  4150,
    4151,   192,  4422,  4423,   623,  5023,  1058, -2822,   623,  1055,
    4416,  4413,  4426,  4427, -2822,  4443,  4457,  4460,  2493,  2494,
    2495,  2496,  2497,  2498,  4429,  4475,  4467,  4469,  4463,  4476,
    4483,  4489,  3361,  4491,  4492,  4497,  3361,  4493,  4504,  4506,
     623,  2557,  4507,  4494,  4495,  4508,  4517,  4518,   893,  2012,
    5169,  5170,  4519,  5172,  1251,  4520,  4522,  3964,  4523,  5257,
     623,  3965,  3966,  3967,  4524,  4525,  5202,  4526,  4530,  3964,
   -2168,  4579,  5162,  4590,  2052,  4562,  4591,  4602,  5038,  4632,
    4621,   950,  4539,  4563,  4633,  4564,  4640,  4646,  3361,  4641,
    4647,  4648,  4571,  4659,  4593,  4665,  4617,  4625,  4608,   188,
    4619,  4628,  4694,  4630,  4645,  4650,  5018,  4656,  4673,  4697,
    4695,  4705,  4704,  4707, -2822,  4708,  4710,  4715,  2861,  3354,
    4716,  4751,  4735,  3354,  4696,  2493,  2494,  2495,  2496,  2497,
    2498,  4732,  1782,  4747, -2822,  4748,  4749,  1782,   893,  1782,
    4750,  4761,  4763,  4764,  4762,  5354,  1543,  4765,  4777,  3257,
    4766,  3258,  1544,  4775,  4781,  4794,  4103,  4778,  4783,  4795,
    4800,  4803,  4819,  1782,   893,  4820,  4822,  1649,  4722,  5220,
    4836,  4838,  4825,  4839,  4840,  3259,  3971,  3972,  3973,  3974,
    3975,  3976,  3977,  3978,  3979,  4877,  4862,  4891,  4898,  4910,
    4920,  4835,  4851,  4872,  4897,  4904,  4926,  1546,  4937,  4883,
    4927,  4946,  4903,  4944,  4948,  4962,  4943,  4950,  4947,   950,
    4951,  4964,   950,  4968,  4956,  4981,  4986,  4988,  4996,  5604,
    5003,  5606,  4785,  5004,  5009,  5021,  5024,  5025, -2170,  5071,
    5015,  5026,  5080,  4793, -2822,  5043,  5030,  5061,  1543,  4321,
    5083,  5057,  5064,  5075,  1544,  2493,  2494,  2495,  2496,  2497,
    2498,  1650,  5084,  1547,  5087,  5091,  5089,  5096,  5097,  5124,
    1548,  5419,  3969,  1549,  5106,  5125,  5126,   764,  5129,  5135,
    5136,  5137,  5149,  5156,  5158,  5174,   623,  5173,  5164,  3260,
    3261,  3262,  3263,  5165,  5181,  5152,  3264,  3265,  5182,  1546,
    1550,  5183,  3266,   764,  5188,  5192,  5199,  5195,  5200,  5207,
    5210,  5215,   950,   950,  5216,  5217,   893,   764,  5219,  5223,
    5225,  5330,  5229,   950,  5234,  5239,  5241,  5245,   764,  5246,
     623,   623,  5330,  5250,  1551,  5252,  5253,  5263,  5248,  3106,
     950,  5254,  3970,  5269,  5271,  5285,  5288,  5289,  5296,  5306,
    5307,  5314,  5716,  5300,  5319,  1547,  5323,  5308,  3361,  3361,
    5466,  5364,  1548,   893,  5309,  1549,  5329,  5361,   893,   623,
     623,  5355,  5372,  5333,  5376,  5379,  5380,  5386,  4929,  5614,
     623,  5336,  5381,  5738,  5412,  5434,  5375,   975,  5392,  5541,
    5393,  5397,  1550,  5403,  4861,  5368,  5440,  5404,  5405,  1651,
    5442,  5445,  5472,  1553,  1199,  1200,  5448,  5453,  5452,  4474,
    5477,  5473,  5482,  1554,  5484,  5501,  5514,  5506,  5512,  5513,
    5520,  5528,  1555,   623,  5384,  5530,  1551,  5540,  5544,  5773,
    5775,  5548,  5560,  5562,  1556,  5566,   950,  5585,  5564,  5357,
   -2821,  5565,  5586,  5575,  5577,  3354,  5389,  5584,  5598,  1251,
    3267,  5592,  3964,  5616,  3209,  5634,  3965,  3966,  3967,  5629,
    5631,  3268,   623,  5644,  5638,  5652,  5642,  5657,  5666,  5670,
    5671,   188,  5672,   623,  1652,  5673,  5674,  1558,  1559,  5685,
    5684,  5686,  3249,  5692,  5687,  5714,  5694,  5698,  5715,  5718,
    5696,  1651,   764,  5734,  5728,  1553,  4603,  5708,  5736,  5737,
    5749,   623,  5753,  5772,   623,  1554,  3209,   948,  1653,  5778,
    5781,  5784,   623,   623,  1555,   893,   984,  5786,  5788,   623,
     623,  5792,  5795,  1513,   623,  5796,  1556,  5812,   623,  5813,
    1006,   623,   623,  5815,  5814,  5823,   623, -2821,  5824,  5829,
    5830,  5833,   623,  3971,  3972,  3973,  3974,  3975,  3976,  3977,
    3978,  3979,  5843,  5844,  5842,  5849,  5856,  5858,  1514,   623,
     764,  5869,  5864,  5877,  5879,  5782,   623,  5783,  5886,  1558,
    1559,   623,  5894,  5767,   623,   623,  1561,  5895,  5912,  5896,
    5884,  5938,   623,  5914,  5779,  5933,  5948,  3361, -2821,  5951,
    5557,  5964,  5958,   623,  3361,   623,  5966,  5996,  5985,  3361,
    1560, -2821,  3361,  6005,  5991,  5992,  5090, -2821,  6008,  6007,
     623,  6028, -2821,  6029,  6033,  6030,  6032,  6055, -2821,  1515,
    6057, -2821,  6042,  6058,  6066, -2821,  4487,  6070,   893,  6068,
    6081,  6090,  6086,  6075,  6076,  5720,  6045,  6087,  6096,  6103,
    6099,   950,  5508,  3770,  4057,  2914,  3640,  4187,  3559,  4738,
    1432,  5942,  5943,  4731, -2821,  1516, -2821, -2822,  5880,  3727,
    3679,  2541,  5431,  1540,  4332,  5766,   893,  5965,  1561,  5608,
    4879,  5483,  4728,  5198, -2821,  5465,  4134,  3884,  5871,  5366,
    5961,  3354,  5787,   950,  5785,  5893,  3354,  4139,   893,  3354,
    5227,  1517,  5976,  5122,  5419,   950,  4909,  4901,  4930,  5747,
    4871,  3745,  3746,  5130,  4736,  4205,  4392,  5221,  1630,  4896,
    5471,   623,  4432,  4954,  5688,  6025,  6102,   623,  6088,  5446,
    4338,  5391,  5898, -2821,  4938,  2981, -2821,  3970,   950,  1518,
    5594,  5755, -2821,  1519,  5394,   727,  1050,   781,  4498,  1986,
    4982,  3209,  5571,  6021,  3414,  3774,  4125,  5603,  4940,  3044,
    3040,  4449,  3056,  5682,  5509,  3073,  1120,  1160,  3150,   893,
    3151,  1119,  4302,  4767,  1520,  1521,  3677,  4249,  5918,  6056,
    3209,  4957,  1483,  3704,  1377,  4958,  3096,  3369,   764,  6071,
    2939,  5570,  2673,  5281,   764,   623,  5865,  2562,   764,  4972,
   -2821,  2514,   818,  5743,   819,  4101,  2623,  3379,  4113,  5861,
    5730,   623,  4075,  2622,  1522,  4638,  1782,  4623,    36,  4069,
    5335,  2627,  5546,  1523,  5547,  5146,  5147,  4973,  6039,  4070,
    5150,  5151,  1524,  5848,  5949,   950,  5719,  2571,  5536,  4573,
    1525,  5731,   623,   975,  5732,  3298,  3215,  4032,  1526,  3939,
    3703,  4030,  3250,  5767,  1428,  3307,     0,  3367,     0,     0,
    1527,  5537,     0,     0,     0,     0,     0,     0,     0,  1528,
    3361,     0,     0,  1529,     0,     0,  5232,     0,     0,     0,
       0,     0,  4103, -2821,     0,  4850,  5740,     0,   893,     0,
     893,     0,     0,     0,   975,  5558,     0,  5390,     0,  4852,
       0,     0,  2054,     0,     0,     0,     0, -2821,     0, -2821,
   -2821,     0,  5388,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1530,     0,     0,
    5278,  5280,   950,     0,     0,     0,     0,     0,  3971,  3972,
    3973,  3974,  3975,  3976,  3977,  3978,  3979,     0,     0,     0,
     623,     0, -2821,   623, -2821, -2821,   623,   623,   623,  5433,
       0,  1075,  5599,  5600,     0,  1119,     0,  1075,     0,   188,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
       0,   623,   623,     0,     0,   623,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   623,  3209,     0,     0,     0,
       0,   623,     0,  6079,     0,   623,     0,     0,     0,     0,
       0,   893,   623,   188,   188,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,   950,     0,     0,     0,   623,
       0,     0,     0,  3361,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   621,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3361,     0,     0,
       0,     0,   774,     0,   776,     0,     0,     0,   782,   893,
     950,     0,     0,     0,   799,   807,   774,     0,   814,     0,
     623,   807,   807,     0,   844,     0,   847,     0,     0,  5709,
       0,     0,     0,   901,   901,   901,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5603,     0,  2060,     0,  5727,
    2061,  5729,     0,  6064,  2062,  2063,  2064,     0,     0,     0,
    3354,     0,  1782,     0,  5920,     0,     0,   623,  5922,     0,
       0,  2549,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2550,     0,     0,     0,     0,     0,     0,  2551,     0,
       0,     0,     0,  6089,     0,  5356,     0,     0,     0,     0,
       0,  6064,  5498,  5847,     0,     0,     0,     0,  1513,     0,
       0,     0,     0,     0,  2552,  5470,     0,     0,     0,  6064,
    6014,  6015,     0,     0,     0,     0,     0,     0,   623,     0,
       0,   893,     0,     0,     0,     0,     0,     0,   764,     0,
       0,     0,     0,  1514,     0,     0,  5496,    72,   185,     0,
     176,   193,    81,     0,    84,   192,  3361,   623,  5920,   623,
     187,    85,  5922,   182,    86,  1119,     0,     0,    87,   107,
     623,     0,     0,   125,   623,     0,   623,   621,   930,   930,
     130,   160,   930,   179,   186,  3361,   941,   905,   844,     0,
       0,   977,     0,     0,   941,     0,   623,   941,     0,   623,
     844,     0,   930,     0,  1515,   844,     0,     0,   188,   930,
     623,   844,     0,     0,     0,     0,     0,   623,     0,     0,
       0,     0,     0,     0,  3361,     0,     0,     0,  2553,     0,
       0,     0,     0,  2554,     0,  3209,  3209,     0,     0,   188,
    1516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,   975,  2555,  2248,     0,     0,     0,
       0,   893,     0,     0,     0,     0,   893,   893,     0,  5920,
    2556,   623,     0,  5922,     0,     0,  1517,   623,   623,   950,
       0,     0,     0,     0,  5171,     0,     0,     0,     0, -2600,
       0,     0,     0,   950,     0,     0,     0,     0,     0,  5175,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2300,     0,   623,     0,     0,     0,     0,  1519,     0,
       0,   623,     0,     0,  1782,  2557,     0,     0,  2558,     0,
       0,     0,  2052,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   623,
    1521,     0,     0,     0,     0,     0,     0,  1483,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5660,     0,     0,     0,  3361,     0,   893,
     893,     0,     0,     0,     0,     0, -2600,     0,     0,     0,
    5233,     0,     0,    36,     0,  2739,     0,     0,  1523,     0,
       0,     0,     0,     0,     0,     0,     0,  1524,   623,     0,
       0,     0,     0,     0,   623,  1525,     0,     0,  2559,     0,
       0,     0,   764,  2740,     0,   623,  1782,     0,     0,   893,
       0,     0,     0,     0,   623,  1527,   623, -2600,   623,     0,
       0,     0,     0,     0,  1528,     0,  5876,     0,  1529,     0,
   -2600,     0,     0,  6013,     0,     0, -2600,     0,     0,     0,
     623, -2600,     0,     0,  3354,     0,   188, -2600,     0,     0,
   -2600,     0,     0,     0, -2600,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1782, -2602,   950,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1530, -2600,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2489,  5925,
    5926,     0,     0, -2600,     0,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,     0,     0,     0,     0,  3953,
     623,     0,  3954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   623,     0,     0,     0,     0,     0,     0,  6082,
       0,     0,     0,     0,     0,     0,     0,     0,  3361,     0,
       0,     0, -2600,     0,     0, -2600,  5369,     0,  5370,     0,
    3361, -2600,     0, -2602,   623,   623,   623,     0,     0,     0,
       0,     0,   623,     0,  5831,     0,     0,     0,     0,     0,
       0,     0,   623,     0,     0,     0,  5764,     0,   623,     0,
       0,   950,     0,  1029,     0,     0,     0,     0,     0,   844,
       0,   930,     0,   930,   623,     0,   930,     0,     0,     0,
       0,     0,     0,   977, -2602,     0,     0,   950,  1087, -2600,
     930,     0,     0,     0,     0,     0,   930, -2602,     0,     0,
       0,     0,     0, -2602,     0,     0,     0,     0, -2602,     0,
       0,     0,     0,     0, -2602,     0,     0, -2602,     0,     0,
     621, -2602,     0,     0,     0,     0,     0,     0,   623,   941,
       0,     0,     0,   977,     0,     0,   941,   188,   623,   941,
       0,     0,  5899,     0,   779,     0,     0,   623,   623,     0,
   -2602,     0,     0,   623,     0,   930,     0,     0,   623,  5924,
       0,     0,     0,   192,     0,     0,  3361,     0,  5923,     0,
   -2602,  5921, -2600,     0,   623,   623,     0,     0,     0,     0,
       0,  5497,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2600,     0, -2600, -2600,
       0,     0,     0,     0,     0,     0,     0,   950,     0,   844,
    5990,     0,   807,   807,   807,     0,     0,     0,     0, -2602,
       0,     0, -2602,     0,     0,     0,     0,  1233, -2602,     0,
     623,     0,  6097,  6098,     0,   188,   623,     0, -2600,  1543,
     879, -2600, -2600, -2600,     0,  1544,     0,  1349,  1349,     0,
     844,   807,     0,  5924,   623,   807,     0,   192,  3361,     0,
    1649,   188,  5923,     0,  3361,  5921,     0,     0,     0,   844,
       0,     0,     0,     0,   844,   623,     0,     0,     0,     0,
    1349,  1900,     0,     0,     0,     0, -2602,  1904,   623,     0,
    1546,     0,     0,     0,     0,     0,     0,  1915,     0,     0,
       0,  1918,     0,     0,     0,  1921, -2618,  1923,     0,     0,
       0,     0,     0,  1931,     0,     0,     0,     0,     0,  1937,
     623,     0,  1940,     0,     0,  1349,     0,   623,     0,     0,
       0,     0,     0,     0,     0,     0,  1543,     0,  5605,   844,
    5607,   779,  1544,     0,  1650,     0,  1547,   623,     0,     0,
       0,     0,   844,  1548,  1782,  5989,  1549,  1545,     0,     0,
       0,     0,     0,  2912,  5924,     0,     0,   844,   192, -2602,
       0,     0,     0,  5923,     0,  3361,  5921,     0,     0,     0,
       0,     0,     0,  1550,     0,     0,   844,  1546,     0,   623,
     623,   930,   930, -2602,   623, -2602, -2602,     0,   623,     0,
       0,     0,  1782, -2618,     0,     0,     0,     0,     0,     0,
     623,   623,     0,     0,     0,     0,     0,  1551,     0,     0,
    1782,     0,     0,   807,   807,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2602,     0,     0, -2602, -2602,
   -2602,     0,     0,  1547,     0,     0,  1349,  1349,     0,     0,
    1548,     0,     0,  1549, -2618,     0,     0,     0,     0,   621,
       0,   930,     0,     0,     0,   941,   188, -2618,   977,   941,
       0,   941,     0, -2618,     0,     0,   930,     0, -2618,     0,
    1550,     0,  1651,  6062, -2618,     0,  1553, -2618,     0,     0,
       0, -2618,     0,     0,     0,     0,  1554,     0,     0,     0,
     844,     0,     0,     0,     0,  1555,     0,   930,   930,     0,
       0,     0,     0,     0,  1551,     0,     0,  1556,     0,     0,
   -2618,     0,     0,     0,     0,     0,     0,     0,   844,   844,
     844,  6062,   930,     0,   621,  2991,   621,   621,     0,     0,
   -2618,     0,     0,  3008,     0,     0,     0,     0,     0,  6062,
       0,  2912,     0,     0,     0,     0,     0,  3637,     0,     0,
    1558,  1559,     0,     0,     0,     0,     0,     0,     0,     0,
     930,     0,   930,   930,     0,     0,     0,     0,     0,  1552,
     620,  5794,     0,  1553,     0,     0,     0,     0,     0, -2618,
       0,  3638, -2618,  1554,     0,  3066,     0,     0, -2618,     0,
       0,     0,  1555,     0,     0,  1349,     0,     0,     0,     0,
       0,     0,     0,   844,  1556,     0,     0,     0,     0,     0,
       0,     0,  2912,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1966,     0,  1966,     0,     0,     0,   844,
       0,   774,     0,  2060,     0,     0,  2061,     0,     0,     0,
    2062,  2063,  2064,     0,  1557,     0, -2618,  1558,  1559,  1561,
     844,     0,     0,     0,     0,     0,  2001,  2549,     0,   844,
       0,     0,  2007,  2060,     0,     0,  2061,  2550,     0,     0,
    2062,  2063,  2064,     0,  2551,     0,  1349,     0,  1560,     0,
       0,     0,     0,     0,  5881,     0,     0,  2549,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2550,     0,     0,
    2552,   779,     0,     0,  2551,     0,     0,  1349,     0,     0,
       0,     0,     0,  2060,     0,     0,  2061,     0,     0,     0,
    2062,  2063,  2064,     0,     0,     0,     0,     0,     0, -2618,
    2552,     0,     0,     0,     0,  1349,  1349,  1349,     0,  1349,
       0,     0,     0,     0,     0,     0,  1561,  2550,     0,     0,
       0,     0,     0, -2618,  2551, -2618, -2618,     0,     0,  1349,
       0,     0,   928,     0,     0,     0,     0,     0,     0,     0,
       0,   940,     0,     0,     0,     0,     0,     0,     0,   940,
    2552,     0,   940,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2618,  5963,   844, -2618, -2618,
   -2618,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,     0,     0,  2553,  1349,     0,  1544,     0,  2554,
       0,     0,     0,     0,     0,     0,  5977,  5977,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2555,  2248,     0,  2553,     0,     0,     0,     0,  2554,
       0,     0,     0,     0,     0,     0,  2556,     0,     0,     0,
       0,  1349,  1546,     0,     0,  1349,  1349,     0,     0,     0,
       0,  2555,  2248,     0,  1131,     0,   844,   844,   844,  2637,
       0,  1349,     0,     0,     0,     0,  2556,     0,     0,     0,
       0,     0,     0,     0,  2553,     0,     0,  2300,     0,  2554,
    1131,     0,     0,     0,     0,   807,     0,     0,     0,     0,
       0,  2557,     0,     0,  2558,     0,     0,     0,  1547,     0,
       0,  2555,  2248,     0,     0,  1548,     0,  2300,  1549,     0,
    1513,     0,     0,     0,     0,     0,  2556,     0,     0,  5977,
    2728,  2557,     0,     0,  2558,   807,     0,     0,   930,     0,
       0,     0,     0,     0,     0,  1550,     0,     0,     0,     0,
       0,   844,  2756,     0,     0,  1514,     0,     0,     0,     0,
     844,     0,     0,   930,     0,     0,     0,  2300,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1551,
       0,  2557,     0,     0,     0,     0,     0,     0,     0,     0,
     977,     0,   844,     0,  2559,   807,     0,     0,  2824,  2824,
       0,     0,  2824,     0,     0,     0,     0,  3824,     0,     0,
       0,     0,   807,     0,     0,   844,  1515,     0,   844,     0,
       0,     0,     0,     0,  2559,     0,     0,     0,     0,     0,
       0,  1513,     0,     0,     0,     0,     0,     0,     0,  3068,
     930,     0,     0,     0,  1651,     0,     0,  3075,  1553,     0,
       0,     0,  1516,     0,     0,     0,     0,   844,  1554,     0,
       0,     0,     0,     0,     0,     0,  1514,  1555,     0,   930,
     930,   930,   930,   844,  2559,     0,     0,     0,     0,  1556,
       0,     0,     0,     0,     0,     0,     0,   844,  1517,     0,
       0,     0,     0,     0,  2489,     0,     0,     0,  1349,  1349,
    1349,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,     0,     0,     0,     0,     0,  3955,  1679,
       0,     0,  1558,  1559,  2489,     0,  1518,  1515,     0,     0,
    1519,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,     0,     0,     0,     0,     0,  4006,     0,
       0,     0,     0,  1680,     0,     0,     0,     0,     0,     0,
       0,  1584,  1521,  1516,     0,     0,     0,     0,     0,  1483,
       0,     0,     0,     0,  2489,     0,     0,     0,     0,     0,
       0,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,     0,  3825,     0,   844,     0,     0,  1517,
       0,  1585,     0,  1803,   689,    36,     0,   844,     0,     0,
    1523,     0,     0,   778,  1812,   930,   930,     0,     0,  1524,
       0,  1561,     0,     0,     0,     0,     0,  1525,     0,     0,
    1820,   930,     0,     0,     0,  1586,     0,     0,     0,     0,
       0,  1519,     0,     0,     0,   928,     0,  1527,     0,   844,
    2824,     0,     0,     0,   940,     0,  1528,     0,     0,     0,
    1529,   940,     0,     0,   940,   930,   930,   930,   930,     0,
       0,     0,     0,  1521,   844,     0,  2060,     0,     0,  2061,
    1483,   844,     0,  2062,  2063,  2064,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   621,     0,
    2549,   621,     0,     0,     0,     0,     0,     0,     0,  3405,
    2550,   941,   941,     0,  1530,     0,    36,  2551,     0,     0,
       0,  3826,   977,   977,     0,     0,   941,  3421,     0,   941,
    1524,  3424,     0,     0,     0,  3427,     0,     0,  1525,     0,
       0,     0,     0,  2552,   930,   930,  2740,     0,     0,     0,
       0,   930,     0,   844,     0,     0,   844,     0,  1527,     0,
       0,     0,  3452,     0,     0,     0,     0,  1528,     0,     0,
       0,  1529,  1966,     0,     0,     0,     0,     0,     0,   930,
       0,   941,     0,     0,  3122,   941,   941,     0,   844,   844,
    3827,   930,     0,  1992,     0,     0,  3494,     0,   844,     0,
       0,     0,     0,     0,     0,   844,     0,     0,     0,     0,
       0,   774,   774,     0,     0,  3158,  1075,     0,     0,  1349,
       0,  1349,     0,     0,     0,  1530,  1349,  1349,     0,  3828,
       0,     0,     0,  1349,  1349,  1349,     0,     0,  1349,     0,
    1349,   977,  1349,  1349,  1349,  1349,  1349,  1349,  3544,     0,
    1349,     0,  1349,  1349,     0,     0,  1349,  2553,     0,     0,
       0,     0,  2554,     0,     0,     0,     0,     0,     0,     0,
       0,  1349,  1349,  1349,  1543,  3573,     0,     0,     0,     0,
    1544,  3582,     0,     0,  2555,  2248,     0,  1610,  1349,     0,
       0,     0,     0,     0,     0,  3592,     0,     0,     0,  2556,
       0,     0,  1075,     0,     0,  3605,     0,  2060,     0,  1611,
    2061,  3610,     0,     0,  2062,  2063,  2064,     0,     0,     0,
       0,     0,     0,     0,     0,  1546,     0,     0,   930,     0,
       0,  3623,     0,     0,     0,     0,     0,  3626,     0,     0,
    2300,  2550,     0,     0,  3632,     0,     0,     0,  2551,     0,
       0,     0,     0,     0,  2557,     0,     0,  2558,  3647,     0,
    1612,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3672,     0,     0,  2552,     0,     0,     0,     0,     0,
       0,  1547,  1075,     0,   928,     0,     0,     0,  1548,     0,
     940,  1549,     0,     0,   940,     0,   940,     0,  2060,     0,
       0,  2061,     0,     0,     0,  2062,  2063,  2064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1550,     0,
       0,     0,  2549,     0,     0,     0,     0,     0,     0,     0,
       0,  1349,  2550,     0,     0,     0,     0,     0,     0,  2551,
       0,     0,     0,     0,     0,     0,     0,  2559,     0,  1613,
       0,     0,  1551,     0,     0,     0,     0,     0,     0,  1875,
    2060,  1877,  1878,  2061,     0,  2552,     0,  2062,  2063,  2064,
       0,  1349,     0,     0,     0,     0,     0,  3319,     0,     0,
       0,     0,     0,     0,  2549,     0,     0,     0,  2553,     0,
       0,     0,     0,  2554,  2550,     0,     0,     0,  1614,     0,
       0,  2551,  1615,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2822, -2822,  1616,     0,     0,
       0,  1553,     0,     0,  1349,     0,     0,  2552,     0,     0,
    2556,  1554,     0,     0,     0,     0,     0,     0,     0,     0,
    1555,     0,     0,     0,     0,  2805,     0,  2489,     0,     0,
       0,  1617,  1556,     0,     0,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,     0,     0,     0,     0,  3238,     0,
       0, -2822,     0,     0,     0,     0,     0,     0,     0,  2553,
       0,     0,     0,     0,  2554,  2557,     0,     0,     0,     0,
       0,     0,  1618,     0,     0,  1558,  1559,  1619,     0,  3899,
       0,     0,     0,     0,     0,     0,  2555,  2248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3913,     0,     0,
    1620,  2556,     0,  1051,  3899,     0,  1621,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1622,  2553,     0,     0,     0,     0,  2554,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2300,     0,     0,     0,     0,     0,  2555,  2248,
       0,     0,     0,  1118,   689,     0,  2557,     0,  2559,  2558,
       0,     0,     0,  2556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1561,     0,     0,     0,     0,  1349,
    1349,  1349,  1349,  1349,  1349,  1349,  1349,  1349,     0,  1349,
       0,     0,     0,     0,     0,     0,     0,   844,  1349,     0,
    1349,     0,     0,     0,  2300,     0,     0,   844,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2557,     0,
       0,  2558,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   844,     0,  1349,     0,
       0,   930,  1349,     0,     0,  1349,     0,  1349,  2943,  2559,
    1349,     0,     0,  1224,  1349,     0,     0,     0,  2489,  2954,
       0,     0,     0,     0,     0,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,  2972,     0,  3364,     0,  1242,
       0,     0,     0,   844,   844,     0,     0,  1352,     0,     0,
    1361,  1118,  1363,     0,  1349,     0,     0,     0,     0,     0,
       0,     0,     0,  1349,  1349,     0,     0,     0,     0,     0,
       0,  2559,     0,     0,     0,     0,     0,   844,     0,     0,
       0,     0,     0,     0,     0,  3403,     0,     0,  3046,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3058,     0,     0,  1131,  3062,     0,  2489,
       0,     0,     0,     0,     0,     0,     0,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2497,  2498,   774,     0,   774,     0,
    4334,     0,     0,     0,     0,     0,     0,  3081,  1131,     0,
       0,     0,     0,     0,     0,  1349,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   621,     0,     0,   941,
     977,   941,   941,     0,     0,   930,     0,   892,   844,     0,
    4146,  2489,     0,     0,     0,     0,     0,     0,     0,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,   807,
       0,     0,  4532,     0,     0,     0,     0,     0,     0,     0,
    2756,     0,     0,     0,     0,     0,     0,     0,  3512,   844,
       0,     0,     0,     0,     0,  3523,     0,     0,     0,     0,
       0,     0,     0,  1543,   844,     0,     0,  3847,     0,  1544,
       0,     0,  3853,     0,  3854,     0,     0,     0,     0,     0,
       0,     0,  3824,     0,  3860,     0,   844,  3861,     0,  3862,
    3863,     0,  1118,  3865,     0,     0,     0,  3868,     0,  3869,
       0,     0,  3871,     0,     0,     0,  1513,     0,   844,  3242,
    4218,     0,     0,     0,  1546,     0,  2060,     0,     0,  2061,
     807,     0,     0,  2062,  2063,  2064,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2549,  1514,     0,   930,     0,     0,   930,     0,     0,     0,
    2550,     0,     0,     0,     0,     0,     0,  2551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3922,     0,
    1547,     0,   844,   844,     0,     0,     0,  1548,     0,     0,
    1549,     0,     0,  2552,     0,     0,     0,  3666,     0,  3669,
    3671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1515,     0,     0,     0,     0,  1550,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1349,  1349,  1349,     0,     0,     0,  1349,     0,     0,     0,
       0,     0,     0,     0,   930,     0,     0,  4313,  1516,     0,
       0,  1551,     0,     0,     0,     0,     0,   930,     0,     0,
       0,  2060,     0,  1349,  2061,   930,     0,     0,  2062,  2063,
    2064,     0,     0,     0,     0,     0,     0,     0,  2756,  3825,
       0,     0,     0,   844,  1517,  2549,     0,     0,     0,  3771,
       0,     0,   774,     0,  1991,  2550,     0,     0,     0,     0,
       0,     0,  2551,     0,   930,  3782,     0,  2553,     0,     0,
       0,     0,  2554,     0,     0,  3666,  1651,     0,     0,     0,
    1553,     0,  1118,     0,     0,   930,  1519,  3804,  2552,     0,
    1554,     0,     0,   928,  2555,  2248,   928,     0,     0,  1555,
       0,     0,     0,     0,     0,     0,   940,   940,     0,  2556,
       0,  1556,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,   940,     0,     0,   940,  1483,   930,     0,   930,     0,
     930,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2300,  2720,     0,     0,  1558,  1559,  3882,     0,     0,  2056,
       0,    36,     0,     0,  2557,  1966,  1523,  2558,  2058,     0,
       0,     0,     0,     0,     0,  1524,   940,     0,     0,     0,
     940,   940,  2512,  1525,     0,  2721,  2912,     0,     0,     0,
       0,  2740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,  2553,  1527,  2529,  2530,     0,  2554,     0,  1118,
    1118,     0,  1528,     0,     0,  4500,  1529,     0,   621,   930,
       0,   941,     0,   941,   941,     0,   930,     0,     0,  2555,
    2248,  4144,     0,  1349,  2060,  3827,     0,  2061,  1349,     0,
    4516,  2062,  2063,  2064,  2556,     0,     0,     0,     0,     0,
       0,     0,     0,  1561,     0,     0,     0,  2559,  2549,     0,
       0,     0,     0,     0,  1349,  1349,  1349,     0,  2550,  1349,
    1530,     0,     0,     0,  3828,  2551,     0,  1349,  1349,  1349,
    1349,     0,     0,     0,     0,  2300,     0,     0,     0,     0,
       0,     0,     0,  1349,     0,     0,  1349,     0,  1349,  2557,
       0,  2552,  4194,     0,  4196,     0,     0,     0,     0,  1349,
    1349,     0,     0,  1349,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     977,     0,  1349,     0,  1349,     0,  1349,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1349,  2489,     0,     0,
     844,     0,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,     0,     0,     0,  1543,  4582,     0,
       0,   844,     0,  1544,     0,     0,     0,     0,     0,     0,
       0,     0,  2559,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   621,
       0,     0,  3364,  4079,     0,  2553,     0,  4079,  4093,  4079,
    2554,   892,     0,     0,  1349,     0,     0,     0,  1546,  1349,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2555,  2248,  1349,     0,  4297,   892,     0,     0,
       0,     0,  4304,     0,     0,     0,     0,  2556,  3364,     0,
    4118,  3364,     0,     0,     0,  2865,     0,     0,     0,     0,
       0,     0,     0,  2873,     0,     0,  4699,     0,     0,     0,
       0,     0,     0,     0,  1547,     0,     0,     0,     0,     0,
       0,  1548,  2489,     0,  1549,     0,     0,     0,  2300,  1349,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,
       0,     0,  2557,     0,     0,  2558,     0,     0,     0,     0,
       0,  1550,     0,     0,     0,  1543,     0,  3468,     0,   930,
     930,  1544,     0,  3476,     0,     0,     0,     0,  1610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1551,     0,     0,     0,     0,
    1611,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3509,     0,  1546,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   892,
       0,     0,     0,     0,  4808,  2559,     0,  4811,     0,     0,
       0,  1612,     0,     0,     0,     0,     0,     0,     0,     0,
    1552,     0,     0,     0,  1553,     0,     0,     0,     0,     0,
       0,     0,  1547,     0,  1554,     0,  4466,   844,  4468,  1548,
    4470,     0,  1549,  1555,     0,     0,     0,  2824,     0,     0,
       0,     0,     0,     0,     0,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1550,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3002,     0,     0,     0,
    3007,     0,     0,     0,     0,  2798,     0,     0,  1558,  1559,
    1613,     0,     0,  1551,     0,  2489,     0,     0,  4893,     0,
       0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,
    2497,  2498,     0,     0,     0,  2912,  4675,     0,     0,  2799,
       0,     0,  2060,     0,     0,  2061,     0,     0,     0,  2062,
    2063,  2064,  1698,     0,     0,     0,     0,     0,     0,  1614,
       0,     0,  1349,  1615,     0,     0,  2549,     0,  1349,     0,
     892,     0,     0,     0,     0,     0,  2550,     0,  1616,   930,
       0,   892,  1553,  2551,     0,     0,     0,     0,     0,     0,
       0,     0,  1554,  3732,     0,     0,  2060,   892,     0,  2061,
       0,  1555,   620,  2062,  2063,  2064,     0,  1561,     0,  2552,
       0,     0,  1617,  1556,     0,     0,   844,   844,   844,     0,
    2549,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2550,  3899,     0,   844,     0,     0,     0,  2551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1349,     0,     0,
       0,     0,     0,  3612,     0,     0,  1558,  1559,  1619,     0,
       0,     0,     0,  2552,     0,  1966,   844,   844,     0,     0,
    3191,   844,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1620,     0,   844,     0,     0,     0,  3613,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1622,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   928,     0,  2553,   940,     0,   940,   940,  2554,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   930,
       0,     0,     0,     0,  4482,     0,     0,  3882,     0,     0,
    2555,  2248,     0,     0,     0,  1561,     0,     0,     0,     0,
     892,     0,     0,  3122,  4499,  2556,     0,     0,     0,     0,
       0,     0,   844,     0,  3912,     0,     0,  2553,     0,     0,
       0,     0,  2554,     0,     0,   844,     0,     0,   844,  3925,
       0,     0,     0,     0,  3930,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2555,  2248,  2300,  1349,     0,     0,
       0,     0,     0,     0,     0,     0,  1349,     0,     0,  2556,
    2557,     0,     0,  2558,  1349,     0,  1349,     0,     0,  1349,
       0,     0,     0,     0,  1349,  1349,  1349,  1349,     0,     0,
    1349,  1349,  1349,  1349,  1349,  1349,  1349,  1349,  1349,  1349,
       0,     0,     0,  1349,  1349,  1349,     0,     0,     0,     0,
    2300,     0,     0,  1349,     0,     0,     0,     0,  1349,     0,
       0,     0,  1349,     0,  2557,  1543,     0,  2558,  5143,     0,
    1349,  1544,     0,  1349,     0,  1349,     0,     0,     0,     0,
    5153,     0,     0,     0,     0,  1349,     0,     0,  1349,  1349,
       0,     0,     0,  1349,  1349,     0,     0,     0,  4605,     0,
    1349,     0,     0,  2559,     0,     0,     0,   844,   844,   844,
       0,     0,     0,     0,     0,     0,  1546,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4079,  4093,  4079,
       0,  1349,  4079,     0,     0,  4629,     0,     0,     0,  3364,
       0,     0,     0,  3364,     0,     0,     0,     0,     0,  4644,
       0,     0,     0,     0,     0,     0,     0,  2559,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1547,     0,     0,  1349,     0,     0,     0,  1548,
       0,     0,  1549,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2657,     0,  4681,  1966,  1966,     0,     0,
    1966,     0,     0,  2489,     0,     0,     0,     0,     0,  1550,
     620,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,
       0,     0,     0,     0,  4899,     0,     0,   690,     0,     0,
       0,     0,  3159,     0,     0,  2756,  4713,     0,     0,     0,
       0,     0,     0,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,  4961,     0,  4734,  4963,     0,  2489,     0,     0,
       0,  2657,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,     0,     0,     0,     0,  5005,     0,
       0,     0,     0,   693,  3160,  4149,     0,     0,     0,     0,
       0,     0,     0,  4152,     0,     0,  4989,     0,     0,   694,
       0,     0,   892,     0,     0,     0,     0,  3899,  1651,     0,
       0,     0,  1553,     0,     0,     0,     0,  1034,     0,     0,
       0,     0,  1554,     0,     0,     0,     0,     0,     0,     0,
       0,  1555,     0,     0,     0,   892,     0,     0,     0,     0,
       0,  3161,     0,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,   697,     0,     0,     0,     0,     0,     0,     0,
       0,   698,  4826,   928,     0,  3314,   940,     0,   940,   940,
       0,     0,     0,     0,   699,     0,     0,     0,     0,  3162,
       0,     0,     0,  3504,     0,     0,  1558,  1559,  4235,     0,
    4237,     0,     0,     0,     0,   930,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1037,     0,     0,  3899,   930,
    3899,  1349,     0,     0,  1698,  1698,  1698,  1560,   844,     0,
       0,     0,     0,     0,  4870,     0,     0,     0,     0,     0,
    3163,     0,     0,     0,     0,  2756,     0,     0,     0,   891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     844,     0,   703,     0,     0,  3364,  3782,     0,     0,     0,
       0,     0,     0,  3666,     0,     0,     0,     0,     0,     0,
       0,     0,  4919,  5109,     0,     0,     0,     0,     0,     0,
       0,     0,   844,     0,  4298,  1561,     0,     0,     0,     0,
       0,     0,     0,     0,  1349,  1349,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1349,     0,     0,     0,     0,
       0,     0,  1118,     0,  5133,  5134,  1966,   844,     0,     0,
       0,     0,     0,     0,     0,   892,  4320,     0,   214,  3164,
       0,     0,   708,     0,   844,     0,   892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3882,     0,  1349,     0,
       0,     0,   892,     0,   620,     0,     0,   620,     0,  1041,
       0,     0,  3165,     0,     0,     0,     0,     0,   712,     0,
       0,  1363,     0,     0,     0,   713,     0,     0,   714,     0,
       0,     0,     0,     0,     0,     0,     0,  1349,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   715,  1349,     0,
       0,     0,     0,   620,  1043,   892,   620,  5179,  5180,     0,
     717,     0,     0,  1044,     0,     0,     0,   719,     0,     0,
     892,     0,  3509,   892,   892,     0,  1349,     0,     0,  1349,
       0,     0,  3166,     0,     0,     0,     0,  1349,  1349,     0,
       0,     0,     0,     0,  1349,  1349,     0,     0,     0,  1349,
       0,  1363,     0,  1349,   892,   892,  1349,  1349,   724,  1543,
       0,  1349,  5046,     0,     0,  1544,  4462,  1349,   844,   844,
     844,   844,     0,     0,     0,  1363,     0,     0,     0,     0,
       0,     0,     0,     0,   621,     0,     0,  4079,     0,     0,
       0,  3364,     0,     0,     0,     0,  3364,     0,     0,  3364,
     621,     0,  3666,     0,  5077,  2060,     0,  1349,  2061,   977,
    1546,     0,  2062,  2063,  2064,     0,     0,     0,  1349,     0,
    1349,     0,     0,     0,     0,     0,     0,     0,     0,  2549,
       0,     0,   774,     0,     0,  1349,     0,  5273,     0,  2550,
    5275,  5276,  3675,     0,     0,     0,  2551,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1698,  4531,
       0,  1698,     0,     0,     0,     0,  1547,     0,  5290,  2756,
       0,     0,  2552,  1548,     0,     0,  1549,     0,     0,  3707,
       0,  3707,  4540,  3707,  3707,  5131,   892,     0,  3707,  3707,
    3707,     0,  3707,  3707,  3707,     0,     0,     0,     0,     0,
       0,     0,     0,  1550,     0,     0,     0,  4561,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1349,  1551,     0,     0,
    5160,     0,  1349,     0,     0,     0,  3784,     0,     0,     0,
       0,  2060,     0,     0,  2061,     0,     0,     0,  2062,  2063,
    2064,     0,     0,     0,   930,     0,     0,     0,     0,     0,
       0,  3812,     0,     0,     0,  2549,     0,     0,     0,   930,
       0,     0,     0,     0,     0,  2550,  2553,     0,     0,     0,
       0,  2554,  2551,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1651,  1543,     0,     0,  1553,     0,     0,  1544,
    1349,     0,     0,  2555,  2248,     0,  1554,     0,  2552,     0,
       0,     0,     0,     0,     0,  1555,   621,     0,  2556,     0,
       0,     0,     0,  2756,     0,     0,     0,  1556,     0,     0,
       0,     0,  1966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1546,     0,     0,  3782,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2300,
     930,     0,  3804,  1543,     0,     0,     0,  3682,     0,  1544,
    1558,  1559,     0,  2557,     0,     0,  2558,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   844,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   844,
    1547,  3683,     0,     0,     0,     0,     0,  1548,     0,     0,
    1549,     0,     0,     0,  1546,  4482,     0,     0,     0,     0,
    3882,     0,  2553,     0,     0,     0,     0,  2554,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1550,     0,     0,
       0,     0,     0,     0,     0,     0,  3899,     0,     0,  2555,
    2248,     0,     0,     0,     0,  1349,     0,  1513,  1349,     0,
       0,  1349,  1349,  1349,  2556,     0,  2559,     0,     0,  1561,
    1547,  1551,     0,   891,     0,     0,     0,  1548,     0,     0,
    1549,     0,     0,     0,     0,     0,  1349,  1349,     0,     0,
    1349,     0,  1514,     0,     0,     0,     0,     0,     0,   891,
       0,     0,     0,     0,     0,  2300,     0,  1550,     0,     0,
    1349,     0,     0,     0,     0,     0,  1349,     0,     0,  2557,
    3364,     0,  2558,     0,  5077,     0,     0,  1349,     0,  5353,
       0,     0,     0,  5573,     0,     0,  1651,     0,     0,     0,
    1553,  1551,  1118,     0,  4681,   977,   930,     0,   930,     0,
    1554,     0,     0,  1515,     0,     0,     0,     0,     0,  1555,
       0,     0,     0,     0,     0,     0,  2489,     0,     0,     0,
       0,  1556,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,  5609,     0,  5042,     0,  1516,
    4882,     0,     0,     0,     0,   941,   977,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1651,     0,     0,     0,
    1553,  4162,  2559,     0,  1558,  1559,     0,     0,     0,     0,
    1554,     0,     0,     0,     0,  1517,  1698,     0,     0,  1555,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1556,   941,     0,     0,  4163,     0,     0,     0,     0,
       0,   891,     0,     0,  4870,     0,     0,     0,     0,   844,
       0,     0,     0,  1518,   844,     0,     0,  1519,     0,     0,
       0,     0,     0,  2756,   620,     0,     0,     0,   620,     0,
       0,  4220,     0,   844,  1558,  1559,     0,  4919,     0,     0,
    5485,  1118,     0,     0,     0,     0,     0,     0,  1601,  1521,
       0,   930,   844,  4681,  5704,     0,  1483,     0,     0,     0,
       0,     0,  2489,  1561,     0,  4221,     0,     0,     0,     0,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,
     620,     0,  4681,  5294,  1349,     0,     0,     0,  1602,     0,
       0,     0,    36,     0,     0,  1349,     0,  1523,     0,  1349,
       0,  1349,     0,     0,     0,     0,  1524,     0,     0,     0,
       0,     0,  3410,     0,  1525,     0,  2657,  3416,     0,  4210,
       0,   621,  1603,     0,  1349,     0,     0,     0,  5555,     0,
       0,     0,     0,  1561,  1527,  1349,     0,     0,     0,     0,
       0,     0,  1349,  1528,     0,   882,     0,  1529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,     0,
       0,   844,     0,   891,   892,     0,     0,  4257,     0,     0,
     892,     0,     0,     0,     0,     0,     0,     0,     0,   891,
       0,     0,     0,     0,     0,     0,  1349,     0,     0,     0,
       0,  1530,  1349,  1349,     0,     0,     0,   930,   930,   930,
     930,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   892,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1349,     0,
       0,     0,     0,     0,     0,  4300,   621,     0,     0,     0,
       0,     0,  5110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   844,     0,     0,  3364,  2060,     0,     0,  2061,     0,
       0,     0,  2062,  2063,  2064,     0,     0,     0,     0,     0,
    5132,  3707,     0,     0,     0,     0,     0,     0,     0,  2549,
     844,     0,     0,  4331,  4331,     0,     0,     0,     0,  2550,
       0,     0,  5148,  4347,     0,     0,  2551,     0,  1118,     0,
    1118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1349,     0,     0,     0,     0,     0,  1349,
     620,   620,  2552,  1966,     0,     0,     0,  3666,     0,     0,
    1349,     0,   891,     0,     0,     0,     0,     0,     0,  1349,
       0,  1349,     0,  1349,  5353,     0,  4402,     0,     0,     0,
       0,     0,     0,     0,  1966,     0,   977,     0,     0,     0,
       0,     0,     0,  5178,     0,  1349,     0,  5959,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1698,     0,
       0,  4438,  1118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   942,   952,     0,
    1966,  1966,     0,     0,     0,   942,     0,   952,   942,     0,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   952,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   930,     0,     0,     0,     0,  2553,     0,     0,     0,
       0,  2554,     0,     0,     0,  5808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4681,     0,     0,
       0,     0,     0,  2555,  2248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2528,     0,     0,     0,  2556,     0,
       0,     0,     0,  2657,  5262,     0,     0,  2657,     0,  1349,
    1349,  1349,     0,     0,     0,     0,     0,  1349,     0,     0,
       0,  5555,     0,     0,     0,     0,     0,  1349,     0,     0,
       0,     0,     0,  1349,     0,     0,     0,     0,     0,  2300,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   941,
       0,     0,     0,  2557,     0,     0,  2558,     0,     0,     0,
       0,     0,     0,     0,   930,     0,     0,     0,     0,   620,
       0,  1966,     0,     0,     0,     0,   620,     0,     0,     0,
       0,   620,     0,     0,   620,  5073,     0,  4583,     0,     0,
       0,     0,     0,     0,     0,   891,  2756,     0,     0,     0,
       0,     0,     0,  1349,     0,     0,     0,     0,     0,     0,
       0,   892,     0,  4681,     0,     0,     0,     0,     0,     0,
       0,     0,   941,   941,  5928,     0,   892,     0,  1349,     0,
       0,   892,  3882,  1349,     0,  4298,     0,     0,     0,     0,
       0,     0,  1966,  1966,  5944,     0,  2559,     0,     0,  1349,
    1349,     0,     0,     0,     0,  5950,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   930,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   891,  5808,   930,   930,     0,     0,
       0,  4681,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   621,
       0,     0,     0,     0,     0,     0,     0,   891,     0,     0,
       0,     0,     0,     0,     0,     0,  2489,     0,     0,     0,
    1349,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,  1349,     0,     0,     0,  5305,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   882,
       0,  4347,     0,     0,     0,  1349,     0,     0,     0,     0,
    6034,  6035,   621,  6038,  5555,     0,     0,  3882,     0,     0,
       0,  5204,     0,     0,     0,   882,     0,  4773,     0,   930,
       0,     0,  4681,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4786,     0,     0,  4787,     0,  4788,     0,     0,
       0,     0,   620,   952,     0,  4482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   952,     0,  1349,   621,     0,     0,   952,  1349,
       0,     0,     0,   621,  2657,     0,     0,  3416,     0,  3416,
     952,     0,     0,  4828,  2657,   941,   941,     0,     0,  6100,
       0,     0,     0,     0,     0,     0,   952,     0,     0,  3707,
       0,     0,     0,     0,  3707,     0,     0,     0,     0,     0,
     942,   952,     0,     0,     0,     0,     0,   942,     0,   952,
     942,     0,     0,     0,     0,     0,     0,   891,     0,     0,
       0,     0,   892,   952,     0,     0,     0,     0,   891,     0,
     892,     0,     0,   952,     0,  1992,     0,     0,     0,     0,
    1992,  1992,     0,     0,   891,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2657,     0,   882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4933,     0,   952,  4347,   891,     0,  2060,
       0,     0,  2061,     0,     0,   620,  2062,  2063,  2064,     0,
       0,     0,   891,     0,     0,   891,   891,     0,     0,     0,
       0,     0,     0,  2549,   952,   892,     0,   892,     0,   620,
       0,     0,     0,  2550,     0,     0,     0,     0,     0,     0,
    2551,     0,     0,     0,     0,     0,   891,   891,     0,   952,
       0,     0,     0,     0,  5683,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2552,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     940,     0,     0,     0,  4992,  4992,  4992,  4992,     0,  4992,
    4992,  4992,  4992,  4992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5724,     0,     0,     0,     0,     0,   952,
       0,     0,     0,     0,     0,     0,     0,     0,   882,     0,
       0,   892,     0,     0,     0,     0,     0,   940,     0,   882,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   882,     0,     0,  1698,     0,
       0,     0,     0,     0,  1698,     0,     0,     0,     0,     0,
       0,     0,     0,   892,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,  -136,
    2553,     0,     0,     0,  5054,  2554,  5056,     0,   620,     0,
       0,  3416,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,  2555,  2248,     2,
       0,     3,     4,     0,     0,     0,     0,   620,     0,  1784,
       0,     0,  2556,     0,     0,   952,     0,     0,     0,     5,
       0,     0,     0,     0,     0,     0,   942,     0,     0,     6,
     942,     0,   942,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     0,     8,     9,     0,   620,     0,     0,   892,
      10,     0,    11,  2300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,    13,  2557,     0,     0,
    2558,  3416,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    14,     0,     0,    15,     0,     0,     0,
       0,     0,     0,   892,     0,     0,     0,     0,   882,     0,
       0,    16,     0,    17,     0,     0,     0,    18,     0,     0,
       0,  2060,     0,    19,  2061,     0,     0,     0,  2062,  2063,
    2064,    20,     0,    21,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,  2549,     0,     0,   952,     0,
       0,     0,     0,     0,     0,  2550,     0,    23,     0,     0,
       0,     0,  2551,     0,     0,     0,     0,     0,     0,     0,
    2559,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,  5643,     0,     0,     0,     0,     0,     0,  2552,     0,
    5176,  5177,     0,     0,     0,     0,   892,     0,     0,     0,
       0,     0,     0,  3707,     0,  3707,  3707,  3707,     0,   620,
       0,   952,     0,     0,    25,    26,     0,     0,     0,   892,
      27,     0,     0,     0,     0,     0,     0,   952,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,     0,
       0,   952,     0,     0,   892,   952,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2489,  5228,     0,     0,     0,     0,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,    30,
       0,  5313,     0,     0,     0,     0,     0,    31,     0,     0,
       0,     0,  2553,     0,     0,     0,     0,  2554,     0,     0,
    5256,    32,     0,     0,     0,     0,     0,    33,    34,     0,
      35,     0,     0,     0,     0,    36,     0,     0,     0,  2555,
    2248,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,    39,     0,     0,  2556,     0,     0,    40,    41,     0,
       0,   882,     0,     0,     0,    42,     0,     0,     0,    43,
       0,     0,     0,  4992,   952,     0,     0,     0,     0,    44,
       0,     0,   952,   952,     0,     0,     0,     0,     0,  2657,
       0,     0,     0,     0,    45,  2300,     0,     0,     0,  2060,
       0,     0,  2061,     0,     0,     0,  2062,  2063,  2064,  2557,
     620,     0,  2558,     0,    46,     0,     0,     0,     0,     0,
       0,     0,   620,  2549,     0,    47,     0,     0,     0,   882,
       0,    48,     0,  2550,     0,  1784,    49,     0,     0,     0,
    2551,     0,     0,     0,     0,     0,     0,     0,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2552,     0,     0,     0,
     882,     0,    51,    52,    53,    54,    55,    56,     0,  3416,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     0,  -136,   940,     0,     0,     0,     0,     0,
       0,     0,  2559,   882,     0,  3416,     0,     0,     0,     0,
       0,     0,  4347,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2060,     0,     0,  2061,     0,     0,     0,  2062,  2063,
    2064,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2549,     0,     0,   620,     0,
    3707,     0,     0,     0,     0,  2550,     0,   940,   940,  5432,
       0,     0,  2551,     0,   891,     0,     0,     0,   891,   891,
    2553,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2552,     0,
       0,     0,  2489,     0,     0,     0,     0,  2555,  2248,     0,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,
       0,     0,  2556,  5316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,   892,     0,     0,
     620,     0,     0,     0,     0,     0,   620,     0,     0,     0,
       0,     0,     0,  2300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5994,     0,     0,  2557,     0,     0,
    2558,     0,     0,   891,   952,     0,     0,     0,     0,     0,
       0,     0,     0,   882,  3416,     0,     0,     0,     0,  2657,
       0,     0,     0,     0,   882,     0,     0,     0,     0,     0,
       0,     0,  2553,     0,     0,     0,     0,  2554,     0,     0,
     882,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2555,
    2248,     0,     0,     0,     0,     0,     0,  6036,     0,     0,
       0,     0,     0,     0,  2556,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   620,     0,     0,
    2559,     0,     0,   882,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   882,     0,
       0,   882,   882,     0,     0,  2300,  1118,   690,   952,     0,
    5618,     0,  2707,     0,     0,     0,     0,     0,     0,  2557,
    6036,     0,  2558,     0,     0,     0,     0,     0,  6085,     0,
       0,     0,   882,   882,     0,     0,     0,     0,     0,     0,
     940,   940,     0,  1784,     0,     0,     0,     0,     0,     0,
    2708,     0,     0,     0,     0,     0,   892,     0,     0,     0,
       0,     0,     0,   693,     0,     0,   952,     0,     0,     0,
       0,     0,     0,     0,   952,     0,     0,     0,     0,   694,
    2489,     0,   952,     0,     0,     0,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,  1034,     0,     0,
       0,  5363,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2559,     0,     0,     0,     0,     0,     0,     0,
       0,  2709,   942,   942,     0,   952,   952,     0,     0,     0,
       0,     0,   697,     0,     0,     0,     0,   942,     0,   952,
     942,   698,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   952,   952,   699,     0,     0,     0,     0,  2710,
       0,     0,     0,     0,   882,     0,     0,     0,     0,   892,
       0,     0,     0,     0,     0,   891,     0,     0,     0,   891,
       0,     0,     0,     0,     0,  1037,     0,     0,     0,     0,
       0,     0,   942,     0,     0,     0,   942,   942,     0,     0,
    1118,     0,     0,     0,  5770,     0,  5771,   892,     0,     0,
    5776,  5777,  2489,     0,     0,     0,     0,     0,     0,     0,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,   892,
       0,     0,   703,  5396,     0,   629,     0,     0,     0,     0,
       0,   678,   629,     0,     0,     0,     0,   730,     0,   629,
       0,     0,     0,     0,     0,   629,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2711,     0,     0,     0,   855,   855,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,     0,
     892,  1784,     0,   891,     0,     0,     0,     0,   214,  2712,
       0,     0,   708,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1041,
       0,     0,  2713,     0,     0,     0,     0,     0,   712,     0,
       0,     0,     0,     0,     0,   713,     0,     0,   714,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   715,     0,     0,
       0,     0,     0,     0,  1043,     0,     0,     0,     0,     0,
     717,     0,     0,  1044,     0,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,  2714,     0,     0,     0,     0,
       0,     0,  2715,     0,     0,     0,     0,     0,     0,  5260,
       0,   892,     0,     0,     0,     0,     0,     0,   932,     0,
       0,     0,   936,  -136,     0,     0,     0,     0,   724,     0,
     979,     0,     0,   981,     0,     0,   986,   987,     0,   990,
       0,   993,     0,     1,   999,     0,  1001,     0,     0,     0,
       0,     0,     0,     2,     0,     3,     4,     0,     0,     0,
    1118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     8,     9,     0,
       0,     0,     0,     0,    10,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,  2060,
      13,     0,  2061,     0,     0,     0,  2062,  2063,  2064,     0,
       0,     0,     0,     0,     0,     0,   891,    14,     0,   891,
      15,   891,   892,  2549,     0,     0,   891,     0,     0,     0,
       0,     0,     0,  2550,     0,    16,     0,    17,     0,     0,
    2551,    18,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,     0,     0,    22,     0,  2552,     0,     0,     0,
       0,     0,     0,     0,   891,     0,     0,     0,     0,     0,
    3416,    23,   891,     0,     0,     0,     0,  6063,     0,     0,
       0,     0,     0,  2512,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,     0,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6063,     0,     0,    25,    26,
       0,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,  6063,     0,     0,  5054,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,   891,     0,   891,
    2553,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3416,     0,     0,     0,     0,  2555,  2248,     0,
       0,     0,     0,    30,     0,     0,     0,     0,     0,     0,
     882,    31,  2556,     0,   882,   882,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     0,     0,
       0,    33,    34,     0,    35,     0,     0,     0,     0,    36,
       0,     0,     0,     0,     0,    37,     0,     0,    38,     0,
       0,     0,     0,  2300,     0,    39,     0,     0,     0,     0,
       0,    40,    41,   891,     0,     0,  1784,  2557,     0,    42,
    2558,     0,   882,    43,     0,     0,     0,     0,   882,     0,
       0,     0,     0,    44,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,   882,
     952,  1028,   892,     0,     0,     0,     0,   892,   892,    47,
       0,     0,  1065,   891,     0,    48,  1069,     0,   952,     0,
      49,     0,   952,  1082,  1083,     0,   952,  1089,     0,  1092,
    1093,     0,     0,    50,     0,   952,     0,     0,     0,     0,
    2559,     0,     0,     0,  1115,     0,     0,     0,     0,     0,
       0,     0,     0,   952,     0,     0,    51,     0,     0,     0,
       0,     0,  1128,     0,     0,     0,     0,     0,     0,     0,
     942,     0,   942,   942,    57,     0,     0,  -136,     0,     0,
       0,   891,     0,  1156,     0,  1158,     0,   952,     0,     0,
       0,     0,     0,     0,     0,  1174,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,   952,   952,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5260,   892,     0,     0,     0,   891,     0,     0,     0,   629,
       0,     0,     0,     0,     0,     0,     0,     0,  1784,   952,
    2489,     0,  1784,     0,     0,     0,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,     0,
       0,  5398,     0,     0,     0,     0,   952,     0,  1784,     0,
     892,     0,   952,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   952,     0,     0,     0,
       0,     0,     0,   952,     0,     0,   952,     0,     0,     0,
       0,     0,   952,     0,     0,     0,     0,     0,   882,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,   855,
       0,     0,   952,     0,     0,     0,     0,     0,   952,     0,
       0,     0,     0,     0,     0,   952,     0,     0,     0,     0,
       0,   891,     0,     0,     0,  2060,     0,     0,  2061,   952,
       0,     0,  2062,  2063,  2064,     0,     0,     0,     0,     0,
       0,     0,   952,     0,   884,     0,   891,  1784,     0,  2549,
       0,     0,     0,   952,     0,     0,     0,     0,     0,  2550,
       0,   882,     0,     0,     0,   882,  2551,     0,     0,  2060,
     884,     0,  2061,     0,     0,     0,  2062,  2063,  2064,     0,
       0,     0,  1504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2552,  2549,     0,     0,     0,     0,     0,  2060,
       0,     0,  2061,  2550,     0,     0,  2062,  2063,  2064,     0,
    2551,     0,     0,  1784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2549,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2550,     0,     0,  2552,     0,     0,     0,
    2551,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2552,     0,     0,   882,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1802,   891,     0,     0,   882,     0,     0,     0,     0,   882,
       0,     0,     0,     0,     0,  1814,     0,  1815,     0,     0,
       0,     0,     0,     0,     0,     0,  2553,  1818,     0,     0,
       0,  2554,     0,     0,  1828,     0,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2555,  2248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2556,     0,
    2553,     0,     0,     0,     0,  2554,  1879,     0,  1881,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     952,   891,     0,     0,     0,     0,     0,  2555,  2248,     0,
    2553,     0,     0,     0,     0,  2554,     0,     0,   952,  2300,
       0,     0,  2556,     0,     0,   952,     0,   891,     0,     0,
       0,     0,   942,  2557,   942,   942,  2558,  2555,  2248,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2556,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2300,   629,     0,   629,     0,   629,     0,
     629,     0,   629,   629,   629,     0,     0,  2557,     0,   629,
    2558,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1987,     0,  2300,     0,     0,     0,     0,     0,  1784,
       0,     0,     0,     0,     0,  1784,     0,  2557,     0,  1999,
    2558,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,  2559,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2060,     0,     0,  2061,     0,     0,     0,  2062,
    2063,  2064,   882,     0,     0,   882,     0,   882,     0,   891,
    2559,     0,   882,     0,     0,     0,  2549,     0,     0,     0,
       0,     0,     0,     0,     0,   952,  2550,     0,     0,     0,
    1698,     0,     0,  2551,     0,     0,     0,     0,     0,     0,
    2559,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,  2552,
     882,   891,     0,     0,     0,     0,  2489,     0,   882,     0,
       0,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,     0,     0,  5437,     0,     0,
       0,     0,     0,   882,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   855,     0,     0,     0,
    2489,     0,     0,     0,     0,     0,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,     0,
       0,  5758,     0,     0,     0,     0,     0,     0,     0,     0,
    2489,     0,     0,   884,   952,   952,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,     0,
       0,  5780,     0,   882,     0,   882,     0,     0,     0,     0,
       0,   952,     0,  2553,   952,     0,     0,     0,  2554,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,     0,
    2555,  2248,     0,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,     0,  2556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2718,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1784,  1784,  1784,     0,
       0,     0,     0,     0,     0,     0,  2300,     0,     0,   882,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2557,   952,     0,  2558,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     952,     0,     0,     0,     0,     0,     0,     0,     0,  2810,
    2060,   882,     0,  2061,     0,     0,     0,  2062,  2063,  2064,
       0,     0,   952,     0,     0,     0,     0,     0,     0,     0,
       0,   891,     0,     0,  2549,     0,     0,     0,     0,   882,
       0,     0,     0,     0,  2550,     0,     0,     0,     0,     0,
       0,  2551,     0,     0,  2060,     0,     0,  2061,     0,     0,
       0,  2062,  2063,  2064,     0,     0,     0,     0,     0,   891,
       0,     0,     0,  2559,     0,     0,     0,  2552,  2549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2550,     0,
       0,   891,     0,     0,     0,  2551,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   882,   952,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2552,     0,     0,     0,     0,     0,     0,     0,   882,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   882,     0,     0,     0,  1784,     0,     0,     0,     0,
       0,   952,   891,   952,   884,     0,     0,     0,     0,     0,
       0,     0,     0,  2489,     0,     0,   952,     0,   952,     0,
       0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,
       0,  2553,     0,     0,  5975,     0,  2554,     0,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2555,  2248,
       0,     0,     0,  2940,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2556,     0,  2553,     0,     0,   884,     0,
    2554,     0,     0,     0,   882,   952,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2976,     0,
       0,     0,  2555,  2248,     0,     0,     0,   882,     0,     0,
       0,     0,     0,     0,  2300,     0,     0,  2556,     0,     0,
       0,     0,     0,   891,     0,     0,     0,   952,  2557,     0,
       0,  2558,   882,     0,     0,     0,     0,     0,     0,     0,
       0,  3037,     0,  3041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   952,     0,  2300,   951,
       0,     0,     0,  3059,     0,     0,     0,     0,   951,     0,
       0,     0,  2557,     0,     0,  2558,     0,     0,   952,     0,
       0,   952,   951,     0,     0,     0,     0,     0,     0,  3079,
       0,  3080,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3089,     0,  3090,     0,
       0,     0,     0,     0,     0,     0,   629,   887,   629,     0,
     629,  2559,   629,  2060,   629,     0,  2061,     0,   629,     0,
    2062,  2063,  2064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2549,     0,     0,
       0,     0,     0,     0,   891,     0,     0,  2550,     0,     0,
       0,  1784,     0,     0,  2551,  2559,     0,   882,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,     0,  2060,     0,     0,  2061,     0,
    2552,     0,  2062,  2063,  2064,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2549,
       0,     0,   891,  3371,     0,     0,     0,     0,     0,  2550,
       0,  2489,     0,     0,     0,     0,  2551,     0,     0,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,
       0,     0,  5993,     0,   888,     0,     0,     0,   884,     0,
       0,     0,  2552,     0,     0,     0,     0,   882,     0,     0,
       0,     0,     0,   884,     0,  2489,   884,   884,     0,     0,
       0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,
    2497,  2498,     0,   882,     0,     0,  6040,  2060,     0,   885,
    2061,     0,     0,     0,  2062,  2063,  2064,   884,   884,     0,
       0,     0,     0,  3372,  2553,     0,     0,     0,     0,  2554,
       0,  2549,     0,     0,     0,   885,     0,   952,     0,     0,
       0,  2550,     0,     0,     0,     0,     0,     0,  2551,     0,
       0,  2555,  2248,     0,   891,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2556,     0,     0,     0,
       0,     0,     0,     0,  2552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2553,     0,  1784,     0,
       0,  2554,     0,  1784,     0,  1784,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2300,     0,     0,
       0,     0,     0,  2555,  2248,     0,     0,     0,     0,  1784,
       0,  2557,     0,     0,  2558,     0,     0,     0,  2556,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   882,     0,     0,     0,   884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5936,     0,   952,     0,     0,   952,  2300,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2557,   891,     0,  2558,   885,  2553,   891,
     891,     0,   882,  2554,     0,     0,     0,   882,     0,     0,
       0,     0,     0,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2559,  2555,  2248,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,     0,     0,   951,
    2556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,   952,   952,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   952,
       0,  2300,   951,     0,     0,     0,  2559,     0,     0,     0,
     951,     0,     0,     0,     0,  2557,   952,     0,  2558,     0,
       0,     0,     0,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,   891,   951,     0,     0,     0,     0,     0,
       0,     0,  5937,     0,  2489,     0,     0,     0,     0,     0,
       0,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,  2936,     0,     0,  3373,     0,     0,     0,
       0,     0,     0,     0,   882,     0,     0,     0,   885,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,   951,     0,     0,     0,
       0,     0,     0,     0,     0,   885,  2489,     0,  2559,     0,
       0,     0,   952,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,   951,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2489,     0,
     951,   887,     0,     0,     0,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,   882,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3406,  3407,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,  3422,  3423,     0,
    3425,  3426,     0,     0,     0,  3429,  3430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3441,     0,     0,     0,     0,     0,     0,  3450,     0,     0,
       0,  3453,  3454,     0,     0,  3457,  3458,   952,   882,     0,
    1783,     0,  3463,     0,     0,     0,   951,     0,     0,     0,
       0,     0,     0,     0,  3478,     0,     0,     0,   888,     0,
       0,     0,     0,     0,     0,  2060,  3495,     0,  2061,     0,
       0,  3497,  2062,  2063,  2064,     0,     0,     0,     0,   952,
       0,     0,     0,     0,   888,     0,  3503,     0,     0,  2549,
       0,   952,     0,     0,     0,  3510,     0,     0,  3514,  2550,
    3516,  3519,  3521,     0,     0,     0,  2551,  3529,  3532,   887,
       0,     0,     0,     0,     0,     0,     0,  3545,     0,     0,
       0,     0,     0,  3555,   952,     0,     0,  3558,     0,     0,
       0,     0,  2552,     0,     0,     0,     0,     0,     0,  3568,
    3569,     0,     0,     0,  3574,     0,     0,     0,     0,     0,
    3583,  3584,     0,  2060,     0,     0,  2061,     0,     0,   882,
    2062,  2063,  2064,     0,  3593,     0,     0,  3594,     0,   951,
       0,     0,     0,     0,  3606,  3607,     0,  2549,     0,     0,
    3611,     0,     0,     0,     0,   884,     0,  2550,     0,   884,
     884,     0,  3618,     0,  2551,  3621,     0,     0,     0,     0,
    3624,     0,  1784,     0,     0,     0,  3627,  3628,     0,     0,
       0,     0,     0,     0,  3634,     0,     0,     0,  3636,     0,
    2552,   952,  3643,  3644,  3645,  3646,     0,  3648,     0,     0,
       0,   885,   951,     0,     0,     0,   888,     0,     0,     0,
    3673,  3674,     0,  3676,     0,     0,  2553,   884,   951,     0,
       0,  2554,     0,   884,  3685,  3686,  3687,     0,     0,     0,
       0,     0,   951,     0,     0,     0,   951,     0,     0,     0,
     887,     0,     0,  2555,  2248,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,  2556,     0,
     882,     0,     0,     0,   884,     0,     0,   887,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3984,  3739,     0,     0,     0,  3985,     0,     0,   952,  3763,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2300,
       0,     0,     0,     0,  2553,     0,     0,     0,  3775,  2554,
     885,     0,     0,  2557,     0,     0,  2558,     0,   882,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2555,  2248,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4574,   885,   890,     0,  2556,     0,     0,     0,
       0,     0,     0,     0,     0,   951,     0,     0,  3843,     0,
       0,     0,     0,   951,   951,     0,     0,   888,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3857,   888,  3859,
       0,     0,     0,     0,     0,     0,     0,  2300,     0,   952,
       0,   952,     0,     0,   888,     0,     0,     0,     0,     0,
       0,  2557,     0,     0,  2558,     0,  2559,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1783,     0,     0,     0,
       0,     0,     0,  4575,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,     0,   952,     0,     0,     0,
     882,     0,     0,     0,     0,     0,   942,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,  3932,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1784,     0,
       0,     0,     0,   942,  3986,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2489,     0,     0,     0,
       0,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,   884,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,   888,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     882,     0,     0,     0,     0,   882,   882,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2489,     0,     0,     0,     0,     0,
       0,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,   885,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,   885,   885,     0,   951,     0,     0,  2060,   884,
       0,  2061,     0,   887,   884,  2062,  2063,  2064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   882,
       0,     0,  2549,     0,     0,  3941,     0,     0,     0,     0,
       0,     0,  2550,     0,     0,   952,     0,     0,     0,  2551,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   952,
    2060,     0,     0,  2061,     0,     0,     0,  2062,  2063,  2064,
       0,     0,     0,     0,     0,  2552,     0,     0,   882,     0,
       0,   887,     0,     0,  2549,     0,     0,     0,     0,  4135,
    1784,     0,     0,     0,  2550,     0,     0,     0,     0,     0,
       0,  2551,     0,     0,     0,     0,     0,     0,     0,  4147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,   887,     0,     0,     0,  4154,  2552,     0,     0,
    4154,     0,     0,     0,   885,  4165,  4166,  4167,     0,     0,
     888,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1783,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4197,  4198,  4199,  4200,     0,     0,   951,     0,     0,
       0,     0,     0,     0,     0,   951,     0,     0,     0,  2553,
       0,     0,  1784,   951,  2554,     0,     0,     0,     0,     0,
       0,  4216,     0,     0,     0,     0,     0,     0,   888,  4219,
       0,  4223,  4224,  4225,     0,     0,  2555,  2248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2556,     0,     0,     0,     0,   951,   951,     0,     0,
       0,  2553,     0,     0,     0,     0,  2554,     0,     0,   888,
     951,  1784,     0,   952,     0,     0,     0,   884,     0,     0,
     884,     0,   884,   951,   951,     0,     0,   884,  2555,  2248,
       0,     0,  2300,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   888,  2556,     0,     0,  2557,     0,     0,  2558,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   690,     0,     0,     0,     0,   691,     0,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,   884,  2300,     0,     0,  4308,   890,     0,
       0,     0,     0,     0,     0,     0,  4314,     0,  2557,     0,
       0,  2558,     0,     0,     0,   887,   692,     0,   884,     0,
       0,     0,     0,     0,   890,     0,   887,     0,     0,   693,
       0,  3957,  4324,  4325,     0,     0,     0,  4326,     0,     0,
       0,     0,   887,     0,     0,   694,     0,   952,     0,  2559,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4368,
     942,     0,     0,   695,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   952,     0,     0,     0,     0,     0,     0,
       0,     0,  1783,     0,     0,     0,     0,   696,   884,     0,
     884,     0,     0,     0,     0,   887,     0,     0,   697,     0,
       0,  2559,     0,     0,     0,     0,     0,   698,     0,     0,
     887,  4405,     0,   887,   887,     0,  4411,     0,     0,     0,
     699,     0,  4417,     0,     0,   700,     0,     0,     0,     0,
       0,     0,   701,   942,   942,     0,     0,     0,     0,     0,
       0,     0,   888,     0,   887,   887,     0,     0,     0,  2489,
       0,   702,  4456,   888,     0,     0,     0,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2497,  2498,     0,     0,     0,   888,
       0,     0,     0,     0,     0,     0,   890,     0,     0,     0,
       0,  4471,     0,  4472,   884,     0,     0,     0,     0,     0,
       0,     0,     0,   952,     0,     0,     0,     0,   703,     0,
       0,  2489,     0,     0,     0,     0,     0,     0,     0,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,     0,
       0,     0,   888,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,  4512,     0,     0,   888,     0,   704,
     888,   888,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   705,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   706,     0,     0,     0,   955,     0,
       0,   888,   888,     0,   214,   707,   887,     0,   708,     0,
     989,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   709,     0,     0,   710,     0,
       0,     0,   711,     0,   712,     0,     0,     0,     0,     0,
       0,   713,   884,     0,   714,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
    1784,     0,     0,   715,   884,     0,     0,     0,   890,     0,
     716,     0,     0,     0,     0,     0,   717,     0,     0,   718,
       0,     0,     0,   719,   890,     0,   884,     0,     0,     0,
       0,   720,     0,   721,     0,     0,     0,     0,   722,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1784,     0,
     885,   723,     0,     0,   885,   885,   942,   942,     0,     0,
       0,     0,     0,   888,   724,     0,  1784,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   885,     0,     0,     0,     0,  4685,   885,   884,
    4692,     0,  4693,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4700,     0,     0,     0,     0,
       0,     0,   884,     0,     0,     0,     0,  4706,     0,     0,
       0,  4709,     0,     0,     0,     0,     0,  2060,     0,   885,
    2061,     0,     0,     0,  2062,  2063,  2064,   884,     0,     0,
    4733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2549,     0,     0,  3989,     0,     0,   890,  4737,     0,
       0,  2550,     0,     0,  4741,     0,     0,     0,  2551,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4776,
       0,     0,     0,  4780,  2552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4789,  4790,
    4791,  4792,     0,     0,     0,     0,     0,  1783,  4796,  4797,
    4798,  4799,     0,     0,     0,     0,     0,  4801,  4802,     0,
       0,     0,     0,  4809,  4810,     0,  4812,  4813,  4814,  4815,
    4816,  4817,  4818,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4827,     0,     0,     0,  4830,  4831,  4832,  4833,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   951,   884,     0,     0,     0,     0,     0,     0,     0,
    4154,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,   951,     0,     0,     0,   951,  4853,     0,
       0,     0,     0,     0,     0,     0,   951,     0,  2553,     0,
       0,     0,     0,  2554,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1027,   951,     0,     0,     0,     0,  1059,
       0,     0,     0,     0,     0,  2555,  2248,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2556,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4934,     0,     0,     0,   951,   951,
       0,     0,     0,     0,     0,     0,     0,     0,   884,     0,
       0,  2300,     0,     0,     0,     0,     0,     0,     0,     0,
     890,     0,     0,     0,     0,  2557,     0,  4154,  2558,  1783,
     951,   885,     0,  1783,  4959,   885,  4960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,  1783,
       0,     0,     0,   951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4985,     0,     0,     0,   951,     0,     0,
       0,     0,     0,     0,   951,     0,     0,   951,   890,     0,
       0,     0,     0,   951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,   951,     0,     0,   887,   887,  2559,   951,
       0,     0,     0,     0,     0,     0,   951,     0,     0,   890,
    1356,     0,     0,     0,     0,     0,     0,     0,     0,   885,
     951,     0,     0,     0,     0,     0,     0,     0,     0,  1379,
     884,     0,     0,   951,   885,     0,     0,     0,  1783,   885,
       0,     0,   890,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2489,  1437,
       0,   887,     0,     0,  1783,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,     0,     0,     0,     0,   888,
       0,     0,     0,   888,   888,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5111,  5112,  5113,     0,  1574,     0,  5114,  5115,
    5116,  5117,     0,     0,     0,  5119,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   888,     0,     0,     0,     0,     0,   888,     0,     0,
       0,  5138,  5139,  5140,  5141,  5142,     0,  5144,  5145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5154,
    5155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   888,   884,
       0,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5163,   890,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   890,
    1833,   951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,   885,     0,     0,   885,   951,   885,  1867,  1870,
    1871,     0,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
     890,   890,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,   884,     0,  5226,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1783,   890,   890,     0,     0,     0,  1783,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
     884,     0,     0,   887,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1356,
       0,     0,   884,     0,     0,     0,     0,     0,     0,  5277,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1998,     0,     0,     0,     0,     0,     0,     0,     0,  1356,
       0,     0,     0,     0,     0,     0,     0,   888,     0,     0,
       0,     0,     0,   885,     0,   885,   951,     0,     0,     0,
       0,  2060,     0,     0,  2061,     0,     0,     0,  2062,  2063,
    2064,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,  2549,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2550,     0,     0,     0,     0,
       0,   887,  2551,   890,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
     888,   887,     0,     0,   888,     0,     0,     0,  2552,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   629,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,   951,  2543,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,  5385,     0,     0,     0,     0,     0,
       0,     0,   951,     0,   884,   951,     0,     0,     0,     0,
       0,     0,     0,  5395,     0,     0,     0,     0,     0,   885,
       0,  5401,  5402,  3994,     0,     0,     0,     0,   888,     0,
       0,  5413,     0,     0,     0,     0,     0,     0,  5415,     0,
       0,     0,  2553,   888,     0,     0,     0,  2554,   888,     0,
       0,     0,     0,     0,     0,     0,     0,  2634,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2555,
    2248,     0,     0,  5467,  5468,     0,     0,  1783,  1783,  1783,
       0,     0,     0,     0,  2556,     0,  5476,   885,  5478,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,  5492,     0,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   951,     0,     0,     0,  2300,     0,     0,  4154,     0,
       0,   885,     0,     0,     0,   884,     0,     0,     0,  2557,
       0,  2750,  2558,   951,     0,     0,  5532,     0,     0,     0,
    2773,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,   887,     0,   887,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,  2811,     0,     0,     0,     0,     0,  2823,  2823,
       0,     0,  2823,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2841,     0,     0,  2844,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,     0,   885,     0,     0,     0,     0,   951,
     887,     0,  2559,  5583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5590,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,   887,     0,     0,     0,     0,
       0,     0,     0,  2897,     0,     0,     0,     0,     0,     0,
       0,     0,   885,     0,     0,     0,  1783,  2916,     0,     0,
       0,     0,   951,     0,   951,     0,     0,     0,     0,     0,
       0,   888,     0,     0,   888,     0,   888,   951,     0,   951,
       0,   888,     0,     0,     0,     0,     0,     0,     0,     0,
    5649,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,     0,   887,     0,     0,
       0,     0,  2489,     0,     0,     0,     0,     0,     0,     0,
    2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,   888,
       0,     0,     0,  2060,     0,     0,  2061,   888,     0,     0,
    2062,  2063,  2064,     0,     0,     0,   951,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2549,     0,     0,
    4001,  4154,   888,     0,     0,  5699,  2938,  2550,     0,     0,
       0,     0,     0,     0,  2551,     0,     0,  2941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,   951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2060,
    2552,   887,  2061,     0,     0,     0,  2062,  2063,  2064,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,  2985,
    2823,  5746,     0,  2549,     0,   884,     0,     0,     0,     0,
     884,   884,   888,  2550,   888,  5759,     0,     0,     0,   951,
    2551,     0,   951,   887,  3020,     0,     0,     0,     0,     0,
       0,  3033,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2552,     0,     0,   890,
       0,   887,     0,   890,   890,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5798,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2553,     0,     0,     0,     0,  2554,
       0,     0,  1783,  3094,     0,     0,  2634,     0,   888,     0,
       0,   890,     0,     0,     0,     0,     0,   890,     0,   887,
       0,  2555,  2248,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2556,     0,  1356,  1356,
    2060,   887,     0,  2061,     0,     0,     0,  2062,  2063,  2064,
     888,     0,     0,     0,     0,  3149,     0,     0,   890,     0,
    2553,     0,     0,   887,  2549,  2554,  5875,  4581,     0,     0,
       0,     0,     0,   884,  2550,     0,     0,  2300,   888,     0,
       0,  2551,     0,     0,     0,     0,     0,  2555,  2248,     0,
       0,  2557,     0,     0,  2558,     0,     0,     0,  5887,     0,
       0,     0,  2556,     0,     0,     0,     0,  2552,     0,  5897,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,  2060,     0,
       0,  2061,     0,     0,     0,  2062,  2063,  2064,     0,     0,
       0,     0,     0,  2300,     0,     0,   888,     0,     0,     0,
       0,     0,  2549,     0,     0,     0,   887,  2557,   951,     0,
    2558,     0,  2550,     0,     0,     0,     0,     0,   888,  2551,
       0,     0,   885,     0,     0,     0,     0,   885,     0,   887,
       0,     0,     0,     0,  2559,     0,     0,     0,     0,     0,
     888,     0,     0,     0,     0,  2552,     0,     0,     0,     0,
       0,     0,     0,     0,   887,     0,     0,     0,     0,  1783,
       0,     0,     0,  5969,  1783,     0,  1783,     0,     0,     0,
       0,  2553,     0,     0,     0,     0,  2554,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1783,     0,  1332,  1332,     0,     0,     0,     0,  2555,  2248,
    2559,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2556,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4528,   888,  2489,     0,   951,     0,     0,   951,
    5006,     0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,     0,     0,     0,  2300,     0,   888,     0,     0,  2553,
       0,     0,     0,     0,  2554,     0,     0,     0,  2557,     0,
    1332,  2558,     0,     0,   885,     0,     0,     0,     0,     0,
       0,   888,     0,     0,     0,     0,  2555,  2248,     0,   887,
     890,     0,     0,     0,   890,     0,     0,     0,     0,     0,
    2489,  2556,     0,     0,     0,     0,     0,     0,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,  2060,     0,     0,
    2061,     0,     0,     0,  2062,  2063,  2064,     0,     0,   951,
     951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     951,  2549,  2300,     0,     0,     0,     0,     0,     0,     0,
       0,  2550,     0,     0,     0,     0,  2557,   951,  2551,  2558,
       0,  2559,     0,     0,     0,  2060,     0,     0,  2061,     0,
       0,     0,  2062,  2063,  2064,     0,     0,     0,     0,   887,
       0,     0,     0,     0,  2552,     0,     0,   885,     0,  2549,
       0,  1695,  1699,     0,     0,     0,     0,     0,   890,  2550,
       0,     0,     0,     0,     0,   887,  2551,     0,     0,     0,
       0,     0,     0,   890,     0,     0,   888,     0,   890,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,     0,
       0,     0,  2552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,     0,  2559,
       0,     0,     0,   951,     0,     0,     0,     0,     0,     0,
       0,  2489,     0,     0,     0,     0,     0,  2500,     0,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,     0,  5012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2553,     0,
       0,     0,     0,  2554,     0,     0,   888,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3306,   885,     0,
       0,  2500,  5013,     0,     0,  2555,  2248,  3311,     0,     0,
       0,     0,   888,     0,     0,     0,     0,     0,     0,     0,
    2556,     0,     0,     0,     0,     0,  2553,   887,     0,  2489,
       0,  2554,     0,     0,     0,     0,  1437,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2497,  2498,     0,     0,     0,     0,
       0,     0,     0,  2555,  2248,     0,     0,     0,     0,     0,
       0,  2300,     0,     0,     0,     0,     0,     0,  2556,     0,
       0,     0,     0,     0,   887,  2557,     0,     0,  2558,   887,
       0,     0,     0,  1437,  1437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2300,
       0,  2015,     0,     0,     0,     0,     0,  1356,     0,   885,
       0,     0,     0,  2557,     0,     0,  2558,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   951,     0,
       0,   890,  2030,     0,   890,     0,   890,     0,     0,     0,
       0,   890,     0,     0,   888,     0,     0,  2060,     0,     0,
    2061,     0,     0,     0,  2062,  2063,  2064,     0,  2559,     0,
    2049,  2050,  2051,     0,  2053,     0,     0,     0,     0,     0,
     951,  2549,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2550,   951,     0,  2507,     0,     0,     0,  2551,   890,
       0,   888,     0,     0,     0,  2060,   888,   890,  2061,     0,
       0,     0,  2062,  2063,  2064,     0,  2559,     0,     0,     0,
       0,     0,     0,     0,  2552,   951,   887,     0,     0,  2549,
       0,     0,   890,     0,     0,     0,     0,     0,     0,  2550,
       0,     0,     0,     0,     0,     0,  2551,     0,     0,  3513,
     885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3535,     0,     0,     0,  2489,     0,
       0,     0,  2552,     0,     0,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,     0,  3563,     0,     0,     0,
       0,     0,     0,  5014,     0,     0,  2601,     0,     0,     0,
    2613,  2618,   890,  1783,   890,     0,     0,     0,   885,     0,
    2500,     0,     0,     0,  2500,     0,  2489,     0,     0,     0,
       0,     0,   951,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,     0,     0,     0,  2553,   887,
       0,     0,     0,  2554,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   888,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2555,  2248,     0,     0,     0,
       0,     0,  3641,  3642,     0,     0,     0,   887,     0,     0,
    2556,     0,     0,     0,     0,     0,  2553,     0,     0,     0,
       0,  2554,     0,  2060,     0,     0,  2061,     0,   890,   887,
    2062,  2063,  2064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2555,  2248,     0,     0,  2549,     0,   951,
       0,  2300,     0,     0,     0,     0,     0,  2550,  2556,     0,
     885,     0,     0,     0,  2551,  2557,     0,     0,  2558,     0,
     890,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2552,     0,     0,     0,     0,     0,   888,     0,   890,  2300,
     887,     0,  2060,  3765,     0,  2061,     0,     0,     0,  2062,
    2063,  2064,     0,  2557,     0,     0,  2558,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2549,     0,     0,     0,
       0,     0,     0,     0,   888,     0,  2550,     0,     0,     0,
       0,     0,     0,  2551,     0,     0,     0,     0,     0,     0,
     951,     0,   951,     0,     0,     0,   888,     0,  2559,     0,
       0,     0,     0,     0,     0,     0,   890,     0,     0,  2552,
       0,     0,     0,  1695,  1695,  1695,     0,     0,     0,     0,
    5534,     0,     0,     0,     0,     0,     0,     0,   890,     0,
     885,     0,     0,     0,     0,   885,   885,   951,     0,     0,
       0,     0,     0,     0,  2553,     0,  2559,     0,     0,  2554,
     890,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,   888,     0,     0,
       0,  2555,  2248,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2556,     0,     0,  1783,
       0,     0,     0,     0,     0,     0,     0,     0,  2489,     0,
    2500,     0,     0,     0,     0,     0,  2490,  2491,  2492,  2493,
    2494,  2495,  2496,  2497,  2498,  2500,     0,     0,     0,  3210,
       0,  5357,     0,  2553,     0,     0,     0,  2300,  2554,     0,
       0,     0,     0,     0,  2500,  2500,  2500,     0,  2500,     0,
       0,  2557,     0,   890,  2558,     0,  2489,     0,     0,   885,
    2555,  2248,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,     0,     0,  2556,   890,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   888,     0,
       0,   890,   887,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,  2300,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2557,     0,     0,  2558,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2559,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4047,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1437,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   951,     0,     0,     0,
       0,     0,     0,  2559,     0,     0,     0,     0,     0,   888,
     951,     0,     0,     0,     0,     0,   890,     0,     0,     0,
       0,     0,     0,     0,  2489,     0,     0,     0,     0,     0,
       0,  3177,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  1783,     0,  3197,     0,  3198,     0,  3200,     0,     0,
    3214,  3217,  3222,     0,     0,     0,     0,     0,  3231,     0,
       0,  3236,   887,     0,     0,     0,     0,   888,     0,     0,
       0,     0,     0,     0,     0,     0,  3243,  3244,  3245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3246,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2489,     0,     0,   890,     0,     0,     0,
       0,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1783,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   888,
       0,     0,   887,     0,     0,     0,     0,   887,   887,     0,
       0,     0,  1783,     0,   951,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4241,     0,     0,
       0,     0,     0,     0,     0,     0,  3253,  2823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,   690,  3270,     0,     0,     0,
    1030,     0,  2500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,  1031,   888,
       0,   890,     0,     0,   888,   888,   890,     0,   951,  3272,
       0,   693,  1032,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1033,     0,     0,     0,   694,     0,     0,
       0,     0,     0,     0,   951,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2500,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,  1035,
       0,     0,     0,  2500,     0,     0,  4372,  4373,  4374,     0,
     697,     0,     0,     0,     1,     0,     0,     0,     0,   698,
       0,     0,     0,  4383,     2,     0,     3,     4,     0,     0,
       0,     0,   699,     0,     0,     0,     0,  1036,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   888,     0,
       0,     0,     0,     0,     6,     0,  4408,  4410,     0,     0,
       0,  4415,     0,  1037,     0,     0,     7,     0,     8,     9,
       0,     0,     0,     0,     0,    10,     0,    11,     0,     0,
       0,     0,     0,   890,   951,     0,     0,     0,  1038,    12,
       0,    13,     0,     0,     0,     0,     0,   888,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    14,     0,
     703,    15,     0,     0,  3279,  3280,  3281,  3282,  3283,  3284,
    3285,  3286,  3287,   641,  3288,     0,    16,     0,    17,     0,
       0,     0,    18,  1332,     0,  1695,     0,     0,  5507,     0,
       0,   642,     0,     0,     0,     0,    20,     0,    21,     0,
       0,  1039,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   643,     0,     0,     0,
       0,     0,    23,  3246,     0,  4511,   706,  3253,  1356,   644,
    3270,     0,  3272,     0,     0,  3323,   214,  1040,     0,    24,
     708,     0,     0,     0,     0,  -865,   890,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   645,     0,     0,     0,  1041,     0,   646,
    1042,     0,     0,     0,   711,     0,   712,     0,     0,    25,
      26,  1783,     0,   713,   890,    27,   714,   647,  2050,  2051,
       0,     0,     0,     0,     0,     0,     0,     0,   648,    28,
       0,     0,     0,     0,     0,   715,   890,   649,     0,     0,
       0,     0,  1043,     0,     0,     0,     0,    29,   717,     0,
     650,  1044,     0,     0,     0,   719,     0,     0,   651,  1783,
       0,     0,   652,  1045,     0,   721,     0,     0,     0,     0,
    1046,     0,     0,     0,     0,     0,     0,  1783,     0,     0,
       0, -1066,     0,     0,    30,     0,     0,  4613,  4614,  4615,
       0,     0,    31,     0,     0,     0,   724,     0,     0,     0,
    3455,     0,     0,     0,     0,     0,    32,   890,     0,     0,
       0,     0,    33,    34,     0,    35,     0,     0,   653,     0,
      36,     0,     0,  4446,     0,     0,    37,     0,  -601,    38,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,    40,    41,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    44,     0,     0,     0,     0,   654,
       0,     0,   655,     0,     0,     0,     0,     0,     0,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   656,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,   657,     0,
      47,     0,     0,     0,     0,  -459,    48,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,   890,     0,
       0,     0,     0,     0,    50,   658,     0,     0,     0,     0,
       0,     0,     0,     0,   659,     0,     0,     0,     0,     0,
       0,  -459,     0,     0,   660,     0,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   661,     0,    57,     0,     0,  -136,     0,
     662,     0,     0,     0,     0,     0,  -459,     0,     0,   663,
     664,     0,   665,   666,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   667,     0,
       0,     0,     0,     0,     0,   668,     0,     0,   669,     0,
       0,   670,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -459,  3697,  3698,  1695,     0,     0,
       0,  3702,  2500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   890,
       0,     0,  2500,  2500,     0,  2500,     0,     0,  3731,     0,
    3210,  3210,     0,  3980,     0,  3210,     0,     0,     0,  2500,
       0,     0,  2500,     0,     0,     0,     0,  2500,     0,     0,
       0,     0,     0,     0,     0,     0,  2500,     0,  4863,     0,
       0,  2500,     0,     0,     0,     0,     0,     0,  2500,  2500,
    2500,  2500,     0,     0,     0,  3210,  3210,   890,  2500,     0,
       0,     0,     0,     0,     0,   198,     0,     0,     0,     0,
    4895,     0,     0,     0,     0,  2500,     0,  2500,     0,     0,
       0,     0,     0,     0,  2500,  2500,  2500,  2500,  2500,  2500,
    2500,  2500,  2500,  2500,     0,     0,     0,     0,     0,     0,
       0,     0,  3033,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,     0,
       0,     0,   200,     0,     0,     0,     0,  4953,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,     0,     0,     0,  3094,     0,   202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,     0,     0,     0,     0,   890,
       0,     0,     0,     0,     0,   204,     0,     0,     0,     0,
       0,     0,     0,     0,   205,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   206,     0,     0,
       0,     0,   207,     0,     0,     0,     0,     0,  3937,   208,
       0,     0,     0,  3943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   209,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2053,     0,     0,     0,     0,     0,     0,     0,     0,
    2500,     0,  3222,   210,  3222,  3222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4004,     0,
       0,  4007,     0,  4009,     0,   211,     0,     0,  5049,  5050,
    5051,  5052,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   890,
       0,     0,     0,     0,   890,   890,     0,  4028,     0,  4031,
       0,  4033,     0,     0,     0,     0,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   214,   215,     0,     0,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   218,     0,     0,     0,   219,
       0,   220,     0,     0,     0,     0,     0,     0,   221,  4098,
       0,   222,     0,     0,  2601,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   890,  2618,
     223,     0,     0,     0,     0,     0,     0,   224,     0,     0,
       0,     0,   225,   226,     0,     0,   227,     0,     0,     0,
     228,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     229,     0,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,   231,     0,
       0,     0,     0,     0,  4133,     0,     0,     0,     0,     0,
       0,   232,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2500,  2500,     0,     0,     0,  2500,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2500,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5255,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5265,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1695,     0,     0,
       0,     0,  2500,  1695,     0,     0,     0,     0,  2500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3980,  3980,     0,     0,
    3210,  3210,  3210,  3210,     0,     0,  3210,  3210,  3210,  3210,
    3210,  3210,  3210,  3210,  3210,  3210,  3980,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2500,
       0,     0,  2500,     0,  2500,     0,     0,  3980,  3980,     0,
       0,     0,  4395,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2500,  3210,  3210,  2500,     0,  2500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5451,
       0,     0,     0,     0,  1356,     0,     0,     0,     0,     0,
       0,     0,     0,  2500,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5481,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4529,     0,     0,     0,     0,     0,     0,     0,
       0,  4533,     0,     0,     0,     0,     0,     0,     0,  4535,
       0,  4536,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4558,  4559,
    4560,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3231,     0,     0,
       0,  5580,     0,     0,     0,  4584,     0,     0,  4587,     0,
    4589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4592,     0,     0,     0,     0,     0,     0,     0,  4599,  4600,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5656,     0,     0,     0,     0,     0,  3210,     0,     0,
    4658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5679,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2500,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2500,     0,     0,     0,  2500,     0,
    2500,  2500,     0,     0,     0,     0,  3980,  3980,  3980,  3980,
       0,     0,     0,  3980,  3980,  3980,  3980,  3980,  3980,  3980,
    3980,  3980,  3980,  2500,  2500,  2500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2500,
       0,     0,  2500,     0,  2500,     0,     0,  2500,     0,     0,
    3980,  3980,     0,     0,  2500,  2500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2500,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4941,
    4942,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4949,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5027,  5029,     0,     0,     0,     0,     0,  5033,
    5034,     0,     0,     0,  5035,     0,     0,     0,  5036,     0,
       0,  5039,  5040,     0,     0,     0,  5044,     0,     0,     0,
       0,     0,  5048,     0,     0,     0,     0,     0,     0,  3980,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5079,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  5086,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5093,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2500,  2500,     0,     0,
       0,     0,     0,     0,  2500,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2500,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2500,     0,     0,
       0,     0,     0,  2500,  3210,     0,     0,     0,     0,     0,
       0,  5157,     0,     0,     0,     0,     0,  5161,     0,     0,
       0,     0,  2500,     0,  2500,     0,     0,     0,  2500,  2500,
    2500,  2500,     0,     0,  2500,  2500,     0,     0,     0,  2500,
       0,     0,     0,  2500,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2500,     0,     0,     0,     0,     0,
       0,  2500,     0,     0,     0,  5196,     0,     0,  2500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2500,     0,     0,     0,  2500,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2500,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5293,     0,     0,     0,     0,     0,  5297,  5298,  5299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5310,  5311,     0,     0,  5312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,     0,
    3980,  3210,  2500,  2500,  2500,     0,     0,     0,     0,     0,
       0,  5332,     0,     0,     0,  2500,  2500,  2500,     0,     0,
       0,     0,  5350,     0,     0,     0,     0,     0,     0,     0,
    3210,     0,     0,  3980,     0,     0,     0,  2500,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5531,
       0,     0,     0,     0,     0,     0,  2500,     0,     0,     0,
    3980,     0,     0,     0,  3231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3980,     0,  3210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2053,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,     0,
       0,  5597,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5633,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2500,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2500,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5705,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5350,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5748,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3210,  3210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2500,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2500,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3980,  3980,     0,  5837,  5837,  5837,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5350,     0,     0,     0,     0,     0,  5863,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2500,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5929,     0,     0,     0,     0,  5837,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,     0,  1248,   685,     0,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,  1689,
     244,   245,   246,     0,     0,  6006,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
    5837,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,  1690,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,  1695,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,   590,  1307,
    1691,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,  1318,  1692,     0,     0,     0,     0,
       0,     0,  1320,  1693,   235,     0,  1248,   685,     0,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
      41,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,    45,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,  1180,  1307,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,    50,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,    51,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,  1318,     0,     0,     0,     0,     0,
       0,     0,  1320,  5563,   235,     0,  1248,   685,     0,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,   590,  1307,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,  1318,     0,     0,     0,     0,     0,
       0,     0,  1320,  3212,   235,     0,  1248,   685,     0,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,   590,  1307,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,  1318,     0,     0,     0,     0,     0,
       0,     0,  1320,  4537,   235,     0,  1248,   685,     0,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,   590,  1307,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,     0,     0,     0,   626,     0,     0,
       0,     0,     0,  1317,  1318,     0,     0,     0,     0,     0,
       0,     0,  1320,  4606,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,  4076,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0, -1809,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0, -1809,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
   -1809,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393, -1809,   395,   396,   397,   398,
     399,     0,     0,   400,   401, -1809,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426, -1809,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508, -1809,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,     0,
     857,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1430,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   858,
     260,   859,   860,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   861,   862,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   863,   864,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   865,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   866,   349,     0,   350,     0,   351,   352,     0,
     353,   354,   355,   356,   357,     0,   358,     0,     0,     0,
     361,   362,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,  2643,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,  2644,   383,   384,   385,   386,   867,
     868,     0,   869,     0,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,     0,     0,   400,     0,   402,   403,
     404,     0,   405,   406,   407,     0,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   870,   427,   871,   429,   430,
     431,   432,   433,   434,   435,     0,     0,   438,     0,   439,
     440,   441,   442,     0,     0,   444,   872,   446,   447,   448,
       0,   449,   450,     0,     0,   451,   452,   453,     0,     0,
     454,   455,  2646,   457,   458,   459,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
     472,     0,   474,     0,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   873,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,     0,   507,   508,
     509,   510,   511,   512,   513,   514,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     0,   525,   526,   527,
     528,   529,     0,   530,   531,  2647,   533,   534,   535,   536,
     537,   875,   539,     0,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,     0,   554,     0,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
       0,   564,   876,   877,     0,     0,   567,   568,     0,   570,
       0,     0,   572,   573,   574,   575,   576,   577,   578,   579,
       0,     0,   580,   581,   582,   583,   584,     0,     0,   585,
     586,   587,   588,   589,     0,   878,  2648,   592,   593,   594,
     595,   596,   597,     0,     0,   598,     0,     0,   599,   600,
     601,   602,   603,   604,   857,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   616,   617,   618,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,  2744,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   858,   260,   859,   860,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   861,
     862,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   863,   864,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   866,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,     0,     0,     0,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,  2643,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,  2644,   383,
     384,   385,   386,   867,   868,     0,   869,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,     0,   402,   403,   404,     0,   405,   406,   407,     0,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   870,
     427,   871,   429,   430,   431,   432,   433,   434,   435,     0,
       0,   438,     0,   439,   440,   441,   442,     0,     0,   444,
     872,   446,   447,   448,     0,   449,   450,     0,     0,   451,
     452,   453,     0,     0,   454,   455,  2646,   457,   458,   459,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,     0,   474,     0,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   873,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,     0,   530,   531,  2647,
     533,   534,   535,   536,   537,   875,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,     0,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,   876,   877,     0,     0,
     567,   568,     0,   570,     0,     0,   572,   573,   574,   575,
     576,   577,   578,   579,     0,     0,   580,   581,   582,   583,
     584,     0,     0,   585,   586,   587,   588,   589,     0,   878,
    2648,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   235,     0,
    1248,   685,     0,  1249,  1250,  1251,   747,  1252,     0,   616,
     617,   618,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1253,     0,  3820,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1254,   260,  1255,
    1256,     0,   263,   264,   265,   266,   267,   268,   269,  1257,
    1258,   270,   271,  1259,  1260,   274,     0,   275,   276,   277,
     278,  1261,     0,  1262,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,   307,
    1270,  1271,   310,  1272,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   865,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1273,   339,
     340,   341,   342,  1274,  1275,   344,     0,   345,   346,   347,
    1276,   349,     0,   350,     0,   351,   352,     0,   353,   354,
     355,   356,   357,     0,   358,  1277,     0,  1278,   361,   362,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   383,   384,   385,   386,  1279,  1280,     0,
    1281,     0,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,     0,     0,   400,  1282,   402,   403,   404,     0,
     405,   406,   407,  1283,  1284,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1285,   427,  1286,   429,   430,   431,   432,
     433,   434,   435,   436,  1287,   438,  1288,   439,   440,   441,
     442,  1289,  1290,   444,  1291,   446,   447,   448,     0,   449,
     450,     0,     0,  1292,   452,   453,     0,     0,   454,   455,
     456,   457,   458,   459,  1293,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,  1294,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,  1295,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,   509,   510,
     511,   512,   513,   514,  1296,   516,   517,   518,   519,   520,
     521,   522,   523,   524,    41,   525,   526,   527,   528,   529,
    1297,   530,   531,   532,   533,   534,   535,   536,   537,  1298,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,  1299,   554,     0,   555,   556,
      45,   557,   558,   559,   560,   561,   562,   563,     0,   564,
    1300,  1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,
     572,   573,   574,   575,   576,   577,   578,   579,     0,  1305,
     580,   581,   582,   583,   584,  1306,     0,   585,   586,   587,
     588,   589,  1180,  1307,     0,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,    50,   599,   600,   601,   602,
     603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,
    1314,  1315,   615,   616,   617,   618,  1316,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  1317,  1318,     0,
       0,     0,   235,     0,  1248,   685,  1320,  1249,  1250,  1251,
     747,  1252,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1253,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1254,   260,  1255,  1256,  3218,   263,   264,   265,   266,
     267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,   274,
       0,   275,   276,   277,   278,  1261,     0,  1262,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,
     304,   305,   306,   307,  1270,  1271,   310,  1272,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   865,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1273,   339,   340,   341,   342,  1274,  1275,   344,
       0,   345,   346,   347,  1276,   349,     0,   350,     0,   351,
     352,  3219,   353,   354,   355,   356,   357,     0,   358,  1277,
       0,  1278,   361,   362,     0,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,     0,   373,   374,   375,   376,
     377,   378,   379,     0,   380,   381,   382,   383,   384,   385,
     386,  1279,  1280,     0,  1281,     0,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,     0,  3220,   400,  1282,
     402,   403,   404,     0,   405,   406,   407,  1283,  1284,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1285,   427,  1286,
     429,   430,   431,   432,   433,   434,   435,   436,  1287,   438,
    1288,   439,   440,   441,   442,  1289,  1290,   444,  1291,   446,
     447,   448,     0,   449,   450,     0,     0,  1292,   452,   453,
       0,     0,   454,   455,   456,   457,   458,   459,  1293,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     0,
       0,   471,   472,  1294,   474,   475,   476,   477,   478,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
    1295,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,     0,
     507,   508,   509,   510,   511,   512,   513,   514,  1296,   516,
     517,   518,   519,   520,   521,   522,   523,   524,     0,   525,
     526,   527,   528,   529,  1297,   530,   531,   532,   533,   534,
     535,   536,   537,  1298,   539,     0,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,  1299,
     554,     0,   555,   556,     0,   557,   558,   559,   560,   561,
     562,   563,     0,   564,  1300,  1301,     0,  3221,   567,   568,
    1302,   570,  1303,  1304,   572,   573,   574,   575,   576,   577,
     578,   579,     0,  1305,   580,   581,   582,   583,   584,  1306,
       0,   585,   586,   587,   588,   589,   590,  1307,     0,   592,
     593,   594,   595,   596,   597,     0,     0,   598,     0,     0,
     599,   600,   601,   602,   603,   604,   605,  1308,  1309,  1310,
    1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,
    1316,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1317,  1318,     0,     0,     0,   235,     0,  1248,   685,
    1320,  1249,  1250,  1251,   747,  1252,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243, -2199,   244,   245,   246,     0,     0,     0, -2199,  1253,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1254,   260,  1255,  1256,     0,
     263,   264,   265,   266,   267,   268,   269,  1257,  1258,   270,
     271,  1259,  1260,   274,     0,   275,   276,   277,   278,  1261,
       0,  1262,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,   302,   303,   304,   305,   306,   307,  1270,  1271,
     310,  1272,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     865,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1273,   339,   340,   341,
     342,  1274,  1275,   344,     0,   345,   346,   347,  1276,   349,
       0,   350,     0,   351,   352,     0,   353,   354,   355,   356,
     357,     0,   358,  1277,     0,  1278,   361,   362,     0,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,     0,
     373,   374,   375,   376,   377,   378,   379,     0,   380,   381,
     382,   383,   384,   385,   386,  1279,  1280,     0,  1281,     0,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
       0,     0,   400,  1282,   402,   403,   404,     0,   405,   406,
     407,  1283,  1284,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1285,   427,  1286,   429,   430,   431,   432,   433,   434,
     435,   436,  1287,   438,  1288,   439,   440,   441,   442,  1289,
    1290,   444,  1291,   446,   447,   448,     0,   449,   450,     0,
       0,  1292,   452,   453,     0,     0,   454,   455,   456,   457,
     458,   459,  1293,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     0,     0,   471,   472,  1294,   474,   475,
     476,   477,   478,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,  1295,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,     0,   507,   508,   509,   510,   511,   512,
     513,   514,  1296,   516,   517,   518,   519,   520,   521,   522,
     523,   524,     0,   525,   526,   527,   528,   529,  1297,   530,
     531,   532,   533,   534,   535,   536,   537,  1298,   539, -2199,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,  1299,   554,     0,   555,   556,     0,   557,
     558,   559,   560,   561,   562,   563,     0,   564,  1300,  1301,
       0,     0,   567,   568,  1302,   570,  1303,  1304,   572,   573,
     574,   575,   576,   577,   578,   579,     0,  1305,   580,   581,
     582,   583,   584,  1306,     0,   585,   586,   587,   588,   589,
     590,  1307,     0,   592,   593,   594,   595,   596,   597,     0,
       0,   598,     0,     0,   599,   600,   601,   602,   603,   604,
     605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,
     615,   616,   617,   618,  1316,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1317,  1318,     0,     0,     0,
     235,     0,  1248,   685,  1320,  1249,  1250,  1251,   747,  1252,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243, -2197,   244,   245,   246,     0,
       0,     0, -2197,  1253,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1254,
     260,  1255,  1256,     0,   263,   264,   265,   266,   267,   268,
     269,  1257,  1258,   270,   271,  1259,  1260,   274,     0,   275,
     276,   277,   278,  1261,     0,  1262,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,
     306,   307,  1270,  1271,   310,  1272,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   865,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1273,   339,   340,   341,   342,  1274,  1275,   344,     0,   345,
     346,   347,  1276,   349,     0,   350,     0,   351,   352,     0,
     353,   354,   355,   356,   357,     0,   358,  1277,     0,  1278,
     361,   362,     0,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,     0,   373,   374,   375,   376,   377,   378,
     379,     0,   380,   381,   382,   383,   384,   385,   386,  1279,
    1280,     0,  1281,     0,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,     0,     0,   400,  1282,   402,   403,
     404,     0,   405,   406,   407,  1283,  1284,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1285,   427,  1286,   429,   430,
     431,   432,   433,   434,   435,   436,  1287,   438,  1288,   439,
     440,   441,   442,  1289,  1290,   444,  1291,   446,   447,   448,
       0,   449,   450,     0,     0,  1292,   452,   453,     0,     0,
     454,   455,   456,   457,   458,   459,  1293,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   471,
     472,  1294,   474,   475,   476,   477,   478,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,  1295,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,     0,   507,   508,
     509,   510,   511,   512,   513,   514,  1296,   516,   517,   518,
     519,   520,   521,   522,   523,   524,     0,   525,   526,   527,
     528,   529,  1297,   530,   531,   532,   533,   534,   535,   536,
     537,  1298,   539, -2197,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,  1299,   554,     0,
     555,   556,     0,   557,   558,   559,   560,   561,   562,   563,
       0,   564,  1300,  1301,     0,     0,   567,   568,  1302,   570,
    1303,  1304,   572,   573,   574,   575,   576,   577,   578,   579,
       0,  1305,   580,   581,   582,   583,   584,  1306,     0,   585,
     586,   587,   588,   589,   590,  1307,     0,   592,   593,   594,
     595,   596,   597,     0,     0,   598,     0,     0,   599,   600,
     601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,   610,
    1312,  1313,  1314,  1315,   615,   616,   617,   618,  1316,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1317,
    1318,     0,     0,     0,   235,     0,  1248,   685,  1320,  1249,
    1250,  1251,   747,  1252,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1253,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1254,   260,  1255,  1256,     0,   263,   264,
     265,   266,   267,   268,   269,  1257,  1258,   270,   271,  1259,
    1260,   274,     0,   275,   276,   277,   278,  1261,     0,  1262,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,
     302,   303,   304,   305,   306,   307,  1270,  1271,   310,  1272,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   865,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1273,   339,   340,   341,   342,  1274,
    1275,   344,     0,   345,   346,   347,  1276,   349,     0,   350,
       0,   351,   352,     0,   353,   354,   355,   356,   357,     0,
     358,  1277,     0,  1278,   361,   362,     0,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,     0,   373,   374,
     375,   376,   377,   378,   379,     0,   380,   381,   382,   383,
     384,   385,   386,  1279,  1280,     0,  1281,     0,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,     0,     0,
     400,  1282,   402,   403,   404,     0,   405,   406,   407,  1283,
    1284,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1285,
     427,  1286,   429,   430,   431,   432,   433,   434,   435,   436,
    1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,   444,
    1291,   446,   447,   448,     0,   449,   450,     0,     0,  1292,
     452,   453,     0,     0,   454,   455,   456,   457,   458,   459,
    1293,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   471,   472,  1294,   474,   475,   476,   477,
     478,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,  1295,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,     0,   507,   508,   509,   510,   511,   512,   513,   514,
    1296,   516,   517,   518,   519,   520,   521,   522,   523,   524,
       0,   525,   526,   527,   528,   529,  1297,   530,   531,   532,
     533,   534,   535,   536,   537,  1298,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,  1299,   554,     0,   555,   556,     0,   557,   558,   559,
     560,   561,   562,   563,     0,   564,  1300,  1301,     0,     0,
     567,   568,  1302,   570,  1303,  1304,   572,   573,   574,   575,
     576,   577,   578,   579,     0,  1305,   580,   581,   582,   583,
     584,  1306,     0,   585,   586,   587,   588,   589,   590,  1307,
       0,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   599,   600,   601,   602,   603,   604,   605,  1308,
    1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,
     617,   618,  1316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1317,  1318,     0,     0,     0,     0,     0,
    2012,  3170,  1320,   235,     0,  1248,   685,     0,  1249,  1250,
    1251,   747,  1252,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1253,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1254,   260,  1255,  1256,     0,   263,   264,   265,
     266,   267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,  1270,  1271,   310,  1272,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1273,   339,   340,   341,   342,  1274,  1275,
     344,     0,   345,   346,   347,  1276,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,  1278,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1279,  1280,     0,  1281,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403,   404,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1285,   427,
    1286,   429,   430,   431,   432,   433,   434,   435,   436,  1287,
     438,  1288,   439,   440,   441,   442,  1289,  1290,   444,  1291,
     446,   447,   448,     0,   449,   450,     0,     0,  1292,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1295,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1296,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534,   535,   536,   537,  1298,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1300,  1301,     0,     0,   567,
     568,  1302,   570,  1303,  1304,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1305,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,  1307,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,
     618,  1316,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1317,  1318,  1319,     0,     0,   235,     0,  1248,
     685,  1320,  1249,  1250,  1251,   747,  1252,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2611,   244,   245,   246,     0,     0,     0,     0,
    1253,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1254,   260,  1255,  1256,
       0,   263,   264,   265,   266,   267,   268,   269,  1257,  1258,
     270,   271,  1259,  1260,   274,     0,   275,   276,   277,   278,
    1261,     0,  1262,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,   302,   303,   304,   305,   306,   307,  1270,
    1271,   310,  1272,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1273,   339,   340,
     341,   342,  1274,  1275,   344,     0,   345,   346,   347,  1276,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1277,     0,  1278,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1279,  1280,     0,  1281,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1282,   402,   403,   404,     0,   405,
     406,   407,  1283,  1284,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1285,   427,  1286,   429,   430,   431,   432,   433,
     434,   435,   436,  1287,   438,  1288,   439,   440,   441,   442,
    1289,  1290,   444,  1291,   446,   447,   448,     0,   449,   450,
       0,     0,  1292,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1293,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1294,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1295,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  1296,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1297,
     530,   531,   532,   533,   534,   535,   536,   537,  1298,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1299,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1300,
    1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1305,   580,
     581,   582,   583,   584,  1306,     0,   585,   586,   587,   588,
     589,   590,  1307,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,
    1315,   615,   616,   617,   618,  1316,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1317,  1318,     0,     0,
       0,   235,     0,  1248,   685,  1320,  1249,  1250,  1251,   747,
    1252,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1253,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1254,   260,  1255,  1256,     0,   263,   264,   265,   266,   267,
     268,   269,  1257,  1258,   270,   271,  1259,  1260,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,  1270,  1271,   310,  1272,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1273,   339,   340,   341,   342,  1274,  1275,   344,     0,
     345,   346,   347,  1276,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
    1278,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1279,  1280,     0,  1281,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1285,   427,  1286,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,  1288,
     439,   440,   441,   442,  1289,  1290,   444,  1291,   446,   447,
     448,     0,   449,   450,     0,     0,  1292,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1295,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1296,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,  1298,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1300,  1301,     0,     0,   567,   568,  1302,
     570,  1303,  1304,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  1305,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,  1307,  3699,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,  1316,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1317,  1318,     0,     0,     0,   235,     0,  1248,   685,  1320,
    1249,  1250,  1251,   747,  1252,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1253,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1254,   260,  1255,  1256,     0,   263,
     264,   265,   266,   267,   268,   269,  1257,  1258,   270,   271,
    1259,  1260,   274,     0,   275,   276,   277,   278,  1261,     0,
    1262,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,   302,   303,   304,   305,   306,   307,  1270,  1271,   310,
    1272,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1273,   339,   340,   341,   342,
    1274,  1275,   344,     0,   345,   346,   347,  1276,   349,     0,
     350,     0,   351,   352,  3219,   353,   354,   355,   356,   357,
       0,   358,  1277,     0,  1278,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1279,  1280,     0,  1281,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1282,   402,   403,   404,     0,   405,   406,   407,
    1283,  1284,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1285,   427,  1286,   429,   430,   431,   432,   433,   434,   435,
     436,  1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,
     444,  1291,   446,   447,   448,     0,   449,   450,     0,     0,
    1292,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1293,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1294,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1295,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1296,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1297,   530,   531,
     532,   533,   534,   535,   536,   537,  1298,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1299,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1300,  1301,     0,
       0,   567,   568,  1302,   570,  1303,  1304,   572,   573,   574,
     575,   576,   577,   578,   579,     0,  1305,   580,   581,   582,
     583,   584,  1306,     0,   585,   586,   587,   588,   589,   590,
    1307,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,
     616,   617,   618,  1316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1317,  1318,     0,     0,     0,   235,
       0,  1248,   685,  1320,  1249,  1250,  1251,   747,  1252,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1253,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1254,   260,
    1255,  1256,     0,   263,   264,   265,   266,   267,   268,   269,
    1257,  1258,   270,   271,  1259,  1260,   274,     0,   275,   276,
     277,   278,  1261,     0,  1262,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,
     307,  1270,  1271,   310,  1272,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1273,
     339,   340,   341,   342,  1274,  1275,   344,     0,   345,   346,
     347,  1276,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1277,     0,  1278,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1279,  1280,
       0,  1281,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1282,   402,   403,   404,
       0,   405,   406,   407,  1283,  1284,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1285,   427,  1286,   429,   430,   431,
     432,   433,   434,   435,   436,  1287,   438,  1288,   439,   440,
     441,   442,  1289,  1290,   444,  1291,   446,   447,   448,     0,
     449,   450,     0,     0,  1292,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1293,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1294,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1295,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  1296,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1297,   530,   531,   532,   533,   534,   535,   536,   537,
    1298,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1299,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1300,  1301,  3273,     0,   567,   568,  1302,   570,  1303,
    1304,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    1305,   580,   581,   582,   583,   584,  1306,     0,   585,   586,
     587,   588,   589,   590,  1307,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,
    1313,  1314,  1315,   615,   616,   617,   618,  1316,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1317,  1318,
       0,     0,     0,   235,     0,  1248,   685,  1320,  1249,  1250,
    1251,   747,  1252,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1253,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1254,   260,  1255,  1256,     0,   263,   264,   265,
     266,   267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,  1270,  1271,   310,  1272,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1273,   339,   340,   341,   342,  1274,  1275,
     344,     0,   345,   346,   347,  1276,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,  1278,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1279,  1280,     0,  1281,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403,   404,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1285,   427,
    1286,   429,   430,   431,   432,   433,   434,   435,   436,  1287,
     438,  1288,   439,   440,   441,   442,  1289,  1290,   444,  1291,
     446,   447,   448,     0,   449,   450,     0,     0,  1292,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1295,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1296,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534,   535,   536,   537,  1298,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1300,  1301,     0,     0,   567,
     568,  1302,   570,  1303,  1304,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1305,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,  1307,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,
     618,  1316,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1317,  1318,     0,     0,     0,   235,     0,  1248,
     685,  1320,  1249,  1250,  1251,   747,  1252,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1253,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1254,   260,  1255,  1256,
       0,   263,   264,   265,   266,   267,   268,   269,  1257,  1258,
     270,   271,  1259,  1260,   274,     0,   275,   276,   277,   278,
    1261,     0,  1262,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,   302,   303,   304,   305,   306,   307,  1270,
    1271,   310,  1272,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1273,   339,   340,
     341,   342,  1274,  1275,   344,     0,   345,   346,   347,  1276,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1277,     0,  1278,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1279,  1280,     0,  1281,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1282,   402,   403,   404,     0,   405,
     406,   407,  1283,  1284,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1285,   427,  1286,   429,   430,   431,   432,   433,
     434,   435,   436,  1287,   438,  1288,   439,   440,   441,   442,
    1289,  1290,   444,  1291,   446,   447,   448,     0,   449,   450,
       0,     0,  1292,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1293,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1294,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1295,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  1296,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1297,
     530,   531,   532,   533,   534,   535,   536,   537,  1298,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1299,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1300,
    1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1305,   580,
     581,   582,   583,   584,  1306,     0,   585,   586,   587,   588,
     589,   590,  1307,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,
    1315,   615,   616,   617,   618,  1316,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2614,  2615,     0,     0,
       0,   235,     0,  3386,   685,  1320,  1249,  1250,  1251,   747,
    1252,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1253,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1254,   260,  1255,  1256,     0,   263,   264,   265,   266,   267,
     268,   269,  1257,  1258,   270,   271,  1259,  1260,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,  1270,  1271,   310,  1272,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1273,   339,   340,   341,   342,  1274,  1275,   344,     0,
     345,   346,   347,  1276,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
    1278,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1279,  1280,     0,  1281,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1285,   427,  1286,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,  1288,
     439,   440,   441,   442,  1289,  1290,   444,  1291,   446,   447,
     448,     0,   449,   450,     0,     0,  1292,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1295,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1296,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,  1298,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1300,  1301,     0,     0,   567,   568,  1302,
     570,  1303,  1304,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  1305,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,  1307,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,  1316,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1317,  1318,     0,     0,     0,   235,     0,  1248,   685,  1320,
    1249,  1250,  1251,   747,  1252,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1253,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1254,   260,  1255,  1256,     0,   263,
     264,   265,   266,   267,   268,   269,  1257,  1258,   270,   271,
    1259,  1260,   274,     0,   275,   276,   277,   278,  1261,     0,
    1262,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,  4657,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,   302,   303,   304,   305,   306,   307,  1270,  1271,   310,
    1272,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1273,   339,   340,   341,   342,
    1274,  1275,   344,     0,   345,   346,   347,  1276,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1277,     0,  1278,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1279,  1280,     0,  1281,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1282,   402,   403,   404,     0,   405,   406,   407,
    1283,  1284,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1285,   427,  1286,   429,   430,   431,   432,   433,   434,   435,
     436,  1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,
     444,  1291,   446,   447,   448,     0,   449,   450,     0,     0,
    1292,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1293,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1294,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1295,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1296,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1297,   530,   531,
     532,   533,   534,   535,   536,   537,  1298,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1299,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1300,  1301,     0,
       0,   567,   568,  1302,   570,  1303,  1304,   572,   573,   574,
     575,   576,   577,   578,   579,     0,  1305,   580,   581,   582,
     583,   584,  1306,     0,   585,   586,   587,   588,   589,   590,
    1307,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,
     616,   617,   618,  1316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1317,  1318,     0,     0,     0,   235,
       0,  1248,   685,  1320,  1249,  1250,  1251,   747,  1252,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1253,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1254,   260,
    1255,  1256,     0,   263,   264,   265,   266,   267,   268,   269,
    1257,  1258,   270,   271,  1259,  1260,   274,     0,   275,   276,
     277,   278,  1261,     0,  1262,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,
     307,  1270,  1271,   310,  1272,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1273,
     339,   340,   341,   342,  1274,  1275,   344,     0,   345,   346,
     347,  1276,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1277,     0,  1278,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1279,  1280,
       0,  1281,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1282,   402,   403,   404,
       0,   405,   406,   407,  1283,  1284,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1285,   427,  1286,   429,   430,   431,
     432,   433,   434,   435,   436,  1287,   438,  1288,   439,   440,
     441,   442,  1289,  1290,   444,  1291,   446,   447,   448,     0,
     449,   450,     0,     0,  1292,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1293,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1294,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1295,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  1296,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1297,   530,   531,   532,   533,   534,   535,   536,   537,
    1298,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1299,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1300,  1301,     0,     0,   567,   568,  1302,   570,  1303,
    1304,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    1305,   580,   581,   582,   583,   584,  1306,     0,   585,   586,
     587,   588,   589,   590,  1307,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,  5016,  1308,  1309,  1310,  1311,   610,  1312,
    1313,  1314,  1315,   615,   616,   617,   618,  1316,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1317,  1318,
       0,     0,     0,   235,     0,  1248,   685,  1320,  1249,  1250,
    1251,   747,  1252,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1253,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1254,   260,  1255,  1256,     0,   263,   264,   265,
     266,   267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,  1270,  1271,   310,  1272,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1273,   339,   340,   341,   342,  1274,  1275,
     344,     0,   345,   346,   347,  1276,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,  1278,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1279,  1280,     0,  1281,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403,   404,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1285,   427,
    1286,   429,   430,   431,   432,   433,   434,  5028,   436,  1287,
     438,  1288,   439,   440,   441,   442,  1289,  1290,   444,  1291,
     446,   447,   448,     0,   449,   450,     0,     0,  1292,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1295,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1296,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534,   535,   536,   537,  1298,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1300,  1301,     0,     0,   567,
     568,  1302,   570,  1303,  1304,   572,   573,   574,   575,   576,
     577,   578,   579,     0,  1305,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,  1307,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,
     618,  1316,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1317,  1318,     0,     0,     0,   235,     0,  1248,
     685,  1320,  1249,  1250,  1251,   747,  1252,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1253,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1254,   260,  1255,  1256,
       0,   263,   264,   265,   266,   267,   268,   269,  1257,  1258,
     270,   271,  1259,  1260,   274,     0,   275,   276,   277,   278,
    1261,     0,  1262,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,  5340,   300,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,   302,   303,   304,   305,   306,   307,  1270,
    1271,   310,  1272,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1273,   339,   340,
     341,   342,  1274,  1275,   344,     0,   345,   346,   347,  1276,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1277,     0,  5341,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1279,  1280,     0,  1281,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1282,   402,   403,   404,     0,   405,
     406,   407,  1283,  1284,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1285,   427,  1286,   429,   430,   431,   432,   433,
     434,   435,   436,  1287,   438,  1288,   439,   440,   441,   442,
    1289,  1290,   444,  1291,   446,   447,   448,     0,   449,   450,
       0,     0,  1292,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1293,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1294,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1295,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
    5342,   513,   514,  1296,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1297,
     530,   531,   532,   533,   534,   535,   536,   537,  1298,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1299,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1300,
    1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  1305,   580,
     581,   582,   583,   584,  1306,     0,   585,   586,   587,   588,
     589,   590,  1307,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,
    1315,   615,   616,   617,   618,  1316,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1317,  1318,     0,     0,
       0,   235,     0,  1248,   685,  5343,  1249,  1250,  1251,   747,
    1252,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1253,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,  5834,
    1254,   260,  1255,  1256,     0,   263,   264,   265,   266,   267,
     268,   269,  1257,  1258,   270,   271,  1259,  1260,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,  5835,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,  1270,  1271,   310,  1272,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1273,   339,   340,   341,   342,  1274,  1275,   344,     0,
     345,   346,   347,  1276,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
    1278,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1279,  1280,     0,  1281,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1285,   427,  1286,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,  1288,
     439,   440,   441,   442,  1289,  1290,   444,  1291,   446,   447,
     448,     0,   449,   450,     0,     0,  1292,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1295,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  1296,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,  1298,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1300,  1301,     0,     0,   567,   568,  1302,
     570,  1303,  1304,   572,   573,   574,   575,   576,  5836,   578,
     579,     0,  1305,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,  1307,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,  1316,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1317,  1318,     0,     0,     0,   235,     0,  1248,   685,  1320,
    1249,  1250,  1251,   747,  1252,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1253,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1254,   260,  1255,  1256,     0,   263,
     264,   265,   266,   267,   268,   269,  1257,  1258,   270,   271,
    1259,  1260,   274,     0,   275,   276,   277,   278,  1261,     0,
    1262,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,  5835,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,   302,   303,   304,   305,   306,   307,  1270,  1271,   310,
    1272,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1273,   339,   340,   341,   342,
    1274,  1275,   344,     0,   345,   346,   347,  1276,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1277,     0,  1278,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,  1279,  1280,     0,  1281,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1282,   402,   403,   404,     0,   405,   406,   407,
    1283,  1284,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
    1285,   427,  1286,   429,   430,   431,   432,   433,   434,   435,
     436,  1287,   438,  1288,   439,   440,   441,   442,  1289,  1290,
     444,  1291,   446,   447,   448,     0,   449,   450,     0,     0,
    1292,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1293,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1294,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1295,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,  1296,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1297,   530,   531,
     532,   533,   534,   535,   536,   537,  1298,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1299,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,  1300,  1301,     0,
       0,   567,   568,  1302,   570,  1303,  1304,   572,   573,   574,
     575,   576,  5836,   578,   579,     0,  1305,   580,   581,   582,
     583,   584,  1306,     0,   585,   586,   587,   588,   589,   590,
    1307,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,
     616,   617,   618,  1316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1317,  1318,     0,     0,     0,   235,
       0,  1248,   685,  1320,  1249,  1250,  1251,   747,  1252,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1253,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1254,   260,
    1255,  1256,     0,   263,   264,   265,   266,   267,   268,   269,
    1257,  1258,   270,   271,  1259,  1260,   274,     0,   275,   276,
     277,   278,  1261,     0,  1262,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,
     307,  1270,  1271,   310,  5325,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1273,
     339,   340,   341,   342,  1274,  1275,   344,     0,   345,   346,
     347,  1276,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1277,     0,  1278,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1279,  1280,
       0,  1281,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1282,   402,   403,   404,
       0,   405,   406,   407,  1283,  1284,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1285,   427,  1286,   429,   430,   431,
     432,   433,   434,   435,   436,  1287,   438,     0,   439,   440,
     441,   442,  1289,  1290,   444,  1291,   446,   447,   448,     0,
     449,   450,     0,     0,  1292,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1293,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1294,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1295,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  3204,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1297,   530,   531,   532,   533,   534,   535,   536,   537,
    1298,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1299,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1300,  1301,     0,     0,   567,   568,  1302,   570,  1303,
    1304,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1306,     0,   585,   586,
     587,   588,   589,   590,  1307,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,
    1313,  1314,  1315,   615,   616,   617,   618,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3205,  3206,
       0,     0,     0,   235,     0,  1248,   685,  3207,  1249,  1250,
    1251,   747,  1252,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1253,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257, -2822,  1254,   260,  1255,  1256,     0,   263,   264,   265,
     266,   267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,  5835,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,  1270,  1271,   310,  1272,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1273,   339,   340,   341,   342,  1274,  1275,
     344,     0,   345,   346,   347,  1276,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,  1278,   361,   362,     0,   363,   364,   365,   366,
     367, -2822,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1279,  1280,     0,  1281,     0,   390,     0,     0,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403, -2822,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1285,   427,
    1286,   429,   430,   431,   432,   433,   434,   435,   436,  1287,
     438,  1288,   439,   440,     0,   442,  1289,  1290,   444,  1291,
     446,   447,   448,     0,   449,   450,     0,     0,  1292,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1295,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  1296,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534, -2822,   536,   537,  1298,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1300,  1301,     0,     0,   567,
     568,  1302,   570,  1303,  1304,   572,   573,   574,   575,   576,
    5836,   578,   579,     0,  1305,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,  1307,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,
     618, -2822,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1317,  1318,     0,     0,     0,   235,     0,  1248,
     685,  1320,  1249,  1250,  1251,   747,  1252,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1253,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1254,   260,  1255,  1256,
       0,   263,   264,   265,   266,   267,   268,   269,  1257,  1258,
     270,   271,  1259,  1260,   274,     0,   275,   276,   277,   278,
    1261,     0,  1262,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,   302,   303,   304,   305,   306,   307,  1270,
    1271,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1273,   339,   340,
     341,   342,  1274,  1275,   344,     0,   345,   346,   347,  1276,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1277,     0,  1278,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,  1279,  1280,     0,  1281,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,  1282,   402,   403,   404,     0,   405,
     406,   407,  1283,  1284,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,  1285,   427,  1286,   429,   430,   431,   432,   433,
     434,   435,   436,  1287,   438,     0,   439,   440,   441,   442,
    1289,  1290,   444,  1291,   446,   447,   448,     0,   449,   450,
       0,     0,  1292,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1293,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1294,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1295,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,  3204,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1297,
     530,   531,   532,   533,   534,   535,   536,   537,  1298,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1299,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,  1300,
    1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  1306,     0,   585,   586,   587,   588,
     589,   590,  1307,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,
    1315,   615,   616,   617,   618,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3205,  3206,   235,     0,
    1248,   685,     0,  1249,  1250,  3207,   747,  1252,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1253,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1254,   260,  1255,
    1256,     0,   263,   264,   265,   266,   267,   268,   269,  1257,
    1258,   270,   271,  1259,  1260,   274,     0,   275,   276,   277,
     278,  1261,     0,  1262,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,   307,
    1270,  1271,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   865,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1273,   339,
     340,   341,   342,  1274,  1275,   344,     0,   345,   346,   347,
    1276,   349,     0,   350,     0,   351,   352,     0,   353,   354,
     355,   356,   357,     0,   358,  1277,     0,  1278,   361,   362,
       0,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,   381,   382,   383,   384,   385,   386,  1279,  1280,     0,
    1281,     0,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,     0,     0,   400,  1282,   402,   403,   404,     0,
     405,   406,   407,  1283,  1284,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1285,   427,  1286,   429,   430,   431,   432,
     433,   434,   435,   436,  1287,   438,     0,   439,   440,   441,
     442,  1289,  1290,   444,  1291,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,   457,   458,   459,  1293,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,  1294,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,  1295,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,   509,   510,
     511,   512,   513,   514,  3375,  3376,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
    1297,   530,   531,   532,   533,   534,   535,   536,   537,  1298,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,  1299,   554,     0,   555,   556,
       0,   557,   558,   559,   560,   561,   562,   563,     0,   564,
    1300,  1301,     0,     0,   567,   568,  1302,   570,  1303,  1304,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,  1306,     0,   585,   586,   587,
     588,   589,   590,  1307,     0,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,
    1314,  1315,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3377,  3378,   235,
       0,  1248,   685,     0,  1249,  1250,  3207,   747,  1252,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1253,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1254,   260,
    1255,  1256,     0,   263,   264,   265,   266,   267,   268,   269,
    1257,  1258,   270,   271,  1259,  1260,   274,     0,   275,   276,
     277,   278,  1261,     0,  1262,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,
     307,  1270,  1271,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1273,
     339,   340,   341,   342,  1274,  1275,   344,     0,   345,   346,
     347,  1276,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1277,     0,  1278,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1279,  1280,
       0,  1281,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1282,   402,   403,   404,
       0,   405,   406,   407,  1283,  1284,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1285,   427,  1286,   429,   430,   431,
     432,   433,   434,   435,   436,  1287,   438,     0,   439,   440,
     441,   442,  1289,  1290,   444,  1291,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1293,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1294,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1295,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,  3204,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1297,   530,   531,   532,   533,   534,   535,   536,   537,
    1298,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1299,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1300,  1301,     0,     0,   567,   568,  1302,   570,  1303,
    1304,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1306,     0,   585,   586,
     587,   588,   589,   590,  1307,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,
    1313,  1314,  1315,   615,   616,   617,   618,     0,     0,     0,
       0,   235,     0,  1248,   685,     0,  1249,  1250,     0,   747,
    1252,     0,     0,     0,     0,     0,     0,  3207,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1253,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1254,   260,  1255,  1256,     0,   263,  4568,   265,   266,   267,
     268,   269,  1257,  1258,   270,   271,  1259,  1260,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,  1270,  1271,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1273,   339,   340,   341,   342,  1274,  1275,   344,     0,
     345,   346,   347,  1276,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
    1278,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
    1279,  1280,     0,  1281,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1285,   427,  1286,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,     0,
     439,   440,   441,   442,  1289,  1290,   444,  1291,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1295,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,  3204,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,  1298,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,  1300,  1301,     0,     0,   567,   568,  1302,
     570,  1303,  1304,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,  1307,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,     0,
       0,     0,     0,   235,     0,  1248,   685,     0,  1249,  1250,
       0,   747,  1252,     0,     0,     0,     0,     0,     0,  3207,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1253,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1254,   260,  1255,  1256,     0,   263,   264,   265,
     266,   267,   268,   269,  1257,  1258,   270,   271,  1259,  1260,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,  1270,  1271,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1273,   339,   340,   341,   342,  1274,  1275,
     344,     0,   345,   346,   347,  1276,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,  1278,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,  1279,  1280,     0,  1281,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403,   404,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1285,   427,
    1286,   429,   430,   431,   432,   433,   434,   435,   436,  1287,
     438,     0,   439,   440,   441,   442,  1289,  1290,   444,  1291,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,  1295,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,  3204,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534,   535,   536,   537,  1298,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,  1300,  1301,     0,     0,   567,
     568,  1302,   570,  1303,  1304,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,  1307,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,  4626,  1312,  1313,  1314,  1315,   615,   616,   617,
     618,     0,     0,     0,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3207,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1258,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1261,     0,
    1262,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
    1274,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1277,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,  3350,
       0,   400,  1282,   402,   403,   404,     0,   405,   406,   407,
    1283,  1284,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1287,   438,     0,   439,   440,   441,   442,     0,  1290,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   840,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1293,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1294,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  3351,   517,   518,   519,   520,   521,   522,   523,
     524,    41,   525,   526,   527,   528,   529,  1297,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1299,   554,     0,   555,   556,    45,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,  1302,   570,  1303,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  1306,     0,   585,   586,   587,   588,   589,  1180,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,    50,   599,   600,   601,   602,   603,   604,   605,
    1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,  3352,
     616,   617,   618,     0,     0,    51,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3353,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,  1258,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
    1261,     0,  1262,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,  1274,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,  1277,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,  3350,     0,   400,  1282,   402,   403,   404,     0,   405,
     406,   407,  1283,  1284,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1287,   438,     0,   439,   440,   441,   442,
       0,  1290,   444,   445,   446,   447,   448,     0,   449,   450,
       0,   840,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,  1293,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,  1294,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  3351,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,  1297,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,  1299,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,  1302,   570,  1303,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  1306,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,  1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,
    1315,  3352,   616,   617,   618,     0,     0,     0,     0,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3353,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,  1258,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,  1261,     0,  1262,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1274,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,  1277,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,  1282,   402,   403,   404,
       0,   405,   406,   407,  1283,  1284,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1287,   438,     0,   439,   440,
     441,   442,     0,  1290,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,  1293,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
    1294,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,  1297,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,  1299,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,  1302,   570,  1303,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,  1306,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,  1308,  1309,  1310,  1311,   610,  1312,
    1313,  1314,  1315,   615,   616,   617,   618,     0,     0,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3778,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1258,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,  1274,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,     0,
     439,   440,   441,   442,     0,  1290,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,  3351,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,  1302,
     570,  1303,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,  3352,   616,   617,   618,     0,
       0,     0,     0,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,  1258,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,  1261,     0,  1262,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1274,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
    1277,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
    1282,   402,   403,   404,     0,   405,   406,   407,  1283,  1284,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1287,
     438,     0,   439,   440,   441,   442,     0,  1290,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,  1293,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,  1294,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,  1297,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
    1299,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,  1302,   570,  1303,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    1306,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,  1308,  1309,
    1310,  1311,   610,  1312,  1313,  1314,  1315,   615,   616,   617,
     618,     0,     0,     0,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4676,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1258,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1261,     0,
    1262,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
    1274,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,  1277,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,  1282,   402,   403,   404,     0,   405,   406,   407,
    1283,  1284,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1287,   438,     0,   439,   440,   441,   442,     0,  1290,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,  1293,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,  1294,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,  1297,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,  1299,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,  1302,   570,  1303,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  1306,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
    1308,  1309,  1310,  1311,   610,  1312,  1313,  1314,  1315,   615,
     616,   617,   618,     0,     0,     0,     0,   943,     0,  1567,
     685,     0,     0,     0,     0,   747,     0,     0,     0,     0,
       0,     0,     0,  5804,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1789,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
    1790,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,  1791,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,  1568,  1569,  5612,     0,
       0,     0,     0,     0,     0,  5613,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     3,     4,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,    41,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,    45,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,  1180,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,    50,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,     0,     0,    51,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,     0,
       0,     0,     0,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5387,
     236,   237,   238,   239,   240,   241,   242,   243,  2817,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,  2818,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,   840,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,  2819,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1823,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,    41,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,    45,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,  1180,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,    50,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,     0,     0,    51,     0,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,     0,     0,     0,     0,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1378,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,     0,     0,     0,
       0,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3878,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,     0,
       0,     0,     0,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4603,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,   857,     0,
    1567,   685,     0,     0,     0,   958,   747,     0,     0,     0,
       0,  4643,   959,   960,   961,   236,   237,   238,   239,   240,
     241,   242,   243,  1702,   244,   245,   246,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,   247,   248,   249,  1710,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   858,   260,   859,
     860,  1711,   263,   264,   265,   266,   267,   268,   269,  1712,
    1713,   270,   271,   861,   862,   274,  1714,   275,   276,   277,
     278,     0,  1715,   280,  1716,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,  1717,   291,   292,   293,   294,
     295,   296,  1718,   297,   298,   299,   300,  1719,  1720,  1721,
     301,  1722,  1723,  1724,   302,   303,   304,   305,   306,   307,
     863,   864,   310,  1725,   311,  1726,   312,   313,   314,   315,
     316,   317,   318,  1727,   319,   320,   321,   322,  1728,  1729,
     323,   324,   865,   326,   327,  1730,   328,   329,   330,  1731,
     331,   332,   333,  1732,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,  1733,   344,  1734,   345,   346,   347,
     866,   349,  1735,   350,  1736,   351,   352,  1737,   353,   354,
     355,   356,   357,  1738,   358,     0,  1739,     0,   361,   362,
    1740,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,  1741,   373,   374,   375,   376,   377,   378,   379,  1742,
     380,   381,     0,   383,   384,   385,   386,   867,   868,  1743,
     869,  1744,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,  1745,  1746,   400,     0,   402,   403,   404,  1747,
     405,   406,   407,  1748,  1749,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   870,   427,   871,   429,   430,   431,   432,
     433,   434,   435,  4339,     0,   438,  1750,   439,   440,   441,
     442,  1751,     0,   444,   872,   446,   447,   448,  1752,   449,
     450,  1753,  1754,  4340,   452,   453,  1755,  1756,   454,   455,
       0,   457,   458,   459,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,  1757,   471,   472,     0,
     474,     0,   476,   477,   478,  1758,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   873,   490,   491,   492,
     493,  1759,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,  1760,   507,   508,   509,   510,
     511,   512,   513,   514,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,  1761,   525,   526,   527,   528,   529,
    1762,   530,   531,  2647,   533,   534,   535,   536,   537,   875,
     539,  1763,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,     0,   554,  1764,   555,   556,
    1765,   557,   558,   559,   560,   561,   562,   563,  1766,   564,
     876,   877,  1767,  1768,   567,   568,     0,   570,     0,  1769,
     572,   573,   574,   575,   576,   577,   578,   579,  1770,  1771,
     580,   581,   582,   583,   584,  1772,  1773,   585,   586,   587,
     588,   589,     0,   878,  1774,   592,   593,   594,   595,   596,
     597,  1775,  1776,   598,  1777,  1778,   599,   600,   601,   602,
     603,   604,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,  4341,  4342,   969,
     970,   971,   972,   857,     0,  1567,   685,     0,     0,     0,
     958,   747,     0,     0,     0,     0,     0,   959,   960,   961,
     236,   237,   238,   239,   240,   241,   242,   243,  1702,   244,
     245,   246,  1703,  1704,  1705,  1706,  1707,  1708,  1709,   247,
     248,   249,  1710,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   858,   260,   859,   860,  1711,   263,   264,   265,
     266,   267,   268,   269,  1712,  1713,   270,   271,   861,   862,
     274,  1714,   275,   276,   277,   278,     0,  1715,   280,  1716,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
    1717,   291,   292,   293,   294,   295,   296,  1718,   297,   298,
     299,   300,  1719,  1720,  1721,   301,  1722,  1723,  1724,   302,
     303,   304,   305,   306,   307,   863,   864,   310,  1725,   311,
    1726,   312,   313,   314,   315,   316,   317,   318,  1727,   319,
     320,   321,   322,  1728,  1729,   323,   324,   865,   326,   327,
    1730,   328,   329,   330,  1731,   331,   332,   333,  1732,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,  1733,
     344,  1734,   345,   346,   347,   866,   349,  1735,   350,  1736,
     351,   352,  1737,   353,   354,   355,   356,   357,  1738,   358,
       0,  1739,     0,   361,   362,  1740,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  1741,   373,   374,   375,
     376,   377,   378,   379,  1742,   380,   381,     0,   383,   384,
     385,   386,   867,   868,  1743,   869,  1744,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,  1745,  1746,   400,
       0,   402,   403,   404,  1747,   405,   406,   407,  1748,  1749,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   870,   427,
     871,   429,   430,   431,   432,   433,   434,   435,  4768,     0,
     438,  1750,   439,   440,   441,   442,  1751,     0,   444,   872,
     446,   447,   448,  1752,   449,   450,  1753,  1754,  4340,   452,
     453,  1755,  1756,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,  1757,   471,   472,     0,   474,     0,   476,   477,   478,
    1758,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   873,   490,   491,   492,   493,  1759,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
    1760,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,  1761,
     525,   526,   527,   528,   529,  1762,   530,   531,  2647,   533,
     534,   535,   536,   537,   875,   539,  1763,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,  1764,   555,   556,  1765,   557,   558,   559,   560,
     561,   562,   563,  1766,   564,   876,   877,  1767,  1768,   567,
     568,     0,   570,     0,  1769,   572,   573,   574,   575,   576,
     577,   578,   579,  1770,  1771,   580,   581,   582,   583,   584,
    1772,  1773,   585,   586,   587,   588,   589,     0,   878,  1774,
     592,   593,   594,   595,   596,   597,  1775,  1776,   598,  1777,
    1778,   599,   600,   601,   602,   603,   604,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   964,
     965,   966,  4341,  4342,   969,   970,   971,   972,  2059,     0,
       0,     0,     0,     0,     0,  2060,     0,     0,  2061,     0,
       0,     0,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,     0,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,
    2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,
    2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,
    2109,  2110,  2111,     0,     0,  2112,  2113,  2114,  2115,  2116,
    2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,
    2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,     0,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,     0,  2154,
    2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,
    2165,  2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2187,     0,  2188,  2189,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2199,     0,     0,  2200,  2201,
    2202,  2203,     0,  2204,  2205,  2206,  2207,     0,  2208,  2209,
    2210,  2211,  2212,     0,  2213,  2214,     0,  2215,  2216,  2217,
       0,  2218,  2219,     0,  2220,  2221,  2222,  2223,  2224,  2225,
    2226,  2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,
    2236,  2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,     0,
    2245,     0,  2246,  2247,  2248,  2249,  2250,  2251,  2252,  2253,
    2254,  2255,  2256,  2257,  2258,  2259,  2260,  2261,  2262,     0,
    2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,
    2273,  2274,  2275,  2276,  2277,  2278,     0,  2279,  2280,     0,
    2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,
    2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,     0,  2309,
    2310,     0,  2311,  2312,  2313,  2314,  2315,     0,  2316,  2317,
    2318,  2319,     0,     0,  2320,  2321,  2322,  2323,  2324,  2325,
    2326,  2327,  2328,  2329,  2330,     0,  2331,  2332,  2333,  2334,
    2335,     0,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,
    2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  2365,  2366,  2367,  2368,     0,  2369,  2370,  2371,  2372,
    2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,
    2383,  2384,     0,  2385,  2386,  2387,  2388,  2389,  2390,  2391,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,
    2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,  2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,
    2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,
    2432,  2433,     0,  2434,  2435,  2436,  2437,  2438,  2439,  2440,
    2441,  2442,  2443,  2444,  2445,  2446,  2447,  2448,     0,  2449,
    2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,  2459,
    2460,  2461,  2462,  2463,  2464,     0,  2465,  2466,  2467,  2468,
    2469,  2470,     0,  2471,     0,     0,     0,     0,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,
    2484,  2485,  2486,     0,  2487,  2488,  2489,     0,     0,     0,
       0,     0,     0,     0,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,   626,     0,     0,     0,     0,     0,     0,
     958,     0,     0,     0,     0,     0,     0,   959,   960,   961,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   962,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     963,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   626,     0,
       0,     0,     0,     0,     0,   958,     0,     0,     0,     0,
       0,     0,   959,   960,   961,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  1078,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  1079,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   626,     0,     0,     0,     0,     0,     0,
     958,     0,     0,     0,     0,     0,     0,   959,   960,   961,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,  1143,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
    1144,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1145,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   626,     0,
       0,     0,     0,     0,     0,   958,     0,     0,     0,     0,
       0,     0,   959,   960,   961,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  1806,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  1807,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   626,     0,     0,     0,     0,     0,     0,
     958,     0,     0,     0,     0,     0,     0,   959,   960,   961,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,     0,     0,     0,     0,     0,     0,     0,     0,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   626,     0,
       0,     0,     0,     0,     0,   958,     0,     0,     0,     0,
       0,     0,   959,   960,   961,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,  3470,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,  3471,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,     0,     0,     0,   354,
     355,   356,   357,     0,   358,   359,     0,   360,   361,   362,
       0,   363,   364,   365,   366,   367,     0,   369,   370,   371,
     372,     0,   373,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   382,   383,   384,   385,   386,   387,   388,     0,
     389,     0,   390,     0,     0,   393,     0,   395,   396,   397,
     398,   399,     0,     0,   400,   401,     0,   403,     0,     0,
     405,   406,   407,     0,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,     0,
     442,     0,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,     0,   451,   452,   453,     0,     0,   454,   455,
     456,     0,   458,     0,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   471,   472,   473,
     474,   475,   476,   477,   478,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,     0,   507,   508,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,     0,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,     0,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,     0,   555,   556,
       0,   557,     0,   559,   560,   561,   562,   563,     0,   564,
     565,   566,     0,     0,   567,   568,   569,   570,   571,     0,
     572,   573,   574,   575,   576,   577,   578,   579,     0,     0,
     580,   581,   582,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,     0,   592,     0,   594,   595,   596,
     597,     0,     0,   598,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   626,     0,     0,     0,     0,     0,     0,
     958,     0,     0,     0,     0,     0,     0,   959,   960,   961,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,  5367,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1701,     0,     0,     0,     0,     0,     0,     0,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   236,   237,
     238,   239,   240,   241,   242,   243,  1702,   244,   245,   246,
    1703,  1704,  1705,  1706,  1707,  1708,  1709,   247,   248,   249,
    1710,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,  1711,   263,   264,   265,   266,   267,
     268,   269,  1712,  1713,   270,   271,   272,   273,   274,  1714,
     275,   276,   277,   278,   279,  1715,   280,  1716,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,  1717,   291,
     292,   293,   294,   295,   296,  1718,   297,   298,   299,   300,
    1719,  1720,  1721,   301,  1722,  1723,  1724,   302,   303,   304,
     305,   306,   307,   308,   309,   310,  1725,   311,  1726,   312,
     313,   314,   315,   316,   317,   318,  1727,   319,   320,   321,
     322,  1728,  1729,   323,   324,   325,   326,   327,  1730,   328,
     329,   330,  1731,   331,   332,   333,  1732,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1733,   344,  1734,
     345,   346,   347,   348,   349,  1735,   350,  1736,   351,   352,
    1737,   353,   354,   355,   356,   357,  1738,   358,   359,  1739,
     360,   361,   362,  1740,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,  1741,   373,   374,   375,   376,   377,
     378,   379,  1742,   380,   381,   382,   383,   384,   385,   386,
     387,   388,  1743,   389,  1744,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,  1745,  1746,   400,   401,   402,
     403,   404,  1747,   405,   406,   407,  1748,  1749,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,  1750,
     439,   440,   441,   442,  1751,   443,   444,   445,   446,   447,
     448,  1752,   449,   450,  1753,  1754,   451,   452,   453,  1755,
    1756,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,  1757,
     471,   472,   473,   474,   475,   476,   477,   478,  1758,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,  1759,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,  1760,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,  1761,   525,   526,
     527,   528,   529,  1762,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,  1763,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
    1764,   555,   556,  1765,   557,   558,   559,   560,   561,   562,
     563,  1766,   564,   565,   566,  1767,  1768,   567,   568,   569,
     570,   571,  1769,   572,   573,   574,   575,   576,   577,   578,
     579,  1770,  1771,   580,   581,   582,   583,   584,  1772,  1773,
     585,   586,   587,   588,   589,   590,   591,  1774,   592,   593,
     594,   595,   596,   597,  1775,  1776,   598,  1777,  1778,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1779,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     846,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   857,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5774,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   858,   260,   859,   860,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     861,   862,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   863,   864,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   866,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,  2643,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,  2644,
     383,   384,   385,   386,   867,   868,     0,   869,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     870,   427,   871,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,     0,     0,
     444,   872,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,  2645,   454,   455,  2646,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   873,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
    2647,   533,   534,   535,   536,   537,   875,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   876,   877,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     878,  2648,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,     0,
       0,  3815,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,  2649,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     858,   260,   859,   860,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   861,   862,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   863,   864,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,   866,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,  2643,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,  2644,   383,   384,   385,   386,
     867,   868,     0,   869,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   870,   427,   871,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,   872,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
    2645,   454,   455,  2646,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   873,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,  2647,   533,   534,   535,
     536,   537,   875,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   876,   877,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,   878,  2648,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,     0,     0,   943,     0,  1567,
     685,     0,     0,     0,     0,   747,   616,   617,   618,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2649,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,  2535,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1789,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
    1790,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,  1791,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   943,     0,  1567,   685,     0,
       0,     0,     0,   747,     0,     0,  1568,  1569,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    2540,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1789,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,  1790,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,  1791,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   943,     0,  1567,   685,     0,     0,     0,
       0,   747,     0,     0,  1568,  1569,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1789,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,  1790,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,  1791,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   943,     0,     0,   685,     0,     0,     0,     0,   747,
       0,     0,  1568,  1569,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,  3431,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1789,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,  1790,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,  1791,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,   747,     0,     0,
     759,   760,     0,     0,     0,     0,   236,   748,   238,   239,
     240,   241,   242,   243,   749,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   750,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     751,   348,   349,     0,   350,     0,   752,     0,   753,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,   754,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   755,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   756,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   757,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   758,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1701,     0,  6059,
     685,     0,     0,     0,     0,   747,     0,     0,   759,   760,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  1702,   244,   245,   246,  1703,  1704,  1705,  1706,
    1707,  1708,  1709,   247,   248,   249,  1710,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
    1711,   263,   264,   265,   266,   267,   268,   269,  1712,  1713,
     270,   271,   272,   273,   274,  1714,   275,   276,   277,   278,
     279,  1715,   280,  1716,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,  1717,   291,   292,   293,   294,   295,
     296,  1718,   297,   298,   299,   300,  1719,  1720,  1721,   301,
    1722,  1723,  1724,   302,   303,   304,   305,   306,   307,   308,
     309,   310,  1725,   311,  1726,   312,   313,   314,   315,   316,
     317,   318,  1727,   319,   320,   321,   322,  1728,  1729,   323,
     324,   325,   326,   327,  1730,   328,   329,   330,  1731,   331,
     332,   333,  1732,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1733,   344,  1734,   345,   346,   347,   348,
     349,  1735,   350,  1736,   351,   352,  1737,   353,   354,   355,
     356,   357,  1738,   358,   359,  1739,   360,   361,   362,  1740,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
    1741,   373,   374,   375,   376,   377,   378,   379,  1742,   380,
     381,   382,   383,   384,   385,   386,   387,   388,  1743,   389,
    1744,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,  1745,  1746,   400,   401,   402,   403,   404,  1747,   405,
     406,   407,  1748,  1749,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,  1750,   439,   440,   441,   442,
    1751,   443,   444,   445,   446,   447,   448,  1752,   449,   450,
    1753,  1754,   451,   452,   453,  1755,  1756,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,  1757,   471,   472,   473,   474,
     475,   476,   477,   478,  1758,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
    1759,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,  1760,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,  1761,   525,   526,   527,   528,   529,  1762,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
    1763,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,  1764,   555,   556,  1765,
     557,   558,   559,   560,   561,   562,   563,  1766,   564,   565,
     566,  1767,  1768,   567,   568,   569,   570,   571,  1769,   572,
     573,   574,   575,   576,   577,   578,   579,  1770,  1771,   580,
     581,   582,   583,   584,  1772,  1773,   585,   586,   587,   588,
     589,   590,   591,  1774,   592,   593,   594,   595,   596,   597,
    1775,  1776,   598,  1777,  1778,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1701,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1702,   244,   245,   246,  1703,  1704,  1705,  1706,  1707,  1708,
    1709,   247,   248,   249,  1710,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,  1711,   263,
     264,   265,   266,   267,   268,   269,  1712,  1713,   270,   271,
     272,   273,   274,  1714,   275,   276,   277,   278,   279,  1715,
     280,  1716,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,  1717,   291,   292,   293,   294,   295,   296,  1718,
     297,   298,   299,   300,  1719,  1720,  1721,   301,  1722,  1723,
    1724,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    1725,   311,  1726,   312,   313,   314,   315,   316,   317,   318,
    1727,   319,   320,   321,   322,  1728,  1729,   323,   324,   325,
     326,   327,  1730,   328,   329,   330,  1731,   331,   332,   333,
    1732,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1733,   344,  1734,   345,   346,   347,   348,   349,  1735,
     350,  1736,   351,   352,  1737,   353,   354,   355,   356,   357,
    1738,   358,   359,  1739,   360,   361,   362,  1740,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,  1741,   373,
     374,   375,   376,   377,   378,   379,  1742,   380,   381,   382,
     383,   384,   385,   386,   387,   388,  1743,   389,  1744,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,  1745,
    1746,   400,   401,   402,   403,   404,  1747,   405,   406,   407,
    1748,  1749,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,  1750,   439,   440,   441,   442,  1751,   443,
     444,   445,   446,   447,   448,  1752,   449,   450,  1753,  1754,
     451,   452,   453,  1755,  1756,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,  1757,   471,   472,   473,   474,   475,   476,
     477,   478,  1758,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,  1759,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,  1760,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,  1761,   525,   526,   527,   528,   529,  1762,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,  1763,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,  1764,   555,   556,  1765,   557,   558,
     559,   560,   561,   562,   563,  1766,   564,   565,   566,  1767,
    1768,   567,   568,   569,   570,   571,  1769,   572,   573,   574,
     575,   576,   577,   578,   579,  1770,  1771,   580,   581,   582,
     583,   584,  1772,  1773,   585,   586,   587,   588,   589,   590,
     591,  1774,   592,   593,   594,   595,   596,   597,  1775,  1776,
     598,  1777,  1778,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1701,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,  3536,   241,   242,   243,  1702,   244,
     245,   246,  1703,  1704,  1705,  1706,  1707,  1708,  1709,   247,
     248,   249,  1710,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1711,   263,   264,   265,
     266,   267,   268,   269,  1712,  1713,   270,   271,   272,   273,
     274,  1714,   275,   276,   277,   278,   279,  1715,   280,  1716,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
    1717,   291,   292,   293,   294,   295,   296,  1718,   297,   298,
     299,   300,  1719,  1720,  1721,   301,  1722,  1723,  1724,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  1725,   311,
    1726,   312,   313,   314,   315,   316,   317,   318,  1727,   319,
     320,   321,   322,  1728,  1729,   323,   324,   325,  3537,   327,
    1730,   328,   329,   330,  1731,   331,   332,   333,  1732,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1733,
     344,  1734,   345,   346,   347,   348,   349,  1735,   350,  1736,
     351,   352,  1737,   353,   354,   355,   356,   357,  1738,   358,
     359,  1739,   360,   361,   362,  1740,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  1741,   373,   374,   375,
     376,   377,   378,   379,  1742,   380,   381,   382,   383,   384,
     385,   386,   387,   388,  1743,   389,  1744,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,  1745,  1746,   400,
     401,   402,   403,   404,  1747,   405,   406,   407,  1748,  1749,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,  1750,   439,   440,   441,   442,  1751,   443,   444,   445,
     446,   447,   448,  1752,   449,   450,  1753,  1754,   451,   452,
     453,  1755,  1756,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,  1757,   471,   472,   473,   474,   475,   476,   477,   478,
    1758,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,  1759,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
    1760,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,  1761,
     525,   526,   527,   528,   529,  1762,  3538,   531,   532,   533,
     534,   535,   536,   537,   538,   539,  1763,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,  1764,   555,   556,  1765,   557,   558,   559,   560,
     561,   562,   563,  1766,   564,   565,   566,  1767,  1768,   567,
     568,   569,   570,   571,  1769,   572,   573,   574,   575,   576,
     577,   578,   579,  1770,  1771,   580,   581,   582,   583,   584,
    1772,  1773,   585,   586,   587,   588,   589,   590,   591,  1774,
     592,   593,   594,   595,   596,   597,  1775,  1776,   598,  1777,
    1778,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1258,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1261,     0,  1262,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,  1274,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,  1277,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,  1282,   402,
     403,   404,     0,   405,   406,   407,  1283,  1284,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1287,   438,     0,
     439,   440,   441,   442,     0,  1290,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,  1293,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,  1294,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,  1297,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,  1299,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,  1302,
     570,  1303,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,  1306,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,  1308,  1309,  1310,  1311,
     610,  1312,  1313,  1314,  1315,   615,   616,   617,   618,   235,
       0,  1248,   685,     0,  1249,  1250,     0,   747,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1254,   260,
    1255,  1256,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,  1259,  1260,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,  1270,  1271,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,  1275,   344,     0,   345,   346,
     347,  1276,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,  1279,  1280,
       0,  1281,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1285,   427,  1286,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,  1289,   443,   444,  1291,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1295,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
    1298,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,  1300,  1301,     0,     0,   567,   568,   569,   570,   571,
    1304,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,  1307,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   982,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,   944,   301,
       0,     0,   945,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   946,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1003,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,   944,   301,     0,     0,
     945,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,  1004,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   946,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,   944,   301,     0,     0,   945,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   946,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
    2910,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,   944,   301,     0,     0,   945,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,  3896,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   946,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   943,
       0,     0,   685,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,  1789,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,  1790,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
    1791,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,   944,   301,
       0,     0,   945,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   946,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,   944,   301,     0,     0,
     945,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,  1096,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   946,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,   944,   301,     0,     0,   945,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1138,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   946,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,   944,   301,     0,     0,   945,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1151,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   946,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
     944,   301,     0,     0,   945,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1163,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
    1164,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   946,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     3,     4,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   943,     0,     0,   685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    2520,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   943,     0,     0,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1122,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,   401,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1135,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,   401,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1149,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,   401,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1153,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
     401,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,   401,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,  2682,   275,   276,
     277,   278,   279,     0,     0,  2751,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,  2683,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,  2752,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,  2685,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  2753,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,  2686,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
    2687,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,  2682,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,  2683,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,  2752,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,  2685,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,  3749,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,  2686,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,  2687,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   808,   242,   243,
     766,   244,   767,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,   768,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
     809,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   769,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   770,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   766,   244,
     767,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,   768,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,  3438,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   769,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   770,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,  2682,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,  2683,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,  2752,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,  2685,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,  2686,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,  2687,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   766,   244,   767,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,   768,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   769,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   770,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  2817,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,  2818,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,   840,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,  2819,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    2986,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,  2818,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   840,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,  2819,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,  1968,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,  1969,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,  1970,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,  1971,
     351,     0,     0,     0,  1972,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,  1973,  1974,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,  1975,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,  1976,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,  1977,   514,   515,
     516,   517,   518,  1978,   520,   521,   522,   523,   524,     0,
    1979,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,  1980,   557,     0,  1981,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,  1982,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   767,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,   768,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   769,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   770,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   996,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   997,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,   840,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  3517,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,  3518,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    3530,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,  3531,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   627,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   676,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   677,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   800,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     801,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   802,   566,     0,     0,   803,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   834,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   835,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   836,
     566,     0,     0,   837,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   840,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   953,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   954,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,  1114,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   800,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
    1222,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,  1353,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,  1364,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   820,   271,   272,   273,  1365,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   823,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   824,   511,   512,   513,   514,   515,   516,   517,
     518,   825,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  1357,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   827,   566,     0,     0,   828,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   829,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1511,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,   840,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,  1572,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1573,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,  3299,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,  3300,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,  3301,   557,     0,
     559,  3302,   561,  3303,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,  3304,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,   685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,   747,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,  4076,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,  4090,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
    4712,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,  5159,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   786,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   798,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   820,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   821,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   822,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   823,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   824,   511,   512,   513,
     514,   515,   516,   517,   518,   825,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   826,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   827,   566,     0,
       0,   828,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   829,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   852,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   978,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   988,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   991,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1007,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1063,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1068,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1085,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1088,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1090,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1127,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1155,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1157,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1167,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1170,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1173,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   820,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   823,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   824,   511,   512,   513,   514,   515,   516,   517,
     518,   825,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  1357,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   827,   566,     0,     0,   828,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   829,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1832,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,  1866,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  1868,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    1907,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  1909,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  1911,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,  2006,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,  2636,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,   367,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,     0,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   820,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
     367,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   823,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   824,   511,   512,   513,   514,   515,
     516,   517,   518,   825,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,  1357,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,  2669,   560,
     561,   562,   563,     0,   564,   827,   566,     0,     0,   828,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   829,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   820,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,   367,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   823,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   824,   511,   512,   513,   514,   515,   516,   517,
     518,  2734,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,  2735,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   827,   566,     0,     0,  2736,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   829,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   820,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,   367,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   823,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     824,   511,   512,   513,   514,   515,   516,   517,   518,  2814,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
    2735,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   827,   566,     0,     0,  2736,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   829,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     820,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   823,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   824,   511,
     512,   513,   514,   515,   516,   517,   518,  2838,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,  2735,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   827,
     566,     0,     0,  2736,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     829,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  3031,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    3035,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  3093,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  3449,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     820,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   823,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   824,   511,
     512,   513,   514,   515,   516,   517,   518,   825,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,  2735,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   827,
     566,     0,     0,  2736,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     829,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  3506,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,     0,     0,     0,   354,   355,   356,   357,     0,   358,
     359,     0,   360,   361,   362,     0,   363,   364,   365,   366,
    3520,     0,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   382,   383,   384,
     385,   386,   387,   388,     0,   389,     0,   390,     0,     0,
     393,     0,   395,   396,   397,   398,   399,     0,     0,   400,
     401,     0,   403,     0,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,     0,   442,     0,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,   456,     0,   458,     0,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,   473,   474,   475,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,     0,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   556,     0,   557,     0,   559,   560,
     561,   562,   563,     0,   564,   565,   566,     0,     0,   567,
     568,   569,   570,   571,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,     0,
     592,     0,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,     0,   298,   299,   300,
       0,     0,     0,     0,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,     0,   344,     0,
     345,   346,   347,   348,   349,     0,   350,     0,   351,     0,
       0,     0,   354,   355,   356,   357,     0,   358,   359,     0,
     360,   361,   362,     0,   363,   364,   365,   366,  3522,     0,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   382,   383,   384,   385,   386,
     387,   388,     0,   389,     0,   390,     0,     0,   393,     0,
     395,   396,   397,   398,   399,     0,     0,   400,   401,     0,
     403,     0,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,     0,   442,     0,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,   456,     0,   458,     0,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,   473,   474,   475,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   532,   533,   534,     0,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
       0,   555,   556,     0,   557,     0,   559,   560,   561,   562,
     563,     0,   564,   565,   566,     0,     0,   567,   568,   569,
     570,   571,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,     0,   592,     0,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,     0,   298,   299,   300,     0,     0,
       0,     0,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   308,   309,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,     0,   344,     0,   345,   346,
     347,   348,   349,     0,   350,     0,   351,     0,     0,     0,
     354,   355,   356,   357,     0,   358,   359,     0,   360,   361,
     362,     0,   363,   364,   365,   366,  3670,     0,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,     0,   382,   383,   384,   385,   386,   387,   388,
       0,   389,     0,   390,     0,     0,   393,     0,   395,   396,
     397,   398,   399,     0,     0,   400,   401,     0,   403,     0,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
       0,   442,     0,   443,   444,   445,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,   456,     0,   458,     0,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
     473,   474,   475,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,     0,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,     0,   555,
     556,     0,   557,     0,   559,   560,   561,   562,   563,     0,
     564,   565,   566,     0,     0,   567,   568,   569,   570,   571,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,     0,   592,     0,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
    3710,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,   361,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,   344,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,     0,     0,     0,   354,   355,   356,   357,
       0,   358,   359,     0,   360,   361,   362,     0,   363,   364,
     365,   366,  4894,     0,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   382,
     383,   384,   385,   386,   387,   388,     0,   389,     0,   390,
       0,     0,   393,     0,   395,   396,   397,   398,   399,     0,
       0,   400,   401,     0,   403,     0,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,     0,   442,     0,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,   456,     0,   458,
       0,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,   473,   474,   475,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     532,   533,   534,     0,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,     0,   555,   556,     0,   557,     0,
     559,   560,   561,   562,   563,     0,   564,   565,   566,     0,
       0,   567,   568,   569,   570,   571,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,     0,   592,     0,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   857,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   858,   260,   859,   860,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   861,   862,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   863,   864,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   866,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,  2643,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,  2644,   383,   384,
     385,   386,   867,   868,     0,   869,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   870,   427,
     871,   429,   430,   431,   432,   433,   434,   435,     0,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   872,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,  2646,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   873,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,  2647,   533,
     534,   535,   536,   537,   875,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   876,   877,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   878,  2648,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,   344,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,     0,     0,     0,   354,   355,
     356,   357,     0,   358,   359,     0,   360,     0,   362,     0,
     363,   364,   365,   366,   367,     0,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   382,   383,   384,   385,   386,   387,   388,     0,   389,
       0,   390,     0,     0,   393,     0,   395,   396,   397,   398,
     399,     0,     0,   400,   401,     0,   403,     0,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,     0,   442,
       0,   443,   444,   445,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,   456,
       0,   458,     0,   460,   461,   462,   463,   464,   465,   466,
     467,     0,   469,   470,     0,     0,   471,   472,   473,   474,
     475,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,     0,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,     0,   510,   511,
     512,   513,   514,   515,     0,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,     0,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,     0,   555,   556,     0,
     557,     0,   559,   560,   561,   562,   563,     0,   564,   565,
     566,     0,     0,   567,   568,   569,   570,   571,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,     0,   592,     0,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   857,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   858,   260,   859,   860,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     861,   862,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   863,   864,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   866,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,     0,
     383,   384,   385,   386,   867,   868,     0,   869,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     870,   427,   871,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,  2730,     0,
     444,   872,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,     0,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   873,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
    2647,   533,   534,   535,   536,   537,   875,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,  4440,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   876,   877,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     878,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   857,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   858,   260,
     859,   860,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   861,   862,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   863,   864,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     339,   340,   341,   342,     0,     0,   344,     0,   345,   346,
     347,   866,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,     0,     0,     0,   361,
     362,     0,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,     0,   383,   384,   385,   386,   867,   868,
       0,   869,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,     0,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   870,   427,   871,   429,   430,   431,
     432,   433,   434,   435,  2804,     0,   438,     0,   439,   440,
     441,   442,     0,     0,   444,   872,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,     0,   457,   458,   459,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
       0,   474,     0,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   873,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   874,   533,   534,   535,   536,   537,
     875,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,     0,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   876,   877,     0,     0,   567,   568,     0,   570,     0,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,     0,   878,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   857,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   616,   617,   618,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   858,   260,   859,   860,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   861,   862,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   863,   864,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   866,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,     0,   383,   384,
     385,   386,   867,   868,     0,   869,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   870,   427,
     871,   429,   430,   431,   432,   433,   434,   435,  4236,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   872,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   873,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,   874,   533,
     534,   535,   536,   537,   875,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   876,   877,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   878,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   857,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   858,   260,   859,   860,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   861,   862,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   863,
     864,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   339,   340,
     341,   342,     0,     0,   344,     0,   345,   346,   347,   866,
     349,  5723,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,     0,     0,     0,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,     0,   383,   384,   385,   386,   867,   868,     0,   869,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,     0,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   870,   427,   871,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   438,     0,   439,   440,   441,   442,
       0,     0,   444,   872,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,     0,
     457,   458,   459,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,     0,   474,
       0,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   873,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,   874,   533,   534,   535,   536,   537,   875,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,     0,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   876,
     877,     0,     0,   567,   568,     0,   570,     0,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,     0,   878,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   616,   617,   618,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     858,   260,   859,   860,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   861,   862,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,   863,   864,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   865,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,   866,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,     0,   383,   384,   385,   386,
     867,   868,     0,   869,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   870,   427,   871,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,   872,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,     0,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   873,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,   874,   533,   534,   535,
     536,   537,   875,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,   876,   877,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,   878,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,   857,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   616,   617,   618,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   858,   260,   859,   860,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     861,   862,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,     0,     0,     0,   301,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   863,   864,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   865,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   339,   340,   341,   342,
       0,     0,   344,     0,   345,   346,   347,   866,   349,     0,
     350,     0,   351,   352,     0,   353,   354,   355,   356,   357,
       0,   358,     0,     0,     0,   361,   362,     0,   363,   364,
     365,   366,  1129,   368,   369,   370,   371,   372,     0,   373,
     374,   375,   376,   377,   378,   379,     0,   380,   381,     0,
     383,   384,   385,   386,   867,   868,     0,   869,     0,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,     0,
       0,   400,     0,   402,   403,   404,     0,   405,   406,   407,
       0,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     870,   427,   871,   429,   430,   431,   432,   433,   434,   435,
       0,     0,   438,     0,   439,   440,   441,   442,     0,     0,
     444,   872,   446,   447,   448,     0,   449,   450,     0,     0,
     451,   452,   453,     0,     0,   454,   455,     0,   457,   458,
     459,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   471,   472,     0,   474,     0,   476,
     477,   478,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   873,   490,   491,   492,   493,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,     0,   507,   508,   509,   510,   511,   512,   513,
     514,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   525,   526,   527,   528,   529,     0,   530,   531,
     874,   533,   534,   535,   536,   537,   875,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,     0,   554,     0,   555,   556,     0,   557,   558,
     559,   560,   561,   562,   563,     0,   564,   876,   877,     0,
       0,   567,   568,     0,   570,     0,     0,   572,   573,   574,
     575,   576,   577,   578,   579,     0,     0,   580,   581,   582,
     583,   584,     0,     0,   585,   586,   587,   588,   589,     0,
     878,     0,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,   599,   600,   601,   602,   603,   604,   857,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     616,   617,   618,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   858,   260,
     859,   860,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   861,   862,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,   303,   304,   305,   306,
     307,   863,   864,   310,     0,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   865,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     339,   340,   341,   342,     0,     0,   344,     0,   345,   346,
     347,   866,   349,     0,   350,     0,   351,   352,     0,   353,
     354,   355,   356,   357,     0,   358,     0,     0,     0,   361,
     362,     0,   363,   364,   365,   366,  1161,   368,   369,   370,
     371,   372,     0,   373,   374,   375,   376,   377,   378,   379,
       0,   380,   381,     0,   383,   384,   385,   386,   867,   868,
       0,   869,     0,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,     0,     0,   400,     0,   402,   403,   404,
       0,   405,   406,   407,     0,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   870,   427,   871,   429,   430,   431,
     432,   433,   434,   435,     0,     0,   438,     0,   439,   440,
     441,   442,     0,     0,   444,   872,   446,   447,   448,     0,
     449,   450,     0,     0,   451,   452,   453,     0,     0,   454,
     455,     0,   457,   458,   459,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   471,   472,
       0,   474,     0,   476,   477,   478,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   873,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,     0,   507,   508,   509,
     510,   511,   512,   513,   514,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   525,   526,   527,   528,
     529,     0,   530,   531,   874,   533,   534,   535,   536,   537,
     875,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,     0,   554,     0,   555,
     556,     0,   557,   558,   559,   560,   561,   562,   563,     0,
     564,   876,   877,     0,     0,   567,   568,     0,   570,     0,
       0,   572,   573,   574,   575,   576,   577,   578,   579,     0,
       0,   580,   581,   582,   583,   584,     0,     0,   585,   586,
     587,   588,   589,     0,   878,     0,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,   599,   600,   601,
     602,   603,   604,   857,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   616,   617,   618,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   858,   260,   859,   860,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   861,   862,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   863,   864,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   865,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   866,   349,     0,   350,     0,
     351,   352,     0,   353,   354,   355,   356,   357,     0,   358,
       0,     0,     0,   361,   362,     0,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,     0,   373,   374,   375,
     376,   377,   378,   379,     0,   380,   381,     0,   383,   384,
     385,   386,   867,   868,     0,   869,     0,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,     0,     0,   400,
       0,   402,   403,   404,     0,   405,   406,   407,     0,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   870,   427,
     871,   429,   430,   431,   432,   433,   434,   435,     0,     0,
     438,     0,   439,   440,   441,   442,     0,     0,   444,   872,
     446,   447,   448,     0,   449,   450,     0,     0,   451,   452,
     453,     0,     0,   454,   455,     0,   457,   458,   459,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   471,   472,     0,   474,     0,   476,   477,   478,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   873,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
       0,   507,   508,   509,   510,   511,   512,   513,   514,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     525,   526,   527,   528,   529,     0,   530,   531,  2647,   533,
     534,   535,   536,   537,   875,   539,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
       0,   554,     0,   555,   556,     0,   557,   558,   559,   560,
     561,   562,   563,     0,   564,   876,   877,     0,     0,   567,
     568,     0,   570,     0,     0,   572,   573,   574,   575,   576,
     577,   578,   579,     0,     0,   580,   581,   582,   583,   584,
       0,     0,   585,   586,   587,   588,   589,     0,   878,     0,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,   599,   600,   601,   602,   603,   604,   857,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   616,   617,
     618,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   858,   260,   859,   860,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   861,   862,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   863,
     864,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   865,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   339,   340,
     341,   342,     0,     0,   344,     0,   345,   346,   347,   866,
     349,     0,   350,     0,   351,   352,     0,   353,   354,   355,
     356,   357,     0,   358,     0,     0,     0,   361,   362,     0,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
       0,   373,   374,   375,   376,   377,   378,   379,     0,   380,
     381,     0,   383,   384,   385,   386,   867,   868,     0,   869,
       0,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,     0,     0,   400,     0,   402,   403,   404,     0,   405,
     406,   407,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   870,   427,   871,   429,   430,   431,   432,   433,
     434,   435,     0,     0,   438,     0,   439,   440,   441,   442,
       0,     0,   444,   872,   446,   447,   448,     0,   449,   450,
       0,     0,   451,   452,   453,     0,     0,   454,   455,     0,
     457,   458,   459,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   471,   472,     0,   474,
       0,   476,   477,   478,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   873,   490,   491,   492,   493,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,     0,   507,   508,   509,   510,   511,
     512,   513,   514,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   525,   526,   527,   528,   529,     0,
     530,   531,     0,   533,   534,   535,   536,   537,   875,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,     0,   554,     0,   555,   556,     0,
     557,   558,   559,   560,   561,   562,   563,     0,   564,   876,
     877,     0,     0,   567,   568,     0,   570,     0,     0,   572,
     573,   574,   575,   576,   577,   578,   579,     0,     0,   580,
     581,   582,   583,   584,     0,     0,   585,   586,   587,   588,
     589,     0,   878,     0,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,   599,   600,   601,   602,   603,
     604,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   616,   617,   618,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
       0,   260,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,     0,     0,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
       0,     0,     0,   301,     0,     0,     0,   302,   303,   304,
     305,   306,   307,     0,     0,   310,     0,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,     0,   344,     0,
     345,   346,   347,     0,   349,     0,   350,     0,   351,   352,
       0,   353,   354,   355,   356,   357,     0,   358,     0,     0,
       0,   361,   362,     0,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,   373,   374,   375,   376,   377,
     378,   379,     0,   380,   381,     0,   383,   384,   385,   386,
       0,     0,     0,     0,     0,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,     0,     0,   400,     0,   402,
     403,   404,     0,   405,   406,   407,     0,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   427,     0,   429,
     430,   431,   432,   433,   434,   435,     0,     0,   438,     0,
     439,   440,   441,   442,     0,     0,   444,     0,   446,   447,
     448,     0,   449,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,     0,   457,   458,   459,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     471,   472,     0,   474,     0,   476,   477,   478,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,     0,   507,
     508,   509,   510,   511,   512,   513,   514,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   525,   526,
     527,   528,   529,     0,   530,   531,     0,   533,   534,   535,
     536,   537,     0,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,     0,   554,
       0,   555,   556,     0,   557,   558,   559,   560,   561,   562,
     563,     0,   564,     0,     0,     0,     0,   567,   568,     0,
     570,     0,     0,   572,   573,   574,   575,   576,   577,   578,
     579,     0,     0,   580,   581,   582,   583,   584,     0,     0,
     585,   586,   587,   588,   589,     0,     0,     0,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   599,
     600,   601,   602,   603,   604,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   616,   617,   618
};

static const yytype_int16 yycheck[] =
{
       6,   639,   989,     0,     0,   639,     0,     0,     0,   212,
       0,     0,   212,   654,    45,  1017,     0,     0,    46,     0,
       0,    57,  1141,   207,     0,     0,   821,    21,     6,     0,
      37,   215,    21,  1624,   218,   633,     0,     0,   818,     0,
       0,   768,   769,   770,   727,  1025,    52,   774,   190,  1559,
     956,   874,   918,  1006,  1497,  1021,   912,   709,   914,   892,
      22,   845,   990,  2687,  1015,  1252,    28,  2630,  2979,   863,
     864,   723,  1204,   797,   198,  1536,  2631,  1091,   872,  1543,
     686,  1240,   217,   828,  1862,  3308,  3044,  3310,   686,  3510,
    3132,   877,  1468,  3590,   844,  4104,   231,   930,  3784,   731,
    1543,  3536,  2012,  3538,    23,  1691,  3483,  3399,  3006,     0,
    3155,   955,  1065,  1548,  2991,  3736,  1069,  3833,    37,  1025,
    1994,  1074,  4136,  3811,  1589,  1590,  3800,  4179,  1593,   635,
      21,  1084,  2898,  3353,  4627,   733,   980,  3359,  2510,     8,
     707,   985,  2514,   710,  1097,    22,    15,  4132,  1658,  1659,
     176,    28,  2058,   192,  1526,  1933,   732,     2,  1425,  3878,
    1536,  4428,  1019,   722,  4416,   192,    57,  4411,  4643,  4214,
    4645,  4373,  3373,    36,  5279,  1128,  2944,  5206,  2946,  2947,
      43,    51,  3402,  2951,  2952,  2953,  4924,  2955,  2956,  2957,
    4875,   941,   198,    42,  2547,   226,  2876,   795,  2651,  2652,
    4714,   207,   208,  2617,  2615,  4681,  3265,   915,  3798,   215,
    5283,   217,   218,  4415,  1586,  3409,     0,  1652,   824,  5119,
     915,   989,  1509,  5242,   939,   231,   824,  2034,     0,  4932,
     998,  1603,    37,  5486,     0,    11,     0,  4484,  4923,     6,
    1008,  2594,   861,   862,  1679,  4569,  1080,    11,  3358,     0,
    3360,   849,   871,    13,  5170,  5171,    93,     6,    53,     6,
       6,  1095,  5470,  5163,    28,   980,    15,    16,     6,     0,
     985,    24,    62,     6,     6,    84,    62,    15,    16,  1029,
      11,    46,    15,    16,     6,     6,     6,   112,    62,     3,
      34,   118,     6,  1489,    13,   145,  2588,    28,    79,   118,
       6,   192,     6,    62,    79,     6,   118,  2987,     6,     6,
     167,   909,    42,    90,    87,    90,     6,   196,     3,   167,
      31,    79,    79,    79,    42,    44,   152,    62,   172,   172,
     172,     3,  1059,     5,     6,   216,     5,   172,     6,    11,
       6,   196,    11,   172,    11,     6,     6,  3485,   184,    62,
       5,   292,  5195,  4405,    28,     6,    11,   130,    77,   172,
     184,    35,  4518,  4519,  4520,     6,  4522,  4523,  4524,  4525,
    4526,   172,   118,    15,   174,   200,  1841,  5371,   292,    62,
    1104,   292,   200,   307,  4429,   138,   272,   286,   172,    62,
     188,    62,    62,   278,    29,    79,   167,   287,    22,   113,
     172,    90,   118,   166,    89,  4919,   172,   319,   172,   133,
     363,   135,   196,   172,   369,  1381,  5669,   292,  1369,   335,
     376,   172,   161,  1437,   196,   148,   172,  1025,    77,   118,
     196,   267,   196,    97,   122,   302,   164,   275,   417,   441,
     451,   172,   134,   267,    13,   196,   118,   404,  5132,  1081,
     405,   654,  5660,   251,   290,   359,   451,   142,   247,   246,
     851,  1367,   169,  1429,     5,   196,  1372,  1373,   491,  5488,
      11,   338,   286,   300,   188,   342,  1270,  1271,     6,   329,
     503,   300,   271,   440,   271,  5385,    28,   391,   288,    79,
     501,   366,   447,    35,  5178,   234,  1148,  1291,    46,   501,
      90,   704,    13,   120,  1228,  5243,   501,   419,    77,   376,
     347,   234,    28,    10,   178,  1301,    13,   652,   210,    35,
      17,    18,    19,   658,    79,   173,   505,   151,    90,   217,
     446,  5203,   305,    44,   262,   670,   189,   251,   363,    13,
     254,   172,   369,   215,   283,   383,   501,   271,   501,   505,
     179,   463,   315,   439,   179,   240,   441,  5810,   348,  1211,
     276,   502,   348,   120,   505,   237,    77,    13,  1425,   367,
     460,  1321,  1538,   344,   348,  1227,   211,   501,   405,   404,
     405,   140,   271,   224,  5578,   123,    13,   405,   417,  1241,
    5433,   505,   125,  4214,   505,   395,   134,    50,    44,  1349,
    5075,   123,   501,   220,   363,   460,  1182,  3745,  1514,   445,
     276,   111,   460,   348,   172,   276,   276,   302,  1524,  4240,
     447,   445,   431,   376,   505,   276,   505,   633,   447,  1825,
     456,    77,  1426,   460,   345,   348,   417,   410,   196,  1245,
    1259,  1260,   417,   639,   501,   422,   652,  1245,  5901,  5668,
     639,   501,   658,   367,   271,   639,   483,   501,   639,   417,
     417,   417,   505,   505,   670,   348,  1619,  1286,   505,  1622,
     505,   417,   402,   417,   501,   348,   501,   348,   348,   491,
     686,   446,   501,   450,   402,   691,   439,  1689,  1690,  5605,
     696,  5899,   505,   452,   700,   701,   501,   733,  4384,  5023,
     501,   707,  1630,   709,   710,  1611,   501,  1390,  1614,  1615,
      22,   737,   386,   330,  3006,   505,   722,   723,  4139,   505,
     504,  5974,  2009,   408,   500,   410,  4973,   733,   492,   493,
    1574,   505,   504,   417,   501,   359,  1687,   497,   504,  4425,
     504,  5814,  5480,   732,  1512,   491,    31,  1455,   639,   780,
    4424,  4248,   501,   504,   501,   379,  4253,   503,  1364,  1593,
    1455,   492,   493,   501,   478,  6018,  1364,   499,   501,   501,
     505,   503,   462,   504,  1372,  1373,   918,    24,   497,   501,
     501,   501,  5801,  1402,  1403,  1176,   748,  1610,   750,   795,
     752,   288,   505,   483,   462,   501,   758,   501,   199,   200,
     501,  5830,   203,   501,   501,   460,  1574,   172,  4429,  1643,
    1644,   501,   818,   819,   845,   483,  1935,    22,   824,  1534,
     492,   493,   223,   492,   493,   492,   493,   417,   483,   230,
    1696,  1963,   505,   501,   505,   505,  1039,   492,   493,  1039,
    4996,   732,   733,   849,   386,   851,  5746,  4069,   501,   491,
     499,  1970,  1036,   501,   503,   417,  1040,   499,  1042,  5759,
    4080,   503,   417,  1982,  4084,   393,   394,   906,   874,   417,
     386,   748,  1587,   750,   505,   752,   505,    28,  3920,   906,
     505,   758,   759,   760,  5903,  4475,   443,  5363,   505,  1604,
     896,   138,   923,   762,  3771,  3954,   349,   456,   446,  1805,
     123,   439,   460,   909,  5576,   405,  1030,   938,   441,  5581,
    5582,   908,   908,  4334,   908,   908,   908,   439,   908,   908,
     783,   784,   785,   151,   908,   908,  5664,   908,   908,  1320,
    4124,   243,   908,   908,   267,   932,  1184,   908,   148,  6044,
    1581,   287,   111,   184,   908,   908,  3714,   908,   908,    24,
    3630,  3631,  1447,   111,  5973,  3635,  4333,     3,  4068,  3412,
    4070,  3414,  5647,   151,  5667,  3379,  1823,  3378,   118,  3322,
    5484,   222,   123,   822,    75,  5875,   784,   826,  5663,   307,
     118,   172,   852,   494,   495,   496,   497,   210,  6093,   111,
     173,   287,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   783,  5833,  1509,   214,  1396,    41,   123,  1842,    36,
     300,  1017,  1018,  1019,   111,   906,   267,   908,   122,  1025,
     494,   495,   496,   497,  1030,   376,  6055,    24,   281,  1035,
    1036,  5233,    87,    30,  1040,   173,  1042,   361,   243,  4240,
    1046,  1590,   267,    89,  1593,  2011,   492,   493,   494,   495,
     496,   497,   417,   376,   307,   302,  1062,   286,  3350,   210,
     345,  3353,    67,   138,  5802,   492,   493,   494,   495,   496,
     497,  1462,  5822,  5548,   359,   130,   361,   281,   121,   956,
     322,  5095,   292,  4460,   123,   376,    38,   113,  3768,  2055,
    5135,   118,    68,    69,   210,   342,   408,   143,   422,  1105,
      71,  1107,  1108,   307,  4396,  5807,  5808,  3399,  5811,    10,
    3402,    28,    13,   217,   460,   123,    17,    18,    19,    90,
     113,   271,    87,   306,     6,   437,   491,    22,   379,   376,
     138,   994,   995,    34,   272,   287,    22,   422,   503,    71,
     181,   138,  1148,   120,  1871,   267,   479,   327,  1025,   192,
     462,   379,   287,  1184,   505,   501,   202,   447,   363,   194,
      22,  5422,   188,  5424,    24,   130,  5916,  5428,  5429,   465,
    1176,   210,    10,   501,  5226,    13,   128,  6008,   149,    17,
      18,    19,   505,   284,  1979,  1980,    22,   995,   439,   501,
    1788,   379,    24,  1182,    39,   188,    34,   444,   169,   382,
    5452,    24,   425,   408,   445,  1211,  5909,    30,    53,  1457,
     249,  1459,   994,   363,   505,   290,   439,   149,   369,  1225,
     445,  1227,  4908,   433,  2081,   251,   417,    22,   254,  4945,
    5482,  5498,   437,  4921,  5478,  1241,   405,   169,  4136,  1245,
    4914,   642,   175,   644,   354,   363,   647,   405,   501,  5451,
     305,  1257,  4971,  1905,  4675,  1938,  5834,   462,   251,   501,
     661,   254,   267,   309,   109,   292,   667,  1919,  1113,  5972,
     499,   346,   347,  5975,   503,  2651,   373,  6027,   138,  5481,
    1932,  5984,  1288,  3736,  1320,  2720,  1969,  2751,   439,   174,
    1973,  1182,  1841,   637,   118,  1978,   501,   501,  1981,   276,
      22,   376,  2052,   441,   175,   302,   138,    22,   460,   317,
    1316,  1317,  1318,   354,  1320,   138,  6019,   218,  1187,  2586,
    1189,   501,  1191,   439,  1193,   460,  1195,  1196,  1197,    10,
     440,   155,    13,  1202,  1340,  1902,    17,    18,    19,  1898,
     305,   367,   405,   133,    51,   342,  6049,  2933,   243,   320,
    1917,   177,     3,  1920,  5847,   410,  1994,   243,  1364,  1385,
    1994,   460,  1253,  2798,   209,   189,  1372,  1373,  2740,  1945,
    6073,  1930,   123,  3826,   367,    62,  5361,   101,  1581,   376,
     218,   243,  1273,   501,   483,   729,   432,   288,   320,   164,
    1396,  2032,   325,    10,   440,   312,    13,   443,  3205,  3206,
     439,  1440,  1441,  3210,  1443,  1972,  4628,   243,  3314,  1976,
    1977,   237,  4632,  1440,  1441,  5467,  1443,  4637,  5996,  1425,
    4640,   247,   267,   281,  5476,   358,  1457,    44,  1459,  1320,
    5691,    90,  3023,   161,    51,   359,  1442,  4872,   371,   324,
    1446,  1447,   302,  3250,  3251,   410,    34,   271,   243,   307,
     288,   226,   478,   251,   371,    28,  1462,   181,   376,   210,
      77,  4503,  1468,   434,   491,   342,    22,   118,   363,   813,
     302,  4513,   499,   406,   501,   502,   503,   363,   505,   302,
    5532,   271,   342,  4441,   191,   478,   334,   358,   172,   196,
    1367,   301,   409,   364,   411,  1372,  1373,   301,   249,  4397,
     371,   363,   434,  2009,    24,   281,   234,  3879,   501,  2511,
     342,   112,   196,   408,  5135,   196,   376,   183,   177,   342,
     365,   243,   408,  1400,    22,   123,   233,   363,   243,   146,
    1536,   307,  1409,   267,  1411,   406,   377,   218,  1415,  2034,
     417,   200,   437,   267,   376,  1422,   408,  2513,  2043,  1440,
    1441,   437,  1443,   376,  4322,   131,  5244,   428,  5232,  4327,
     133,   962,   963,    26,   152,   141,   376,   462,   363,   367,
    5579,  1577,   408,   167,   191,   437,   462,   501,   237,   196,
     267,  3042,   110,   409,   178,   411,    49,   505,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  5649,  1595,   200,
     462,   437,   196,  1600,  1610,   453,   501,   288,   342,   120,
     376,   437,   210,   408,   361,   501,   233,  1648,   138,  2010,
     271,  2012,   301,    71,   417,   276,   462,  2018,    63,  1844,
     319,  1032,   291,  2024,  2025,  2026,    71,  1514,  4404,   501,
     174,   363,   437,   501,  2035,   196,  1047,  1524,   363,  1864,
    2041,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     501,   348,  3038,   329,  5678,   501,  3042,   462,  1674,   359,
     118,   288,    28,   177,   381,   422,  1673,  1078,  1079,    86,
    1677,   120,   301,  1689,  1690,  1691,   408,   243,   439,   376,
     414,  1568,  1569,   408,   360,  2675,   120,   376,   750,   751,
     752,   121,  1103,   755,   756,   757,   501,  5907,  5908,   220,
    1913,  1914,   505,   765,  1914,   437,   302,    24,  4398,  1903,
     248,   118,   437,    30,   252,   501,   302,  4625,   176,  2586,
     419,   460,  5741,   237,  1611,   168,  4360,  1614,  1615,   505,
     462,   247,  1143,  1144,   347,   243,  5798,   462,   211,   439,
     409,   223,   411,   302,   288,  2834,   163,   376,   352,   310,
     271,  4214,   363,   422,   381,   334,   342,   121,  1892,   202,
     167,   369,   192,   376,   463,   434,   505,   133,   437,   501,
     204,   220,  1788,  5469,    32,    33,   501,  4240,  4080,    10,
     376,   342,  4084,   342,  1800,   346,    17,    18,    19,  5487,
    6003,   370,   237,   404,   405,  1811,   290,   363,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  1823,   302,   330,
    6020,  1827,  5496,   271,  2647,   376,   460,   376,   276,  2032,
     334,   138,   271,  2628,   419,  2914,   405,   173,   192,   184,
    1846,   439,   302,   267,  4136,  5897,    97,   271,  1854,    97,
     302,  5071,   408,     5,   501,   417,  1862,  2844,   342,    11,
      57,   161,   161,  6066,   481,   363,   117,   167,   167,   117,
     206,   505,   320,     0,  1880,   492,   493,   494,   495,   496,
     497,   437,   342,  1889,   453,   221,  1892,   441,   336,  1895,
     342,   330,  1898,  1899,  5271,   231,  1902,  1903,  5912,  1905,
    1906,   152,   334,   271,   152,   409,   462,   411,   276,   460,
     408,  1917,    10,  1919,  1920,    13,   376,  5969,    27,    17,
      18,    19,   267,  1929,  1930,  2782,  1932,  1933,  1805,   491,
     127,    13,   483,   437,   234,   234,    34,  1587,   370,   437,
     302,   503,  2848,  4988,   359,   501,   385,   501,  3067,   453,
    2856,  2808,   501,  2859,  1604,   261,  1945,   302,  1989,   150,
     328,   302,    44,  4874,   462,  5681,  1972,  1595,   452,   504,
    1976,  1977,  1600,   405,  5662,   174,  4429,   222,   344,   285,
     342,    90,  2750,   283,   283,    10,   434,  5661,    13,   359,
     405,   361,    17,    18,    19,    77,  2003,   342,  1994,   457,
    4898,   342,  4913,   501,  2010,  1994,  2012,   198,   207,  6023,
    1994,  2017,  2018,  1994,   376,  5450,  4893,   353,  2024,  2025,
    2026,   453,   267,  2029,  3615,  2031,  3936,  2033,  2034,  2035,
    2036,  2037,  2038,  3409,   152,  2041,    92,  2043,  2044,  3500,
     417,  2047,  5265,  3419,  5089,  1673,  5091,   505,   460,  1677,
    2907,  3238,   422,  2897,  1945,  2061,  2062,  2063,  2064,   505,
    2894,  2927,  2928,  2929,   441,   174,   310,   288,  4836,   733,
    4838,  4839,  4840,  2079,  2824,  2081,  2844,  2675,   462,   135,
    1949,  5502,  1951,  2002,  1953,   330,  1955,   338,  1957,  3867,
     338,   419,  1961,   505,   460,  2822,  2748,  2824,   462,   483,
     445,   302,   346,  1994,  4396,  4397,  3059,  3693,   272,   273,
    2605,   460,    34,  3699,  2882,  5803,  2973,   483,   369,   483,
     218,   369,    24,  3588,  3500,   500,   363,   322,  1529,   342,
     505,   795,   376,  1185,   379,   463,  1188,   501,  1190,   505,
    1192,   342,  1194,  2020,  2021,   346,  1198,  5524,  2916,  2040,
    2027,  2028,   110,  1554,   405,   392,   505,   405,  3965,  3966,
    3967,  3968,   422,   376,  3971,  3972,  3973,  3974,  3975,  3976,
    3977,  3978,  3979,  3980,  2565,   376,  3010,  3011,  3012,  3013,
    2057,  3015,  4862,  5475,  4864,   849,  4060,    89,   460,  2872,
     288,  2874,   342,   218,   439,  2878,   447,  5095,   462,   447,
     453,    28,  3637,   451,   280,   369,  3040,    79,  5431,   460,
     168,   483,   460,  3119,  5902,   324,  2222,   302,    90,   483,
      98,     3,  4029,  4030,  4716,   502,   376,  5913,   505,   131,
    1631,  4723,   483,   505,     5,   483,   138,   501,   302,   141,
      11,   405,  5739,    25,   202,   909,    98,  3682,    19,  5291,
     501,   369,   361,   501,   346,    82,  2262,   342,    85,  1660,
    1661,  1662,  1663,   288,    91,   366,   148,    38,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   460,   342,   161,
     330,   167,   167,   447,   376,   167,   346,   405,   380,   224,
     248,   376,   119,   343,   252,   173,   460,  3807,    31,   300,
     483,   359,   360,    47,   190,   190,  3033,    89,   152,  2315,
     499,   420,   376,   422,   503,    98,   376,   426,   501,   483,
      79,   173,   372,  5744,  5745,    58,    70,   167,   206,   447,
     501,    90,   214,  4625,    26,   460,  2227,   501,   250,   496,
    4632,     5,   460,   221,   501,  4637,   503,    11,  4640,   176,
     190,   984,   234,   231,   206,   120,  5254,    49,   483,   500,
    2992,   143,   189,   148,   505,   483,  6052,   501,   369,   221,
    1003,    22,  3229,  1006,   201,   286,   161,    28,  3235,   231,
     291,   259,   167,   501,   499,  5283,   501,   133,   503,   135,
     173,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     302,   283,   167,   422,   405,  1806,  1807,   259,   286,  3315,
     292,   286,   496,   159,   196,  5183,   291,   501,   366,   503,
     202,  1822,   502,   206,  5322,   505,  3150,  3151,   344,   214,
    6081,    71,  6083,  3116,   286,   247,   338,    77,   221,   204,
     342,   247,  3218,  3309,  3220,  3221,   447,  5868,   231,   234,
      90,   502,  6103,    94,   505,  1856,  1857,  1858,  1859,   460,
     263,   264,   265,   266,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   200,   376,   353,   259,  5700,   118,   190,
     120,   383,   483,   250,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,   502,  2500,   409,   505,   411,   283,   422,
     501,   353,   267,  2509,  5387,  2511,   271,   292,  2711,  5392,
    5393,  2711,   502,    15,    16,   505,   980,   263,   264,   265,
     266,   985,    32,    33,   270,   369,  2710,   309,  2712,  2713,
     276,   502,  5102,  5103,   505,  1936,   176,    86,     3,   502,
    5961,  1942,   505,  2549,   453,  4352,  5504,  2553,  3334,  3335,
    2556,   433,  2558,   502,  2548,  2561,   505,   502,  3486,  2565,
     505,   405,    58,   441,   204,   392,    10,  3312,   395,    13,
     353,   366,   354,    17,    18,    19,   502,  3410,   224,   505,
    2586,   494,  2588,  2707,  3512,   148,   499,   494,   501,   409,
     503,   411,   499,   501,   501,  4186,   503,   451,   161,  2605,
      44,    11,   502,   447,   167,   505,  4898,    51,  2614,  2615,
    2588,   501,  2747,   503,  3364,   502,   460,  2045,   505,   502,
    2048,   403,   505,   404,    89,  3591,  3420,   501,  4406,   502,
    3271,   271,   505,    77,  2640,   502,   276,   502,   505,   483,
     505,  2647,   359,   360,   502,  2651,  2652,   505,   433,   505,
     432,   214,  2658,   359,   360,   369,  2662,   501,   440,   502,
    2666,   443,   505,  2554,  3796,   502,  5840,  5841,   505,  2675,
    2677,   234,  2679,   499,  4184,   501,  4186,   142,   424,   363,
     320,   502,  5135,   502,   505,  5365,   505,  2693,  2719,   435,
    2696,   405,  5737,  5373,  5374,  3882,   336,  2588,  2833,  2576,
    2577,  2707,   286,  2709,  2710,  2582,  2712,  2713,  5931,  2715,
    3205,  3206,  4176,  2675,   501,  3210,   503,  3315,  2119,  3487,
     283,  2727,   502,    37,   460,   505,   462,  4162,   502,   292,
      58,   505,   502,   447,   453,   505,   502,  2614,  2615,   505,
     502,  2747,  2748,   505,   501,    59,   460,   191,  4124,   409,
    2756,   411,   196,    86,  3437,  3250,  3251,  5711,  5712,   502,
    3919,   502,   505,  3777,   505,   359,   360,   502,  5666,   483,
     505,   502,  2778,  2779,   505,   240,  2782,    47,  2913,  5071,
    5678,   502,  3434,  3435,   505,  4220,  3739,   501,  2819,   233,
     502,    55,    56,   505,   434,  3563,   110,   220,  2675,  5354,
    2806,  6024,  2808,  5095,  5257,   502,  2812,   502,   505,   502,
     505,   502,   505,   503,   505,   502,  3207,   289,   505,   502,
    2826,   502,   505,   502,   505,   289,   505,  2833,  3219,   502,
    2836,   502,   505,   480,   505,   502,  2842,   302,   505,   502,
     502,   286,   505,   505,   288,   310,   502,   502,   502,   505,
     505,   505,   502,   286,   502,   505,  2862,   505,  3464,   167,
    3587,  6084,  2868,  3254,  3591,   502,  3464,   289,   505,  2875,
     433,   502,   502,   338,   505,   505,   502,   342,  3735,   505,
      47,   346,  2759,  2889,   502,   199,  5797,   505,   502,   502,
     502,   505,   505,   505,   502,   502,  2902,   505,   505,  3733,
     502,  2907,   502,   505,   480,   505,  3297,  2913,  4418,  2871,
     502,   376,   502,   505,   502,   505,  5814,   505,  3642,   502,
     502,   502,   505,   505,   505,  2931,  2932,  2933,  3580,   502,
     502,  2937,   505,   505,   248,   480,   499,   381,   252,   502,
     503,   502,   220,   408,   505,   410,    37,   494,   502,   502,
    3602,   505,   505,   267,   502,   171,   450,   505,  2964,  2965,
     502,   502,  5254,   505,   505,   505,   502,  2973,    59,   505,
    4413,  2848,    53,  4434,   502,   501,   501,   505,  3162,  2856,
    3164,  3165,  2859,   502,   316,   502,   505,   301,   505,   502,
     502,  5283,   505,   505,  2871,   460,   502,   148,   502,   505,
    3006,   505,   501,    36,  5567,  4137,  4138,   502,  5906,  4141,
     161,   409,   502,   411,  5912,   505,   167,   502,    99,   110,
     505,  3927,   502,   502,   502,   505,   505,   505,  3006,   502,
    5322,   502,  3038,   347,   505,  3159,  3042,   481,  3765,   501,
      58,  3025,  4008,   124,   172,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    10,   216,   370,    13,  4434,   502,
     216,   142,   505,   214,   502,   146,   502,   505,  3271,   505,
    2579,  2580,  2581,   460,   501,   462,   390,   460,   133,   462,
     135,   342,   502,   234,   504,   176,   501,   168,    44,   502,
     171,   504,  4051,   464,  4053,    51,  4616,  4085,  4618,  4087,
    3783,   503,   501,  4054,  3756,   186,  3758,  5053,   199,  5055,
     501,   196,  3096,   153,   503,   501,   153,   286,   196,  3903,
     273,    77,   342,   286,  3130,  6023,   153,   153,   196,   153,
     342,  4097,   283,   167,  3025,  3741,   286,  3743,   153,  4730,
    3146,   292,  3148,  3741,  4001,  3743,   232,   120,   441,  3155,
     286,  2552,   501,  3159,   280,  3161,  3162,   248,  3164,  3165,
    3166,   252,   167,   502,    71,   271,    37,   271,  3174,   464,
    3373,  3207,   501,  3179,   286,   271,   267,    47,    47,   271,
     427,   271,   302,  5475,    89,   453,   453,   422,   502,   167,
     146,   323,  5816,   153,   153,   276,   501,   167,   153,  3205,
    3206,  3207,  5009,   153,  3210,  3096,   464,  3890,   153,   153,
     301,   505,  3218,  3219,  3220,  3221,   369,   153,  3254,  3825,
     153,    10,   153,  3229,    13,   153,   153,  3825,  3234,  3235,
     153,  3237,  4185,  3239,   153,   191,   153,   153,   153,   153,
     196,   286,  3119,   405,  3250,  3251,  4710,   328,  3254,   216,
     501,    37,   405,   232,   167,    44,   347,   167,   286,   501,
       6,     6,    51,   501,   501,   167,  3918,  3273,   501,  3275,
     501,  3277,   501,   501,  3302,  3303,  3304,   233,   501,   370,
     501,     6,   433,     6,   501,     6,   501,   501,    77,     6,
     501,  3297,   501,   501,   447,  4482,   501,   501,   501,   390,
     501,   501,   501,   278,   501,   501,   501,   460,   501,  3315,
     501,   501,   501,   501,   461,  2716,  3207,  3353,   298,   216,
     505,  4154,   505,    37,   101,  4457,   232,  4121,    37,   501,
     483,    37,   288,    36,  4240,   415,   415,   501,   172,   499,
     499,   417,   417,   417,  3350,   417,   167,  3353,   501,   502,
     505,   504,   167,    59,   283,   281,  4213,   146,  4215,  3365,
      67,   417,   363,  3254,  3370,   417,   417,    37,   452,   417,
     363,   417,  3350,   503,  5666,  3353,   417,  4330,   363,  3385,
    4308,   234,  4239,   346,    78,  3276,  5678,   417,   417,    59,
     491,    90,   417,  3399,   363,   153,  3402,  6021,   286,   229,
     368,  3292,   191,  3409,   110,   417,  3412,   196,  3414,   417,
     276,   126,   408,  3419,   417,    85,   307,   440,   286,   359,
     281,  3399,  4060,   417,  3402,   381,  4060,   417,  3434,  3435,
     501,   501,   189,    90,  3440,   126,  3313,   302,  3315,   505,
     110,   111,   196,   153,   233,   417,   441,   126,   118,   441,
     112,   417,  4318,  2854,  3331,  3461,  2857,   126,  3464,  3350,
     417,  3467,  3353,   417,   417,   417,   417,    58,   417,  3475,
    3965,  3966,  3967,  3968,   417,   417,  3971,  3972,  3973,  3974,
    3975,  3976,  3977,  3978,  3979,  3980,    58,   417,   256,  5296,
     290,   327,   417,   199,  3500,   417,   417,   417,   327,   288,
    3377,  3378,   327,   307,  3999,   417,   176,   408,  3399,   417,
     307,  3402,    46,   417,   417,    46,   505,   417,  5325,   417,
     502,   218,  5814,   506,  4490,   481,   218,   286,   218,   199,
    3536,  3537,  3538,  3736,  4029,  4030,   492,   493,   494,   495,
     496,   497,   248,   218,  2945,   218,   252,   218,   286,   427,
     218,   218,   218,   218,   417,  3561,    37,  2958,   153,   286,
     501,   267,   118,   153,  3570,  2966,  3572,   271,  4944,  3960,
     153,   153,   452,   153,  3580,   286,    10,  4072,   248,    13,
     240,   441,   252,   271,   271,   271,    37,    37,   167,   224,
     501,  4497,   381,   365,   153,   301,  3602,   267,   153,   441,
     153,   271,   501,  3994,  3005,   501,    10,   153,   441,    13,
      44,   376,   417,   456,  5906,   172,   280,    51,   501,   275,
    5912,    13,   256,   256,   505,  3026,   501,   415,   501,   181,
     417,   301,   162,   505,   419,   502,   480,   499,   189,   189,
      44,   347,   480,    77,   502,   502,   502,    51,   502,   367,
    4041,   254,   502,   214,   457,   379,   505,   222,   287,   505,
    3666,   441,    37,   441,   370,   295,   501,    58,  3069,   452,
    3071,   502,   441,    77,   363,   222,   276,   347,   222,   276,
     417,   417,  3688,   417,   390,   501,    47,  3693,   167,   276,
     286,   232,   481,  3699,   286,   271,   232,   232,   359,   126,
     370,   385,  3708,   492,   493,   494,   495,   496,   497,   286,
     250,   505,   146,    10,   505,   417,    13,   286,   286,   286,
     390,   342,   392,   408,   406,   395,  4378,  4379,   376,  3735,
    3736,  6023,   460,   190,   373,  3741,   417,  3743,   292,   417,
     502,   330,   146,    37,   218,   441,   441,    44,   224,   491,
    3756,  4883,  3758,   326,    51,   153,   281,   191,  4581,  3160,
     167,    37,   196,   406,   169,   327,  3167,    10,   501,   373,
      13,   153,  3778,   453,    17,    18,    19,   153,   281,   501,
      77,   153,   441,  3814,   460,   271,    37,   191,   271,   286,
      26,  4647,   196,   286,    37,  5238,   224,   281,  3804,   233,
     187,   187,   167,    37,   168,   224,   286,   373,  4491,  4492,
    4493,  4494,  4495,   167,   464,  4721,   271,   196,   196,  3825,
    3826,    25,   196,   196,   179,   196,  3810,   501,   505,   233,
     172,   501,   417,    10,   460,   253,    13,   286,    58,  3875,
     503,   280,  3848,   172,   298,   133,   308,   505,   172,   146,
     505,   505,   505,   502,   288,   502,   502,  4352,   502,  3736,
    5370,  3867,  3846,   505,   502,   502,   502,    44,   480,   270,
     502,   502,  3903,   501,    51,   502,   297,   502,   417,  4659,
     502,   505,  3759,   502,   288,   501,   501,   501,   501,   247,
    3896,  4844,   501,   500,   191,  4037,   502,   172,   500,   196,
      77,   181,   501,   242,   505,   483,   439,   482,   457,    58,
     200,   153,  3918,   501,   276,  3921,   286,   501,   286,  3810,
     289,   417,   417,   417,   208,   156,   417,   501,   271,   153,
      85,   376,  3938,   368,   153,  3941,   233,   153,   368,   368,
     232,  3947,   200,   156,   417,   286,   491,   381,   156,  3955,
     196,  3957,   441,   457,  3960,  3846,   234,   309,  3964,  3965,
    3966,  3967,  3968,   309,   156,  3971,  3972,  3973,  3974,  3975,
    3976,  3977,  3978,  3979,  3980,   218,   417,   381,  3984,  3985,
    3986,   417,   438,  3989,  3875,   417,   392,   244,  3994,   244,
     244,   288,   417,  3999,   417,  4001,   363,  4003,   126,  4035,
     417,  4967,   417,   417,   363,  4011,   417,   363,  4014,  4650,
    4016,  4214,   363,   376,   191,  4043,  4044,  4045,  4046,   196,
    4026,   417,   417,  4029,  4030,    46,   271,   153,  4034,  4035,
     502,   502,   417,   417,   417,  4041,   502,  4240,   218,   500,
     218,   184,   502,  5850,  5851,   288,   290,   481,     3,   502,
    3927,   167,    47,   505,   111,  4707,   233,   505,   492,   493,
     494,   495,   496,   497,  4060,   502,  4072,   427,   167,  3470,
    3471,  4060,    37,   153,  4080,  4570,  4060,   481,  4084,  4060,
     502,   501,   417,   153,   381,   167,   281,   184,   492,   493,
     494,   495,   496,   497,   491,   153,   441,   441,   501,   447,
     286,   491,  4080,   363,   363,   505,  4084,   363,   289,   373,
    4116,   288,   151,   363,   363,   151,   218,   218,  4124,   499,
    4803,  4804,   218,  4806,    10,   218,   218,    13,   218,  5505,
    4136,    17,    18,    19,   218,   218,  4863,   218,   144,    13,
     298,   452,  4794,   172,  4035,   502,   270,   457,    34,   221,
     500,  4157,   505,   502,   296,   502,   221,   293,  4136,   407,
      58,   185,   502,   350,   502,   427,   502,   501,   505,  4060,
     502,   502,    37,   501,   501,   501,  4567,   414,   167,   224,
     441,   208,   417,    58,   481,   408,   153,   392,  5779,  4080,
     176,   363,   368,  4084,   441,   492,   493,   494,   495,   496,
     497,   427,  4208,   417,   381,   156,   417,  4213,  4214,  4215,
     417,   417,   363,   502,   417,  5081,    24,   502,   501,   133,
     502,   135,    30,   342,   363,    58,  4429,   460,   501,   408,
     447,   167,   286,  4239,  4240,    77,   153,    45,   111,  4891,
     218,   218,   427,   218,   218,   159,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   203,   222,   417,   286,    37,
     307,   502,   501,   501,   464,   505,   284,    75,     3,   501,
     286,   427,   502,   501,    43,   373,   505,   417,   505,  4285,
     501,   446,  4288,    88,   502,   178,   111,   172,   218,  5408,
     502,  5410,  4254,   502,   172,    58,   458,   458,   298,   221,
     502,   502,   459,  4265,   481,   502,   505,   501,    24,  3710,
     414,   502,   501,   501,    30,   492,   493,   494,   495,   496,
     497,   129,   281,   131,   427,   172,   417,   460,    77,   190,
     138,  5188,   218,   141,   202,   190,   276,  4214,   276,   491,
      58,   408,   505,   417,    71,   156,  4352,   153,   417,   263,
     264,   265,   266,   417,   417,   505,   270,   271,   502,    75,
     168,   218,   276,  4240,   501,   125,   118,   174,    37,   196,
     281,   501,  4378,  4379,   373,   441,  4382,  4254,    37,   271,
     169,  5064,   373,  4389,   281,   460,    58,    83,  4265,   408,
    4396,  4397,  5075,    37,   202,   172,   286,   167,   460,   505,
    4406,   501,   288,   337,   205,   491,   289,   216,   172,   446,
     389,   307,  5544,   501,   366,   131,    37,   502,  4396,  4397,
    5215,   197,   138,  4429,   502,   141,    80,   286,  4434,  4435,
    4436,   502,   336,   501,   417,    37,   153,   417,  4422,  5419,
    4446,   501,   153,  5575,   167,    37,   502,  4650,   501,  5315,
     501,   501,   168,   501,   276,  5096,   441,   501,   501,   267,
     245,   501,   153,   271,  4341,  4342,   501,   373,   502,  3870,
      37,   111,   502,   281,   290,   172,   502,   427,   387,   387,
     167,    90,   290,  4489,  5136,   134,   202,    58,   110,  5621,
    5622,   501,   501,   501,   302,    37,  4502,   189,   505,   456,
       0,   505,   441,   501,   501,  4396,  5147,   408,   408,    10,
     424,   167,    13,  5419,  5009,   200,    17,    18,    19,   267,
     501,   435,  4528,     6,   286,   160,   502,   464,   501,   360,
     360,  4422,    71,  4539,   342,   289,    71,   345,   346,   134,
     504,   460,    42,   139,   460,   164,   456,   446,   164,   505,
     445,   267,  4429,    34,   501,   271,   501,   446,   246,   172,
     408,  4567,   333,   276,  4570,   281,  5061,   208,   376,   202,
     408,   286,  4578,  4579,   290,  4581,   217,   286,   501,  4585,
    4586,   373,    37,    61,  4590,    37,   302,   289,  4594,   289,
     231,  4597,  4598,   197,   501,   174,  4602,    97,   174,   501,
     152,   376,  4608,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    58,    58,   502,   293,    37,   343,    96,  4625,
    4497,   502,   413,    58,   417,   123,  4632,   439,   396,   345,
     346,  4637,   502,  5613,  4640,  4641,   444,     6,   501,   373,
    5772,   149,  4648,   139,  5631,   359,   276,  4625,   148,   501,
    5333,   501,   413,  4659,  4632,  4661,    23,    34,   359,  4637,
     376,   161,  4640,    80,   505,   505,  4673,   167,   376,   272,
    4676,   417,   172,   172,   294,   501,   359,   152,   178,   157,
     387,   181,   272,   387,   118,   185,   505,   501,  4694,   447,
     446,   441,   174,   460,   460,  5552,   447,   174,   501,   446,
     502,  4707,  5264,  2990,  3315,  1676,  2882,  3512,  2791,  4213,
     908,  5843,  5844,  4188,   214,   193,   216,   218,  5763,  2962,
    2908,  1373,  5191,   948,  3727,  5611,  4732,  5883,   444,  5412,
    4376,  5238,  4186,  4853,   234,  5214,  3441,  3106,  5743,  5095,
    5871,  4632,  5641,  4749,  5640,  5783,  4637,  3445,  4754,  4640,
    4898,   229,  5906,  4715,  5611,  4761,  4408,  4397,  4423,  5585,
    4366,  2976,  2976,  4725,  4208,  3537,  3775,  4892,   990,  4392,
    5221,  4777,  3819,  4459,  5517,  5985,  6096,  4783,  6078,  5205,
    3735,  5149,  5795,   283,  4431,  1835,   286,   288,  4794,   267,
    5390,  5594,   292,   271,  5152,    18,   635,    28,  3894,  1212,
    4502,  5296,  5360,  5981,  2652,  2992,  3419,  5405,  4434,  1878,
    1875,  3830,  1889,  5505,  5264,  1913,   687,   720,  1997,  4825,
    1997,  5419,  3669,  4239,   302,   303,  2907,  3588,  5822,  6027,
    5325,  4463,   310,  2938,   839,  4465,  1947,  2595,  4715,  6046,
    1788,  5358,  1493,  4966,  4721,  4851,  5736,  1389,  4725,  4487,
     350,  1350,    41,  5580,    41,  3370,  1450,  2605,  3385,  5728,
    5564,  4867,  3353,  1449,   342,  4086,  4872,  4069,   346,  3350,
    5072,  1452,  5321,   351,  5322,  4752,  4753,  4488,  6005,  3350,
    4757,  4758,   360,  5722,  5854,  4891,  5551,  1406,  5300,  4003,
     368,  5565,  4898,  5096,  5566,  2506,  2036,  3276,   376,  3175,
    2937,  3274,   402,  5883,   896,  2509,    -1,  2593,    -1,    -1,
     388,  5302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   397,
    4898,    -1,    -1,   401,    -1,    -1,  4910,    -1,    -1,    -1,
      -1,    -1,  5135,   433,    -1,  4336,  5577,    -1,  4944,    -1,
    4946,    -1,    -1,    -1,  5147,  5336,    -1,  5147,    -1,  4350,
      -1,    -1,  5343,    -1,    -1,    -1,    -1,   457,    -1,   459,
     460,    -1,  5146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,
    4964,  4965,  4988,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
    5006,    -1,   502,  5009,   504,   505,  5012,  5013,  5014,  5193,
      -1,   652,  5403,  5404,    -1,  5613,    -1,   658,    -1,  4910,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   670,
      -1,  5037,  5038,    -1,    -1,  5041,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5061,  5551,    -1,    -1,    -1,
      -1,  5067,    -1,  6065,    -1,  5071,    -1,    -1,    -1,    -1,
      -1,  5077,  5078,  4964,  4965,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5089,    -1,  5091,    -1,    -1,    -1,  5095,
      -1,    -1,    -1,  5071,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5095,    -1,    -1,
      -1,    -1,    23,    -1,    25,    -1,    -1,    -1,    29,  5135,
    5136,    -1,    -1,    -1,    35,    36,    37,    -1,    39,    -1,
    5146,    42,    43,    -1,    45,    -1,    47,    -1,    -1,  5540,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5763,    -1,    10,    -1,  5560,
      13,  5562,    -1,  6030,    17,    18,    19,    -1,    -1,    -1,
    5071,    -1,  5188,    -1,  5822,    -1,    -1,  5193,  5822,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,  6079,    -1,  5084,    -1,    -1,    -1,    -1,
      -1,  6078,  5253,  5718,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    77,  5219,    -1,    -1,    -1,  6096,
    5967,  5968,    -1,    -1,    -1,    -1,    -1,    -1,  5254,    -1,
      -1,  5257,    -1,    -1,    -1,    -1,    -1,    -1,  5135,    -1,
      -1,    -1,    -1,    96,    -1,    -1,  5250,  5264,  5264,    -1,
    5264,  5264,  5264,    -1,  5264,  5264,  5254,  5283,  5916,  5285,
    5264,  5264,  5916,  5264,  5264,  5883,    -1,    -1,  5264,  5264,
    5296,    -1,    -1,  5264,  5300,    -1,  5302,   198,   199,   200,
    5264,  5264,   203,  5264,  5264,  5283,   207,  5343,   209,    -1,
      -1,   212,    -1,    -1,   215,    -1,  5322,   218,    -1,  5325,
     221,    -1,   223,    -1,   157,   226,    -1,    -1,  5219,   230,
    5336,   232,    -1,    -1,    -1,    -1,    -1,  5343,    -1,    -1,
      -1,    -1,    -1,    -1,  5322,    -1,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,    -1,  5850,  5851,    -1,    -1,  5250,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5264,  5577,   218,   219,    -1,    -1,    -1,
      -1,  5387,    -1,    -1,    -1,    -1,  5392,  5393,    -1,  6027,
     233,  5397,    -1,  6027,    -1,    -1,   229,  5403,  5404,  5405,
      -1,    -1,    -1,    -1,  4805,    -1,    -1,    -1,    -1,     0,
      -1,    -1,    -1,  5419,    -1,    -1,    -1,    -1,    -1,  4820,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,  5439,    -1,    -1,    -1,    -1,   271,    -1,
      -1,  5447,    -1,    -1,  5450,   288,    -1,    -1,   291,    -1,
      -1,    -1,  5343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5475,
     303,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5477,    -1,    -1,    -1,  5475,    -1,  5505,
    5506,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
    4911,    -1,    -1,   346,    -1,   348,    -1,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,  5534,    -1,
      -1,    -1,    -1,    -1,  5540,   368,    -1,    -1,   381,    -1,
      -1,    -1,  5419,   376,    -1,  5551,  5552,    -1,    -1,  5555,
      -1,    -1,    -1,    -1,  5560,   388,  5562,   148,  5564,    -1,
      -1,    -1,    -1,    -1,   397,    -1,  5750,    -1,   401,    -1,
     161,    -1,    -1,  5964,    -1,    -1,   167,    -1,    -1,    -1,
    5586,   172,    -1,    -1,  5475,    -1,  5477,   178,    -1,    -1,
     181,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5611,     0,  5613,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   455,   214,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,  5823,
    5824,    -1,    -1,   234,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,   502,
    5666,    -1,   505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5678,    -1,    -1,    -1,    -1,    -1,    -1,  6070,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5666,    -1,
      -1,    -1,   283,    -1,    -1,   286,  5097,    -1,  5099,    -1,
    5678,   292,    -1,    97,  5710,  5711,  5712,    -1,    -1,    -1,
      -1,    -1,  5718,    -1,  5698,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5728,    -1,    -1,    -1,  5603,    -1,  5734,    -1,
      -1,  5737,    -1,   634,    -1,    -1,    -1,    -1,    -1,   640,
      -1,   642,    -1,   644,  5750,    -1,   647,    -1,    -1,    -1,
      -1,    -1,    -1,   654,   148,    -1,    -1,  5763,   659,   350,
     661,    -1,    -1,    -1,    -1,    -1,   667,   161,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,    -1,    -1,   178,    -1,    -1,   181,    -1,    -1,
     691,   185,    -1,    -1,    -1,    -1,    -1,    -1,  5804,   700,
      -1,    -1,    -1,   704,    -1,    -1,   707,  5698,  5814,   710,
      -1,    -1,  5796,    -1,   405,    -1,    -1,  5823,  5824,    -1,
     214,    -1,    -1,  5829,    -1,   726,    -1,    -1,  5834,  5822,
      -1,    -1,    -1,  5822,    -1,    -1,  5814,    -1,  5822,    -1,
     234,  5822,   433,    -1,  5850,  5851,    -1,    -1,    -1,    -1,
      -1,  5252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   457,    -1,   459,   460,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5883,    -1,   780,
    5916,    -1,   783,   784,   785,    -1,    -1,    -1,    -1,   283,
      -1,    -1,   286,    -1,    -1,    -1,    -1,   798,   292,    -1,
    5906,    -1,  6086,  6087,    -1,  5796,  5912,    -1,   499,    24,
      52,   502,   503,   504,    -1,    30,    -1,   818,   819,    -1,
     821,   822,    -1,  5916,  5930,   826,    -1,  5916,  5906,    -1,
      45,  5822,  5916,    -1,  5912,  5916,    -1,    -1,    -1,   840,
      -1,    -1,    -1,    -1,   845,  5951,    -1,    -1,    -1,    -1,
     851,  1130,    -1,    -1,    -1,    -1,   350,  1136,  5964,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    -1,  1146,    -1,    -1,
      -1,  1150,    -1,    -1,    -1,  1154,     0,  1156,    -1,    -1,
      -1,    -1,    -1,  1162,    -1,    -1,    -1,    -1,    -1,  1168,
    5996,    -1,  1171,    -1,    -1,   896,    -1,  6003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,  5409,   910,
    5411,   405,    30,    -1,   129,    -1,   131,  6023,    -1,    -1,
      -1,    -1,   923,   138,  6030,  5916,   141,    45,    -1,    -1,
      -1,    -1,    -1,  1674,  6027,    -1,    -1,   938,  6027,   433,
      -1,    -1,    -1,  6027,    -1,  6023,  6027,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,   957,    75,    -1,  6065,
    6066,   962,   963,   457,  6070,   459,   460,    -1,  6074,    -1,
      -1,    -1,  6078,    97,    -1,    -1,    -1,    -1,    -1,    -1,
    6086,  6087,    -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,
    6096,    -1,    -1,   994,   995,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   499,    -1,    -1,   502,   503,
     504,    -1,    -1,   131,    -1,    -1,  1017,  1018,    -1,    -1,
     138,    -1,    -1,   141,   148,    -1,    -1,    -1,    -1,  1030,
      -1,  1032,    -1,    -1,    -1,  1036,  6027,   161,  1039,  1040,
      -1,  1042,    -1,   167,    -1,    -1,  1047,    -1,   172,    -1,
     168,    -1,   267,  6030,   178,    -1,   271,   181,    -1,    -1,
      -1,   185,    -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,
    1071,    -1,    -1,    -1,    -1,   290,    -1,  1078,  1079,    -1,
      -1,    -1,    -1,    -1,   202,    -1,    -1,   302,    -1,    -1,
     214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1099,  1100,
    1101,  6078,  1103,    -1,  1105,  1846,  1107,  1108,    -1,    -1,
     234,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    -1,  6096,
      -1,  1862,    -1,    -1,    -1,    -1,    -1,   342,    -1,    -1,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1141,    -1,  1143,  1144,    -1,    -1,    -1,    -1,    -1,   267,
       6,  5652,    -1,   271,    -1,    -1,    -1,    -1,    -1,   283,
      -1,   376,   286,   281,    -1,  1906,    -1,    -1,   292,    -1,
      -1,    -1,   290,    -1,    -1,  1176,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1184,   302,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1204,    -1,  1206,    -1,    -1,    -1,  1210,
      -1,  1212,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,   342,    -1,   350,   345,   346,   444,
    1231,    -1,    -1,    -1,    -1,    -1,  1237,    34,    -1,  1240,
      -1,    -1,  1243,    10,    -1,    -1,    13,    44,    -1,    -1,
      17,    18,    19,    -1,    51,    -1,  1257,    -1,   376,    -1,
      -1,    -1,    -1,    -1,  5765,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      77,   405,    -1,    -1,    51,    -1,    -1,  1288,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,   433,
      77,    -1,    -1,    -1,    -1,  1316,  1317,  1318,    -1,  1320,
      -1,    -1,    -1,    -1,    -1,    -1,   444,    44,    -1,    -1,
      -1,    -1,    -1,   457,    51,   459,   460,    -1,    -1,  1340,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,
      77,    -1,   218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   499,  5877,  1378,   502,   503,
     504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,   191,  1396,    -1,    30,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    -1,  5907,  5908,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,   191,    -1,    -1,    -1,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,  1442,    75,    -1,    -1,  1446,  1447,    -1,    -1,    -1,
      -1,   218,   219,    -1,   696,    -1,  1457,  1458,  1459,  1460,
      -1,  1462,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,   274,    -1,   196,
     722,    -1,    -1,    -1,    -1,  1486,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,   291,    -1,    -1,    -1,   131,    -1,
      -1,   218,   219,    -1,    -1,   138,    -1,   274,   141,    -1,
      61,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,  6020,
    1521,   288,    -1,    -1,   291,  1526,    -1,    -1,  1529,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,  1542,  1543,    -1,    -1,    96,    -1,    -1,    -1,    -1,
    1551,    -1,    -1,  1554,    -1,    -1,    -1,   274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1581,    -1,  1583,    -1,   381,  1586,    -1,    -1,  1589,  1590,
      -1,    -1,  1593,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      -1,    -1,  1603,    -1,    -1,  1606,   157,    -1,  1609,    -1,
      -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1908,
    1631,    -1,    -1,    -1,   267,    -1,    -1,  1916,   271,    -1,
      -1,    -1,   193,    -1,    -1,    -1,    -1,  1648,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,   290,    -1,  1660,
    1661,  1662,  1663,  1664,   381,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,   229,    -1,
      -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,  1689,  1690,
    1691,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   342,
      -1,    -1,   345,   346,   481,    -1,   267,   157,    -1,    -1,
     271,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,   303,   193,    -1,    -1,    -1,    -1,    -1,   310,
      -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,   224,    -1,  1787,    -1,    -1,   229,
      -1,   342,    -1,  1035,    17,   346,    -1,  1798,    -1,    -1,
     351,    -1,    -1,    26,  1046,  1806,  1807,    -1,    -1,   360,
      -1,   444,    -1,    -1,    -1,    -1,    -1,   368,    -1,    -1,
    1062,  1822,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,   271,    -1,    -1,    -1,   691,    -1,   388,    -1,  1840,
    1841,    -1,    -1,    -1,   700,    -1,   397,    -1,    -1,    -1,
     401,   707,    -1,    -1,   710,  1856,  1857,  1858,  1859,    -1,
      -1,    -1,    -1,   303,  1865,    -1,    10,    -1,    -1,    13,
     310,  1872,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1889,    -1,
      34,  1892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2640,
      44,  1902,  1903,    -1,   455,    -1,   346,    51,    -1,    -1,
      -1,   351,  1913,  1914,    -1,    -1,  1917,  2658,    -1,  1920,
     360,  2662,    -1,    -1,    -1,  2666,    -1,    -1,   368,    -1,
      -1,    -1,    -1,    77,  1935,  1936,   376,    -1,    -1,    -1,
      -1,  1942,    -1,  1944,    -1,    -1,  1947,    -1,   388,    -1,
      -1,    -1,  2693,    -1,    -1,    -1,    -1,   397,    -1,    -1,
      -1,   401,  1963,    -1,    -1,    -1,    -1,    -1,    -1,  1970,
      -1,  1972,    -1,    -1,  1975,  1976,  1977,    -1,  1979,  1980,
     420,  1982,    -1,  1225,    -1,    -1,  2727,    -1,  1989,    -1,
      -1,    -1,    -1,    -1,    -1,  1996,    -1,    -1,    -1,    -1,
      -1,  2002,  2003,    -1,    -1,  2006,  2747,    -1,    -1,  2010,
      -1,  2012,    -1,    -1,    -1,   455,  2017,  2018,    -1,   459,
      -1,    -1,    -1,  2024,  2025,  2026,    -1,    -1,  2029,    -1,
    2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2779,    -1,
    2041,    -1,  2043,  2044,    -1,    -1,  2047,   191,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2062,  2063,  2064,    24,  2806,    -1,    -1,    -1,    -1,
      30,  2812,    -1,    -1,   218,   219,    -1,    37,  2079,    -1,
      -1,    -1,    -1,    -1,    -1,  2826,    -1,    -1,    -1,   233,
      -1,    -1,  2833,    -1,    -1,  2836,    -1,    10,    -1,    59,
      13,  2842,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,  2119,    -1,
      -1,  2862,    -1,    -1,    -1,    -1,    -1,  2868,    -1,    -1,
     274,    44,    -1,    -1,  2875,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,   291,  2889,    -1,
     110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2902,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,   131,  2913,    -1,  1030,    -1,    -1,    -1,   138,    -1,
    1036,   141,    -1,    -1,  1040,    -1,  1042,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2222,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,   199,
      -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,  1105,
      10,  1107,  1108,    13,    -1,    77,    -1,    17,    18,    19,
      -1,  2262,    -1,    -1,    -1,    -1,    -1,  2546,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,    44,    -1,    -1,    -1,   248,    -1,
      -1,    51,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,   219,   267,    -1,    -1,
      -1,   271,    -1,    -1,  2315,    -1,    -1,    77,    -1,    -1,
     233,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    -1,    -1,    -1,  1577,    -1,   481,    -1,    -1,
      -1,   301,   302,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,    -1,    -1,   502,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,   288,    -1,    -1,    -1,    -1,
      -1,    -1,   342,    -1,    -1,   345,   346,   347,    -1,  3130,
      -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3148,    -1,    -1,
     370,   233,    -1,   636,  3155,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     390,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,   686,   687,    -1,   288,    -1,   381,   291,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,  2498,    -1,  2500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2508,  2509,    -1,
    2511,    -1,    -1,    -1,   274,    -1,    -1,  2518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,   291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2547,    -1,  2549,    -1,
      -1,  2552,  2553,    -1,    -1,  2556,    -1,  2558,  1800,   381,
    2561,    -1,    -1,   786,  2565,    -1,    -1,    -1,   481,  1811,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1827,    -1,  2588,    -1,   812,
      -1,    -1,    -1,  2594,  2595,    -1,    -1,   820,    -1,    -1,
     823,   824,   825,    -1,  2605,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2614,  2615,    -1,    -1,    -1,    -1,    -1,
      -1,   381,    -1,    -1,    -1,    -1,    -1,  2628,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2636,    -1,    -1,  1880,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1895,    -1,    -1,  1898,  1899,    -1,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,  2677,    -1,  2679,    -1,
     502,    -1,    -1,    -1,    -1,    -1,    -1,  1929,  1930,    -1,
      -1,    -1,    -1,    -1,    -1,  2696,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2707,    -1,    -1,  2710,
    2711,  2712,  2713,    -1,    -1,  2716,    -1,    52,  2719,    -1,
    3461,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,  2740,
      -1,    -1,   502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2759,  2760,
      -1,    -1,    -1,    -1,    -1,  2766,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,  2775,    -1,    -1,  3056,    -1,    30,
      -1,    -1,  3061,    -1,  3063,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,  3073,    -1,  2797,  3076,    -1,  3078,
    3079,    -1,  1025,  3082,    -1,    -1,    -1,  3086,    -1,  3088,
      -1,    -1,  3091,    -1,    -1,    -1,    61,    -1,  2819,  2061,
    3561,    -1,    -1,    -1,    75,    -1,    10,    -1,    -1,    13,
    2831,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    96,    -1,  2854,    -1,    -1,  2857,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3157,    -1,
     131,    -1,  2883,  2884,    -1,    -1,    -1,   138,    -1,    -1,
     141,    -1,    -1,    77,    -1,    -1,    -1,  2898,    -1,  2900,
    2901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2931,  2932,  2933,    -1,    -1,    -1,  2937,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2945,    -1,    -1,  3688,   193,    -1,
      -1,   202,    -1,    -1,    -1,    -1,    -1,  2958,    -1,    -1,
      -1,    10,    -1,  2964,    13,  2966,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2979,   224,
      -1,    -1,    -1,  2984,   229,    34,    -1,    -1,    -1,  2990,
      -1,    -1,  2993,    -1,  1217,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,  3005,  3006,    -1,   191,    -1,    -1,
      -1,    -1,   196,    -1,    -1,  3016,   267,    -1,    -1,    -1,
     271,    -1,  1245,    -1,    -1,  3026,   271,  3028,    77,    -1,
     281,    -1,    -1,  1889,   218,   219,  1892,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,  1902,  1903,    -1,   233,
      -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,
      -1,  1917,    -1,    -1,  1920,   310,  3067,    -1,  3069,    -1,
    3071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,   342,    -1,    -1,   345,   346,  3097,    -1,    -1,  1322,
      -1,   346,    -1,    -1,   288,  3106,   351,   291,  1331,    -1,
      -1,    -1,    -1,    -1,    -1,   360,  1972,    -1,    -1,    -1,
    1976,  1977,  1345,   368,    -1,   376,  3867,    -1,    -1,    -1,
      -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1364,   191,   388,  1367,  1368,    -1,   196,    -1,  1372,
    1373,    -1,   397,    -1,    -1,  3896,   401,    -1,  3159,  3160,
      -1,  3162,    -1,  3164,  3165,    -1,  3167,    -1,    -1,   218,
     219,  3450,    -1,  3174,    10,   420,    -1,    13,  3179,    -1,
    3921,    17,    18,    19,   233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   444,    -1,    -1,    -1,   381,    34,    -1,
      -1,    -1,    -1,    -1,  3205,  3206,  3207,    -1,    44,  3210,
     455,    -1,    -1,    -1,   459,    51,    -1,  3218,  3219,  3220,
    3221,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3234,    -1,    -1,  3237,    -1,  3239,   288,
      -1,    77,  3521,    -1,  3523,    -1,    -1,    -1,    -1,  3250,
    3251,    -1,    -1,  3254,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3271,    -1,  3273,    -1,  3275,    -1,  3277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3297,   481,    -1,    -1,
    3301,    -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,    -1,    24,   502,    -1,
      -1,  3322,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3350,
      -1,    -1,  3353,  3354,    -1,   191,    -1,  3358,  3359,  3360,
     196,   696,    -1,    -1,  3365,    -1,    -1,    -1,    75,  3370,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,  3385,    -1,  3665,   722,    -1,    -1,
      -1,    -1,  3671,    -1,    -1,    -1,    -1,   233,  3399,    -1,
    3401,  3402,    -1,    -1,    -1,  1628,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1636,    -1,    -1,  4157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,   138,   481,    -1,   141,    -1,    -1,    -1,   274,  3440,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
      -1,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    24,    -1,  2709,    -1,  3470,
    3471,    30,    -1,  2715,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2756,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   874,
      -1,    -1,    -1,    -1,  4285,   381,    -1,  4288,    -1,    -1,
      -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,   281,    -1,  3855,  3578,  3857,   138,
    3859,    -1,   141,   290,    -1,    -1,    -1,  3588,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1849,    -1,    -1,    -1,
    1853,    -1,    -1,    -1,    -1,   342,    -1,    -1,   345,   346,
     199,    -1,    -1,   202,    -1,   481,    -1,    -1,  4389,    -1,
      -1,    -1,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,    -1,    -1,  4406,   502,    -1,    -1,   376,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  1017,    -1,    -1,    -1,    -1,    -1,    -1,   248,
      -1,    -1,  3693,   252,    -1,    -1,    34,    -1,  3699,    -1,
    1035,    -1,    -1,    -1,    -1,    -1,    44,    -1,   267,  3710,
      -1,  1046,   271,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   281,  2965,    -1,    -1,    10,  1062,    -1,    13,
      -1,   290,  2588,    17,    18,    19,    -1,   444,    -1,    77,
      -1,    -1,   301,   302,    -1,    -1,  3747,  3748,  3749,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,  4502,    -1,  3764,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3778,    -1,    -1,
      -1,    -1,    -1,   342,    -1,    -1,   345,   346,   347,    -1,
      -1,    -1,    -1,    77,    -1,  3796,  3797,  3798,    -1,    -1,
    2023,  3802,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   370,    -1,  3814,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2707,    -1,   191,  2710,    -1,  2712,  2713,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3870,
      -1,    -1,    -1,    -1,  3875,    -1,    -1,  3878,    -1,    -1,
     218,   219,    -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,
    1225,    -1,    -1,  3894,  3895,   233,    -1,    -1,    -1,    -1,
      -1,    -1,  3903,    -1,  3146,    -1,    -1,   191,    -1,    -1,
      -1,    -1,   196,    -1,    -1,  3916,    -1,    -1,  3919,  3161,
      -1,    -1,    -1,    -1,  3166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,   274,  3938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3947,    -1,    -1,   233,
     288,    -1,    -1,   291,  3955,    -1,  3957,    -1,    -1,  3960,
      -1,    -1,    -1,    -1,  3965,  3966,  3967,  3968,    -1,    -1,
    3971,  3972,  3973,  3974,  3975,  3976,  3977,  3978,  3979,  3980,
      -1,    -1,    -1,  3984,  3985,  3986,    -1,    -1,    -1,    -1,
     274,    -1,    -1,  3994,    -1,    -1,    -1,    -1,  3999,    -1,
      -1,    -1,  4003,    -1,   288,    24,    -1,   291,  4749,    -1,
    4011,    30,    -1,  4014,    -1,  4016,    -1,    -1,    -1,    -1,
    4761,    -1,    -1,    -1,    -1,  4026,    -1,    -1,  4029,  4030,
      -1,    -1,    -1,  4034,  4035,    -1,    -1,    -1,  4039,    -1,
    4041,    -1,    -1,   381,    -1,    -1,    -1,  4048,  4049,  4050,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4068,  4069,  4070,
      -1,  4072,  4073,    -1,    -1,  4076,    -1,    -1,    -1,  4080,
      -1,    -1,    -1,  4084,    -1,    -1,    -1,    -1,    -1,  4090,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,  4116,    -1,    -1,    -1,   138,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1468,    -1,  4136,  4137,  4138,    -1,    -1,
    4141,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,   168,
    3006,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,   502,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    27,    -1,    -1,  4176,  4177,    -1,    -1,    -1,
      -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4471,    -1,  4195,  4474,    -1,   481,    -1,    -1,
      -1,  1536,    -1,    -1,    -1,   489,   490,   491,   492,   493,
     494,   495,   496,   497,    -1,    -1,    -1,    -1,   502,    -1,
      -1,    -1,    -1,    78,    79,  3467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3475,    -1,    -1,  4515,    -1,    -1,    94,
      -1,    -1,  1577,    -1,    -1,    -1,    -1,  4988,   267,    -1,
      -1,    -1,   271,    -1,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   290,    -1,    -1,    -1,  1610,    -1,    -1,    -1,    -1,
      -1,   136,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   156,  4303,  3159,    -1,  2528,  3162,    -1,  3164,  3165,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,   342,    -1,    -1,   345,   346,  3570,    -1,
    3572,    -1,    -1,    -1,    -1,  4336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,  5089,  4350,
    5091,  4352,    -1,    -1,  1689,  1690,  1691,   376,  4359,    -1,
      -1,    -1,    -1,    -1,  4365,    -1,    -1,    -1,    -1,    -1,
     225,    -1,    -1,    -1,    -1,  4376,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4391,    -1,   247,    -1,    -1,  4396,  4397,    -1,    -1,    -1,
      -1,    -1,    -1,  4404,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4413,  4692,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4423,    -1,  3666,   444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4435,  4436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4446,    -1,    -1,    -1,    -1,
      -1,    -1,  2675,    -1,  4733,  4734,  4457,  4458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1800,  3708,    -1,   323,   324,
      -1,    -1,   327,    -1,  4475,    -1,  1811,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4487,    -1,  4489,    -1,
      -1,    -1,  1827,    -1,  3350,    -1,    -1,  3353,    -1,   354,
      -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,  2734,    -1,    -1,    -1,   370,    -1,    -1,   373,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4528,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,  4539,    -1,
      -1,    -1,    -1,  3399,   399,  1880,  3402,  4826,  4827,    -1,
     405,    -1,    -1,   408,    -1,    -1,    -1,   412,    -1,    -1,
    1895,    -1,  3804,  1898,  1899,    -1,  4567,    -1,    -1,  4570,
      -1,    -1,   427,    -1,    -1,    -1,    -1,  4578,  4579,    -1,
      -1,    -1,    -1,    -1,  4585,  4586,    -1,    -1,    -1,  4590,
      -1,  2814,    -1,  4594,  1929,  1930,  4597,  4598,   453,    24,
      -1,  4602,  4603,    -1,    -1,    30,  3848,  4608,  4609,  4610,
    4611,  4612,    -1,    -1,    -1,  2838,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4625,    -1,    -1,  4628,    -1,    -1,
      -1,  4632,    -1,    -1,    -1,    -1,  4637,    -1,    -1,  4640,
    4641,    -1,  4643,    -1,  4645,    10,    -1,  4648,    13,  4650,
      75,    -1,    17,    18,    19,    -1,    -1,    -1,  4659,    -1,
    4661,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,  4673,    -1,    -1,  4676,    -1,  4956,    -1,    44,
    4959,  4960,  2905,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2033,  3941,
      -1,  2036,    -1,    -1,    -1,    -1,   131,    -1,  4987,  4710,
      -1,    -1,    77,   138,    -1,    -1,   141,    -1,    -1,  2942,
      -1,  2944,  3964,  2946,  2947,  4726,  2061,    -1,  2951,  2952,
    2953,    -1,  2955,  2956,  2957,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,  3989,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4777,   202,    -1,    -1,
    4781,    -1,  4783,    -1,    -1,    -1,  3009,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,  4805,    -1,    -1,    -1,    -1,    -1,
      -1,  3034,    -1,    -1,    -1,    34,    -1,    -1,    -1,  4820,
      -1,    -1,    -1,    -1,    -1,    44,   191,    -1,    -1,    -1,
      -1,   196,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   267,    24,    -1,    -1,   271,    -1,    -1,    30,
    4851,    -1,    -1,   218,   219,    -1,   281,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,   290,  4867,    -1,   233,    -1,
      -1,    -1,    -1,  4874,    -1,    -1,    -1,   302,    -1,    -1,
      -1,    -1,  4883,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    -1,  4898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
    4911,    -1,  4913,    24,    -1,    -1,    -1,   342,    -1,    30,
     345,   346,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4939,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4950,
     131,   376,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
     141,    -1,    -1,    -1,    75,  4966,    -1,    -1,    -1,    -1,
    4971,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5737,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,  5006,    -1,    61,  5009,    -1,
      -1,  5012,  5013,  5014,   233,    -1,   381,    -1,    -1,   444,
     131,   202,    -1,   696,    -1,    -1,    -1,   138,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,  5037,  5038,    -1,    -1,
    5041,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,   722,
      -1,    -1,    -1,    -1,    -1,   274,    -1,   168,    -1,    -1,
    5061,    -1,    -1,    -1,    -1,    -1,  5067,    -1,    -1,   288,
    5071,    -1,   291,    -1,  5075,    -1,    -1,  5078,    -1,  5080,
      -1,    -1,    -1,  5362,    -1,    -1,   267,    -1,    -1,    -1,
     271,   202,  3315,    -1,  5095,  5096,  5097,    -1,  5099,    -1,
     281,    -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,
      -1,   302,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,  5414,    -1,   502,    -1,   193,
    4382,    -1,    -1,    -1,    -1,  5146,  5147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,
     271,   342,   381,    -1,   345,   346,    -1,    -1,    -1,    -1,
     281,    -1,    -1,    -1,    -1,   229,  2511,    -1,    -1,   290,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,  5193,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,   874,    -1,    -1,  5205,    -1,    -1,    -1,    -1,  5210,
      -1,    -1,    -1,   267,  5215,    -1,    -1,   271,    -1,    -1,
      -1,    -1,    -1,  5224,  4080,    -1,    -1,    -1,  4084,    -1,
      -1,   342,    -1,  5234,   345,   346,    -1,  5238,    -1,    -1,
    5241,  3464,    -1,    -1,    -1,    -1,    -1,    -1,   302,   303,
      -1,  5252,  5253,  5254,  5533,    -1,   310,    -1,    -1,    -1,
      -1,    -1,   481,   444,    -1,   376,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
    4136,    -1,  5283,   502,  5285,    -1,    -1,    -1,   342,    -1,
      -1,    -1,   346,    -1,    -1,  5296,    -1,   351,    -1,  5300,
      -1,  5302,    -1,    -1,    -1,    -1,   360,    -1,    -1,    -1,
      -1,    -1,  2647,    -1,   368,    -1,  2651,  2652,    -1,  3542,
      -1,  5322,   376,    -1,  5325,    -1,    -1,    -1,  5329,    -1,
      -1,    -1,    -1,   444,   388,  5336,    -1,    -1,    -1,    -1,
      -1,    -1,  5343,   397,    -1,    52,    -1,   401,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5372,    -1,  1046,  2709,    -1,    -1,  3600,    -1,    -1,
    2715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1062,
      -1,    -1,    -1,    -1,    -1,    -1,  5397,    -1,    -1,    -1,
      -1,   455,  5403,  5404,    -1,    -1,    -1,  5408,  5409,  5410,
    5411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2756,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5439,    -1,
      -1,    -1,    -1,    -1,    -1,  3668,  5447,    -1,    -1,    -1,
      -1,    -1,  4694,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5472,    -1,    -1,  5475,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
    4732,  3714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
    5501,    -1,    -1,  3726,  3727,    -1,    -1,    -1,    -1,    44,
      -1,    -1,  4754,  3736,    -1,    -1,    51,    -1,  3741,    -1,
    3743,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5534,    -1,    -1,    -1,    -1,    -1,  5540,
    4396,  4397,    77,  5544,    -1,    -1,    -1,  5548,    -1,    -1,
    5551,    -1,  1225,    -1,    -1,    -1,    -1,    -1,    -1,  5560,
      -1,  5562,    -1,  5564,  5565,    -1,  3789,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5575,    -1,  5577,    -1,    -1,    -1,
      -1,    -1,    -1,  4825,    -1,  5586,    -1,  5866,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2933,    -1,
      -1,  3824,  3825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,   208,    -1,
    5621,  5622,    -1,    -1,    -1,   215,    -1,   217,   218,    -1,
    2965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5652,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,  5666,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5678,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1367,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,  3038,  4946,    -1,    -1,  3042,    -1,  5710,
    5711,  5712,    -1,    -1,    -1,    -1,    -1,  5718,    -1,    -1,
      -1,  5722,    -1,    -1,    -1,    -1,    -1,  5728,    -1,    -1,
      -1,    -1,    -1,  5734,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5750,
      -1,    -1,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5765,    -1,    -1,    -1,    -1,  4625,
      -1,  5772,    -1,    -1,    -1,    -1,  4632,    -1,    -1,    -1,
      -1,  4637,    -1,    -1,  4640,  4641,    -1,  4010,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1468,  5797,    -1,    -1,    -1,
      -1,    -1,    -1,  5804,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3146,    -1,  5814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5823,  5824,  5825,    -1,  3161,    -1,  5829,    -1,
      -1,  3166,  5833,  5834,    -1,  5077,    -1,    -1,    -1,    -1,
      -1,    -1,  5843,  5844,  5845,    -1,   381,    -1,    -1,  5850,
    5851,    -1,    -1,    -1,    -1,  5856,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5877,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1577,  5906,  5907,  5908,    -1,    -1,
      -1,  5912,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,
    5951,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,  5964,    -1,    -1,    -1,   502,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   696,
      -1,  4214,    -1,    -1,    -1,  5996,    -1,    -1,    -1,    -1,
    6001,  6002,  6003,  6004,  6005,    -1,    -1,  6008,    -1,    -1,
      -1,  4867,    -1,    -1,    -1,   722,    -1,  4240,    -1,  6020,
      -1,    -1,  6023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4255,    -1,    -1,  4258,    -1,  4260,    -1,    -1,
      -1,    -1,  4898,   633,    -1,  6046,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   652,    -1,  6065,  6066,    -1,    -1,   658,  6070,
      -1,    -1,    -1,  6074,  3409,    -1,    -1,  3412,    -1,  3414,
     670,    -1,    -1,  4306,  3419,  6086,  6087,    -1,    -1,  6090,
      -1,    -1,    -1,    -1,    -1,    -1,   686,    -1,    -1,  4322,
      -1,    -1,    -1,    -1,  4327,    -1,    -1,    -1,    -1,    -1,
     700,   701,    -1,    -1,    -1,    -1,    -1,   707,    -1,   709,
     710,    -1,    -1,    -1,    -1,    -1,    -1,  1800,    -1,    -1,
      -1,    -1,  3467,   723,    -1,    -1,    -1,    -1,  1811,    -1,
    3475,    -1,    -1,   733,    -1,  5387,    -1,    -1,    -1,    -1,
    5392,  5393,    -1,    -1,  1827,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3500,    -1,   874,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4426,    -1,   795,  4429,  1880,    -1,    10,
      -1,    -1,    13,    -1,    -1,  5071,    17,    18,    19,    -1,
      -1,    -1,  1895,    -1,    -1,  1898,  1899,    -1,    -1,    -1,
      -1,    -1,    -1,    34,   824,  3570,    -1,  3572,    -1,  5095,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,  1929,  1930,    -1,   849,
      -1,    -1,    -1,    -1,  5506,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5146,    -1,    -1,    -1,  4517,  4518,  4519,  4520,    -1,  4522,
    4523,  4524,  4525,  4526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5555,    -1,    -1,    -1,    -1,    -1,   909,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1035,    -1,
      -1,  3666,    -1,    -1,    -1,    -1,    -1,  5193,    -1,  1046,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1062,    -1,    -1,  3693,    -1,
      -1,    -1,    -1,    -1,  3699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2061,     0,
     191,    -1,    -1,    -1,  4617,   196,  4619,    -1,  5254,    -1,
      -1,  3736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    30,
      -1,    32,    33,    -1,    -1,    -1,    -1,  5283,    -1,  1019,
      -1,    -1,   233,    -1,    -1,  1025,    -1,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,  1036,    -1,    -1,    60,
    1040,    -1,  1042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    -1,    74,    75,    -1,  5322,    -1,    -1,  3804,
      81,    -1,    83,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    -1,    97,   288,    -1,    -1,
     291,  3826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,  3848,    -1,    -1,    -1,    -1,  1225,    -1,
      -1,   132,    -1,   134,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    10,    -1,   144,    13,    -1,    -1,    -1,    17,    18,
      19,   152,    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,
     161,    -1,    -1,    -1,    -1,    34,    -1,    -1,  1148,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,   178,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     381,    -1,    -1,    -1,   195,    -1,    -1,    -1,    -1,    -1,
      -1,  5447,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,
    4823,  4824,    -1,    -1,    -1,    -1,  3941,    -1,    -1,    -1,
      -1,    -1,    -1,  4836,    -1,  4838,  4839,  4840,    -1,  5475,
      -1,  1211,    -1,    -1,   235,   236,    -1,    -1,    -1,  3964,
     241,    -1,    -1,    -1,    -1,    -1,    -1,  1227,    -1,    -1,
      -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,    -1,
      -1,  1241,    -1,    -1,  3989,  1245,    -1,    -1,    -1,    -1,
      -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     481,  4904,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,   310,
      -1,   502,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
    4943,   332,    -1,    -1,    -1,    -1,    -1,   338,   339,    -1,
     341,    -1,    -1,    -1,    -1,   346,    -1,    -1,    -1,   218,
     219,   352,    -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,
      -1,   362,    -1,    -1,   233,    -1,    -1,   368,   369,    -1,
      -1,  1468,    -1,    -1,    -1,   376,    -1,    -1,    -1,   380,
      -1,    -1,    -1,  4996,  1364,    -1,    -1,    -1,    -1,   390,
      -1,    -1,  1372,  1373,    -1,    -1,    -1,    -1,    -1,  4124,
      -1,    -1,    -1,    -1,   405,   274,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,   288,
    5666,    -1,   291,    -1,   425,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5678,    34,    -1,   436,    -1,    -1,    -1,  1536,
      -1,   442,    -1,    44,    -1,  1425,   447,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   460,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,
    1577,    -1,   483,   484,   485,   486,   487,   488,    -1,  4214,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     501,    -1,    -1,   504,  5750,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   381,  1610,    -1,  4240,    -1,    -1,    -1,    -1,
      -1,    -1,  5135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,  5814,    -1,
    5183,    -1,    -1,    -1,    -1,    44,    -1,  5823,  5824,  5192,
      -1,    -1,    51,    -1,  2647,    -1,    -1,    -1,  2651,  2652,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,   481,    -1,    -1,    -1,    -1,   218,   219,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,    -1,
      -1,    -1,   233,   502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2709,    -1,    -1,    -1,
      -1,    -1,  2715,    -1,    -1,    -1,    -1,  4382,    -1,    -1,
    5906,    -1,    -1,    -1,    -1,    -1,  5912,    -1,    -1,    -1,
      -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5930,    -1,    -1,   288,    -1,    -1,
     291,    -1,    -1,  2756,  1674,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1800,  4429,    -1,    -1,    -1,    -1,  4434,
      -1,    -1,    -1,    -1,  1811,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
    1827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,    -1,    -1,  6003,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6023,    -1,    -1,
     381,    -1,    -1,  1880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,    -1,
      -1,  1898,  1899,    -1,    -1,   274,  5419,    22,  1788,    -1,
    5423,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,   288,
    6066,    -1,   291,    -1,    -1,    -1,    -1,    -1,  6074,    -1,
      -1,    -1,  1929,  1930,    -1,    -1,    -1,    -1,    -1,    -1,
    6086,  6087,    -1,  1823,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,  4581,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,  1846,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    94,
     481,    -1,  1862,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   112,    -1,    -1,
      -1,   502,  2965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   136,  1902,  1903,    -1,  1905,  1906,    -1,    -1,    -1,
      -1,    -1,   147,    -1,    -1,    -1,    -1,  1917,    -1,  1919,
    1920,   156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1932,  1933,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,  2061,    -1,    -1,    -1,    -1,  4694,
      -1,    -1,    -1,    -1,    -1,  3038,    -1,    -1,    -1,  3042,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,    -1,  1972,    -1,    -1,    -1,  1976,  1977,    -1,    -1,
    5613,    -1,    -1,    -1,  5617,    -1,  5619,  4732,    -1,    -1,
    5623,  5624,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  4754,
      -1,    -1,   247,   502,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    -1,    -1,    -1,    -1,    20,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,  3146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3161,    -1,
    4825,  2081,    -1,  3166,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,
      -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,   373,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,
      -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,
     405,    -1,    -1,   408,    -1,    -1,    -1,   412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,    -1,    -1,
      -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,    -1,  4944,
      -1,  4946,    -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,   205,     0,    -1,    -1,    -1,    -1,   453,    -1,
     213,    -1,    -1,   216,    -1,    -1,   219,   220,    -1,   222,
      -1,   224,    -1,    20,   227,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    32,    33,    -1,    -1,    -1,
    5883,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    74,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    10,
      97,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3409,   114,    -1,  3412,
     117,  3414,  5077,    34,    -1,    -1,  3419,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,   132,    -1,   134,    -1,    -1,
      51,   138,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    -1,   161,    -1,    77,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3467,    -1,    -1,    -1,    -1,    -1,
    5135,   178,  3475,    -1,    -1,    -1,    -1,  6030,    -1,    -1,
      -1,    -1,    -1,  6036,    -1,    -1,    -1,    -1,   195,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6078,    -1,    -1,   235,   236,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6096,    -1,    -1,  6099,    -1,   255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,  3570,    -1,  3572,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5257,    -1,    -1,    -1,    -1,   218,   219,    -1,
      -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,
    2647,   318,   233,    -1,  2651,  2652,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   332,    -1,    -1,    -1,    -1,
      -1,   338,   339,    -1,   341,    -1,    -1,    -1,    -1,   346,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,   355,    -1,
      -1,    -1,    -1,   274,    -1,   362,    -1,    -1,    -1,    -1,
      -1,   368,   369,  3666,    -1,    -1,  2586,   288,    -1,   376,
     291,    -1,  2709,   380,    -1,    -1,    -1,    -1,  2715,    -1,
      -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   405,    -1,
      -1,    -1,    -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,  2756,
    2640,   634,  5387,    -1,    -1,    -1,    -1,  5392,  5393,   436,
      -1,    -1,   645,  3736,    -1,   442,   649,    -1,  2658,    -1,
     447,    -1,  2662,   656,   657,    -1,  2666,   660,    -1,   662,
     663,    -1,    -1,   460,    -1,  2675,    -1,    -1,    -1,    -1,
     381,    -1,    -1,    -1,   677,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2693,    -1,    -1,   483,    -1,    -1,    -1,
      -1,    -1,   695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2710,    -1,  2712,  2713,   501,    -1,    -1,   504,    -1,    -1,
      -1,  3804,    -1,   716,    -1,   718,    -1,  2727,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   728,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3826,    -1,    -1,    -1,  2747,  2748,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5505,  5506,    -1,    -1,    -1,  3848,    -1,    -1,    -1,   762,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2778,  2779,
     481,    -1,  2782,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,   502,    -1,    -1,    -1,    -1,  2806,    -1,  2808,    -1,
    5555,    -1,  2812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,    -1,    -1,
      -1,    -1,    -1,  2833,    -1,    -1,  2836,    -1,    -1,    -1,
      -1,    -1,  2842,    -1,    -1,    -1,    -1,    -1,  2965,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3941,   852,
      -1,    -1,  2862,    -1,    -1,    -1,    -1,    -1,  2868,    -1,
      -1,    -1,    -1,    -1,    -1,  2875,    -1,    -1,    -1,    -1,
      -1,  3964,    -1,    -1,    -1,    10,    -1,    -1,    13,  2889,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2902,    -1,   696,    -1,  3989,  2907,    -1,    34,
      -1,    -1,    -1,  2913,    -1,    -1,    -1,    -1,    -1,    44,
      -1,  3038,    -1,    -1,    -1,  3042,    51,    -1,    -1,    10,
     722,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,   935,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    34,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    44,    -1,    -1,    17,    18,    19,    -1,
      51,    -1,    -1,  2973,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    77,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1009,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,  3146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1033,  4124,    -1,    -1,  3161,    -1,    -1,    -1,    -1,  3166,
      -1,    -1,    -1,    -1,    -1,  1048,    -1,  1050,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,  1060,    -1,    -1,
      -1,   196,    -1,    -1,  1067,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   874,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
     191,    -1,    -1,    -1,    -1,   196,  1109,    -1,  1111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3130,  4214,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
     191,    -1,    -1,    -1,    -1,   196,    -1,    -1,  3148,   274,
      -1,    -1,   233,    -1,    -1,  3155,    -1,  4240,    -1,    -1,
      -1,    -1,  3162,   288,  3164,  3165,   291,   218,   219,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   274,  1187,    -1,  1189,    -1,  1191,    -1,
    1193,    -1,  1195,  1196,  1197,    -1,    -1,   288,    -1,  1202,
     291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1214,    -1,   274,    -1,    -1,    -1,    -1,    -1,  3229,
      -1,    -1,    -1,    -1,    -1,  3235,    -1,   288,    -1,  1232,
     291,    -1,    -1,  1035,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1046,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  3409,    -1,    -1,  3412,    -1,  3414,    -1,  4382,
     381,    -1,  3419,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3315,    44,    -1,    -1,    -1,
    6065,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4429,    -1,    -1,    77,
    3467,  4434,    -1,    -1,    -1,    -1,   481,    -1,  3475,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,    -1,    -1,   502,    -1,    -1,
      -1,    -1,    -1,  3500,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1389,    -1,    -1,    -1,
     481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,   502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     481,    -1,    -1,  1225,  3434,  3435,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,   502,    -1,  3570,    -1,  3572,    -1,    -1,    -1,    -1,
      -1,  3461,    -1,   191,  3464,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  4581,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1510,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3536,  3537,  3538,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,  3666,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,  3561,    -1,   291,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1582,
      10,  3708,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,  3602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4694,    -1,    -1,    34,    -1,    -1,    -1,    -1,  3736,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,  4732,
      -1,    -1,    -1,   381,    -1,    -1,    -1,    77,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,  4754,    -1,    -1,    -1,    51,  1468,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3804,  3688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3826,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3848,    -1,    -1,    -1,  3735,    -1,    -1,    -1,    -1,
      -1,  3741,  4825,  3743,  1536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   481,    -1,    -1,  3756,    -1,  3758,    -1,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,   191,    -1,    -1,   502,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1577,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,  1796,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,   191,    -1,    -1,  1610,    -1,
     196,    -1,    -1,    -1,  3941,  3825,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1831,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,  3964,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,  4946,    -1,    -1,    -1,  3867,   288,    -1,
      -1,   291,  3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1874,    -1,  1876,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3896,    -1,   274,   208,
      -1,    -1,    -1,  1896,    -1,    -1,    -1,    -1,   217,    -1,
      -1,    -1,   288,    -1,    -1,   291,    -1,    -1,  3918,    -1,
      -1,  3921,   231,    -1,    -1,    -1,    -1,    -1,    -1,  1922,
      -1,  1924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1939,    -1,  1941,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1949,    52,  1951,    -1,
    1953,   381,  1955,    10,  1957,    -1,    13,    -1,  1961,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,  5077,    -1,    -1,    44,    -1,    -1,
      -1,  4001,    -1,    -1,    51,   381,    -1,  4124,  1800,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1811,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      77,    -1,    17,    18,    19,  1827,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,  5135,    38,    -1,    -1,    -1,    -1,    -1,    44,
      -1,   481,    -1,    -1,    -1,    -1,    51,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,   502,    -1,    52,    -1,    -1,    -1,  1880,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,  4214,    -1,    -1,
      -1,    -1,    -1,  1895,    -1,   481,  1898,  1899,    -1,    -1,
      -1,    -1,    -1,   489,   490,   491,   492,   493,   494,   495,
     496,   497,    -1,  4240,    -1,    -1,   502,    10,    -1,   696,
      13,    -1,    -1,    -1,    17,    18,    19,  1929,  1930,    -1,
      -1,    -1,    -1,   128,   191,    -1,    -1,    -1,    -1,   196,
      -1,    34,    -1,    -1,    -1,   722,    -1,  4157,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,   218,   219,    -1,  5257,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,  4208,    -1,
      -1,   196,    -1,  4213,    -1,  4215,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,  4239,
      -1,   288,    -1,    -1,   291,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4382,    -1,    -1,    -1,  2061,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,  4285,    -1,    -1,  4288,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   288,  5387,    -1,   291,   874,   191,  5392,
    5393,    -1,  4429,   196,    -1,    -1,    -1,  4434,    -1,    -1,
      -1,    -1,    -1,    -1,   633,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   381,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,   652,    -1,    -1,    -1,    -1,    -1,   658,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   686,  4378,  4379,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4389,
      -1,   274,   701,    -1,    -1,    -1,   381,    -1,    -1,    -1,
     709,    -1,    -1,    -1,    -1,   288,  4406,    -1,   291,    -1,
      -1,    -1,    -1,    -1,   723,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5506,   733,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   315,    -1,   481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,   500,    -1,    -1,   441,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4581,    -1,    -1,    -1,  1035,    -1,
      -1,    -1,  5555,    -1,    -1,    -1,    -1,    -1,    -1,  1046,
      -1,    -1,    -1,    -1,    -1,    -1,   795,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1062,   481,    -1,   381,    -1,
      -1,    -1,  4502,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,   824,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4694,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,
     909,   696,    -1,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  4732,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   722,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4754,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2641,  2642,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2660,  2661,    -1,
    2663,  2664,    -1,    -1,    -1,  2668,  2669,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2683,    -1,    -1,    -1,    -1,    -1,    -1,  2690,    -1,    -1,
      -1,  2694,  2695,    -1,    -1,  2698,  2699,  4707,  4825,    -1,
    1019,    -1,  2705,    -1,    -1,    -1,  1025,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2717,    -1,    -1,    -1,   696,    -1,
      -1,    -1,    -1,    -1,    -1,    10,  2729,    -1,    13,    -1,
      -1,  2734,    17,    18,    19,    -1,    -1,    -1,    -1,  4749,
      -1,    -1,    -1,    -1,   722,    -1,  2749,    -1,    -1,    34,
      -1,  4761,    -1,    -1,    -1,  2758,    -1,    -1,  2761,    44,
    2763,  2764,  2765,    -1,    -1,    -1,    51,  2770,  2771,   874,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2780,    -1,    -1,
      -1,    -1,    -1,  2786,  4794,    -1,    -1,  2790,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,  2802,
    2803,    -1,    -1,    -1,  2807,    -1,    -1,    -1,    -1,    -1,
    2813,  2814,    -1,    10,    -1,    -1,    13,    -1,    -1,  4946,
      17,    18,    19,    -1,  2827,    -1,    -1,  2830,    -1,  1148,
      -1,    -1,    -1,    -1,  2837,  2838,    -1,    34,    -1,    -1,
    2843,    -1,    -1,    -1,    -1,  2647,    -1,    44,    -1,  2651,
    2652,    -1,  2855,    -1,    51,  2858,    -1,    -1,    -1,    -1,
    2863,    -1,  4872,    -1,    -1,    -1,  2869,  2870,    -1,    -1,
      -1,    -1,    -1,    -1,  2877,    -1,    -1,    -1,  2881,    -1,
      77,  4891,  2885,  2886,  2887,  2888,    -1,  2890,    -1,    -1,
      -1,  1468,  1211,    -1,    -1,    -1,   874,    -1,    -1,    -1,
    2903,  2904,    -1,  2906,    -1,    -1,   191,  2709,  1227,    -1,
      -1,   196,    -1,  2715,  2917,  2918,  2919,    -1,    -1,    -1,
      -1,    -1,  1241,    -1,    -1,    -1,  1245,    -1,    -1,    -1,
    1035,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,  1046,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
    5077,    -1,    -1,    -1,  2756,    -1,    -1,  1062,    -1,  1536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     167,  2974,    -1,    -1,    -1,   172,    -1,    -1,  4988,  2982,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,  3001,   196,
    1577,    -1,    -1,   288,    -1,    -1,   291,    -1,  5135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,  1610,    52,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1364,    -1,    -1,  3051,    -1,
      -1,    -1,    -1,  1372,  1373,    -1,    -1,  1035,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3070,  1046,  3072,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,  5089,
      -1,  5091,    -1,    -1,  1062,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,   291,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1425,    -1,    -1,    -1,
      -1,    -1,    -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,
    1225,    -1,    -1,    -1,    -1,    -1,  5136,    -1,    -1,    -1,
    5257,    -1,    -1,    -1,    -1,    -1,  5146,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2965,    -1,  3168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5188,    -1,
      -1,    -1,    -1,  5193,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1800,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1811,    -1,  3038,    -1,    -1,    -1,
    3042,    -1,    -1,    -1,    -1,    -1,    -1,  1225,    -1,    -1,
    1827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5387,    -1,    -1,    -1,    -1,  5392,  5393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,  1880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,    -1,
      -1,  1898,  1899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1929,  1930,    -1,  1674,    -1,    -1,    10,  3161,
      -1,    13,    -1,  1468,  3166,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5506,
      -1,    -1,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,  5405,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5419,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,  5555,    -1,
      -1,  1536,    -1,    -1,    34,    -1,    -1,    -1,    -1,  3442,
    5450,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3462,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1788,
      -1,    -1,  1577,    -1,    -1,    -1,  3479,    77,    -1,    -1,
    3483,    -1,    -1,    -1,  2061,  3488,  3489,  3490,    -1,    -1,
    1468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1823,  1610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3524,  3525,  3526,  3527,    -1,    -1,  1846,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,   191,
      -1,    -1,  5552,  1862,   196,    -1,    -1,    -1,    -1,    -1,
      -1,  3554,    -1,    -1,    -1,    -1,    -1,    -1,  1536,  3562,
      -1,  3564,  3565,  3566,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,  1905,  1906,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,  1577,
    1919,  5611,    -1,  5613,    -1,    -1,    -1,  3409,    -1,    -1,
    3412,    -1,  3414,  1932,  1933,    -1,    -1,  3419,   218,   219,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1610,   233,    -1,    -1,   288,    -1,    -1,   291,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,  3467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3475,   274,    -1,    -1,  3680,   696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3689,    -1,   288,    -1,
      -1,   291,    -1,    -1,    -1,  1800,    65,    -1,  3500,    -1,
      -1,    -1,    -1,    -1,   722,    -1,  1811,    -1,    -1,    78,
      -1,   311,  3715,  3716,    -1,    -1,    -1,  3720,    -1,    -1,
      -1,    -1,  1827,    -1,    -1,    94,    -1,  5737,    -1,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3742,
    5750,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5763,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2081,    -1,    -1,    -1,    -1,   136,  3570,    -1,
    3572,    -1,    -1,    -1,    -1,  1880,    -1,    -1,   147,    -1,
      -1,   381,    -1,    -1,    -1,    -1,    -1,   156,    -1,    -1,
    1895,  3794,    -1,  1898,  1899,    -1,  3799,    -1,    -1,    -1,
     169,    -1,  3805,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,   181,  5823,  5824,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1800,    -1,  1929,  1930,    -1,    -1,    -1,   481,
      -1,   200,  3835,  1811,    -1,    -1,    -1,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,    -1,    -1,  1827,
      -1,    -1,    -1,    -1,    -1,    -1,   874,    -1,    -1,    -1,
      -1,  3864,    -1,  3866,  3666,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5883,    -1,    -1,    -1,    -1,   247,    -1,
      -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,    -1,
      -1,    -1,  1880,    -1,    -1,    -1,  3708,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3917,    -1,    -1,  1895,    -1,   288,
    1898,  1899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   301,    -1,  3736,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,   209,    -1,
      -1,  1929,  1930,    -1,   323,   324,  2061,    -1,   327,    -1,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,   357,    -1,
      -1,    -1,   361,    -1,   363,    -1,    -1,    -1,    -1,    -1,
      -1,   370,  3804,    -1,   373,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1035,    -1,    -1,
    6030,    -1,    -1,   392,  3826,    -1,    -1,    -1,  1046,    -1,
     399,    -1,    -1,    -1,    -1,    -1,   405,    -1,    -1,   408,
      -1,    -1,    -1,   412,  1062,    -1,  3848,    -1,    -1,    -1,
      -1,   420,    -1,   422,    -1,    -1,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6078,    -1,
    2647,   440,    -1,    -1,  2651,  2652,  6086,  6087,    -1,    -1,
      -1,    -1,    -1,  2061,   453,    -1,  6096,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2709,    -1,    -1,    -1,    -1,  4140,  2715,  3941,
    4143,    -1,  4145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4158,    -1,    -1,    -1,    -1,
      -1,    -1,  3964,    -1,    -1,    -1,    -1,  4170,    -1,    -1,
      -1,  4174,    -1,    -1,    -1,    -1,    -1,    10,    -1,  2756,
      13,    -1,    -1,    -1,    17,    18,    19,  3989,    -1,    -1,
    4193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    -1,    -1,  1225,  4211,    -1,
      -1,    44,    -1,    -1,  4217,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4242,
      -1,    -1,    -1,  4246,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4261,  4262,
    4263,  4264,    -1,    -1,    -1,    -1,    -1,  2586,  4271,  4272,
    4273,  4274,    -1,    -1,    -1,    -1,    -1,  4280,  4281,    -1,
      -1,    -1,    -1,  4286,  4287,    -1,  4289,  4290,  4291,  4292,
    4293,  4294,  4295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4305,    -1,    -1,    -1,  4309,  4310,  4311,  4312,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2640,  4124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2658,
      -1,    -1,    -1,  2662,    -1,    -1,    -1,  2666,  4351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2675,    -1,   191,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   634,  2693,    -1,    -1,    -1,    -1,   640,
      -1,    -1,    -1,    -1,    -1,   218,   219,    -1,  2965,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2727,    -1,
      -1,    -1,  4214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4427,    -1,    -1,    -1,  2747,  2748,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4240,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1468,    -1,    -1,    -1,    -1,   288,    -1,  4460,   291,  2778,
    2779,  3038,    -1,  2782,  4467,  3042,  4469,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2806,    -1,  2808,
      -1,    -1,    -1,  2812,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4506,    -1,    -1,    -1,  2826,    -1,    -1,
      -1,    -1,    -1,    -1,  2833,    -1,    -1,  2836,  1536,    -1,
      -1,    -1,    -1,  2842,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2647,  2862,    -1,    -1,  2651,  2652,   381,  2868,
      -1,    -1,    -1,    -1,    -1,    -1,  2875,    -1,    -1,  1577,
     821,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3146,
    2889,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   840,
    4382,    -1,    -1,  2902,  3161,    -1,    -1,    -1,  2907,  3166,
      -1,    -1,  1610,    -1,  2913,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,    -1,    -1,    -1,    -1,
    2715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4429,    -1,    -1,
      -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,   910,
      -1,  2756,    -1,    -1,  2973,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,  2647,
      -1,    -1,    -1,  2651,  2652,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4695,  4696,  4697,    -1,   957,    -1,  4701,  4702,
    4703,  4704,    -1,    -1,    -1,  4708,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2709,    -1,    -1,    -1,    -1,    -1,  2715,    -1,    -1,
      -1,  4744,  4745,  4746,  4747,  4748,    -1,  4750,  4751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4762,
    4763,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2756,  4581,
      -1,    -1,  1800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4795,  1811,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1827,
    1071,  3130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3148,
      -1,    -1,  3409,    -1,    -1,  3412,  3155,  3414,  1099,  1100,
    1101,    -1,  3419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2965,    -1,  1880,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,    -1,    -1,
    1898,  1899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3467,    -1,  4694,    -1,  4897,    -1,    -1,    -1,  3475,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3229,  1929,  1930,    -1,    -1,    -1,  3235,    -1,    -1,    -1,
      -1,    -1,    -1,  3500,    -1,    -1,    -1,    -1,    -1,    -1,
    4732,    -1,    -1,  3038,    -1,    -1,    -1,  3042,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1210,
      -1,    -1,  4754,    -1,    -1,    -1,    -1,    -1,    -1,  4962,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2965,    -1,    -1,
      -1,    -1,    -1,  3570,    -1,  3572,  3315,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4825,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,  3146,    51,  2061,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3161,    -1,    -1,    -1,
    3038,  3166,    -1,    -1,  3042,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3666,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3434,  3435,  1378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3708,    -1,    -1,  5137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3461,    -1,  4946,  3464,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5156,    -1,    -1,    -1,    -1,    -1,  3736,
      -1,  5164,  5165,   172,    -1,    -1,    -1,    -1,  3146,    -1,
      -1,  5174,    -1,    -1,    -1,    -1,    -1,    -1,  5181,    -1,
      -1,    -1,   191,  3161,    -1,    -1,    -1,   196,  3166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,  5216,  5217,    -1,    -1,  3536,  3537,  3538,
      -1,    -1,    -1,    -1,   233,    -1,  5229,  3804,  5231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3561,  5246,    -1,    -1,    -1,    -1,    -1,  3826,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3580,    -1,    -1,    -1,   274,    -1,    -1,  5271,    -1,
      -1,  3848,    -1,    -1,    -1,  5077,    -1,    -1,    -1,   288,
      -1,  1542,   291,  3602,    -1,    -1,  5289,    -1,    -1,    -1,
    1551,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3409,    -1,    -1,  3412,    -1,  3414,
      -1,    -1,    -1,    -1,  3419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1583,    -1,    -1,    -1,    -1,    -1,  1589,  1590,
      -1,    -1,  1593,  5135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1606,    -1,    -1,  1609,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3467,    -1,  3941,    -1,    -1,    -1,    -1,  3688,
    3475,    -1,   381,  5376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5386,    -1,    -1,    -1,  3964,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1664,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3989,    -1,    -1,    -1,  3735,  1678,    -1,    -1,
      -1,    -1,  3741,    -1,  3743,    -1,    -1,    -1,    -1,    -1,
      -1,  3409,    -1,    -1,  3412,    -1,  3414,  3756,    -1,  3758,
      -1,  3419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5453,    -1,    -1,    -1,    -1,  5257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3570,    -1,  3572,    -1,    -1,
      -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  3467,
      -1,    -1,    -1,    10,    -1,    -1,    13,  3475,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,  3825,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,  5524,  3500,    -1,    -1,  5528,  1787,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,  1798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4124,  3867,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      77,  3666,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3896,    -1,  1840,
    1841,  5584,    -1,    34,    -1,  5387,    -1,    -1,    -1,    -1,
    5392,  5393,  3570,    44,  3572,  5598,    -1,    -1,    -1,  3918,
      51,    -1,  3921,  3708,  1865,    -1,    -1,    -1,    -1,    -1,
      -1,  1872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,  2647,
      -1,  3736,    -1,  2651,  2652,    -1,    -1,  4214,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5657,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4240,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
      -1,    -1,  4001,  1944,    -1,    -1,  1947,    -1,  3666,    -1,
      -1,  2709,    -1,    -1,    -1,    -1,    -1,  2715,    -1,  3804,
      -1,   218,   219,    -1,  5506,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,  1979,  1980,
      10,  3826,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
    3708,    -1,    -1,    -1,    -1,  1996,    -1,    -1,  2756,    -1,
     191,    -1,    -1,  3848,    34,   196,  5749,    37,    -1,    -1,
      -1,    -1,    -1,  5555,    44,    -1,    -1,   274,  3736,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
      -1,   288,    -1,    -1,   291,    -1,    -1,    -1,  5781,    -1,
      -1,    -1,   233,    -1,    -1,    -1,    -1,    77,    -1,  5792,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4382,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,   274,    -1,    -1,  3804,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,  3941,   288,  4157,    -1,
     291,    -1,    44,    -1,    -1,    -1,    -1,    -1,  3826,    51,
      -1,    -1,  4429,    -1,    -1,    -1,    -1,  4434,    -1,  3964,
      -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,
    3848,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3989,    -1,    -1,    -1,    -1,  4208,
      -1,    -1,    -1,  5896,  4213,    -1,  4215,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4239,    -1,   818,   819,    -1,    -1,    -1,    -1,   218,   219,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,  2965,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   413,  3941,   481,    -1,  4285,    -1,    -1,  4288,
     172,    -1,   489,   490,   491,   492,   493,   494,   495,   496,
     497,    -1,    -1,    -1,   274,    -1,  3964,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,   288,    -1,
     896,   291,    -1,    -1,  4581,    -1,    -1,    -1,    -1,    -1,
      -1,  3989,    -1,    -1,    -1,    -1,   218,   219,    -1,  4124,
    3038,    -1,    -1,    -1,  3042,    -1,    -1,    -1,    -1,    -1,
     481,   233,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,  4378,
    4379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4389,    34,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,   288,  4406,    51,   291,
      -1,   381,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,  4214,
      -1,    -1,    -1,    -1,    77,    -1,    -1,  4694,    -1,    34,
      -1,  1017,  1018,    -1,    -1,    -1,    -1,    -1,  3146,    44,
      -1,    -1,    -1,    -1,    -1,  4240,    51,    -1,    -1,    -1,
      -1,    -1,    -1,  3161,    -1,    -1,  4124,    -1,  3166,    -1,
      -1,    -1,    -1,    -1,    -1,  4732,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4754,    -1,   381,
      -1,    -1,    -1,  4502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   481,    -1,    -1,    -1,    -1,    -1,  1332,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    -1,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,    -1,    -1,  4214,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2508,  4825,    -1,
      -1,  1386,   167,    -1,    -1,   218,   219,  2518,    -1,    -1,
      -1,    -1,  4240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,   191,  4382,    -1,   481,
      -1,   196,    -1,    -1,    -1,    -1,  2547,   489,   490,   491,
     492,   493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    -1,  4429,   288,    -1,    -1,   291,  4434,
      -1,    -1,    -1,  2594,  2595,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,  1257,    -1,    -1,    -1,    -1,    -1,  2628,    -1,  4946,
      -1,    -1,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4707,    -1,
      -1,  3409,  1288,    -1,  3412,    -1,  3414,    -1,    -1,    -1,
      -1,  3419,    -1,    -1,  4382,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,   381,    -1,
    1316,  1317,  1318,    -1,  1320,    -1,    -1,    -1,    -1,    -1,
    4749,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,  4761,    -1,  1340,    -1,    -1,    -1,    51,  3467,
      -1,  4429,    -1,    -1,    -1,    10,  4434,  3475,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,  4794,  4581,    -1,    -1,    34,
      -1,    -1,  3500,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,  2760,
    5077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,   481,    -1,
      -1,    -1,    77,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,  2797,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,  1442,    -1,    -1,    -1,
    1446,  1447,  3570,  4872,  3572,    -1,    -1,    -1,  5135,    -1,
    1695,    -1,    -1,    -1,  1699,    -1,   481,    -1,    -1,    -1,
      -1,    -1,  4891,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,    -1,    -1,    -1,   191,  4694,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4581,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,    -1,  2883,  2884,    -1,    -1,    -1,  4732,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    10,    -1,    -1,    13,    -1,  3666,  4754,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    34,    -1,  4988,
      -1,   274,    -1,    -1,    -1,    -1,    -1,    44,   233,    -1,
    5257,    -1,    -1,    -1,    51,   288,    -1,    -1,   291,    -1,
    3708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,  4694,    -1,  3736,   274,
    4825,    -1,    10,  2984,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,   288,    -1,    -1,   291,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4732,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
    5089,    -1,  5091,    -1,    -1,    -1,  4754,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3804,    -1,    -1,    77,
      -1,    -1,    -1,  1689,  1690,  1691,    -1,    -1,    -1,    -1,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3826,    -1,
    5387,    -1,    -1,    -1,    -1,  5392,  5393,  5136,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,   381,    -1,    -1,   196,
    3848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4946,    -1,    -1,    -1,    -1,    -1,  4825,    -1,    -1,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,  5188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,
    2015,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  2030,    -1,    -1,    -1,  2034,
      -1,   456,    -1,   191,    -1,    -1,    -1,   274,   196,    -1,
      -1,    -1,    -1,    -1,  2049,  2050,  2051,    -1,  2053,    -1,
      -1,   288,    -1,  3941,   291,    -1,   481,    -1,    -1,  5506,
     218,   219,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,    -1,    -1,   233,  3964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,
      -1,  3989,  5077,    -1,    -1,    -1,    -1,    -1,  5555,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,   291,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5405,    -1,    -1,    -1,
      -1,    -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,  5077,
    5419,    -1,    -1,    -1,    -1,    -1,  4124,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,
      -1,  2017,   489,   490,   491,   492,   493,   494,   495,   496,
     497,  5450,    -1,  2029,    -1,  2031,    -1,  2033,    -1,    -1,
    2036,  2037,  2038,    -1,    -1,    -1,    -1,    -1,  2044,    -1,
      -1,  2047,  5257,    -1,    -1,    -1,    -1,  5135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2062,  2063,  2064,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2079,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   481,    -1,    -1,  4214,    -1,    -1,    -1,
      -1,   489,   490,   491,   492,   493,   494,   495,   496,   497,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5257,
      -1,    -1,  5387,    -1,    -1,    -1,    -1,  5392,  5393,    -1,
      -1,    -1,  5611,    -1,  5613,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2222,  3588,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4382,    22,  2262,    -1,    -1,    -1,
      27,    -1,  2507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5506,    -1,    -1,    -1,    -1,    -1,    -1,    65,  5387,
      -1,  4429,    -1,    -1,  5392,  5393,  4434,    -1,  5737,  2315,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    -1,    -1,
      -1,    -1,    -1,    -1,  5763,    -1,    -1,    -1,    -1,    -1,
    5555,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2601,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2613,   136,
      -1,    -1,    -1,  2618,    -1,    -1,  3747,  3748,  3749,    -1,
     147,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,   156,
      -1,    -1,    -1,  3764,    30,    -1,    32,    33,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5506,    -1,
      -1,    -1,    -1,    -1,    60,    -1,  3797,  3798,    -1,    -1,
      -1,  3802,    -1,   200,    -1,    -1,    72,    -1,    74,    75,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,
      -1,    -1,    -1,  4581,  5883,    -1,    -1,    -1,   225,    95,
      -1,    97,    -1,    -1,    -1,    -1,    -1,  5555,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     247,   117,    -1,    -1,  2490,  2491,  2492,  2493,  2494,  2495,
    2496,  2497,  2498,    22,  2500,    -1,   132,    -1,   134,    -1,
      -1,    -1,   138,  2509,    -1,  2511,    -1,    -1,   144,    -1,
      -1,    40,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,
      -1,   288,    -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,   178,  2549,    -1,  3916,   313,  2553,  3919,    78,
    2556,    -1,  2558,    -1,    -1,  2561,   323,   324,    -1,   195,
     327,    -1,    -1,    -1,    -1,    94,  4694,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,   354,    -1,   118,
     357,    -1,    -1,    -1,   361,    -1,   363,    -1,    -1,   235,
     236,  6030,    -1,   370,  4732,   241,   373,   136,  2614,  2615,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,   255,
      -1,    -1,    -1,    -1,    -1,   392,  4754,   156,    -1,    -1,
      -1,    -1,   399,    -1,    -1,    -1,    -1,   273,   405,    -1,
     169,   408,    -1,    -1,    -1,   412,    -1,    -1,   177,  6078,
      -1,    -1,   181,   420,    -1,   422,    -1,    -1,    -1,    -1,
     427,    -1,    -1,    -1,    -1,    -1,    -1,  6096,    -1,    -1,
      -1,   200,    -1,    -1,   310,    -1,    -1,  4048,  4049,  4050,
      -1,    -1,   318,    -1,    -1,    -1,   453,    -1,    -1,    -1,
    2696,    -1,    -1,    -1,    -1,    -1,   332,  4825,    -1,    -1,
      -1,    -1,   338,   339,    -1,   341,    -1,    -1,   237,    -1,
     346,    -1,    -1,   349,    -1,    -1,   352,    -1,   247,   355,
      -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,
      -1,    -1,   368,   369,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,    -1,   288,
      -1,    -1,   291,    -1,    -1,    -1,    -1,    -1,    -1,   405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   313,    -1,    -1,    -1,    -1,   425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,
     436,    -1,    -1,    -1,    -1,   334,   442,    -1,    -1,    -1,
      -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,  4946,    -1,
      -1,    -1,    -1,    -1,   460,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   363,    -1,    -1,    -1,    -1,    -1,
      -1,   370,    -1,    -1,   373,    -1,    -1,   483,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   392,    -1,   501,    -1,    -1,   504,    -1,
     399,    -1,    -1,    -1,    -1,    -1,   405,    -1,    -1,   408,
     409,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,   437,    -1,
      -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,  2931,  2932,  2933,    -1,    -1,
      -1,  2937,  3177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5077,
      -1,    -1,  3197,  3198,    -1,  3200,    -1,    -1,  2964,    -1,
    3205,  3206,    -1,  3208,    -1,  3210,    -1,    -1,    -1,  3214,
      -1,    -1,  3217,    -1,    -1,    -1,    -1,  3222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3231,    -1,  4359,    -1,
      -1,  3236,    -1,    -1,    -1,    -1,    -1,    -1,  3243,  3244,
    3245,  3246,    -1,    -1,    -1,  3250,  3251,  5135,  3253,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
    4391,    -1,    -1,    -1,    -1,  3270,    -1,  3272,    -1,    -1,
      -1,    -1,    -1,    -1,  3279,  3280,  3281,  3282,  3283,  3284,
    3285,  3286,  3287,  3288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3323,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    -1,  4458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,    -1,  4475,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,  5257,
      -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,  3174,   181,
      -1,    -1,    -1,  3179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3455,    -1,  3218,   225,  3220,  3221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3234,    -1,
      -1,  3237,    -1,  3239,    -1,   247,    -1,    -1,  4609,  4610,
    4611,  4612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5387,
      -1,    -1,    -1,    -1,  5392,  5393,    -1,  3273,    -1,  3275,
      -1,  3277,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,   324,    -1,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   354,    -1,    -1,   357,    -1,    -1,    -1,   361,
      -1,   363,    -1,    -1,    -1,    -1,    -1,    -1,   370,  3365,
      -1,   373,    -1,    -1,  3370,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5506,  3385,
     392,    -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,
      -1,    -1,   404,   405,    -1,    -1,   408,    -1,    -1,    -1,
     412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,    -1,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5555,   440,    -1,
      -1,    -1,    -1,    -1,  3440,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3697,  3698,    -1,    -1,    -1,  3702,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3731,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4939,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4950,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3693,    -1,    -1,
      -1,    -1,  3937,  3699,    -1,    -1,    -1,    -1,  3943,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3961,  3962,    -1,    -1,
    3965,  3966,  3967,  3968,    -1,    -1,  3971,  3972,  3973,  3974,
    3975,  3976,  3977,  3978,  3979,  3980,  3981,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4004,
      -1,    -1,  4007,    -1,  4009,    -1,    -1,  4012,  4013,    -1,
      -1,    -1,  3778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4028,  4029,  4030,  4031,    -1,  4033,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5210,
      -1,    -1,    -1,    -1,  5215,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4098,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4133,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3955,
      -1,  3957,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3984,  3985,
    3986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4003,    -1,    -1,
      -1,  5372,    -1,    -1,    -1,  4011,    -1,    -1,  4014,    -1,
    4016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4034,  4035,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5472,    -1,    -1,    -1,    -1,    -1,  4352,    -1,    -1,
    4116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5501,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4529,    -1,    -1,    -1,  4533,    -1,
    4535,  4536,    -1,    -1,    -1,    -1,  4541,  4542,  4543,  4544,
      -1,    -1,    -1,  4548,  4549,  4550,  4551,  4552,  4553,  4554,
    4555,  4556,  4557,  4558,  4559,  4560,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4584,
      -1,    -1,  4587,    -1,  4589,    -1,    -1,  4592,    -1,    -1,
    4595,  4596,    -1,    -1,  4599,  4600,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4658,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4435,
    4436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4489,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4528,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4578,  4579,    -1,    -1,    -1,    -1,    -1,  4585,
    4586,    -1,    -1,    -1,  4590,    -1,    -1,    -1,  4594,    -1,
      -1,  4597,  4598,    -1,    -1,    -1,  4602,    -1,    -1,    -1,
      -1,    -1,  4608,    -1,    -1,    -1,    -1,    -1,    -1,  4854,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4648,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4659,    -1,  4661,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4676,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4941,  4942,    -1,    -1,
      -1,    -1,    -1,    -1,  4949,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4974,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5002,    -1,    -1,
      -1,    -1,    -1,  5008,  5009,    -1,    -1,    -1,    -1,    -1,
      -1,  4777,    -1,    -1,    -1,    -1,    -1,  4783,    -1,    -1,
      -1,    -1,  5027,    -1,  5029,    -1,    -1,    -1,  5033,  5034,
    5035,  5036,    -1,    -1,  5039,  5040,    -1,    -1,    -1,  5044,
      -1,    -1,    -1,  5048,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5061,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5079,    -1,    -1,    -1,    -1,    -1,
      -1,  5086,    -1,    -1,    -1,  4851,    -1,    -1,  5093,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5157,    -1,    -1,    -1,  5161,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5006,    -1,    -1,    -1,    -1,    -1,  5012,  5013,  5014,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5037,  5038,    -1,    -1,  5041,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5293,    -1,
    5295,  5296,  5297,  5298,  5299,    -1,    -1,    -1,    -1,    -1,
      -1,  5067,    -1,    -1,    -1,  5310,  5311,  5312,    -1,    -1,
      -1,    -1,  5078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5325,    -1,    -1,  5328,    -1,    -1,    -1,  5332,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5350,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5285,
      -1,    -1,    -1,    -1,    -1,    -1,  5531,    -1,    -1,    -1,
    5535,    -1,    -1,    -1,  5300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5549,    -1,  5551,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5633,    -1,
      -1,  5397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5439,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5705,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5748,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5534,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5564,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5850,  5851,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5863,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5904,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5946,  5947,    -1,  5710,  5711,  5712,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5728,    -1,    -1,    -1,    -1,    -1,  5734,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6006,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5804,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5829,    -1,    -1,    -1,    -1,  5834,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,  5951,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
    5996,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,   133,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,  6065,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,   483,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   501,   502,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,    -1,   270,    -1,   272,
     273,   274,   275,    -1,    -1,   278,   279,   280,   281,   282,
      -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,    -1,    -1,   312,
     313,    -1,   315,    -1,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,    -1,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,    -1,   401,    -1,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,   422,
      -1,    -1,   425,   426,   427,   428,   429,   430,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,   442,
     443,   444,   445,   446,    -1,   448,   449,   450,   451,   452,
     453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,
     463,   464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,   502,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,    -1,   231,   232,   233,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,    -1,   422,    -1,    -1,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,   478,
     479,   480,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,   502,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,   434,
     435,   436,   437,   438,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,    -1,    -1,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,    -1,   483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,
      -1,    -1,     3,    -1,     5,     6,   501,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,    -1,    -1,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,    -1,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,    -1,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,    -1,   434,   435,   436,   437,   438,   439,   440,
      -1,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,
     501,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    35,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,    -1,   284,   285,    -1,
      -1,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,    -1,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,    -1,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
      -1,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,    -1,   434,   435,   436,
     437,   438,   439,   440,    -1,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,    -1,
      -1,   458,    -1,    -1,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,
       3,    -1,     5,     6,   501,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    35,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
      -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,    -1,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,    -1,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,    -1,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
      -1,   434,   435,   436,   437,   438,   439,   440,    -1,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,
     493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,    -1,   284,   285,    -1,    -1,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,    -1,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,    -1,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,   434,   435,   436,   437,   438,
     439,   440,    -1,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,    -1,    -1,   458,
      -1,    -1,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    -1,
     499,   500,   501,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,   494,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,    -1,    -1,
      -1,     3,    -1,     5,     6,   501,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     492,   493,    -1,    -1,    -1,     3,    -1,     5,     6,   501,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,   434,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,     3,
      -1,     5,     6,   501,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,
      -1,    -1,    -1,     3,    -1,     5,     6,   501,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,   434,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,    -1,     3,    -1,     5,
       6,   501,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,     3,    -1,
       5,     6,    -1,     8,     9,   501,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,   493,     3,
      -1,     5,     6,    -1,     8,     9,   501,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   492,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,   483,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   501,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,    -1,    -1,   483,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   501,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   501,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
       5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,    -1,
      -1,   501,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      -1,   296,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,    -1,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,    -1,   422,    -1,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,    -1,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,     5,     6,    -1,    -1,    -1,
      10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,    -1,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,    -1,   422,    -1,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,    -1,   163,   164,
     165,   166,    -1,   168,   169,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,    -1,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,    -1,   252,   253,    -1,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,    -1,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,    -1,   451,   452,   453,   454,
     455,   456,    -1,   458,    -1,    -1,    -1,    -1,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,   479,   480,   481,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,
     295,    -1,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,    -1,   403,   404,
      -1,   406,    -1,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,   428,   429,   430,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   452,   453,   454,
     455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,   492,   493,   494,   495,   496,   497,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   494,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     494,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   494,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,   292,   293,   294,   295,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,   449,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,   494,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
     292,   293,   294,   295,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,   478,   479,   480,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,   494,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    -1,   492,   493,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,   492,   493,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,   492,   493,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,
     492,   493,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,   172,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   492,   493,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,     5,     6,    -1,     8,     9,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,   104,   105,    -1,    -1,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,   104,   105,    -1,    -1,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
     104,   105,    -1,    -1,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    -1,    79,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,   434,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,    -1,   277,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,    -1,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,    -1,   403,   404,    -1,   406,    -1,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,   277,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,   295,    -1,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
      -1,   403,   404,    -1,   406,    -1,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,   277,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,   295,    -1,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,    -1,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,    -1,   403,
     404,    -1,   406,    -1,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,   295,    -1,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,    -1,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,    -1,   403,   404,    -1,   406,    -1,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,    -1,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,   295,
      -1,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,    -1,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,    -1,   403,   404,    -1,
     406,    -1,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,    -1,   272,   273,
     274,   275,    -1,    -1,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
      -1,   315,    -1,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,    -1,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,    -1,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
      -1,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,    -1,   315,
      -1,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,    -1,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,   480,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,   279,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,   448,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,    -1,    -1,
     278,   279,   280,   281,   282,    -1,   284,   285,    -1,    -1,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,    -1,    -1,   312,   313,    -1,   315,    -1,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,    -1,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
      -1,   419,   420,    -1,   422,    -1,    -1,   425,   426,   427,
     428,   429,   430,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,    -1,
     448,    -1,   450,   451,   452,   453,   454,   455,    -1,    -1,
     458,    -1,    -1,   461,   462,   463,   464,   465,   466,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     478,   479,   480,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,    -1,    -1,   278,   279,   280,   281,   282,    -1,
     284,   285,    -1,    -1,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,    -1,    -1,   312,   313,
      -1,   315,    -1,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,    -1,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,    -1,   419,   420,    -1,   422,    -1,
      -1,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,    -1,   448,    -1,   450,   451,   452,   453,
     454,   455,    -1,    -1,   458,    -1,    -1,   461,   462,   463,
     464,   465,   466,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,   479,   480,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,    -1,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,    -1,    -1,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,   297,   298,    -1,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
      -1,    -1,   312,   313,    -1,   315,    -1,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,    -1,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,    -1,   419,
     420,    -1,   422,    -1,    -1,   425,   426,   427,   428,   429,
     430,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,    -1,   448,    -1,
     450,   451,   452,   453,   454,   455,    -1,    -1,   458,    -1,
      -1,   461,   462,   463,   464,   465,   466,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,   479,
     480,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
      -1,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
      -1,    -1,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,    -1,    -1,   312,   313,    -1,   315,
      -1,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,    -1,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,    -1,   419,   420,    -1,   422,    -1,    -1,   425,
     426,   427,   428,   429,   430,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
      -1,    -1,   458,    -1,    -1,   461,   462,   463,   464,   465,
     466,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,   479,   480,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      -1,    53,    -1,    -1,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    -1,    -1,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,    -1,    -1,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,    -1,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
      -1,    -1,    -1,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,    -1,    -1,   278,    -1,   280,   281,
     282,    -1,   284,   285,    -1,    -1,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,    -1,    -1,
     312,   313,    -1,   315,    -1,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,   335,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,    -1,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
      -1,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,    -1,    -1,    -1,    -1,   419,   420,    -1,
     422,    -1,    -1,   425,   426,   427,   428,   429,   430,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,    -1,    -1,    -1,   450,   451,
     452,   453,   454,   455,    -1,    -1,   458,    -1,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   478,   479,   480
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    50,    60,    72,    74,    75,
      81,    83,    95,    97,   114,   117,   132,   134,   138,   144,
     152,   154,   161,   178,   195,   235,   236,   241,   255,   273,
     310,   318,   332,   338,   339,   341,   346,   352,   355,   362,
     368,   369,   376,   380,   390,   405,   425,   436,   442,   447,
     460,   483,   484,   485,   486,   487,   488,   501,   508,   509,
     510,   511,   512,   513,   519,   520,   522,   523,   524,   525,
     527,   531,   543,   548,   549,   552,   553,   554,   573,   576,
     577,   592,   639,   642,   643,   646,   649,   650,   651,   659,
     666,   668,   669,   672,   675,   676,   680,   689,   693,   694,
     695,   698,   700,   701,   702,   703,   711,   713,   733,   737,
     739,   740,   750,   752,   759,   760,   763,   764,   765,   766,
     767,   776,   778,   780,   783,   787,   788,   798,   799,   802,
     807,   821,   853,   856,   857,   858,   863,   866,   868,   870,
     872,   873,   876,   877,   880,   882,   883,   887,   888,   889,
     892,   893,   894,   895,   896,   903,   905,   906,   907,   908,
     914,   916,   917,   923,   924,   925,   928,   929,   930,   931,
     933,   934,   936,   937,   939,   940,   942,   954,   956,   959,
     961,   963,   972,   974,   980,   985,   993,   997,   998,   999,
    1000,  1001,  1002,  1008,  1044,   419,   463,   909,    27,    78,
      94,   112,   118,   136,   147,   156,   169,   174,   181,   200,
     225,   247,   288,   313,   323,   324,   327,   354,   357,   361,
     363,   370,   373,   392,   399,   404,   405,   408,   412,   422,
     427,   440,   453,   665,   909,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    29,    30,    31,    39,    40,    41,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    57,    58,    59,    60,    61,    62,    63,
      66,    67,    68,    69,    70,    72,    73,    74,    75,    76,
      78,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    91,    92,    93,    94,    95,    96,    98,    99,   100,
     101,   105,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   119,   121,   122,   123,   124,   125,   126,   127,   129,
     130,   131,   132,   135,   136,   137,   138,   139,   141,   142,
     143,   145,   146,   147,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   160,   162,   163,   164,   165,   166,
     168,   170,   171,   173,   174,   175,   176,   177,   179,   180,
     182,   183,   184,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   197,   198,   199,   200,   201,   202,   203,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   215,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     229,   230,   231,   232,   233,   235,   236,   237,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   272,
     273,   274,   275,   277,   278,   279,   280,   281,   282,   284,
     285,   288,   289,   290,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   312,   313,   314,   315,   316,   317,   318,   319,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   370,   371,   372,   373,   374,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   403,   404,   406,   407,   408,
     409,   410,   411,   412,   414,   415,   416,   419,   420,   421,
     422,   423,   425,   426,   427,   428,   429,   430,   431,   432,
     435,   436,   437,   438,   439,   442,   443,   444,   445,   446,
     447,   448,   450,   451,   452,   453,   454,   455,   458,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,  1105,
    1175,  1187,  1188,  1192,  1193,  1194,     3,    28,   994,  1172,
    1187,  1192,   451,   501,   947,   286,   319,   909,    53,   501,
     584,    22,    40,    65,    78,   112,   118,   136,   147,   156,
     169,   177,   181,   237,   288,   291,   313,   327,   354,   363,
     373,   392,   399,   408,   409,   411,   412,   427,   434,   437,
     440,   593,   648,   755,   808,   822,    28,   318,  1172,   994,
      28,   312,   371,   409,   411,     6,   224,   864,   865,  1178,
      22,    27,    65,    78,    94,   112,   136,   147,   156,   169,
     174,   181,   200,   247,   288,   301,   313,   324,   327,   354,
     357,   361,   363,   370,   373,   392,   399,   405,   408,   412,
     420,   422,   427,   440,   453,   665,   768,   770,   771,   909,
    1172,    97,   451,   501,   643,   646,   649,   942,   955,   959,
     962,   972,   979,   985,   993,   997,  1008,    11,    21,    28,
      48,   164,   170,   172,   196,   226,   262,   321,   340,   492,
     493,   784,   785,   994,  1177,  1179,    28,    30,    97,   336,
     369,   789,   790,   791,  1187,   169,  1187,  1174,  1178,   405,
    1011,   784,  1187,   346,   376,   380,   419,  1172,   301,   247,
     112,   200,   363,   404,   405,   501,   874,   875,   362,  1187,
      28,   374,   415,   419,   535,   544,   545,  1187,    25,   178,
     789,   790,   319,   909,  1187,   223,    28,   133,  1013,  1014,
      66,    91,   237,   257,   354,   363,   374,   415,   419,   466,
     532,   533,   534,   535,    28,   374,   415,   419,   535,   419,
     287,  1056,  1057,  1170,  1187,  1011,   494,  1187,   173,   501,
     948,   501,   334,  1003,  1004,  1172,  1003,     3,    52,    54,
      55,    68,    69,   115,   116,   137,   165,   212,   213,   215,
     258,   260,   279,   331,   378,   384,   415,   416,   448,  1079,
    1081,  1083,  1085,  1087,  1089,  1090,  1091,  1093,  1094,  1095,
    1097,  1098,  1188,  1192,  1013,  1014,  1015,  1183,    12,  1184,
    1185,  1187,  1184,  1184,   998,   999,  1002,     0,   504,   501,
     947,   148,   214,   292,   433,  1016,  1017,   998,  1000,  1001,
     123,   210,   249,   439,   505,    34,   913,   838,  1175,   773,
    1187,   773,  1172,   322,   773,   422,  1172,   111,   405,   826,
    1175,  1187,  1194,     3,   104,   108,   375,  1180,  1181,  1189,
    1192,  1193,  1194,    28,   190,  1170,   280,   453,    10,    17,
      18,    19,    73,   160,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   860,   862,  1135,  1136,  1187,   190,  1172,
     826,  1172,    28,  1180,  1181,   826,  1172,  1172,   190,  1170,
    1172,   190,   773,  1172,   346,   376,    28,   190,  1056,  1172,
     366,  1172,   773,    28,   244,  1180,  1181,   190,  1170,   224,
     120,   220,   271,   330,   910,   911,   912,   501,   499,   503,
    1161,  1163,   941,   942,   943,   944,  1189,  1170,  1172,  1187,
      27,    65,    79,    90,   112,   136,   174,   200,   225,   288,
     324,   354,   357,   399,   408,   420,   427,   768,   769,   770,
     771,  1178,   913,   958,   962,   972,   979,   985,   997,  1170,
     250,   773,   501,   190,   773,  1172,   773,   422,   190,  1172,
     111,   405,   409,   411,  1180,  1181,   409,   411,    73,   160,
     860,   344,  1172,  1172,  1180,   190,   528,  1187,   190,  1172,
     190,   773,  1172,  1172,   366,   773,   244,  1180,   334,   370,
     405,   453,   247,    94,   200,    27,    90,   174,   324,   361,
     420,   422,   426,   660,    28,  1172,   995,   542,  1178,  1189,
     865,   250,   190,   838,   839,   190,   869,   190,  1172,   190,
     775,  1079,   422,   111,   405,   190,   825,   826,   190,  1181,
    1182,    86,   453,    73,   160,   190,   861,   862,    58,   190,
     825,   190,  1182,   190,   825,   190,  1172,   190,  1172,   366,
     869,   190,   775,   190,   244,  1182,   224,   190,   772,   773,
     190,  1171,  1172,   190,  1172,   913,   501,   960,   593,   955,
     447,   941,   947,   210,   439,  1179,   785,   786,    28,   786,
    1179,   786,    28,   786,  1179,   786,   786,   786,  1179,  1177,
    1177,   994,   786,   322,   501,   404,   501,   616,   616,   616,
     286,   417,   505,   616,   363,  1056,  1058,   505,   904,   545,
     533,   535,    28,   535,  1178,   501,   957,    58,   453,   941,
      86,   809,   809,  1187,    47,   480,   220,   503,   289,   289,
     286,   172,  1178,   417,   913,   167,   781,   286,     5,     8,
       9,    10,    12,    36,    52,    54,    55,    64,    65,    68,
      69,    76,    78,   102,   103,   104,   105,   106,   107,   108,
     115,   116,   118,   153,   158,   159,   165,   180,   182,   212,
     213,   215,   230,   238,   239,   258,   260,   269,   271,   276,
     277,   279,   288,   299,   314,   331,   359,   375,   384,   400,
     415,   416,   421,   423,   424,   434,   440,   448,   468,   469,
     470,   471,   473,   474,   475,   476,   481,   492,   493,   494,
     501,   998,  1082,  1085,  1088,  1089,  1090,  1092,  1093,  1094,
    1097,  1098,  1102,  1104,  1105,  1106,  1108,  1131,  1132,  1133,
    1137,  1155,  1160,  1167,  1168,  1175,  1176,  1177,  1178,  1187,
    1166,  1167,  1178,    28,   550,  1169,  1170,   374,   532,   118,
     541,  1178,   542,  1178,    47,    70,   532,   480,   385,   911,
     289,   172,   417,   491,    47,   480,   220,   912,   501,  1170,
     494,  1163,  1058,   941,   171,   949,  1102,  1140,  1003,   505,
     501,   950,   450,  1096,  1096,  1096,   501,  1084,  1084,   316,
     501,  1086,    68,    69,  1096,  1084,  1081,   462,   483,   501,
    1099,   501,  1099,    36,  1080,   501,   113,   188,   251,   254,
     367,   478,   501,  1100,  1101,   503,   774,  1084,  1166,  1164,
     502,   502,   510,   941,   951,   952,   953,  1170,    28,   133,
    1012,  1012,    58,  1012,   161,   167,   234,   283,  1020,  1022,
    1023,  1038,  1040,  1041,  1042,  1016,  1017,   172,   216,   216,
    1056,  1059,   501,    67,   267,   302,   342,   376,   501,   836,
     302,   338,   342,   376,   774,   302,   342,   376,     3,    89,
     142,   240,   302,   310,   338,   342,   376,   408,   410,   460,
     543,   546,   918,   919,   920,   921,   803,    24,   138,   302,
     342,   376,   444,   559,  1172,    24,   138,   376,   439,   526,
     464,   190,  1056,    61,    96,   157,   193,   229,   267,   271,
     302,   303,   342,   351,   360,   368,   376,   388,   397,   401,
     455,   543,   547,   842,   854,   881,   501,   823,  1163,   342,
     526,   196,   153,    24,    30,    45,    75,   131,   138,   141,
     168,   202,   267,   271,   281,   290,   302,   342,   345,   346,
     376,   444,   555,   557,   558,   683,   881,     5,   492,   493,
     657,  1179,    28,   190,  1170,   773,   773,   501,   859,   302,
     376,   503,   153,   286,   302,   342,   376,   854,   881,    24,
     138,   302,   342,   376,   196,   521,   342,   460,   483,   514,
     521,   302,   342,   376,   854,   881,   286,   302,   342,   153,
      37,    59,   110,   199,   248,   252,   267,   301,   342,   347,
     370,   376,   390,   555,   654,   655,   302,   342,   452,   683,
     691,   153,   302,   342,   376,    24,    89,   131,   138,   141,
     302,   338,   342,   376,   383,   545,   533,   196,   153,    45,
     129,   267,   342,   376,   555,   556,   302,   342,   346,   376,
      87,   130,   305,   410,   286,    24,    30,   138,   302,   342,
     376,   574,   575,   521,   167,   342,   514,   521,   153,   342,
     376,   555,  1172,   232,   120,   287,   465,   505,   910,    28,
     133,   449,   494,   502,   831,  1102,  1141,  1142,  1188,  1102,
    1162,     3,    28,    32,    33,    34,    35,    36,    37,    38,
      42,    56,    64,    65,    71,    77,    79,    90,    97,   102,
     103,   104,   106,   107,   108,   118,   120,   128,   133,   134,
     140,   144,   148,   159,   161,   167,   169,   172,   178,   181,
     185,   196,   204,   214,   216,   227,   228,   234,   238,   239,
     271,   276,   283,   286,   287,   291,   292,   311,   320,   336,
     350,   369,   375,   386,   402,   405,   413,   417,   418,   424,
     433,   434,   440,   441,   449,   456,   457,   459,   460,   494,
    1173,  1190,  1192,  1193,  1194,  1195,  1161,   502,   505,   159,
     286,   424,   539,   542,   657,   945,   441,   938,   286,   838,
     501,   773,  1172,  1079,   826,   280,    73,   160,   862,   826,
     826,   167,  1079,   773,  1172,  1172,   502,   616,  1172,    71,
    1079,   271,   172,   501,   741,   514,    37,   932,  1172,   271,
     514,   464,   190,  1170,   514,   773,   773,   741,   437,   593,
     286,   167,   460,   850,   514,   271,    47,   529,   271,   427,
     690,   271,   950,    89,   302,   667,    87,   130,   305,   410,
      37,   741,   167,   190,   514,   453,   190,  1170,   190,   644,
    1170,  1170,   453,   773,   809,  1175,   422,  1175,  1175,  1172,
     167,  1172,   665,    39,    53,   109,   209,   267,   365,   153,
      62,   348,   505,   560,   153,   501,   153,   514,   153,   505,
     560,   464,   153,   505,   560,   153,   505,   190,   772,   190,
     773,   190,   773,   153,   505,   560,  1182,   153,   560,   153,
     153,   560,   153,   560,   153,    87,   130,   305,   410,   167,
     153,   560,   153,   167,   190,   153,   505,   560,   153,   505,
     560,   153,   286,  1140,   405,   502,   955,   216,  1059,   786,
     994,   786,   994,   786,   994,   786,   994,   786,   994,   994,
     994,   786,   994,   501,   617,   618,  1187,   617,    28,   112,
     136,   169,   174,   224,   225,   304,   324,   357,   363,   370,
     405,   408,   427,   794,  1169,  1182,   791,  1172,   196,   505,
     975,  1178,  1079,  1144,    37,  1182,   809,   502,  1170,  1172,
     232,  1187,   167,   167,   794,  1182,   362,  1187,   542,   286,
     501,  1164,   499,   998,  1145,  1102,  1159,   501,   501,   167,
     501,   501,   998,   501,   501,   501,   501,   501,   501,   501,
    1102,   501,   501,   501,   501,   501,   501,   501,   501,   278,
     607,   501,   501,   501,   501,   501,   501,   501,   501,  1102,
    1102,  1102,   998,  1102,  1140,  1163,  1178,   501,  1178,     3,
      10,    13,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     163,   164,   165,   166,   168,   169,   170,   171,   173,   174,
     175,   176,   177,   179,   180,   182,   183,   184,   186,   187,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   215,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   252,
     253,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   284,
     285,   287,   288,   289,   290,   291,   293,   294,   295,   296,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   311,   312,   313,   314,   315,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   451,   452,   453,   454,   455,
     456,   458,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   479,   480,   481,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1135,
    1137,  1139,  1191,  1196,   461,  1118,   298,  1102,   216,   505,
    1009,   501,  1178,  1163,  1009,   121,   192,   551,   505,    70,
     118,   542,    37,     3,   118,   237,   540,   657,  1098,  1178,
    1178,    92,   135,  1114,   101,   118,   536,   537,   539,   657,
     118,   536,   232,  1170,    93,   347,   777,   502,   947,    34,
      44,    51,    77,   191,   196,   218,   233,   288,   291,   381,
     502,   505,  1004,  1171,    37,   501,  1140,  1177,  1096,  1096,
      36,  1080,   415,   415,  1177,  1177,   499,   499,  1177,   417,
     417,   417,   501,   417,  1177,  1173,   503,  1084,   172,  1045,
      15,   491,  1161,  1186,   502,   505,   950,  1000,  1000,  1018,
    1019,  1102,  1000,   164,   262,  1029,   222,   267,   330,   379,
     439,    28,  1024,  1102,   492,   493,  1025,  1026,  1102,  1104,
    1038,  1039,  1023,  1022,  1020,  1021,   167,  1041,   281,  1043,
    1020,  1038,  1059,   964,  1170,  1059,    37,  1187,  1140,    67,
     417,   417,   363,   196,   207,   292,   295,   378,   449,   494,
     829,   830,   831,   833,   835,   837,  1079,  1188,   417,   452,
     417,   363,   417,   417,   363,   234,   417,    78,   417,   408,
     532,   302,   918,   920,   491,   922,   167,   178,   196,   352,
     804,   805,    71,    90,   149,   169,   320,   434,   613,   614,
      90,   118,   271,   417,    90,   417,   118,   271,   363,    90,
     131,   141,   302,   342,   738,   363,   673,    27,    65,   136,
     174,   288,   324,   357,   420,   427,   768,   769,  1172,   153,
     342,   376,   555,   286,   657,   368,   229,   417,  1187,   417,
     276,   657,   122,   217,   363,   374,   419,   534,   773,   348,
     376,   842,   855,   126,   502,   824,   829,   417,   440,   408,
    1170,    79,   149,   190,   600,   613,  1187,    79,    90,   878,
     307,   286,   359,   361,   422,    90,   878,    31,   345,   359,
     361,   422,   359,  1170,   168,   202,   281,   773,   501,   417,
     417,   189,   501,   564,    22,   243,   408,   437,   462,   564,
      90,   505,   126,     5,     5,   302,   196,   153,   342,   376,
     555,   881,   441,   441,   268,  1079,   417,   363,   501,   860,
    1172,  1170,   417,   417,   363,   855,   126,    28,   105,   405,
     890,   891,  1057,  1170,  1187,   891,   417,   417,   741,   891,
     112,   376,   546,   417,   516,   546,   417,   417,   363,   855,
     126,  1170,   417,   417,  1170,  1081,   657,    58,   656,   657,
     657,   110,   248,   252,    58,   417,   514,   256,   363,   514,
     267,   655,   417,   417,   276,  1178,   683,   773,   417,   417,
     363,   392,   327,  1178,   327,   417,   327,   417,   327,   741,
     741,   408,  1056,   307,   307,    90,   417,   878,   363,   417,
     417,   564,   564,   773,   773,   773,   773,  1170,    46,   446,
      46,    46,   417,    46,   417,   446,   363,   501,   505,   546,
     440,   699,  1181,   417,   516,   546,  1170,   417,   878,   363,
     302,   342,   330,   343,   372,   538,   910,  1141,  1141,  1142,
     502,    15,    16,   505,  1016,  1017,   500,   506,  1170,   943,
    1172,  1170,   218,  1079,   218,   286,   218,   218,   657,   773,
     773,   218,   218,   218,  1079,   218,   218,   218,   286,   417,
     172,   417,   578,   427,   501,    37,   153,   773,   742,   743,
    1190,   918,  1079,   286,   153,   670,  1172,   271,   307,   501,
     515,   755,   441,   334,   453,  1170,    28,   891,   741,   515,
     153,  1181,    97,   178,   530,   592,   650,   713,   787,   807,
     914,   153,  1178,   691,   692,   153,   286,  1178,  1181,   240,
     773,   773,   773,   773,   145,   329,   501,   699,   271,   515,
    1170,   271,   652,   654,   271,    37,   281,   307,   501,   616,
     616,   190,   647,  1170,   167,   190,   810,  1172,   501,   745,
     836,  1172,   501,   827,   827,    37,  1079,    26,    49,   211,
     714,   224,   460,   462,   996,   365,   839,   838,  1079,  1172,
     501,   775,  1079,   825,   826,  1182,  1181,   153,   560,   153,
     441,   153,   441,   861,   862,   560,   825,  1182,   825,  1172,
    1172,  1079,   775,  1182,   699,   153,   772,   773,  1171,  1172,
    1172,   773,   502,   190,  1170,   955,   964,   376,   994,   994,
     994,   994,   994,   994,   617,   502,   505,   502,   175,   325,
     358,   371,   406,  1171,   772,   111,   373,   825,  1171,   280,
     792,   793,  1187,   825,   825,  1171,  1169,  1169,  1171,   772,
     417,   460,   800,   148,   234,   696,   697,    22,   151,   359,
     379,   976,  1056,   275,   977,   502,   505,   958,   417,  1170,
     874,   875,   790,   789,   790,   172,   179,   801,  1187,    27,
      79,   136,   174,   225,   324,   357,   427,   768,   769,  1140,
     500,  1140,  1145,  1146,   456,  1156,  1157,  1102,  1140,   501,
    1177,  1177,     3,   113,   188,   251,   254,   367,   478,  1147,
    1148,  1178,  1140,  1140,  1140,  1177,  1177,  1102,  1102,   860,
    1102,  1141,  1143,  1150,   359,   492,   493,   501,  1103,  1104,
    1137,  1151,   502,  1140,  1102,  1143,  1152,  1102,    56,   172,
     228,   418,  1102,  1140,  1153,   133,   271,   998,  1140,   256,
    1104,  1102,  1112,  1113,  1114,   256,  1102,  1114,   502,   505,
    1177,  1100,  1079,  1102,  1102,  1102,  1102,  1190,   415,    42,
     402,  1165,   773,  1102,   501,   998,  1154,   133,   135,   159,
     263,   264,   265,   266,   270,   271,   276,   424,   435,  1149,
    1102,   501,  1102,   417,    51,   191,   196,   233,   381,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,    28,
      35,   386,  1134,   181,   162,  1119,   359,   501,  1131,   177,
     237,   405,   409,   411,   437,  1010,  1170,  1168,  1045,  1141,
    1045,  1170,   419,   501,  1178,   505,   502,   189,   189,   560,
     953,   942,   946,  1102,   502,   247,   271,  1005,  1140,   502,
     502,   499,   480,   480,   502,   502,  1177,   500,  1177,   502,
     188,   251,  1101,   251,  1101,  1101,  1177,   254,   502,  1173,
     227,   360,   477,   501,   998,  1046,  1047,  1048,  1056,  1062,
    1072,  1105,  1107,  1108,  1187,   457,  1067,  1183,   953,   951,
     505,    38,   128,   441,   819,   359,   360,   492,   493,  1026,
    1028,  1104,   379,   222,   287,   505,     5,  1027,  1177,  1027,
     359,   360,  1028,  1169,   275,   383,   978,  1039,  1021,   441,
     973,    37,   441,  1187,   502,  1181,  1172,  1172,   295,    58,
    1188,   502,   831,   833,   830,   833,  1188,   292,   502,   505,
     774,  1181,  1172,  1172,  1181,  1172,  1172,  1181,   452,  1172,
    1172,   118,   539,  1179,   354,   440,   789,   363,   178,   789,
     501,  1172,   441,   811,   222,   222,   441,   607,   638,   190,
    1172,   276,  1181,  1172,  1172,  1102,   276,  1172,  1172,    31,
     345,   417,   417,  1172,   417,   674,   838,   501,  1079,   826,
      73,   160,   862,   826,   826,   167,  1079,   773,  1172,   184,
     267,   302,   342,   445,   677,   678,   679,  1056,   417,   878,
     363,   276,   122,   217,  1181,  1172,   286,  1172,   286,   502,
     505,  1180,  1182,  1172,   342,   555,   190,   600,   271,  1079,
    1172,  1177,  1187,  1170,  1172,   232,  1172,    28,   440,  1172,
     190,  1172,   190,  1187,   361,   422,   361,   422,   232,  1172,
      28,   440,  1172,   232,   359,  1170,    24,   138,   376,   684,
     685,   686,   687,  1190,  1181,  1172,   118,   173,   272,   441,
     563,   566,   567,  1190,   250,  1172,    75,   284,  1172,   558,
     286,   417,   408,  1170,   417,   878,   363,   126,  1172,  1172,
     505,   502,   505,  1181,  1172,   884,   885,  1190,   286,   342,
     417,   707,  1181,  1172,  1172,   286,   406,  1056,   505,   616,
     616,  1163,  1181,  1172,  1172,  1180,     3,    89,   143,   202,
     309,   432,   440,   443,   517,  1181,  1172,  1172,   286,   342,
    1181,  1172,   342,   376,   555,   654,   657,   773,  1172,   657,
     773,  1172,   657,  1181,  1172,   376,  1181,  1172,  1172,  1179,
    1171,  1171,  1181,   850,  1172,  1171,  1172,   342,   376,   555,
     556,  1170,  1170,  1172,  1172,  1172,  1172,  1181,  1172,    24,
      30,   138,   302,   342,   376,   302,   342,   376,   741,   342,
     376,   342,   376,   342,   881,  1071,  1187,   190,   751,  1187,
     190,  1187,  1181,  1172,  1172,  1178,  1172,   884,    24,   575,
     373,  1180,   342,   376,   555,  1172,  1172,  1172,   417,   417,
      84,   431,   330,   505,  1016,  1016,  1016,  1102,  1102,   449,
    1142,   502,  1102,  1162,   938,   276,   779,  1178,    37,   779,
     136,   773,   779,   779,   218,   441,   441,   779,   779,   779,
     224,   779,   779,   779,   773,   326,   579,   579,   200,   405,
     712,  1102,  1079,   773,   502,   505,   491,   604,  1190,  1172,
      62,   172,   363,   452,   671,   678,   679,   153,   281,   233,
     594,   596,   598,   600,   610,   613,    25,   196,   354,   403,
     517,   518,   167,  1172,   453,  1170,    37,   708,   406,   850,
     528,  1187,   529,   593,   822,  1172,   169,   773,   501,   640,
     641,  1107,  1187,   327,  1178,   741,   741,   741,   741,   501,
     741,  1069,  1070,  1071,   373,   153,   501,   153,   153,   152,
     997,   773,   281,   594,  1187,   441,   633,   460,   565,   271,
      37,   616,  1178,   271,   286,     3,   746,   747,   741,    26,
     502,   828,   829,   834,    37,   224,   351,   420,   459,   840,
     841,   842,   843,   840,   286,   224,   281,   123,   210,   425,
     439,   715,   716,  1172,   187,   187,   167,   560,    37,   514,
     168,   926,   927,   560,   560,   772,   773,  1172,   773,  1172,
     560,   560,   560,   560,   224,   560,   373,   167,   560,   560,
     286,   560,   271,   118,   300,   501,   965,   997,   501,   981,
     982,   983,  1187,   502,   618,   196,   196,   196,   196,   196,
     464,  1171,   657,   658,   505,   503,   181,   795,   796,  1181,
      25,   801,   417,   501,   172,   151,   379,   151,   379,   359,
     439,   253,  1079,  1181,   460,   645,   809,   809,   172,   286,
     795,    58,   560,   838,   773,  1079,   826,   280,   826,   826,
    1079,   773,  1172,   502,   500,   500,   505,  1102,   140,  1157,
    1158,    37,   502,  1102,   502,   502,   502,   172,   502,   502,
     502,   502,   502,   502,   505,   505,   502,   311,   502,   502,
     501,  1103,  1103,  1140,    13,    17,    18,    19,   196,   218,
     288,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1137,  1103,   502,   502,   167,   172,   381,   502,   502,    37,
    1153,  1140,  1153,  1153,   172,   502,   133,   502,  1190,   308,
    1116,    37,   502,   505,  1102,  1190,   505,  1102,  1164,  1102,
     502,   480,  1103,  1103,   146,  1140,   172,   133,   135,   159,
     270,   276,   424,   435,  1149,   270,   146,   860,  1102,   402,
    1165,  1102,  1154,  1102,   417,   501,   998,   501,   501,   297,
    1123,   501,  1140,   409,   411,   409,   411,  1170,  1011,  1011,
    1011,  1067,  1016,  1067,   911,  1177,  1100,   537,   953,   247,
     501,   502,  1177,  1099,  1099,   500,   500,   502,   998,  1062,
    1072,   172,   501,   998,  1047,  1048,    37,  1049,  1050,  1187,
     505,    98,   173,   206,   221,   231,   259,   353,  1053,  1050,
      37,  1049,  1052,  1187,  1050,   483,  1066,  1163,  1102,   181,
    1030,  1019,   288,  1135,  1138,   482,   820,     5,  1177,  1028,
     287,   460,   439,  1025,   242,  1046,   457,  1068,  1187,  1047,
     837,   774,   833,   833,    58,   835,   496,  1182,  1182,   286,
    1171,   289,   286,  1102,   614,  1172,   501,   501,   501,   638,
     200,   501,   731,   153,   560,   417,  1181,  1172,   542,  1079,
     773,   773,  1079,   661,  1172,   184,   445,   417,   417,   661,
     677,   683,   342,   376,   555,  1172,  1172,  1172,   208,   276,
     156,   829,   301,   376,   417,   271,   153,    85,   602,   603,
     731,   376,    24,   138,   346,   347,   376,   559,   568,   569,
     683,   879,   368,   153,   560,   153,   560,  1172,  1172,  1172,
    1172,   368,   368,   232,   686,   687,   686,   502,   505,   688,
    1178,   200,   502,   505,   491,   503,  1172,   156,  1181,  1172,
     342,   376,   555,  1172,  1172,  1172,   286,   302,   342,   376,
      24,   138,   302,   342,   376,  1079,   268,  1079,   502,   505,
     491,  1170,   417,  1182,   441,   704,   156,   196,   616,   890,
     457,   623,   623,   616,   234,   309,   276,  1178,   309,  1182,
     438,   156,   417,   417,   363,   392,   850,   850,   850,   301,
     376,    90,   417,   878,   363,   118,   167,   570,   163,   809,
     417,   417,   244,   244,   244,   417,   417,   363,   417,   417,
     363,   417,   363,   417,   363,   417,   126,   560,  1079,   271,
    1178,   376,   879,   153,   560,   417,   417,   502,  1172,   417,
     878,   363,   417,  1181,  1172,   502,   502,   502,  1142,   500,
    1079,   773,   218,   779,  1172,  1172,  1172,   218,   393,   394,
     580,  1178,   580,   184,   502,   502,   172,   741,   743,   268,
     288,   492,   493,   657,   744,   833,  1138,  1178,  1195,    71,
      77,    90,   118,   120,   176,   204,   271,   276,   320,   336,
     434,   605,   606,   609,   152,   456,   514,   542,  1172,   542,
     290,   681,  1170,  1170,  1170,   502,   505,  1182,   181,   354,
    1182,  1177,   427,  1170,   616,     3,   167,   709,   850,    47,
     529,   405,   690,   111,   950,  1102,   172,   505,  1171,   565,
     748,   749,  1178,   502,   505,  1172,   167,   617,  1170,   644,
    1170,  1172,   645,   501,   595,  1170,   502,  1172,   460,   462,
     634,   564,    37,   153,   997,   633,   417,   153,  1056,   491,
     502,   505,   715,   502,   505,   118,   491,   844,  1178,   542,
     405,   832,   833,   167,   849,    50,   349,   845,   846,   843,
     846,   123,   210,   369,   439,   901,  1172,   281,   286,   291,
     184,   997,  1079,   501,   502,   505,   560,   441,   560,   441,
     560,  1172,  1172,   699,   773,   153,   447,   404,   440,   966,
     967,   968,  1187,   286,   969,   983,   984,   505,  1045,   491,
    1164,   363,   363,   363,   363,   363,  1171,   505,   793,  1187,
    1181,   460,   505,   797,   289,  1058,   373,   151,   151,   111,
     267,  1170,  1172,  1182,   794,   801,  1181,   218,   218,   218,
     218,   657,   218,   218,   218,   218,   218,  1145,   413,  1102,
     144,  1079,   502,  1102,  1149,  1102,  1102,   502,  1140,   505,
    1079,  1103,  1103,  1103,  1103,   133,   135,   271,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1102,  1102,
    1102,  1079,   502,   502,   502,  1140,   502,   505,    58,  1104,
    1117,   502,  1190,  1113,   317,   398,  1115,   502,   505,   452,
    1109,    37,   502,  1178,  1102,    34,    34,  1102,   502,  1102,
     172,   270,  1102,   502,   146,  1103,  1103,   146,   146,  1102,
    1102,  1017,   457,   501,  1124,  1187,   502,  1140,   505,  1011,
    1011,  1011,  1011,  1170,  1170,  1170,  1030,   502,  1030,   502,
     958,   500,  1050,  1052,  1050,   501,   472,  1104,   502,  1187,
     501,  1047,   221,   296,  1054,  1047,  1054,   221,  1053,  1054,
     221,   407,  1060,   501,  1187,   501,   293,    58,   185,  1037,
     501,   820,   164,   226,   287,   460,   414,   101,  1102,   350,
     971,   286,   502,   496,   837,   427,   175,   358,   364,   371,
     406,   428,   806,   167,   806,   502,   501,   621,   622,   814,
    1107,  1187,   617,   617,   731,  1172,   617,   120,   204,   267,
     271,   732,  1172,  1172,    37,   441,   441,   224,   774,  1181,
    1172,   417,   878,   363,   417,   208,  1172,    58,   408,  1172,
     153,   600,   118,  1187,   681,   392,   176,   155,   189,   271,
     564,   514,   111,   176,   271,   392,   395,   564,   602,   655,
     376,   569,   427,  1172,  1187,   368,   685,  1172,   567,   744,
    1190,  1172,   301,   376,   417,   878,   363,   417,   156,   417,
     417,   363,   174,   288,   395,   753,   754,   174,   288,   761,
     762,   417,   417,   363,   502,   502,   502,   885,   268,   657,
     833,   886,  1138,  1178,  1195,   342,  1172,   501,   460,   705,
    1172,   363,   623,   501,   623,  1179,  1178,  1178,  1178,  1172,
    1172,  1172,  1172,  1179,    58,   408,  1172,  1172,  1172,  1172,
     447,  1172,  1172,   167,   167,   344,   167,   190,  1181,  1172,
    1172,  1181,  1172,  1172,  1172,  1172,  1172,  1172,  1172,   286,
      77,   561,   153,    26,    49,   427,  1187,  1172,  1178,   683,
    1172,  1172,  1172,  1172,  1016,   502,   218,   779,   218,   218,
     218,   779,   514,   441,   585,   586,   661,   731,   460,   462,
     773,   501,   773,  1172,  1103,    31,    58,   608,   121,   192,
     120,   276,   222,  1170,   607,   174,   324,   727,   734,   735,
    1187,   670,   501,   307,   501,   595,   611,   203,   628,   598,
    1182,  1182,  1079,   501,   565,    28,   123,   210,   369,   439,
     710,   417,   706,  1181,   190,  1170,   692,   464,   286,   502,
    1046,   641,   850,   502,   505,  1071,   681,   699,   502,   652,
      37,   281,   307,   501,   960,   597,   599,   601,   613,  1187,
     307,   629,   630,   595,   628,   564,   284,   286,   635,   997,
     647,   645,   565,  1178,  1172,   811,   744,     3,   747,   286,
     834,  1102,  1102,   505,   501,   840,   427,   505,    43,  1102,
     417,   501,   617,  1170,   716,   661,   502,   926,   927,  1172,
    1172,   560,   373,   560,   446,   502,   505,  1164,    88,   971,
     502,   505,   982,  1068,  1102,  1171,  1171,  1171,  1171,  1171,
     657,   178,   796,   801,   502,  1172,   111,   801,   172,   560,
     276,   782,  1178,   782,   782,   782,   218,   782,   782,   782,
     782,   782,  1102,   502,   502,   502,   172,   502,  1102,   172,
     133,   135,   172,   167,   146,   502,   467,  1111,  1140,   335,
     446,    58,  1117,  1104,   458,   458,   502,  1102,   267,  1102,
     505,  1110,  1081,  1102,  1102,  1102,  1102,    34,    34,  1102,
    1102,   146,   502,   502,  1102,  1125,  1187,   502,  1102,  1170,
    1170,  1170,  1170,  1037,  1178,  1037,  1178,   502,  1063,  1064,
    1107,   501,  1116,  1049,   501,  1171,  1047,   286,   441,  1055,
    1047,   221,  1047,  1175,  1070,   501,  1070,  1187,  1012,  1102,
     459,  1120,   860,   414,   281,  1167,  1102,   427,   502,   417,
     789,   172,   731,  1102,   502,   505,   460,    77,   813,   817,
     813,   502,   502,   502,   121,   192,   202,   120,   443,   560,
    1079,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1182,  1172,
     600,   604,  1179,   608,   190,   190,   276,   657,   608,   276,
    1179,  1187,  1079,   560,   560,   491,    58,   408,  1172,  1172,
    1172,  1172,  1172,  1181,  1172,  1172,  1177,  1177,  1079,   505,
    1177,  1177,   505,  1181,  1172,  1172,   417,  1102,    71,   105,
    1187,  1102,  1182,  1172,   417,   417,   172,   196,   460,  1171,
    1171,   773,  1171,   153,   156,   773,  1178,  1178,  1079,   560,
     560,   417,   502,   218,   779,   779,   779,   779,   501,   581,
     582,   514,   125,   174,   207,   174,  1102,   271,   606,   118,
      37,   850,   616,   850,  1175,    34,   152,   196,   682,   686,
     281,   594,   570,   150,   198,   501,   373,   441,   617,    37,
    1182,   704,   529,   271,   501,   169,  1172,   640,  1178,   373,
     565,   152,   997,   773,   281,   594,   645,   502,   505,   460,
     604,    58,   633,   570,   629,    83,   408,   636,   460,   915,
      37,   636,   172,   286,   501,  1170,  1178,   831,   851,   852,
    1188,   846,  1079,   167,   847,  1170,   172,   417,   871,   337,
     717,   205,   662,   560,   502,   560,   560,  1172,   997,   300,
     997,   968,   286,   501,   970,   491,   983,   971,   289,   216,
     560,   795,   782,  1102,   502,  1103,   172,  1102,  1102,  1102,
     501,   502,   505,   502,  1117,   502,   446,   389,   502,   502,
    1102,  1102,  1102,   502,   307,  1126,   502,  1120,  1120,   366,
    1006,   502,   505,    37,  1065,   118,  1077,  1078,  1103,    80,
    1171,   502,  1102,   501,  1047,  1055,   501,   502,  1070,   502,
     100,   182,   356,   501,  1031,  1032,  1033,  1034,  1035,  1036,
    1102,  1121,  1122,  1187,  1016,   502,   994,   456,   986,   987,
     795,   286,   795,   502,   197,   619,   622,   288,   860,   773,
     773,   818,   336,   619,   619,   502,   417,   376,   977,    37,
     153,   153,   561,   744,  1182,  1172,   417,   501,   826,   860,
     862,   754,   501,   501,   762,  1172,   502,   501,   502,   376,
     977,  1172,  1172,   501,   501,   501,   460,   483,   935,   344,
     935,   935,   167,  1172,   561,  1172,   779,   587,   588,  1190,
      53,    99,   124,   142,   146,   168,   171,   186,   276,   328,
     583,   581,  1178,   826,    37,   867,   867,   502,   189,   501,
     441,   637,   245,   620,   637,   501,   735,   727,   501,   502,
     505,  1170,   502,   373,    28,    82,    85,    91,   119,   176,
     189,   201,   392,   395,   612,   612,  1169,  1172,  1172,   502,
     997,   705,   153,   111,   681,   172,  1172,    37,  1172,   645,
     595,  1170,   502,   599,   290,  1187,   634,   629,   633,   123,
     138,   317,  1172,    63,    71,   237,   997,   773,  1056,   812,
     814,   172,   730,   833,   502,   505,   427,   144,   511,   845,
     848,  1067,   387,   387,   502,   261,   285,   718,   719,   720,
     167,   723,   661,   267,   445,   663,   664,   966,    90,   812,
     134,  1102,  1172,   801,   167,  1103,  1112,  1140,   267,   479,
      58,  1016,    57,   127,   110,  1007,  1066,  1063,   501,  1103,
     502,   505,    37,  1073,  1074,  1187,   502,  1171,  1140,   502,
     501,   377,   501,   502,   505,   505,    37,  1021,   246,   271,
     987,   797,   806,   560,   813,   501,   850,   501,   564,   819,
    1170,   850,   850,  1172,   408,   189,   441,   562,   376,   977,
    1172,  1144,   167,   757,   757,  1144,  1144,  1102,   408,  1140,
    1140,   571,   572,  1189,   772,   773,   772,   773,  1171,   560,
     502,   505,   494,   501,   539,   589,   657,   932,  1178,   932,
     271,   276,   328,   932,   932,  1067,   867,    41,   194,   267,
     615,   501,   653,  1102,   200,   173,   306,   382,   286,   624,
     625,   626,   502,  1175,     6,   736,   686,   595,   628,  1172,
     502,   681,   160,   756,   565,   915,  1170,   464,  1046,   681,
     997,   960,   629,   595,   628,   604,   501,   635,   633,   634,
     360,   360,    71,   289,    71,   645,   811,   502,   505,  1170,
     731,   840,   851,  1079,   504,   134,   460,   460,   719,   359,
     405,   721,   139,   724,   456,   726,   445,   661,   446,  1172,
     502,   272,   439,   681,   560,  1102,   502,   502,   446,  1140,
     183,   329,   360,  1127,   164,   164,   617,  1070,   505,  1078,
    1190,   502,   505,   167,  1079,   502,   502,  1140,   501,  1140,
    1032,  1122,  1124,  1039,    34,   988,   246,   172,   617,   637,
     860,   819,   820,   616,   637,   637,  1172,   653,  1102,   408,
     502,   292,   366,   333,   758,   758,   502,   502,   502,  1172,
     502,   502,   502,   505,  1177,   935,   588,   539,   590,   591,
    1178,  1178,   276,   617,   494,   617,  1178,  1178,   202,   654,
     502,   408,   123,   439,   286,   626,   286,   625,   501,   502,
     505,   570,   373,   681,   773,    37,    37,   501,  1172,   915,
     645,   633,   570,   629,   501,   631,   632,  1107,  1187,   636,
     634,   635,   289,   289,   501,   197,   815,   814,   167,   846,
      29,   211,   902,   174,   174,   932,   359,   391,   725,   501,
     152,   997,  1067,   376,    51,   101,   430,  1102,  1128,  1129,
    1128,  1128,   502,    58,    58,   376,   502,  1104,  1074,   293,
       3,   118,   271,   276,  1075,  1076,    37,  1051,   343,  1061,
     502,  1031,   502,  1102,   413,   988,   795,   502,   623,   502,
     820,   620,   731,   731,   977,  1172,   826,    58,   977,   417,
     571,   773,   502,   505,   617,   502,   396,  1172,    62,   267,
     348,   376,   627,   627,   502,     6,   373,  1172,   753,   997,
     681,   634,   629,   633,  1102,   502,   505,   817,   817,   635,
     636,   812,   501,   607,   139,   272,   501,   897,   899,   903,
     962,   972,   979,   997,  1008,   826,   826,   722,  1187,  1102,
     727,   981,  1129,   359,   166,   315,   166,   315,   149,  1130,
    1130,  1130,   617,   617,  1187,  1116,  1103,  1103,   276,  1076,
    1187,   501,   502,   123,   134,   439,   989,   990,   413,   560,
     731,   624,   977,   773,   501,   591,    23,   118,   276,  1172,
     681,   915,   635,   633,   634,   502,   632,   773,   818,   818,
     636,   502,   814,   816,   565,   359,   898,   899,   900,   998,
     999,   505,   505,   502,  1175,  1067,    34,   101,   181,   267,
     414,   376,   376,   417,   441,    80,  1102,   272,   376,   134,
     210,   991,   731,  1140,   616,   616,   681,   636,   634,   635,
     817,   815,   502,   505,   636,   726,   502,   504,   417,   172,
     501,  1129,   359,   294,  1187,  1187,  1175,  1176,  1187,  1073,
     502,   981,   272,   118,   300,   447,   501,   992,   502,   635,
     636,   818,   607,   814,  1067,   152,   900,   387,   387,     5,
     728,   729,  1177,  1178,  1190,   501,   118,   502,   447,   966,
     501,   967,   636,   565,   727,   460,   460,   502,   505,  1141,
    1176,   446,  1140,   502,   636,  1175,   174,   174,   729,  1016,
     441,   992,   502,   300,   992,  1067,   501,   826,   826,   502,
    1187,   966,   728,   446,   502,   992
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   507,   508,   508,   508,   508,   508,   508,   509,   509,
     510,   510,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   512,   513,   514,
     514,   514,   515,   515,   516,   516,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   518,   518,   518,   518,   518,
     518,   519,   520,   520,   521,   521,   522,   522,   522,   522,
     523,   523,   523,   523,   523,   523,   524,   525,   526,   526,
     527,   527,   527,   527,   528,   528,   529,   529,   530,   530,
     530,   530,   530,   530,   531,   531,   531,   531,   532,   532,
     532,   533,   533,   533,   533,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   535,   535,   536,   536,
     537,   537,   538,   538,   538,   538,   539,   539,   539,   539,
     540,   540,   540,   540,   540,   540,   540,   541,   541,   541,
     542,   542,   543,   543,   544,   544,   544,   544,   545,   545,
     546,   546,   547,   547,   548,   548,   548,   548,   548,   548,
     548,   549,   550,   550,   551,   551,   552,   553,   553,   553,
     553,   553,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   554,   554,   554,   554,   554,   554,
     554,   554,   554,   555,   555,   556,   556,   556,   557,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   559,
     559,   560,   560,   560,   561,   561,   562,   562,   563,   563,
     563,   563,   564,   565,   565,   566,   566,   567,   567,   567,
     567,   568,   568,   569,   569,   569,   569,   570,   570,   570,
     570,   571,   572,   572,   573,   574,   574,   575,   575,   575,
     575,   576,   576,   577,   577,   578,   578,   579,   579,   580,
     580,   580,   581,   581,   582,   582,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   584,
     584,   585,   585,   586,   586,   587,   587,   588,   589,   589,
     589,   589,   589,   590,   590,   591,   592,   592,   592,   592,
     592,   592,   593,   593,   593,   593,   593,   593,   593,   593,
     594,   594,   595,   595,   596,   596,   597,   597,   598,   598,
     598,   599,   599,   600,   601,   601,   602,   602,   603,   603,
     604,   604,   605,   605,   605,   605,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   607,   607,   607,   608,   608,
     609,   609,   609,   609,   610,   611,   611,   611,   612,   612,
     612,   612,   612,   612,   612,   612,   612,   612,   613,   613,
     614,   614,   614,   614,   614,   614,   614,   615,   615,   616,
     616,   617,   617,   618,   619,   619,   620,   620,   620,   620,
     621,   621,   622,   622,   623,   623,   624,   624,   624,   624,
     624,   625,   626,   627,   627,   627,   627,   627,   628,   628,
     629,   629,   630,   631,   631,   632,   632,   632,   633,   633,
     634,   634,   634,   635,   635,   635,   635,   636,   636,   637,
     637,   638,   639,   639,   640,   640,   641,   641,   641,   642,
     642,   643,   643,   644,   645,   645,   645,   646,   646,   647,
     648,   648,   649,   650,   650,   651,   651,   652,   652,   653,
     653,   654,   654,   655,   655,   655,   655,   655,   655,   655,
     655,   655,   655,   655,   655,   655,   655,   656,   656,   657,
     657,   657,   657,   658,   658,   659,   659,   660,   660,   661,
     661,   662,   662,   663,   663,   664,   664,   665,   665,   666,
     667,   667,   668,   668,   669,   669,   670,   670,   671,   671,
     671,   671,   672,   673,   673,   674,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   676,
     677,   677,   677,   677,   678,   678,   679,   679,   680,   680,
     681,   681,   682,   682,   683,   684,   684,   685,   685,   685,
     685,   686,   687,   688,   689,   689,   690,   690,   691,   691,
     692,   692,   693,   693,   693,   694,   694,   694,   694,   695,
     696,   696,   697,   697,   698,   698,   699,   699,   700,   700,
     701,   702,   703,   704,   704,   705,   705,   706,   706,   707,
     707,   708,   708,   709,   709,   710,   710,   710,   710,   710,
     711,   712,   712,   713,   713,   714,   714,   714,   715,   715,
     716,   716,   716,   716,   716,   717,   717,   718,   718,   719,
     720,   720,   721,   721,   722,   723,   723,   724,   724,   725,
     725,   726,   726,   727,   727,   728,   728,   728,   729,   729,
     729,   729,   730,   730,   731,   731,   732,   732,   732,   732,
     732,   732,   733,   733,   734,   734,   735,   736,   736,   737,
     738,   738,   738,   738,   739,   740,   740,   740,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,   740,   740,
     740,   741,   742,   742,   743,   743,   744,   744,   744,   744,
     744,   744,   745,   746,   746,   747,   748,   748,   749,   749,
     750,   750,   750,   750,   751,   751,   752,   753,   753,   754,
     754,   754,   754,   754,   755,   755,   756,   756,   757,   757,
     757,   758,   758,   759,   760,   760,   761,   761,   762,   762,
     763,   763,   764,   764,   765,   766,   767,   767,   767,   767,
     767,   767,   767,   767,   767,   767,   767,   767,   768,   768,
     768,   768,   768,   768,   768,   768,   768,   768,   768,   768,
     768,   769,   769,   769,   769,   769,   770,   770,   770,   770,
     770,   770,   770,   770,   771,   771,   771,   772,   772,   773,
     773,   774,   774,   775,   775,   776,   777,   777,   777,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   779,   779,   780,
     780,   780,   780,   780,   780,   780,   780,   780,   780,   781,
     781,   782,   782,   783,   783,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   785,   785,   786,   786,   787,   788,   788,   789,   789,
     789,   789,   789,   790,   790,   791,   791,   791,   791,   791,
     792,   792,   793,   793,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   795,   795,   796,   796,   797,
     797,   798,   799,   799,   800,   800,   801,   801,   802,   803,
     803,   804,   804,   804,   805,   805,   805,   806,   806,   806,
     806,   806,   806,   807,   807,   808,   808,   809,   809,   810,
     810,   811,   811,   812,   812,   813,   813,   814,   814,   814,
     815,   815,   816,   816,   817,   817,   818,   818,   819,   819,
     819,   820,   820,   820,   821,   821,   821,   821,   822,   822,
     823,   823,   824,   824,   825,   825,   826,   826,   826,   826,
     827,   827,   828,   828,   829,   829,   829,   829,   829,   830,
     830,   830,   830,   830,   831,   832,   833,   833,   833,   834,
     834,   834,   835,   836,   836,   836,   836,   837,   837,   838,
     839,   839,   840,   840,   841,   841,   842,   842,   842,   842,
     842,   842,   842,   842,   842,   842,   842,   842,   842,   842,
     842,   842,   842,   843,   843,   843,   843,   843,   844,   844,
     845,   846,   846,   846,   847,   847,   848,   848,   849,   849,
     850,   850,   851,   852,   852,   853,   853,   853,   854,   854,
     855,   855,   856,   856,   856,   856,   856,   856,   857,   857,
     858,   858,   859,   859,   859,   859,   860,   860,   861,   861,
     862,   863,   864,   864,   865,   865,   866,   866,   866,   867,
     867,   867,   868,   869,   869,   870,   871,   871,   871,   871,
     872,   873,   873,   873,   873,   874,   874,   875,   875,   875,
     876,   876,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   878,   878,   879,
     879,   880,   880,   880,   880,   880,   880,   881,   881,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   883,   884,   884,   885,
     885,   886,   886,   886,   886,   886,   887,   888,   888,   888,
     888,   888,   888,   888,   888,   888,   888,   888,   888,   888,
     888,   888,   888,   888,   888,   888,   888,   888,   888,   888,
     888,   889,   889,   889,   890,   890,   890,   890,   890,   890,
     890,   891,   891,   892,   892,   892,   892,   893,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   895,   895,   896,
     897,   897,   897,   898,   898,   899,   899,   899,   899,   899,
     900,   900,   901,   901,   901,   901,   902,   902,   902,   903,
     904,   904,   905,   906,   906,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   908,   908,   909,
     909,   909,   910,   910,   910,   910,   910,   911,   911,   911,
     912,   912,   913,   913,   913,   914,   914,   914,   914,   915,
     915,   915,   915,   916,   917,   918,   918,   919,   919,   920,
     920,   920,   921,   921,   921,   921,   921,   921,   921,   922,
     922,   923,   923,   923,   923,   924,   925,   925,   925,   925,
     926,   926,   927,   928,   929,   929,   930,   931,   931,   931,
     931,   931,   931,   931,   932,   932,   933,   934,   934,   934,
     934,   934,   934,   935,   935,   936,   937,   937,   937,   937,
     938,   938,   939,   939,   940,   940,   941,   941,   942,   942,
     943,   944,   944,   945,   945,   945,   946,   946,   947,   947,
     948,   948,   949,   949,   950,   950,   951,   952,   952,   953,
     953,   954,   954,   954,   954,   955,   955,   955,   955,   955,
     955,   955,   955,   955,   955,   956,   957,   957,   958,   958,
     958,   958,   958,   959,   959,   959,   960,   960,   961,   961,
     961,   961,   962,   963,   964,   964,   965,   965,   965,   965,
     965,   966,   966,   967,   967,   968,   969,   969,   969,   970,
     970,   970,   971,   971,   972,   973,   973,   974,   975,   975,
     976,   976,   976,   976,   976,   976,   976,   976,   977,   977,
     978,   978,   978,   979,   980,   981,   981,   982,   982,   983,
     984,   984,   985,   986,   986,   987,   987,   987,   987,   987,
     988,   988,   989,   990,   991,   991,   991,   991,   991,   992,
     993,   994,   995,   995,   995,   995,   995,   995,   996,   996,
     996,   997,   997,   998,   998,   999,   999,   999,   999,   999,
     999,   999,   999,  1000,  1000,  1001,  1001,  1001,  1001,  1001,
    1001,  1001,  1002,  1002,  1002,  1003,  1003,  1004,  1005,  1005,
    1005,  1006,  1006,  1006,  1007,  1007,  1007,  1008,  1008,  1009,
    1009,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,
    1011,  1011,  1012,  1012,  1012,  1013,  1013,  1014,  1014,  1015,
    1015,  1016,  1016,  1017,  1018,  1018,  1019,  1019,  1020,  1020,
    1020,  1020,  1021,  1021,  1022,  1022,  1022,  1022,  1022,  1022,
    1023,  1023,  1024,  1024,  1025,  1026,  1026,  1026,  1027,  1027,
    1028,  1028,  1029,  1029,  1030,  1030,  1031,  1031,  1032,  1032,
    1032,  1032,  1032,  1033,  1034,  1035,  1036,  1037,  1037,  1038,
    1038,  1039,  1039,  1040,  1040,  1041,  1042,  1042,  1042,  1042,
    1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,  1047,  1047,
    1047,  1047,  1047,  1047,  1047,  1047,  1047,  1047,  1048,  1048,
    1048,  1048,  1048,  1048,  1049,  1049,  1049,  1049,  1050,  1050,
    1051,  1051,  1052,  1052,  1052,  1052,  1052,  1053,  1053,  1053,
    1053,  1054,  1054,  1055,  1055,  1056,  1056,  1057,  1057,  1057,
    1058,  1058,  1059,  1059,  1059,  1060,  1061,  1061,  1062,  1062,
    1063,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1067,  1068,
    1068,  1068,  1069,  1069,  1070,  1070,  1071,  1072,  1072,  1073,
    1073,  1074,  1074,  1074,  1075,  1075,  1076,  1076,  1076,  1076,
    1077,  1077,  1078,  1078,  1079,  1079,  1079,  1079,  1079,  1079,
    1080,  1080,  1080,  1081,  1081,  1081,  1081,  1081,  1081,  1081,
    1082,  1082,  1082,  1082,  1083,  1083,  1084,  1084,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1086,
    1086,  1087,  1087,  1088,  1088,  1089,  1090,  1091,  1091,  1092,
    1092,  1093,  1094,  1095,  1095,  1095,  1095,  1095,  1095,  1096,
    1096,  1097,  1097,  1097,  1097,  1098,  1099,  1099,  1099,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1101,  1101,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,  1102,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1104,  1104,  1104,  1104,  1104,  1104,  1104,  1104,
    1104,  1104,  1104,  1104,  1104,  1104,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1106,  1106,  1107,  1107,  1108,  1108,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1109,  1109,  1110,  1110,  1110,  1110,  1111,
    1112,  1112,  1113,  1113,  1114,  1114,  1115,  1115,  1115,  1116,
    1116,  1116,  1116,  1117,  1117,  1118,  1118,  1119,  1119,  1120,
    1120,  1121,  1121,  1122,  1123,  1123,  1123,  1124,  1125,  1125,
    1126,  1126,  1127,  1127,  1127,  1127,  1128,  1128,  1129,  1129,
    1129,  1129,  1129,  1130,  1130,  1130,  1130,  1130,  1131,  1131,
    1131,  1132,  1132,  1133,  1134,  1134,  1134,  1135,  1135,  1136,
    1136,  1136,  1136,  1136,  1136,  1136,  1136,  1136,  1136,  1136,
    1136,  1137,  1137,  1138,  1138,  1139,  1139,  1139,  1139,  1139,
    1139,  1140,  1140,  1141,  1141,  1142,  1142,  1142,  1143,  1143,
    1144,  1144,  1145,  1145,  1145,  1146,  1146,  1147,  1148,  1148,
    1148,  1148,  1148,  1148,  1148,  1148,  1149,  1149,  1149,  1149,
    1150,  1150,  1151,  1152,  1152,  1152,  1152,  1152,  1153,  1153,
    1153,  1154,  1154,  1155,  1156,  1156,  1157,  1158,  1158,  1159,
    1159,  1160,  1160,  1161,  1161,  1161,  1161,  1162,  1162,  1163,
    1163,  1164,  1164,  1165,  1165,  1166,  1166,  1167,  1167,  1168,
    1168,  1168,  1168,  1169,  1169,  1170,  1170,  1171,  1171,  1172,
    1173,  1174,  1175,  1175,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1177,  1178,  1179,
    1179,  1179,  1180,  1181,  1181,  1181,  1181,  1182,  1182,  1183,
    1184,  1185,  1185,  1186,  1186,  1187,  1187,  1187,  1188,  1188,
    1188,  1189,  1189,  1189,  1189,  1190,  1190,  1190,  1190,  1190,
    1191,  1191,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,  1196,
    1196,  1196,  1196
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     5,     1,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     3,     3,     2,     1,     1,     2,     2,     2,     3,
       3,     5,     5,     5,     0,     3,     5,     5,     5,     5,
       3,     5,     3,     5,     3,     5,     5,     6,     1,     1,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     3,     2,     3,     3,     2,     5,
       1,     3,     3,     3,     3,     1,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     3,     1,     2,     3,     2,     1,     1,
       2,     1,     2,     1,     3,     3,     2,     3,     4,     3,
       2,     4,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     4,     6,     4,     6,    10,    13,     4,     6,
       4,    10,    13,     4,     6,     4,     6,     5,     7,    11,
      14,     5,     7,     1,     3,     4,     4,     4,     3,     2,
       5,     3,     6,     4,     6,     6,     5,     7,     6,     6,
       5,     5,     6,     5,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     4,
       3,     2,     2,     3,     4,     4,     4,     5,     1,     3,
       2,     1,     1,     0,     2,     0,     2,     0,     1,     1,
       1,     3,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     1,     2,     1,     3,     2,     3,     6,     6,    10,
       1,     2,     1,     3,     4,     1,     3,     4,     6,     4,
       8,     2,     2,    11,     9,     1,     1,     1,     0,     1,
       1,     1,     1,     3,     2,     0,     1,     1,     3,     3,
       1,     1,     3,     3,     3,     3,     4,     3,     2,     1,
       0,     3,     0,     1,     0,     1,     3,     2,     1,     1,
       1,     3,     0,     1,     3,     1,    13,    16,    12,    15,
      14,    17,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     5,     2,     4,     2,     2,     1,     0,
       2,     0,     3,     1,     1,     2,     2,     1,     4,     4,
       5,     2,     5,     7,     5,     2,     3,     0,     1,     2,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       5,     9,     3,     9,     4,    10,    11,     2,     0,     3,
       0,     1,     3,     1,     4,     0,     2,     2,     2,     0,
       1,     3,     3,     6,     4,     0,     1,     1,     2,     2,
       0,     3,     3,     2,     1,     1,     3,     3,     4,     0,
       1,     0,     6,     1,     3,     3,     3,     5,     2,     0,
       2,     2,     0,     3,     4,     4,     0,     2,     0,     4,
       0,     3,     8,    11,     1,     3,     1,     1,     3,     6,
       8,     7,    10,     6,     2,     3,     0,     8,    11,     5,
       1,     0,     6,     5,     8,     4,     6,     1,     0,     3,
       0,     1,     2,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     1,     0,     7,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     1,     5,     2,     0,     2,     6,     6,     6,    10,
       6,     6,     6,     9,     9,     6,     6,     9,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     7,     6,
       4,     0,     1,     3,     4,     1,     3,     1,     2,     2,
       2,     2,     1,     1,    10,    13,     2,     0,     2,     2,
       1,     0,     5,     4,     4,    11,    14,    12,    15,    11,
       2,     1,     4,     0,     8,    11,     1,     1,     7,     9,
       8,    10,     8,     4,     0,     5,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     1,     1,     1,     1,     1,
       8,     1,     1,    17,    21,     1,     1,     2,     1,     3,
       1,     1,     1,     3,     1,     2,     0,     1,     2,     4,
       1,     1,     1,     1,     1,     3,     0,     1,     0,     1,
       1,     4,     0,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     0,     0,     2,     2,     1,     2,     2,
       2,     2,    11,    13,     1,     3,     5,     1,     3,     5,
       1,     2,     2,     1,     8,     6,     5,     4,     4,     3,
       7,     8,     6,     6,     6,     6,     6,     4,     7,     5,
       8,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     0,     1,     3,
       7,     9,     9,     8,     3,     0,    13,     1,     3,     5,
       5,     3,     6,     2,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     6,     8,     8,     1,     3,     5,     5,
       7,     9,     7,     9,     5,     6,     6,     4,     6,     4,
       6,     8,     4,     6,     4,     6,     5,     7,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     2,     2,     1,     3,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     2,     3,     1,     3,     5,     2,     2,     0,     6,
       6,     6,     6,     6,     6,     6,     6,     8,     9,     8,
       6,     6,     9,     9,     9,     7,    10,     1,     1,     8,
       8,     8,     8,     8,     8,     8,     9,     8,     8,     2,
       0,     1,     1,     2,     2,     1,     2,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     4,     4,     3,     4,
       4,     1,     1,     1,     0,     8,     8,    11,     1,     1,
       2,     4,     5,     1,     3,     2,     2,     2,     2,     2,
       1,     3,     1,     3,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
       5,     5,     5,     5,     5,     1,     3,     1,     2,     3,
       0,     6,     6,     9,     3,     0,     3,     0,     5,     2,
       0,     3,     3,     3,     7,     7,    10,     1,     1,     1,
       1,     1,     1,    16,    19,     1,     0,     1,     0,     1,
       0,     2,     0,     1,     3,     4,     5,     2,     2,     4,
       4,     0,     1,     3,     2,     0,     1,     0,     1,     1,
       0,     2,     2,     0,     9,    12,     7,     7,     2,     0,
       3,     2,     1,     3,     1,     3,     2,     1,     1,     2,
       3,     2,     1,     3,     3,     3,     2,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     4,     5,     1,
       3,     3,     1,     3,     3,     5,     6,     1,     3,     2,
       1,     3,     1,     0,     1,     2,     4,     5,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     2,     2,
       2,     1,     2,     2,     2,     2,     1,     1,     1,     3,
       2,     1,     4,     0,     3,     0,     1,     1,     3,     5,
       2,     0,     2,     1,     3,     5,     5,     5,     1,     2,
       1,     0,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     3,     5,     5,     5,     1,     3,     1,     3,
       2,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,    10,    11,    11,     5,     5,
       8,     4,     4,     7,     7,     1,     1,     1,     1,     1,
       5,     5,     6,     6,     6,     6,     6,     8,     8,     6,
       6,     7,     9,     9,     8,    10,     6,     6,     6,     6,
       6,     6,     6,     8,     6,     8,     6,     8,     7,     9,
       6,     8,     7,     9,     8,    10,     8,    10,     9,    11,
       8,    10,     9,    11,     8,     8,     7,     6,     6,     6,
       6,     8,     8,     8,     8,     6,     9,     1,     0,     2,
       0,     8,     8,     8,    10,     9,     8,     1,     0,     6,
       6,     6,     6,     6,     6,     6,     9,     9,     6,     6,
       6,     8,     6,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     7,     6,     6,     6,
       6,     6,     6,     7,     7,     6,     9,     9,     6,     6,
       6,     6,     6,     6,     8,     8,     8,     6,     7,     6,
       6,     4,     7,     6,     4,     5,     5,     3,     4,     3,
       1,     1,     3,     5,     5,     5,     5,     8,     5,     5,
       6,     7,     7,     7,     4,     4,     5,     4,     6,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     3,
       2,     0,     2,     2,     2,     3,     3,     3,     3,     2,
       3,     2,     5,     4,     3,     3,     3,     3,     3,     1,
       1,     0,     3,     2,     2,     1,     2,     1,     3,     2,
       1,     0,     2,     3,     0,     9,    11,    12,    14,     3,
       4,     4,     0,     2,     5,     1,     0,     1,     2,     3,
       3,     3,     1,     2,     1,     1,     1,     1,     1,     1,
       0,     5,     4,     6,     6,     4,     3,     5,     7,     9,
       1,     3,     1,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,     1,     1,    10,     4,     6,     2,     5,
       2,     0,     6,     5,     3,     5,     1,     3,     1,     1,
       2,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     1,     3,     1,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     3,     0,     1,     1,
       1,     1,     1,     3,     9,    12,     3,     0,     2,     3,
       2,     3,     7,     4,     1,     3,     1,     4,     4,     7,
       2,     1,     1,     1,     3,     2,     8,     5,     0,     4,
       3,     0,     2,     0,     7,     2,     0,     5,     3,     0,
       2,     2,     2,     3,     1,     3,     1,     2,     1,     0,
       1,     2,     0,     8,     3,     1,     3,     3,     5,     2,
       1,     3,     9,     1,     2,     5,     5,     6,     6,     7,
       2,     0,     3,     1,     2,     5,     5,     8,     3,     4,
       7,     1,     0,     3,     2,     2,     2,     2,     0,     2,
       2,     1,     1,     3,     3,     1,     2,     4,     4,     2,
       3,     5,     5,     1,     1,     9,     9,     1,     2,     4,
       4,     4,     2,     2,     3,     1,     3,     9,     1,     2,
       0,     7,     7,     0,    10,     6,     0,     1,     0,     2,
       0,     3,     3,     4,     4,     4,     4,     3,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       1,     1,     0,     3,     1,     3,     4,     3,     2,     2,
       1,     1,     1,     0,     2,     4,     5,     6,     4,     5,
       2,     3,     1,     1,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     4,     0,     1,     3,     1,     1,
       1,     1,     1,     2,     4,     4,     5,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     4,     5,     2,     0,     1,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     1,     0,
       2,     0,     1,     4,     5,     4,     0,     2,     2,     2,
       1,     1,     0,     5,     2,     1,     1,     2,     2,     4,
       1,     3,     1,     2,     3,     6,     4,     0,     2,     6,
       2,     1,     3,     4,     0,     2,     0,     2,     0,     2,
       4,     0,     1,     0,     1,     3,     3,     7,    12,     1,
       3,     2,     3,     3,     1,     2,     2,     2,     2,     1,
       1,     3,     3,     2,     2,     3,     5,     6,     2,     3,
       3,     4,     0,     1,     1,     1,     1,     1,     2,     4,
       1,     1,     1,     1,     2,     3,     3,     0,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     1,     3,
       0,     1,     1,     1,     1,     5,     2,     1,     1,     1,
       1,     4,     1,     2,     2,     1,     3,     3,     2,     1,
       0,     5,     2,     5,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     0,     1,     4,     1,     3,     3,     5,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     2,     2,     3,
       5,     4,     6,     3,     5,     4,     6,     4,     6,     5,
       7,     3,     2,     4,     2,     3,     3,     4,     3,     4,
       3,     4,     5,     6,     6,     7,     6,     7,     3,     4,
       4,     6,     3,     3,     4,     3,     4,     4,     5,     1,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     5,     6,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     1,     4,     3,     5,     6,     8,
       6,     6,     4,     4,     1,     1,     1,     5,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     6,     4,     4,     4,
       4,     4,     6,     5,     5,     5,     4,     6,     4,     4,
       4,     4,     5,     7,     7,     9,     5,     4,     6,     5,
       7,     7,     7,     2,     3,     3,     3,     4,     0,     4,
       1,     3,     3,     1,     1,     1,     2,     2,     0,     2,
       3,     3,     4,     2,     2,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     3,     3,     3,     0,     1,     4,     2,     2,
       2,     2,     2,     3,     2,     2,     3,     0,     4,     3,
       5,     4,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     3,     3,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     5,     3,     5,     5,     3,     3,     5,     3,     2,
       1,     1,     3,     5,     1,     2,     4,     2,     0,     1,
       0,     1,     2,     2,     2,     3,     5,     1,     0,     1,
       2,     0,     2,     1,     0,     1,     0,     1,     3,     3,
       2,     1,     1,     1,     3,     1,     2,     1,     3,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       6,     2,     3,     5,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,    10,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 894 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 28207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 3:
#line 898 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 28215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 4:
#line 902 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 28224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 5:
#line 907 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 6:
#line 915 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 7:
#line 923 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 8:
#line 943 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 28276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 9:
#line 955 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 28287 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1108 "gram_minimal.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 28304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1124 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1146 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1147 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1151 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1152 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1157 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 28350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1162 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 28358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1166 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1176 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 28384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1184 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 28392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1188 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 28400 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1192 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 28408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1197 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1201 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 28465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1248 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 28471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1251 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 28479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1255 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1259 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 28495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1263 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 28503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1267 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 28511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1281 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1300 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 28537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1309 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 28550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1320 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1321 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1326 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1335 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1344 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1353 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 28614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1375 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1383 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1391 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1399 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 28662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1407 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1415 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1433 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1452 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 28713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 28719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 28725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1476 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 28740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1487 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 28755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1498 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 28775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1514 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 28795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1533 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1538 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 28817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1544 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1572 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28834 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1579 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1586 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1593 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1603 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28880 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1612 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1625 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28906 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1634 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1643 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1651 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1661 "gram_minimal.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 28949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1663 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1672 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28977 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1684 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 28989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1692 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29002 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1701 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29018 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1713 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1722 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29044 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1731 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1739 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1749 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1761 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 29094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1769 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 29112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1771 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1774 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 29124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1775 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 29130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1776 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 29136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 29142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1781 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 29148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1782 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 29154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1783 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 29160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1789 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1802 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1806 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1810 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const    *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 29203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1827 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 29215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1834 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29221 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1835 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1836 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29239 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1841 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29245 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1842 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1847 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1851 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 29269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1853 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 29279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1861 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1863 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 29297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1871 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 29309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1879 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1890 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 29333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1898 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 29344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1909 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1914 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1915 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1922 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 29378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1928 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 29388 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1934 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1941 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 29410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1948 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 29421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1955 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 29432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1962 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 29443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1973 "gram_minimal.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1983 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1984 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1988 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1989 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1998 "gram_minimal.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 29489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2014 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 29500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2021 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2028 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 29522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2035 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 29533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2042 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 29544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2062 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29558 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2072 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29572 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2082 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2092 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2102 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2114 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2126 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2136 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2146 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2156 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2168 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2180 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2190 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2200 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2210 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2220 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2230 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2240 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2252 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2264 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2274 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29850 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2286 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2287 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2293 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2307 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2320 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 29912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2336 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2353 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2363 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2373 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 29968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2383 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2393 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 29994 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2403 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2412 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30018 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2421 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 30030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2430 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2440 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2450 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 30075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2466 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2476 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2486 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2496 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2506 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 30147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2523 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2533 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2543 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2553 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2564 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2578 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 30233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2594 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30245 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2603 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2612 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 30275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2627 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30287 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2636 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30301 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2647 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2658 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 30326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2666 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2675 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2684 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 30361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2692 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 30372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2700 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2709 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2718 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2727 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 30419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2735 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 30430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2743 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2752 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 30453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2760 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 30464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2768 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2777 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2786 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2795 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30512 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2804 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 30524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2813 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 30536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2822 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 30550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2833 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 30561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2841 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 30573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2850 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2859 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2868 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2877 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30621 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2886 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2895 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2903 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2911 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2919 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 30677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2926 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2942 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2948 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2960 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2966 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2974 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2982 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2990 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3000 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3003 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3004 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3008 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3009 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3015 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3019 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 30844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3023 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 30853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3028 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 30861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3035 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3042 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 30881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3046 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3050 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 30904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3061 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30912 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3069 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3122 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3135 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 30998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3149 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 31011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3161 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 31019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3168 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 31027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3172 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 31035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3186 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 31049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3198 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3199 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3205 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 31074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3215 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3226 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3237 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3264 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3271 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3307 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 31182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3341 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 31206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3363 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3364 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3368 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3390 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3395 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 31280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3399 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3403 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3407 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3411 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 31312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3415 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3419 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3423 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3427 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3431 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 31352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3435 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 31360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3439 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3443 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3452 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 31384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3460 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31398 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 31404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3474 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 31412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3478 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 31420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3485 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 31428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3491 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3492 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 31440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3493 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 31446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3494 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 31452 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3495 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3500 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3504 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3511 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 31480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3525 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31502 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3545 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3565 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3586 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3607 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3628 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3659 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3660 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3661 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31634 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3662 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 31640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3664 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3671 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 31662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3677 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 31668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3678 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 31674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3682 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3683 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3687 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31698 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3693 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3697 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3704 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3708 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31730 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31736 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3716 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3720 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3721 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3725 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 31785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3748 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3767 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 31831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3788 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3789 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 31843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3793 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3794 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3798 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3799 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3804 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3811 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3812 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3814 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3846 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3854 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 31933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3862 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31950 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3875 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3887 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 31983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3900 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 31999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3912 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 32013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3922 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 32041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3946 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32062 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3966 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3967 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 32086 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3972 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 32092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3992 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 501:
#line 4000 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 502:
#line 4008 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 503:
#line 4016 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 504:
#line 4028 "gram_minimal.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 32153 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 505:
#line 4039 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 506:
#line 4040 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 32165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4045 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 32177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4046 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 32183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 32189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4048 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 32195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4049 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 32201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4050 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 32207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4051 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 32213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4052 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 32219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 32225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4054 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 32231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4064 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4076 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 32267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4091 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4108 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4125 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4141 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4159 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4178 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 32394 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4199 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 32400 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4200 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 32406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4205 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32418 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4209 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32424 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4210 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4214 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 32438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4224 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 32458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4228 "gram_minimal.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 32470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4236 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4240 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 32486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4246 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 32492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4248 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 32498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4252 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 32506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4257 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 32514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4263 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 32520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4264 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4269 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 32540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4279 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 32554 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4289 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 32566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4297 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 32578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4305 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 32594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4319 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 32608 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4331 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 32616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4338 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4346 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4354 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 32652 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4362 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 32664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4370 "gram_minimal.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 32676 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 32694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4385 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 32700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4389 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 32714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4400 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 32720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 32726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4405 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4416 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 32756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4427 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 32771 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32777 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4441 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4451 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 32807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4452 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 32813 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4453 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 32819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4454 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 32825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4457 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4458 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4462 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4485 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4498 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4518 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 32893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4519 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 32899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4523 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 32909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4529 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 32919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4535 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 32929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4552 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 32942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4561 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 32955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4583 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4597 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4615 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4644 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4658 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4675 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4702 "gram_minimal.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4723 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4734 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4748 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4757 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4768 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4769 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4772 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4773 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4776 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4781 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 33202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4785 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4789 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4793 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 33226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4797 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4801 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4805 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33250 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4809 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 33258 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4813 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 33266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4817 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4821 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4826 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4830 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4834 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 33313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 33319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4847 "gram_minimal.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 33330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4853 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4856 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33342 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4857 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4870 "gram_minimal.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 33368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4887 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 33384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4901 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4902 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4910 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4911 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 33408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4915 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4920 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4925 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4926 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4942 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 33470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4968 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4976 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4994 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 655:
#line 5003 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 656:
#line 5015 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 657:
#line 5017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5022 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5026 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33548 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5030 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 33559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5037 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5049 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5060 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5067 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5080 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 33613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5090 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 668:
#line 5100 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 669:
#line 5110 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 33655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5120 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5130 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5140 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5150 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 33711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5160 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 33725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5170 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5180 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 33753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5190 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 33767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5200 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 33781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5219 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5230 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 33800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5231 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 33806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5232 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 33812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5233 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 33818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5237 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33824 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5238 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5242 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5243 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5254 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5263 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 33868 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5275 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5276 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33880 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5281 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33888 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5285 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5297 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5301 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33918 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5308 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5312 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 33935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5317 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 33944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5322 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 33952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5329 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 33960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5340 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5352 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5365 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34010 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5385 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5386 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5390 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5391 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5402 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5412 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5421 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5441 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5462 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5483 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34149 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5505 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5538 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 34189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5552 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 34195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5553 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 34201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5558 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 34213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5566 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 34224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5582 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5592 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5604 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34258 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5605 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 34264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5618 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5627 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5645 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5672 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5689 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 34335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 34371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 34383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5723 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 34401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5736 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5740 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5741 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5745 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 34425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5746 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 34431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5747 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 34437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5748 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 34443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 34449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5760 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 34462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5771 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 34468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5772 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 34474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5786 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 34499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5810 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 34529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5838 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 34535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 34541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 34547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5847 "gram_minimal.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 34576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5869 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 34582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5871 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 34588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5873 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 34594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5875 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 34600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5877 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 34606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5881 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5882 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5886 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5887 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5892 "gram_minimal.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 34643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5903 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5917 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5926 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 34681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5930 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 34693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5946 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5950 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5960 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5962 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5967 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 34743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5970 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5972 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 34767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5977 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 34773 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 34779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5984 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 34807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6010 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 34813 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6011 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 34819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 798:
#line 6012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 34825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 799:
#line 6013 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 34831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6014 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 34837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6015 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 34843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6030 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6042 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 804:
#line 6055 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 805:
#line 6057 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 34889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6069 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6074 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 34913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 34919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6085 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 34925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 34931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 34937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6099 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 34949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6118 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6130 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34982 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6143 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6154 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6165 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6177 "gram_minimal.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6186 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6194 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6202 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6212 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6222 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6232 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6242 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6252 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6263 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 35164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6273 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6285 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6288 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6289 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6293 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6297 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 35213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 35219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6304 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 35231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6306 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 35237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6307 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6308 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6311 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6314 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6315 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6324 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6330 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6331 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35287 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6337 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6348 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6360 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6372 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6384 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 35363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6397 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6398 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6416 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6431 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6436 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6450 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6460 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 35447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6469 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6479 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6488 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6489 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6492 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6493 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6496 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6497 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6502 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 35533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6515 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6521 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6532 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6542 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6554 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6555 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6560 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6569 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6582 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35632 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6593 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6607 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6618 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6641 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 35689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6652 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 35701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6671 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6682 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6693 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6704 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6715 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6726 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6737 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6748 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6759 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6770 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6781 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 35866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6792 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 35881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6806 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 35887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6807 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 35893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6808 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 35899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6809 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 35905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6810 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 35911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6811 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 35917 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6812 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 35923 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6813 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 35929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6814 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 35935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6815 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 35941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 35947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6817 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 35953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6818 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 35959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6828 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 35965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6829 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 35971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6830 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 35977 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 35983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 35989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6836 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 35995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6837 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6838 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 36013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6841 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6842 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6843 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6848 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 36043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6849 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 36049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6850 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 36055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6854 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 36061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6855 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 36067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6858 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6859 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6863 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6865 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36091 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6869 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6870 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36103 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6882 "gram_minimal.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6893 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6894 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6895 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6906 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6915 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6924 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6933 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6942 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6951 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6960 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6969 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6978 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6987 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 949:
#line 7001 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36282 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 950:
#line 7010 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 951:
#line 7019 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7028 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7037 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7046 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7055 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7064 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7076 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7092 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7103 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7114 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7125 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7136 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7147 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7158 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7169 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7180 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7191 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7202 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7203 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7206 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36543 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7207 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36549 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7218 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 36560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7225 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 36571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7234 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36584 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7243 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7252 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7261 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7270 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7279 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 36649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7288 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7297 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7306 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7315 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7324 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7333 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7342 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7351 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 36753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7360 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 36766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7369 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 36779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7396 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 36797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7414 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7430 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7457 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7459 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7463 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 36865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7471 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 36877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7480 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 36883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7481 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 36889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7485 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7493 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7501 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7509 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 36936 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7516 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36948 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7527 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 36956 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7531 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 36964 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7538 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 36972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7542 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 36980 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7553 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7562 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7571 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7580 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7589 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7598 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7607 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7616 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7625 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37097 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7634 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37110 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7643 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7652 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7661 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7669 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7678 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7687 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37187 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7696 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7705 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7714 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7723 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37239 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7732 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7744 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 37258 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7745 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 37264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37270 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7750 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37282 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7756 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7767 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7781 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37318 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7792 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7804 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7805 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7808 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7809 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 37357 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7820 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7830 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7836 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7840 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7844 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 37405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7856 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 37422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7870 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7885 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7901 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 37464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7902 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 37470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7903 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 37476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 37482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7905 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 37488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7906 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 37494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7921 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 37528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7953 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 37562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7986 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37574 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7990 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7991 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7995 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7996 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 8000 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 8001 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 37610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 8004 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 8005 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8011 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 37638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8023 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 37654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8042 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 37663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8047 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 37672 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8052 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 37681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8058 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8059 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8063 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8070 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8074 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 37735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 37741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8076 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 37747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 37753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 37759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8081 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 37765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8099 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8113 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8128 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8142 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37834 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8162 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8167 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8171 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37876 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8173 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8178 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 37895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8192 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 37907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8200 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 37919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8208 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 37932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8223 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37938 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8228 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37950 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8230 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37956 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8245 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37970 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8255 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8265 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8275 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8285 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 38032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8298 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 38038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8299 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38044 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8300 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38050 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 38056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8312 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 38068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8326 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 38074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8328 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8334 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8344 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38103 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8348 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8353 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8361 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8403 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 38144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8407 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 38152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8411 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 38160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8415 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 38169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8422 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8428 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 38194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8441 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8451 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8452 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8460 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 38232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8464 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 38240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8468 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8472 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 38256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8476 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 38264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8480 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 38272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8484 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 38280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8488 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 38288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8492 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 38296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8496 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 38304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8500 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8504 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 38320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8508 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 38328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8512 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 38336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8516 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8520 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 38353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8525 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8532 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8536 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8540 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 38385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8544 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8548 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 38401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8553 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8555 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 38415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8561 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 38426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8571 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 38434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8575 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 38448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8585 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 38456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8592 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 38468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8600 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 38476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8611 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8612 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 38488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8617 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8621 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8634 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 38522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8638 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 38530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8653 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38543 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8662 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38556 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8671 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8683 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8684 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8708 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38596 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8719 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8730 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8741 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8752 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8763 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8777 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8788 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8802 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8813 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8827 "gram_minimal.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 38743 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8835 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 38749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8837 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 38755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8839 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 38761 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 38773 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8850 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8852 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8857 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8876 "gram_minimal.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8885 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8886 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8891 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 38828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8895 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 38836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8908 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 38851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8920 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 38866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8932 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 38881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8944 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 38887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 38893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8946 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 38899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8951 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8964 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8975 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 38941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8988 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 38949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8992 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 38957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8996 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 38965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9000 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 38973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9007 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 38987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9028 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9041 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9054 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9067 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9081 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 39061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9082 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 39067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9085 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 39073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 39079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 39085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9098 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 39099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9108 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 39113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9126 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9136 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9146 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39155 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9156 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9166 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9176 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9186 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9196 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9206 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39239 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9216 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9226 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9236 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39281 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9246 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9257 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9268 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39325 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9278 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9288 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9298 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9308 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9318 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9328 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9339 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9350 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9361 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9372 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9383 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9394 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9405 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9416 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9427 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9438 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9449 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9460 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9472 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9484 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9496 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9508 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9520 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9532 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9543 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9554 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9566 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 39733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9578 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9589 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39763 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9600 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9609 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9619 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9629 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9639 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9649 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9659 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9669 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9679 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39888 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9689 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9699 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 39925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 39931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9729 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9739 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9749 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9759 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9770 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40002 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9780 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9791 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9792 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 40028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9803 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9813 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9823 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9833 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40084 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9843 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9853 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9863 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9873 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9883 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9893 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9903 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9913 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40196 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9923 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40210 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9933 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9943 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9953 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9963 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9973 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9983 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9993 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 10003 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10013 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10023 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10033 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10043 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10053 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10063 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10082 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40418 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40424 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10092 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10096 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 40436 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 40442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10103 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 40448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10104 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 40454 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10105 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 40460 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10106 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 40466 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10107 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40472 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10120 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10136 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10145 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10154 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10163 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10172 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40549 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10181 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10190 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10199 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40588 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10208 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10217 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10226 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10235 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10244 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40653 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10253 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10262 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10271 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10280 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10289 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10298 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10307 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10316 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10325 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10334 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10343 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10371 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10379 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 40821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10388 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 40835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10414 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 40848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10423 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 40859 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10430 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 40869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10436 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 40900 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10463 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 40914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10474 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 40927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10483 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 40937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10491 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 40943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10493 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 40949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10515 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 40961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10523 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 40975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10533 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 40989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10543 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 41003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10562 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10581 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10591 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10601 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10611 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10622 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10633 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10644 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10655 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10666 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10684 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10693 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41174 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10712 "gram_minimal.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10727 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10728 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10729 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10735 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 41219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10741 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 41229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10757 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10758 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 41241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10761 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 41247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10762 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 41253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10763 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 41259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 41265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10768 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10769 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10770 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10783 "gram_minimal.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10793 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41301 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10794 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 41307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10798 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41318 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10808 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10815 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 41340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10835 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10844 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10852 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10861 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10870 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10878 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 10886 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10894 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10902 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10910 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10918 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10926 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10937 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10945 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41512 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10962 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 41519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 41526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10968 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 41533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 41540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10974 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 41547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10981 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10983 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10991 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10995 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10996 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10997 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11011 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11025 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 41623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11039 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11058 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 41667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11078 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 41679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 11080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 41685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 11081 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 41691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 11092 "gram_minimal.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11109 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11119 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11120 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11124 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11125 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11130 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 41746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11134 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 41754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11138 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 41762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11156 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 41774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11160 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 41804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11181 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 41816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11189 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 41828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11197 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 41841 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11206 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 41852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11216 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 41864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11234 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 41877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11243 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 41890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11252 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11261 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11273 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 41924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11277 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 41932 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11288 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 41940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11300 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 41951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11318 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 41962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11325 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 41973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11342 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 41987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11356 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42000 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11366 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11375 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42024 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11384 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 11394 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 11406 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11418 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11441 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11452 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11464 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11476 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11488 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11500 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11510 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11539 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 42199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11563 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 42214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11575 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11584 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 42242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11596 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11609 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11610 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 42269 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11623 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 42294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11644 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 42307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11655 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 42323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11667 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 42336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 11679 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 42344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 11683 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 42352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11695 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 42360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 42372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11706 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 42378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 42384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 11708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 11712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42408 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11721 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11722 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11725 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11726 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11730 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11731 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11736 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 42458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11743 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11745 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11750 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 11764 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 42494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 11772 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 42509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11783 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 42521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11791 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 42533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11821 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11831 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42558 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11851 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11860 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 42591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11878 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 42612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 11897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 11908 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 42635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 11915 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 42646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11922 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 42657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11929 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 42668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11947 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 42680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11957 "gram_minimal.y" /* yacc.c:1646  */
    {
				InsertStmt *insert = makeNode(InsertStmt);
				insert->relation = (yyvsp[0].range);
				(yyval.node) = (Node *) insert;
				/*
				 * Assign the node directly to the parsetree and exit the scanner
				 * we don't want to keep parsing for information we don't need
				 */
				pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
				YYACCEPT;
			}
#line 42696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11978 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 42704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11982 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 42713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11990 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11996 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 12003 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 12009 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 42755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12016 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 42765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12024 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 42771 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 12025 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 42777 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 12030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 42783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 12032 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 42789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 12037 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 42801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 12048 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 42814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12058 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 42827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12067 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 42835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12074 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 42847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12083 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 42859 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12091 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 42867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12097 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12111 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 42894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12124 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42900 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12125 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42906 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12137 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12147 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 42925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12148 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 42931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12151 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 42937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12152 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 42943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12153 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 42949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12154 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 42955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12155 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 42961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12156 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 42967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 42973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 42979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12162 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 42997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12167 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 43003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12168 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 43009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12184 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 43025 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12197 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[0].range);
					n->targetList = NULL;
					n->fromClause = NULL;
					n->whereClause = NULL;
					n->returningList = NULL;
					n->withClause = (yyvsp[-2].with);
					(yyval.node) = (Node *)n;
					pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
					YYACCEPT;
				}
#line 43042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12211 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43048 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12212 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 43054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12217 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 43063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12222 "gram_minimal.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 43088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12246 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12256 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12257 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 43112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12273 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 43128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12287 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12288 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 43140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12293 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12307 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12314 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43187 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12324 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12336 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12337 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12342 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12355 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12368 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12377 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12386 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12395 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12404 "gram_minimal.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 43306 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12416 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 43314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12428 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12442 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12443 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 43346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 43352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 43358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 43364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 43370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12451 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 43382 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12452 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 43388 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12505 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 43394 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12506 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 43400 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12521 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12523 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 43417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12530 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12538 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12546 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 43453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12554 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 43465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12562 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12570 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 43489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12580 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12581 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43501 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12616 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12632 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43538 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12646 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12648 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 43567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12667 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12671 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12675 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 43591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12690 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 43602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12697 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 43613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12704 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 43624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12718 "gram_minimal.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 43653 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 12733 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 43659 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 12734 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 43665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 43671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12740 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 43685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12750 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 43699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12760 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 43707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12767 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 43723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12779 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 43739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12791 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 43747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12797 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 43753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12798 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 43759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12803 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 43774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12814 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 43780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12823 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12828 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12833 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12838 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12843 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12851 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 43840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12859 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 43849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12864 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 43858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12869 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 43867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12880 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 43873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12881 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 43879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12882 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 43885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12889 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 43891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12890 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12899 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12904 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12905 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 12909 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 12913 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 43933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12914 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 43939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12918 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 43952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12927 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 43965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12940 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 43974 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12945 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 43983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 12950 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 43991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 12954 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 44010 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12966 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 44016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 12971 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44029 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 12980 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 44042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 12996 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 13005 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 13014 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13023 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13035 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13038 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13044 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 44121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 13051 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 13071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13073 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13075 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 44151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 44157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44163 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13085 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13115 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 44193 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13123 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 44205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13133 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 44217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13138 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13139 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13140 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13141 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13142 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13147 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 44255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13160 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13167 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 44271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13174 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13180 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13181 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13185 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13186 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13190 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13191 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13195 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13196 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 44327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13201 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13212 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 44346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13213 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 44352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13214 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 44358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13215 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 44364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13231 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 44387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13238 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 44398 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13256 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13257 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13261 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13262 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13269 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 44431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13274 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 44444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13283 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 44456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13291 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 44469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13300 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 44480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13307 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 44492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13315 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 44532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13351 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 44562 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13377 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 44570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13381 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 44579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13407 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 44587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13411 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 44605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13425 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 44630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13446 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 44656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13468 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 44673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13481 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 44691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13498 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 44701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13504 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 44710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13509 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 44720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13515 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 44729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13521 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 44735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13522 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 44741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13533 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 44751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13538 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 44757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13547 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 44765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13551 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 44773 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13555 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 44784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13562 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 44795 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13569 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 44803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13574 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 44809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13575 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 44815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13576 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 44821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13577 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 44827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13598 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 44835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13602 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 44843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13610 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 44854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13617 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 44862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13624 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 44873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13631 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 44884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13638 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 44895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13648 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 44901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13649 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 44907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13663 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 44915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13667 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 44927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13675 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 44939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13689 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 44954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 44960 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13719 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 44981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13730 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 44996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13743 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 45002 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13747 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 45008 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13748 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 45014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13751 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45020 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13752 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13756 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13761 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45044 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13762 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45050 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13767 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 13769 "gram_minimal.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 45069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 13777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13782 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13783 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13788 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13792 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45103 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13798 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 45126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13823 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 45141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13835 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 45156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13847 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13848 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13853 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 45186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13867 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 45247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13924 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 45262 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 45268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 45274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 45280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13947 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 45286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 45292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 45298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13958 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45310 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13963 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13971 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13991 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 45343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13996 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 45353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 14003 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 45362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 14008 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 45372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 14014 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 45381 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 14019 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 45391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 14028 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 45397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 14030 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 45403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 14032 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 45409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 14036 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14038 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14039 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14040 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14042 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 45448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14047 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 45458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14069 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 45482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14081 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14087 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 45502 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45508 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14095 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45514 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14102 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14107 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14112 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14117 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45550 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14122 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14127 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45568 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14132 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14137 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14143 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14149 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14155 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14162 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 45641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14183 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 45649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14193 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14197 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14205 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14209 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 45682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 14217 "gram_minimal.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 14229 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14250 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14254 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14260 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 45737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14264 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 45752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14277 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 45762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14285 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14299 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 45792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45798 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45804 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 45810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14309 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14310 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14318 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14327 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14335 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 45860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14344 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 45872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14355 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 45881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14362 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14363 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14364 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 45905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 45911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 45917 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 45923 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 45929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14381 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 45944 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14386 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 45953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14391 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 45963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14397 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 45975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14405 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 45984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14410 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 45995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14417 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14428 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 46019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14432 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14467 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14469 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14471 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14480 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 46064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14496 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14500 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46088 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14504 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14506 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14508 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14510 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14512 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14516 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14518 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46136 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14520 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14522 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14525 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14527 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14530 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14534 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14536 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14539 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46193 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14544 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14553 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14558 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14567 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14572 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46250 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14581 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14586 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14596 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 46285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14605 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46298 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14614 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14623 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 46324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14642 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46337 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14651 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14660 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14669 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14678 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 46397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14695 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14704 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14713 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46436 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14722 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14731 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 46462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14740 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 46475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14749 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14753 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 46491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14757 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 46503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14765 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 46515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14773 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 46527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14781 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 46539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14789 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 46564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14810 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 46591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14833 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14845 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 46618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14852 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 46638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14868 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 46647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14873 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14879 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 46668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14886 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 46679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14893 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14901 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 46703 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14909 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14935 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14939 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46752 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14947 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14951 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14955 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14957 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14959 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46812 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46818 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14967 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46824 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14969 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46830 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14971 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 46838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 14975 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 46846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 14979 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 46855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 14984 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 46865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 14999 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 15000 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15002 "gram_minimal.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 46898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15019 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 46915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15032 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15034 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15036 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15048 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 46972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15073 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46988 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15085 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15097 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15105 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15116 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15127 "gram_minimal.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 47058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15137 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 47068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15143 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15152 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15162 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47109 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15172 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 47126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15185 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 47140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15195 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 47163 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15226 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 47203 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15262 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15272 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47215 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15273 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47221 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15281 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15288 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 47240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15292 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 47248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15296 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47256 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 47264 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15304 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15308 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 47280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15312 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15316 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 47296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15320 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 47304 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15324 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 47312 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15328 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 47320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15332 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 47328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15336 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 47336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15340 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 47344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15344 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 47352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15348 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 47358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15350 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15357 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15364 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 47391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15371 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15378 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 47417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15389 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47435 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15403 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15413 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 47464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15424 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 47484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15440 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15450 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15457 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15464 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15471 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 47539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15475 "gram_minimal.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 47551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15483 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 47564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15492 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 47577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15501 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15505 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 47593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15509 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 47601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15513 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 47609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15517 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 47617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15521 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 47630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15530 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 47638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15534 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 47652 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15544 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 47660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15548 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 47668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15552 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 47677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15557 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15572 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15574 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 47703 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15578 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 47709 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15580 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 47715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15582 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 47721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15584 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 47727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15587 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15590 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15591 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47745 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15595 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15603 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 47769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15612 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 47775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15613 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 47781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15616 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 47787 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15617 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15618 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15624 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15628 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 47815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15632 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15636 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 47831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15651 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15652 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15656 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 47849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15657 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15665 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15666 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15670 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 47873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15672 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 47879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15677 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 47890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15686 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 47896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15688 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 47914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 47920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15707 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 47939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15733 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15734 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 47951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15737 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15738 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15747 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 47975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15755 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 47987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15763 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 47999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15771 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15782 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 48034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15800 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 48076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15846 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15855 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15864 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15873 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15882 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15893 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 48147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15894 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 48153 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15895 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 48159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 48165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 15897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 48171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 15911 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 15912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 15913 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 48189 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 15916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 15917 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 15920 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 48207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 15923 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 48213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 15924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 48219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 15925 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 48225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 15928 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 15929 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 15932 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 48243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 15933 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 48249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 15934 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 48255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 15935 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 48261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 15936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 48267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 15937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 48273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 15938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 48279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 15939 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 48285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 15940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 48291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 15941 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 48297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 15942 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 48303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 15943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 48309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 15947 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 15949 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48321 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 15954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 15956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 15961 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 15963 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 15965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 48351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 15967 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 48357 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 15969 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 48363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 15971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 48369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 15983 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 15987 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 15994 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 15998 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16004 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16008 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 48423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16018 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 48437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16033 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 48455 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16034 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 48461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16038 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 48469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16042 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 48477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16046 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 48485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16051 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16052 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16058 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 48505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16068 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 48517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16069 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 48523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16070 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 48529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 48535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16072 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 48541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16073 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 48547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16074 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16078 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 48559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 48565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16080 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 48571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16081 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 48577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16087 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16092 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16100 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 48601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16122 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16126 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 48618 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16131 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16142 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 48654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16159 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 48662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16164 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 48668 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16165 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16166 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48680 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16170 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 48692 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16177 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 48698 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16188 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 48713 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16202 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16203 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16208 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 48738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16223 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16224 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16228 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 48770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16232 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 48778 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16239 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 48786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16243 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 48794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16247 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 48807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16256 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 48820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16267 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16268 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16272 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16273 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16277 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48850 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16278 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 48856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16293 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48868 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16298 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48880 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16302 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48892 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16310 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 48904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16318 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 48916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16326 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 48933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16348 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 48939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16349 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 48945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16361 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 48953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16365 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 48961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 48973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16381 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 48997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16394 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 49006 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16405 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 49014 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16409 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16413 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16417 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16421 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 49051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16430 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16438 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16470 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 49107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16474 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 49118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16481 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 49130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16489 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 49138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16493 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 49146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16497 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 49154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 49160 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16503 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16505 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 49172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16506 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 49178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16507 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 49184 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16512 "gram_minimal.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 49227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16553 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 49259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16581 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 49267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16585 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 49275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16589 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 49283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16595 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 49289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16597 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 49295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16614 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 49326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16647 "gram_minimal.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 49341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16659 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16660 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 49353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16681 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16682 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16683 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16688 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16689 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16695 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16696 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16697 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16698 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16704 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16705 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16706 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49431 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49443 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 49455 "gram_minimal.c" /* yacc.c:1646  */
    break;


#line 49459 "gram_minimal.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 17665 "gram_minimal.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}


static Node *
makeStringConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

	return (Node *) n;
}


static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBoolAConst(bool state, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.boolval.type = T_Boolean;
    n->val.boolval.boolval = state;
    n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.bsval.type = T_BitString;
    n->val.bsval.bsval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
    A_Const    *n = makeNode(A_Const);

    n->isnull = true;
    n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node       *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location)));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("invalid publication object list"),
				 errdetail("One of TABLE or ALL TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				 parser_errposition(pubobj->location)));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid table name at or near"),
						 parser_errposition(pubobj->location)));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("WHERE clause not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("column specification not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid schema name at or near"),
						 parser_errposition(pubobj->location)));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
minimal_parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

